[![CI](https://github.com/FedeClaudi/Term.jl/actions/workflows/CI.yml/badge.svg)](https://github.com/FedeClaudi/Term.jl/actions/workflows/CI.yml)
[![codecov](https://codecov.io/gh/FedeClaudi/Term.jl/branch/master/graph/badge.svg?token=SZM70KS8PK)](https://codecov.io/gh/FedeClaudi/Term.jl)
[![Dev docs](https://img.shields.io/badge/docs-stable-blue.svg)](https://fedeclaudi.github.io/Term.jl/dev/)
[![JuliaHub deps](https://juliahub.com/docs/Term/deps.svg)](https://juliahub.com/ui/Packages/Term/Ctj9q?t=2)
[![PkgEval](https://juliaci.github.io/NanosoldierReports/pkgeval_badges/T/Term.named.svg)](https://juliaci.github.io/NanosoldierReports/pkgeval_badges/T/Term.html)
[![Term.jl Downloads](https://img.shields.io/badge/dynamic/json?url=http%3A%2F%2Fjuliapkgstats.com%2Fapi%2Fv1%2Fmonthly_downloads%2FTerm&query=total_requests&suffix=%2Fmonth&label=Downloads)](http://juliapkgstats.com/pkg/Term)

![](readme.png)

(To see how the content in the image above was created, check: README.jl)
# Term

## Documentation & installation

🖥️  [Documentation](https://fedeclaudi.github.io/Term.jl) 



Install with:
```
julia> ]  # enters the pkg interface
pkg> add Term
```


### Supporting Term
If you like my work on Term so far and want to show support and help with Term's future development, please consider showing your support!

[![ko-fi](https://ko-fi.com/img/githubbutton_sm.svg)](https://ko-fi.com/C0C5E36Z2)

using Pkg
if !Base.get_bool_env("CI", false)
    Pkg.resolve(); Pkg.instantiate()
end
using Term, Documenter

DocMeta.setdocmeta!(Term, :DocTestSetup, :(using Term); recursive = true)

format = Documenter.HTML(;
    prettyurls = Base.get_bool_env("CI", false),
    canonical = "https://FedeClaudi.github.io/Term.jl",
    size_threshold = nothing,
    assets = String[],
    collapselevel = 1,
)

pages = [
    "Home" => "index.md",
    "Basics" => Any[
        "basics/basics.md",
        "basics/styled_text.md",
        "basics/colors_and_theme.md",
        "basics/renderables.md",
        "basics/tprint.md",
        "basics/console.md",
        "basics/prompt.md",
        "basics/markdown.md",
    ],
    "Renderables" => Any[
        "ren/intro.md",
        "ren/text.md",
        "ren/panel.md",
        "ren/table.md",
        "ren/layout_rens.md",
        "ren/annotation.md",
        "ren/dendogram.md",
        "ren/tree.md",
    ],
    "Layout" => Any[
        "layout/layout.md",
        "layout/nesting.md",
        "layout/stacking.md",
        "layout/justify.md",
        "layout/grid.md",
        "layout/compositor.md",
    ],
    "Advanced" => Any[
        "adv/adv.md",
        "adv/repr.md",
        "adv/progressbars.md",
        "adv/logging.md",
        "adv/errors_tracebacks.md",
        "adv/introspection.md",
    ],
    "Live" => [
        "live/intro.md",
        "live/app_intro.md",
        "live/widgets.md",
        "live/keyboard_input.md",
    ],
    "API" => Any[
        "api/api_term.md",
        "api/api_boxes.md",
        "api/api_colors.md",
        "api/api_console.md",
        "api/api_compositors.md",
        "api/api_dendograms.md",
        "api/api_errors.md",
        "api/api_grid.md",
        "api/api_introspection.md",
        "api/api_layout.md",
        "api/api_logs.md",
        "api/api_markdown.md",
        "api/api_measures.md",
        "api/api_panels.md",
        "api/api_renderables.md",
        "api/api_repr.md",
        "api/api_segments.md",
        "api/api_style.md",
        "api/api_tables.md",
        "api/api_tprint.md",
        "api/api_trees.md",
    ],
]

makedocs(;
    modules = [Term],
    authors = "FedeClaudi <federicoclaudi@protonmail.com> and contributors",
    repo = "https://github.com/FedeClaudi/Term.jl/blob/{commit}{path}#{line}",
    sitename = "Term.jl",
    warnonly = true,
    format,
    pages
)

deploydocs(; repo = "github.com/FedeClaudi/Term.jl.git")

module TermMarkdown

using Markdown
import OrderedCollections: OrderedDict

import UnicodeFun: to_latex

import Term:
    reshape_text,
    highlight_syntax,
    escape_brackets,
    default_width,
    TERM_THEME,
    reshape_code_string
import ..Tables: Table
import ..Style: apply_style
import ..Layout: pad, hLine, vLine
import ..Consoles: console_width
import ..Renderables: RenderableText
import ..Renderables
import ..Tprint: tprint, tprintln
import ..Tprint
import ..Panels: Panel
import ..Segments: Segment

export parse_md

# ---------------------------------------------------------------------------- #
#                                   PARSE MD                                   #
# ---------------------------------------------------------------------------- #

"""
    parse_md

Parse a Markdown element (Paragraph, List...) into a string.

A `width` keyword argument can be used to control the width of 
the string representation and an `inline` boolean argument specifies
when an element (e.g. a code snippet) is in-line within a larger element
(e.g. a paragraph).
"""
function parse_md end

parse_md(text::String) = parse_md(Markdown.parse(text))
parse_md(x; kwargs...)::String = string(x)

"""
    parse_md(text::Markdown.MD; kwargs...)::String

Parse an entier `MD` object by parsing its constituent elements
and joining the resulting strings.
"""
function parse_md(text::Markdown.MD; width = default_width(), kwargs...)::String
    elements = parse_md.(text.content; width = width, kwargs...)
    return join(elements, "\n\n")
end

"""
    parse_md(header::Markdown.Header{l}; width = console_width(), kwargs...) where {l}

Parse `Headers` with different style based on the level
"""
function parse_md(header::Markdown.Header{l}; width = default_width(), kwargs...) where {l}
    theme = TERM_THEME[]
    header_styles = Dict(
        1 => theme.md_h1,
        2 => theme.md_h2,
        3 => theme.md_h3,
        4 => theme.md_h4,
        5 => theme.md_h5,
        6 => theme.md_h6,
    )

    header_justify =
        Dict(1 => :center, 2 => :center, 3 => :center, 4 => :left, 5 => :left, 6 => :left)

    style = header_styles[l]
    header_text = chomp(join(map(ln -> "{$style}$ln{/$style}\n", header.text))) |> rstrip
    if l > 1
        header_text = reshape_text(header_text, width)
        return pad(header_text, width - 1, header_justify[l])
    else
        return string(
            Panel(
                header_text;
                box = :HEAVY,
                style = "dim",
                width = width - 8,
                justify = :center,
                padding = (2, 2, 0, 0),
                fit = false,
            ),
        )
    end
end

"""
    parse_md(paragraph::Markdown.Paragraph; width = console_width(), kwargs...)::String

Parse each element in a paragraph
"""
function parse_md(paragraph::Markdown.Paragraph; width = console_width(), kwargs...)::String
    out = join(parse_md.(paragraph.content; inline = true, width = width))
    return reshape_text(out, width) * "\e[0m"
end

parse_md(italic::Markdown.Italic; kwargs...)::String =
    join(map(ln -> "{italic}$(ln){/italic}", italic.text))

parse_md(bold::Markdown.Bold; kwargs...)::String =
    join(map(ln -> "{bold}$(ln){/bold}", bold.text))

parse_md(lb::Markdown.LineBreak; kwargs...)::String = "\n"

"""
---
    function parse_md(
        ltx::Markdown.LaTeX;
        inline = false,
        width = console_width(),
        kwargs...,
    )::String

Parse a math element.
Try to convert it to unicode characters when possible,
otherwise output the latex string.
"""
function parse_md(
    ltx::Markdown.LaTeX;
    inline = false,
    width = console_width(),
    kwargs...,
)::String
    formula = ""
    try
        formula = escape_brackets(to_latex(escape_string(string(ltx.formula))))
    catch
        formula = string(ltx.formula)
    end

    theme = TERM_THEME[]
    if inline
        return "{$(theme.md_latex)}" * formula * "{/$(theme.md_latex)}"
    else
        txt = "\n     {$(theme.md_latex)}" * formula * "{/$(theme.md_latex)}\n"
        return reshape_text(txt, width) * "\e[0m"
    end
end

"""
---
    function parse_md(
        code::Markdown.Code;
        width = console_width(),
        inline = false,
        kwargs...,
    )::String

Parse a code snippet with syntax highlighting (for Julia code).

For non-inline code snippets the code is put in a panel
with different background coloring to make it stand out.
"""
function parse_md(
    code::Markdown.Code;
    width = console_width(),
    inline = false,
    lpad = true,
    kwargs...,
)::String
    syntax = reshape_code_string(highlight_syntax(code.code), width - 20)
    theme = TERM_THEME[]
    if inline
        return "{$(theme.md_code)}`$(code.language){/$(theme.md_code)}" *
               syntax *
               "{$(theme.md_code)}`{/$(theme.md_code)}"
    else
        panel = Panel(
            RenderableText(syntax; style = "on_$(theme.md_codeblock_bg)");
            style = "white on_$(theme.md_codeblock_bg)",
            box = :SQUARE,
            subtitle = length(code.language) > 0 ? code.language : nothing,
            width = width - 12,
            background = "on_$(theme.md_codeblock_bg)",
            subtitle_justify = :right,
            fit = false,
        )

        return if lpad
            string("    " * panel)
        else
            string(panel)
        end
    end
end

"""
    function parse_md(
        qt::Markdown.BlockQuote;
        width = default_width(),
        kwargs...,
    )::String

Style a BlockQuote with a line and a quotation marker.
"""
function parse_md(qt::Markdown.BlockQuote; width = default_width() - 1, kwargs...)::String
    content = parse_md.(qt.content; inline = true)
    content = length(content) > 1 ? join(content) : content[1]
    # content = reshape_text(content, width-1)
    theme = TERM_THEME[]
    content =
        "{$(theme.text_accent)}“{/$(theme.text_accent)}" *
        content *
        "{$(theme.text_accent)}”{/$(theme.text_accent)}\e[0m"

    content = RenderableText(content; width = width - 5)
    line =
        content.measure.h > 1 ?
        (
            "{$(theme.md_quote)}>{/$(theme.md_quote)}" /
            vLine(content.measure.h - 1; style = "$(theme.md_quote) dim", box = :HEAVY)
        ) : "{$(theme.md_quote)}>{/$(theme.md_quote)}"
    string("  " * line * " " * content)
end

parse_md(hl::Markdown.HorizontalRule; width = default_width(), kwargs...)::String =
    string(hLine(width - 1; style = "dim", box = :HEAVY))

"""
    function parse_md(
        list::Markdown.List;
        width = console_width(),
        inline = false,
        space = "",
    )::String

Parse a list and all its elements, for both numbered and unnumbered lists.
"""
function parse_md(
    list::Markdown.List;
    width = console_width(),
    inline = false,
    space = "",
)::String
    theme = TERM_THEME[]
    list_elements = []
    for item in list.items
        push!(list_elements, join(parse_md.(item)))
    end

    rendered = ""
    for (i, item) in enumerate(list.items)
        bullet = if Markdown.isordered(list)
            "$space{bold}" * "  $(i + list.ordered - 1). " * "{/bold}"
        else
            "$space{$(theme.text_accent)}" * "  • " * "{/$(theme.text_accent)}"
        end

        item_content = map(
            elem ->
                elem isa Markdown.List ? "\n" * parse_md(elem; space = "   ") :
                parse_md(elem; inline = true),
            item,
        )
        item_content = length(item_content) > 1 ? join(item_content) : item_content[1]
        rendered *= bullet * item_content * "\n"
    end
    return reshape_text(rendered, width)
end

function parse_md(img::Markdown.Image; kwargs...)::String
    "{dim} 🌄 image: {/dim}" * img.alt * " {dim}| at: " * img.url * "{/dim}"
end

"""
    parse_md(note::Markdown.Footnote; width = console_width(), inline = false)

Style a footnote differently based on if they are a renference to it or its content.
"""
function parse_md(note::Markdown.Footnote; width = console_width(), inline = false)
    theme = TERM_THEME[]
    if isnothing(note.text)
        return id = "{$(theme.md_footnote)}[$(note.id)]{/$(theme.md_footnote)}"
    else
        id =
            (inline ? "\n" : "") *
            "{$(theme.md_footnote)}[$(note.id)]{/$(theme.md_footnote)}"
        content = parse_md.(note.text)
        return if length(content) == 1
            string(RenderableText("$id: " * content[1]; width = width))
        else
            string(RenderableText("$id:\n" * join(content); width = width))
        end
    end
end

function parse_md(content::Vector; kwargs...)::String
    content = parse_md.(content; kwargs...)
    return if length(content) == 1
        content[1]
    else
        join(content)
    end
end

"""
    function parse_md(tb::Markdown.Table; width = console_width())::String

Convert a markdown Table to a `Table` renderable.
"""
function parse_md(tb::Markdown.Table; width = console_width())::String
    just = Dict(:l => :left, :r => :right, :c => :center)
    header = parse_md.(tb.rows[1])
    table_content = OrderedDict(
        header[i] => [parse_md(r[i]; inline = true) for r in tb.rows[2:end]] for
        i in 1:length(header)
    )

    return string(
        pad(
            Table(
                table_content;
                columns_justify = [just[j] for j in tb.align],
                box = :ROUNDED,
                header_style = TERM_THEME[].md_table_header,
                style = "dim",
            );
            width = width - 8,
        ),
    )
end

parse_md(link::Markdown.Link; kwargs...)::String =
    "{white bold}$(parse_md(link.text; inline=true)){/white bold} {dim}($(link.url)){/dim}"

"""
    function parse_md(ad::Markdown.Admonition; width = console_width(), kwargs...)::String

Parse adomitions and style them with colored `Panel` renderables.
"""
function parse_md(ad::Markdown.Admonition; width = console_width(), kwargs...)::String
    theme = TERM_THEME[]
    title_styles = Dict(
        "note" => theme.md_admonition_note,
        "info" => theme.md_admonition_info,
        "warning" => theme.md_admonition_warning,
        "danger" => theme.md_admonition_danger,
        "tip" => theme.md_admonition_tip,
    )
    has_title = length(ad.title) > 0
    content = parse_md(ad.content; inline = true)
    content = reshape_text(content, width - 10)
    style = get(title_styles, ad.category, theme.text)
    return string(
        "    " * Panel(
            content;
            title = has_title ? parse_md(ad.title) : "",
            title_style = has_title ? style * " default" : "",
            style = style * " dim",
            width = width - 8,
            fit = false,
        ),
    )
end

# ---------------------------------------------------------------------------- #
#                              RENDERABLE & TPRINT                             #
# ---------------------------------------------------------------------------- #

"""
---
    RenderableText(md::Markdown.MD; width = console_width() - 2, kwargs...)

Create a `RenderableText` from a markdown string.
"""
Renderables.RenderableText(md::Markdown.MD; width = console_width() - 2, kwargs...) =
    RenderableText(parse_md(md; width = width); width = width, kwargs...)

"""
---
    tprint(md::Markdown.MD; kwargs...)

Print a parsed markdown string.
"""
Tprint.tprint(md::Markdown.MD; kwargs...) = tprint(parse_md(md); kwargs...)
Tprint.tprint(io::IO, md::Markdown.MD; kwargs...) = tprint(io, parse_md(md); kwargs...)

"""
---
    tprintln(md::Markdown.MD; kwargs...)

Print a parsed markdown string.
"""
Tprint.tprintln(md::Markdown.MD; kwargs...) = tprintln(parse_md(md); kwargs...)
Tprint.tprintln(io::IO, md::Markdown.MD; kwargs...) = tprintln(io, parse_md(md); kwargs...)
end

"""
This example shows how to create a small app. 

We'll build a "color picker": the use can input three 
numeric values for RGB and the resulting color gets displayed.
A button lets users select a random color. 

The app is made of a "panel" showing the color, three InputBox
to capture the RGB values and a button. 
These are the steps:

1. define layout
2. create widgets
3. create transition rules to shift focus between the widgets
"""

using Term
using Term.LiveWidgets
using Term.Consoles
import Term.LiveWidgets:
    AbstractWidget, KeyInput, ArrowRight, ArrowLeft, ArrowUp, ArrowDown, set_active
import OrderedCollections: OrderedDict
import Term: apply_style
using Term.Compositors

# ------------------------------- app elements ------------------------------- #
# create some widgets
rgb_visualizer = TextWidget("")

R = InputBox(title = "R value", style = "red", title_justify = :center)
G = InputBox(title = "G value", style = "green", title_justify = :center)
B = InputBox(title = "B value", style = "blue", title_justify = :center)

button = Button("random"; color = "light_slate_grey", text_color = "white")

widgets = OrderedDict{Symbol,AbstractWidget}(
    :A => rgb_visualizer,
    :R => R,
    :G => G,
    :B => B,
    :b => button,
)

# --------------------------------- functions -------------------------------- #
function get_color(ib::InputBox)
    text = something(ib.input_text, "0")
    text == "" && (text = "0")

    color = try
        parse(Int, text)
    catch
        error("Failed to parse $text as a color")
    end
    return color
end

# define a callback function to update rgb_visalizer at each frame
function update_visualizer(app::App)
    r = get_color(app.widgets[:R])
    g = get_color(app.widgets[:G])
    b = get_color(app.widgets[:B])

    viz = app.widgets[:A]

    viz.text =
        "(r:$r, g:$g, b:$b)" / apply_style(
            join(
                repeat([" "^(viz.internals.measure.w - 4)], viz.internals.measure.h),
                "\n",
            ),
            "on_($r, $g, $b)",
        )
end

function set_random_color(::Button)
    app.widgets[:R].input_text = string(rand(0:255))
    app.widgets[:G].input_text = string(rand(0:255))
    app.widgets[:B].input_text = string(rand(0:255))
end

# ------------------------------------ run ----------------------------------- #
# create app and visualize
layout = :(A(22, 0.4) * (R(6, 0.6) / G(6, 0.6) / B(6, 0.6) / b(4, 0.6)))
app = App(layout; widgets = widgets, on_draw = update_visualizer)

button.callback = set_random_color

play(app);

# TODO on highlight stuff

nothing

import Term: reshape_text, tprintln
import Term.Consoles: clear

strings = [
    # latin alphabet
    "Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.",
    "Lorem {red}ipsum dolor sit {underline}amet, consectetur{/underline} adipiscing elit, {/red}{blue}sed do eiusmod tempor incididunt{/blue} ut labore et dolore magna aliqua.",
    "Lorem{red}ipsumdolorsit{underline}amet, consectetur{/underline} adipiscing elit, {/red}seddoeiusmo{blue}dtemporincididunt{/blue}ut labore et dolore magna aliqua.",

    # thai
    "ต้าอ่วยวาทกรรมอาว์เซี้ยว กระดี๊กระด๊า ช็อปซาดิสต์โมจิดีพาร์ตเมนต์ อินดอร์วิว สี่แยกมาร์กจ๊อกกี้ โซนี่บัตเตอร์ฮันนีมูน ยาวีแพลนหงวนสคริปต์ แจ็กพ็อตต่อรองโทรโข่งยากูซ่ารุมบ้า บอมบ์เบอร์รีวีเจดีพาร์ทเมนท์ บอยคอตต์เฟอร์รี่บึมมาราธอน ",
    "ต้าอ่วยวาท{red}กรรมอาว์เซี้ยว กระดี๊กระด๊า {/red}ช็อปซาดิสต์โมจิดีพาร์ตเม{blue underline}นต์ อินดอร์วิว สี่แยกมาร์กจ๊อกกี้ โซนี่บัตเต{/blue underline}อร์ฮันนีมูน ยาวีแพลนหงวนสคริปต์ แจ็กพ็อตต่อรองโทรโข่งยากูซ่ารุมบ้า บอมบ์เบอร์รีวีเจดีพาร์ทเมนท์ บอยคอตต์เฟอร์รี่บึมมาราธอน ",

    # # korean
    "국가유공자·상이군경 및 전몰군경의 유가족은 법률이 정하는 바에 의하여",
    "국{red}가유공자·상이군{bold}경 및 전{/bold}몰군경의 유{/red}가족은 법률이 정하는 바에 의하여",

    # # large chars
    "┌────────────────┬────────────────┬────────────────┬────────────────┬──────────────",
    "┌────────────abcde────┬──────────── ────┬────────abcde fghi────────┬────────────────┬──────────────",
    "┌─────────{red}───ab{/red}cde────┬──────{green}────── ────┬────────abcde fghi{/green}────────┬────────────────┬──────────────",
    "┌──────────{red}────{/red}──┬{blue bold}────────────────┬{/blue bold}──────────────┬────────────────┬──────────────end",

    # nospaces
    "."^100,
    ".{red}|||{/red}...."^10,
    ".|||...."^10,
    replace(
        """
Lorem ipsum {bold}dolor sit{/bold} amet, consectetur adipiscing elit,
ed do e{red}iusmod tempor incididunt{/red} ut {bold}labore et {underline}dolore{/underline} magna aliqua.{/bold} Ut enim ad minim
veniam, quis{green} nostrud exercitation {on_black}ullamco laboris nisi ut aliquip ex {/on_black}
ea commodo consequat.{blue} Duis aute irure dolor in{/blue} reprehenderit 
in voluptate velit{/green} esse {italic}cillum dolore{/italic}{red} eu{/red}{italic green} fugiat {/italic green}nulla 
pariatur. Excepteur{red} sint{/red}{blue} occaecat cupidatat {/blue}non proident, 
sunt in culpa qui {italic}officia{/italic} deserunt mollit anim 
id est laborum.""",
        "\n" => "",
    ),
]

print("\n"^3)
width = 33
for text in strings
    # println('_'^width)
    # println(reshape_text(text, width))

    print("\n\n")
    println("\e[0m" * '_'^width)
    tprintln(reshape_text(text, width) * Panel(; height = 10, width = 10))
    println("\e[0m" * '_'^width)
end

# text = strings[end]

# println('_'^width)
# println(reshape_text(text, width))
# println(text)

using Term
using Term.LiveWidgets
using Term.Compositors
import Term.LiveWidgets: Esc, quit, ArrowLeft, ArrowDown, ArrowRight, ArrowUp
import Term.Style: apply_style

"""
More advanced example of how to build a function with 
a bunch of additional functionality and customization
compared to usual usage.

The app allows the user to play tic tac toe and to read 
some instructions about the game. The tic tac toe "gameborad"
is made of cells. These cells gets highlighted when activated 
and the user can choose to place an X or an O in the cell.
"""

# set layout with cells' 3x3 grid and a pager by the side
h = 9
h2 = 3 * h - 1
layout = :(
    (
        (A($h, 0.15) * B($h, 0.15) * C($h, 0.15)) /
            (D($h, 0.15) * E($h, 0.15) * F($h, 0.15)) /
            (G($h, 0.15) * H($h, 0.15) * I($h, 0.15))
    ) * Z($h2, 0.55)
)

"""
The board's cells are TextWidgets, define some function
to change the widget's text when the user draws and x or a o.
"""

"""
write a X made of multiple line of characters
"""
x = RenderableText(
    """xx    xx
     xx  xx
      xxxx
      xxxx
     xx  xx
    xx    xx""";
    style = "red",
) |> string |> rstrip

o = RenderableText(
    """  oooooo
     oo    oo
    oo      oo
    oo      oo
     oo    oo
      oooooo""";
    style = "blue",
) |> string |> rstrip

""" set widget's text"""
set_text(widget, text) =
if text == 'x'
    widget.text = x
else
    widget.text = o
end

"""
Define some functions to show when a cell is highlighted
"""

function on_cell_highlighted(cell)
    return cell.panel_kwargs[:style] = "whie on_gray23"
end

function on_cell_not_highlighted(cell)
    return cell.panel_kwargs[:style] = "dim"
end

"""
Define keyboard controls
"""

button_controls = Dict('x' => set_text, 'o' => set_text, 'q' => quit, Esc() => quit)

"""
Create a widget for each cell
"""

widgets = Dict{Symbol, Any}(
    map(
        c ->
        c => TextWidget(
            "";
            controls = button_controls,
            as_panel = true,
            on_activated = on_cell_highlighted,
            on_deactivated = on_cell_not_highlighted,
            padding = (1, 0, 0, 0),
            justify = :center,
            style = "dim",
        ),
        (:A, :B, :C, :D, :E, :F, :G, :H, :I),
    )...,
)

widgets[:Z] = Pager(
    """
    Tic-tac-toe, also known as noughts and crosses, 
    is a simple two-player game that has been enjoyed
    by people of all ages for many years. The game 
    is played on a 3x3 grid, typically made up of 
    a pencil and paper or a game board. Each player
    takes turns placing their symbol (an "X" or an "O") on
    the grid, with the goal of getting three of their
     symbols in a row, either horizontally, 
     vertically, or diagonally.

    The origins of tic-tac-toe are uncertain, but it 
    is believed to have originated in ancient Egypt,
    Greece, or Roman times. The game has been played 
    in various forms throughout history and has been known
    by different names in different cultures. The game 
    was known as "tic-tac-toe" in the United States in the
    early 20th century, and it became popular in the 1930s. 
    The name "tic-tac-toe" is thought to have come from the 
    sound that people made when they made the X or O marks on the game board.

    Tic-tac-toe is a simple game that can be played by people
    of all ages and skill levels, making it a popular pastime 
    for families and friends. The game is often used as a tool
    for teaching basic strategic thinking and problem-solving
    skills to children. It is also a popular game 
    to play in the classroom as an educational tool.

    In the 20th century, tic-tac-toe was adopted as a game 
    for computers, and the first computer game of tic-tac-toe 
    was developed in 1952. Since then, it has been used as 
    a benchmark problem for artificial intelligence research 
    and has been widely used to teach computer science 
    students the basics of game theory and artificial intelligence.

    Tic-tac-toe has evolved over time, and it's now possible to 
    play it on smartphones, tablets, and computers. There are also 
    many variations of the game, such as 3D tic-tac-toe, and 
    games that use a larger grid or more symbols.

    In conclusion, Tic-tac-toe is a simple but challenging 
    game that has been enjoyed by people for centuries. It's a 
    game that's easy to learn but difficult to master, making it 
    a popular pastime for families and friends. The game's simplicity 
    has also made it a popular educational tool and a benchmark 
    åproblem for artificial intelligence research.
    """
)

"""
Define a custom set of transition rules
to specify how to move between cells
using keyboard controls.
"""

transition_rules = Dict(
    ArrowDown() => Dict(:A => :D, :B => :E, :C => :F, :D => :G, :E => :H, :F => :I),
    ArrowUp() => Dict(:D => :A, :E => :B, :F => :C, :G => :D, :H => :E, :I => :F),
    ArrowRight() => Dict(
        :A => :B,
        :B => :C,
        :D => :E,
        :E => :F,
        :G => :H,
        :H => :I,
        :C => :Z,
        :F => :Z,
        :I => :Z,
    ),
    ArrowLeft() =>
        Dict(:B => :A, :C => :B, :E => :D, :F => :E, :H => :G, :I => :H, :Z => :A),
)

app = App(layout; widgets = widgets, transition_rules = transition_rules)
play(app; transient = false);

nothing

using Highlights.Tokens, Highlights.Themes
import Markdown: @md_str
using MyterialColors

import Parameters: @with_kw

"""
    Theme

Stores colors for different semantically relevant items, used to 
style outputs to terminal.
"""
@with_kw mutable struct Theme
    name::String = "default"

    # syntax
    docstring::String      = green_dark
    string::String         = "#64b565"
    type::String           = purple_light
    code::String           = yellow
    multiline_code::String = yellow
    symbol::String         = orange
    expression::String     = amber
    number::String         = blue_light
    operator::String       = red
    func::String           = "#f2d777"
    link::String           = "underline $(light_blue_light)"

    # misc
    text::String           = "default"
    text_accent::String    = "white"
    emphasis::String       = "$blue  bold"
    emphasis_light::String = yellow_light
    line::String           = "default" # used by Panel,  hLine, vLine
    box::Symbol            = :ROUNDED  # used by Panel,  hLine, vLine

    # logging 
    info::String   = "#7cb0cf"
    debug::String  = "#197fbd"
    warn::String   = orange
    error::String  = "bold #d13f3f"
    logmsg::String = "#8abeff"

    # tree 
    tree_mid::String         = blue
    tree_terminator::String  = blue
    tree_skip::String        = blue
    tree_dash::String        = blue
    tree_trunc::String       = blue
    tree_pair::String        = red_light
    tree_keys::String        = yellow
    tree_title::String       = "bold " * orange
    tree_max_leaf_width::Int = 44

    # repr
    repr_accent::String      = "bold #e0db79"
    repr_name::String        = "#e3ac8d"
    repr_type::String        = "#bb86db"
    repr_values::String      = "#b3d4ff"
    repr_line::String        = "dim #7e9dd9"
    repr_panel::String       = "#9bb3e0"
    repr_array_panel::String = "dim yellow"
    repr_array_title::String = "dim bright_blue"
    repr_array_text::String  = "bright_blue"

    # errors
    err_accent::String        = pink
    er_bt::String             = "#ff8a4f"
    err_btframe_panel::String = "#9bb3e0"
    err_filepath::String      = "grey62"
    err_errmsg                = "red"

    # introspection
    inspect_highlight::String = pink_light
    inspect_accent::String    = pink

    # progress
    progress_accent::String              = pink
    progress_elapsedcol_default::String  = purple_light
    progress_etacol_default::String      = teal
    progress_spiner_default::String      = "bold blue"
    progress_spinnerdone_default::String = "green bold"

    # dendogram
    dendo_title            = salmon_light
    dendo_pretitle::String = blue_grey_light
    dendo_leaves::String   = blue_grey_light
    dendo_lines::String    = "$blue_light dim bold"

    # markdown
    md_h1::String                 = "bold $indigo_light"
    md_h2::String                 = "bold $blue underline"
    md_h3::String                 = "bold $blue"
    md_h4::String                 = "bold $light_blue"
    md_h5::String                 = "bold $cyan_light"
    md_h6::String                 = "bold $cyan_lighter"
    md_latex::String              = "$yellow_light italic"
    md_code::String               = "$yellow_light italic"
    md_codeblock_bg::String       = "#202020"
    md_quote::String              = "#5a74f2"
    md_footnote::String           = "#9aacdb"
    md_table_header::String       = "bold yellow"
    md_admonition_note::String    = "blue"
    md_admonition_info::String    = "blue"
    md_admonition_warning::String = yellow_light
    md_admonition_danger::String  = "red"
    md_admonition_tip::String     = "green"

    # table
    tb_style::String   = "#9bb3e0"
    tb_header::String  = "bold white"
    tb_columns::String = "default"
    tb_footer::String  = "default"
    tb_box::Symbol     = :MINIMAL_HEAVY_HEAD

    # prompt
    prompt_text::String           = blue
    prompt_default_option::String = "underline bold $green"
    prompt_options::String        = "default"

    # annotations
    annotation_color::String = blue_light
end

(t::Theme)(::Function) = t.func
(t::Theme)(::Number) = t.number
(t::Theme)(::Union{UnionAll,DataType}) = t.type
(t::Theme)(::Symbol) = t.symbol
(t::Theme)(::Expr) = t.expression
(t::Theme)(::AbstractVector) = t.number
(t::Theme)(::Any) = t.text

# ---------------------------------- themes ---------------------------------- #
DarkTheme = Theme(name = "dark")

LightTheme = Theme(
    name = "light",

    # syntax
    docstring      = green_dark,
    string         = "#64b565",
    type           = purple_dark,
    code           = yellow_darker,
    multiline_code = yellow_darker,
    symbol         = orange,
    expression     = amber,
    number         = blue_dark,
    operator       = red,
    func           = yellow_darker,

    # misc
    text           = "default",
    text_accent    = grey_dark,
    emphasis       = "$blue  bold",
    emphasis_light = yellow_dark,
    line           = "default",

    # logging 
    info   = "#7cb0cf",
    debug  = "#197fbd",
    warn   = orange,
    error  = "bold #d13f3f",
    logmsg = "#8abeff",

    # tree 
    tree_mid = blue_darker,
    tree_terminator = blue_darker,
    tree_skip = blue_darker,
    tree_dash = blue_darker,
    tree_trunc = blue_darker,
    tree_pair = red_light,
    tree_keys = red_dark,
    tree_max_leaf_width = 44,

    # repr
    repr_accent      = "bold $yellow_darker",
    repr_name        = yellow_darker,
    repr_type        = purple_darker,
    repr_values      = indigo_darker,
    repr_line        = "dim $indigo_dark",
    repr_panel       = "black",
    repr_array_panel = "dim $yellow_darker",
    repr_array_title = "dim $blue_dark",
    repr_array_text  = "$blue_dark",

    # errors
    err_accent        = pink_darker,
    er_bt             = "#ff8a4f",
    err_btframe_panel = "#9bb3e0",
    err_filepath      = "grey62",
    err_errmsg        = "red",

    # introspection
    inspect_highlight = pink_dark,
    inspect_accent    = pink,

    # progress
    progress_accent              = pink_darker,
    progress_elapsedcol_default  = purple_dark,
    progress_etacol_default      = teal_darker,
    progress_spiner_default      = "bold $blue_dark",
    progress_spinnerdone_default = "$green_dark bold",

    # dendogram
    dendo_title    = salmon_dark,
    dendo_pretitle = blue_grey_dark,
    dendo_leaves   = blue_grey_dark,
    dendo_lines    = "$blue_dark dim bold",

    # markdown
    md_h1                 = "bold $indigo_dark",
    md_h2                 = "bold $blue underline",
    md_h3                 = "bold $blue",
    md_h4                 = "bold $indigo_dark",
    md_h5                 = "bold $cyan_dark",
    md_h6                 = "bold $cyan_darker",
    md_latex              = "$yellow_dark italic",
    md_code               = "$yellow_dark italic",
    md_codeblock_bg       = "#262626",
    md_quote              = "#5a74f2",
    md_footnote           = "#9aacdb",
    md_table_header       = "bold yellow",
    md_admonition_note    = "blue",
    md_admonition_info    = "blue",
    md_admonition_warning = yellow_dark,
    md_admonition_danger  = "red",
    md_admonition_tip     = "green",

    # table
    tb_style   = grey_darker,
    tb_header  = "bold black",
    tb_columns = "black",
    tb_footer  = "black",
)

# ---------------------------------- display --------------------------------- #

function Base.show(io::IO, ::MIME"text/plain", theme::Theme)
    fields = fieldnames(Theme)
    N = length(fields)
    values = map(f -> getfield(theme, f), fields)

    fields = map(v -> if v[2] isa String
        RenderableText(string(v[1]); style = v[2])
    else
        RenderableText(string(v[1]))
    end, zip(fields, values))

    values = map(
        v -> v isa String ? RenderableText("■■"; style = v) : RenderableText(string(v)),
        values,
    )

    content = rvstack(values) * Spacer(1, 2) * lvstack(fields)

    return print(
        io,
        Panel(
            content;
            width = 66,
            justify = :center,
            title = "Theme: {bold}$(theme.name){/bold}",
            padding = (4, 4, 1, 1),
            style = "#9bb3e0",
            title_style = "white",
        ),
    )
end

set_theme(theme::Theme) = (TERM_THEME[] = theme)

function demo_theme(theme::Theme = TERM_THEME[])
    # change theme
    currtheme = TERM_THEME[]
    set_theme(theme)

    # ------------------------------- prepare data ------------------------------- #
    markdow_text = md"""
    # Header lvl 1
    ##  Header lvl two
    ###  Header lvl three
    ####  Header lvl four
    #####  Header lvl five
    ######  Header lvl six

    ---
    ### Math
    ```math
    f(a) = \frac{1}{2\pi}\int_{0}^{2\pi} (\alpha+R\cos(\theta))d\theta
    ```
    .

    ### Code

    ```julia
    function say_hi(x)
        print("Hellow World")
    end
    ```

     ### Quotes
     > Multi line quote

      
    ### Admonitions
    !!! note
        note admonition

    !!! warning
        warning admonition

    !!! danger
        danger admonition

    !!! tip
        tip admonition

    ### Tables
    | Term | handles | tables|
    |:---------- | ---------- |:------------:|
    | Row `1`    | Column `2` |              |
    | *Row* 2    | **Row** 2  | Column ``3`` |

    """

    tree_dict = Dict(
        "nested" => Dict("n1" => 1, "n2" => 2),
        "leaf2" => 2,
        "leaf" => 2,
        "leafme" => "v",
        "canopy" => "test",
    )

    t = 1:5
    table_data = hcat(t, ones(length(t)), rand(Int8, length(t)))

    # ---------------------------------- display --------------------------------- #
    hLine("Renderables") |> println
    Panel() |> println

    hLine("logging") |> println
    @info "info logging" √9
    @debug "debug logging"
    @warn "warn logging"
    @error "error logging"

    hLine("Tree") |> println
    Tree(tree_dict) |> println

    hLine("Dendogram") |> println
    Dendogram("awesome", "this", :is, "a", "dendogram!") |> println

    hLine("Table") |> println
    Table(table_data; header = ["Num", "Const.", "Values"]) |> println

    hLine("Term show") |> println
    termshow(collect(t))
    termshow(rand(5, 5))
    termshow(tree_dict)

    # hLine("Markdown") |> println
    # tprintln(markdow_text)

    # reset theme
    set_theme(currtheme)
    nothing
end

# ------------------------------ Highlighters.jl ----------------------------- #

"""
Custom hilighting theme for Highlighters.jl
https://juliadocs.github.io/Highlights.jl/stable/man/theme/
"""
abstract type CodeTheme <: AbstractTheme end

@theme CodeTheme Dict(
    :style => S"",
    :tokens => Dict(
        TEXT => S"fg: dedede;",

        # yellow
        NAME_FUNCTION => S"fg: e8d472;",
        NAME_OTHER => S"fg: e8d472;",

        # red
        KEYWORD => S"fg: 7a93f5;",
        OPERATOR => S"fg: de6d59;",
        PUNCTUATION => S"fg: e38864",

        # green
        STRING => S"fg: 50ad5f",
        COMMENT => S"fg: 287a36; italic",
        STRING_DOC => S"fg: 50ad5f",

        # blue
        NUMBER => S"fg: 90CAF9",
    ),
)

module Tables

import Tables as TablesPkg

import Term: do_by_line, fillin, str_trunc, TERM_THEME

import ..Renderables: AbstractRenderable, RenderableText
import ..Layout: cvstack, hstack, vstack, pad, vLine, vertical_pad
import ..Measures: Measure, width, height
import ..Style: apply_style
import ..Segments: Segment
import ..Tprint: tprintln
using ..Boxes

export Table

theme = TERM_THEME[]
include("_tables.jl")

"""
    Table

A Table renderable.

# Examples
```julia

t = 1:3
data = hcat(t, rand(Int8, length(t)))
Table(data)

┌───────────┬───────────┐
│  Column1  │  Column2  │
├───────────┼───────────┤
│     1     │    -95    │
├───────────┼───────────┤
│     2     │    -85    │
├───────────┼───────────┤
│     3     │    115    │
└───────────┴───────────┘
```
"""
mutable struct Table <: AbstractRenderable
    segments::Vector{Segment}
    measure::Measure
end

"""
    Table(
        tb::TablesPkg.AbstractColumns;
        box::Symbol = :SQUARE,
        style::String = "default",
        hpad::Union{Vector,Int} = 2,
        vpad::Union{Vector,Int} = 0,
        vertical_justify::Symbol = :center,
        show_header::Bool = true,
        header::Union{Nothing,Vector,Tuple} = nothing,
        header_style::Union{String,Vector,Tuple} = "default",
        header_justify::Union{Nothing,Symbol,Vector,Tuple} = nothing,
        columns_style::Union{String,Vector,Tuple} = "default",
        columns_justify::Union{Symbol,Vector,Tuple} = :center,
        columns_widths::Union{Nothing,Int,Vector} = nothing,
        footer::Union{Function,Nothing,Vector,Tuple} = nothing,
        footer_style::Union{String,Vector,Tuple} = "default",
        footer_justify::Union{Nothing,Symbol,Vector,Tuple} = :center,
        compact::Bool = false,
    )

Generic constructor for a Table renderable.

!!! tip
    Arguments such as `header_style`, `columns_style` and `footer_style` can 
    either be passed a single value, which will be applied to all columns, or
    a vector of values, which will be applied to each column.
"""
function Table(
    tb::TablesPkg.AbstractColumns;
    box::Symbol = TERM_THEME[].tb_box,
    style::String = TERM_THEME[].tb_style,
    hpad::Union{Vector,Int} = 2,
    vpad::Union{Vector,Int} = 0,
    vertical_justify::Symbol = :center,
    show_header::Bool = true,
    header::Union{Nothing,Vector,Tuple} = nothing,
    header_style::Union{String,Vector,Tuple} = TERM_THEME[].tb_header,
    header_justify::Union{Nothing,Symbol,Vector,Tuple} = nothing,
    columns_style::Union{String,Vector,Tuple} = TERM_THEME[].tb_columns,
    columns_justify::Union{Symbol,Vector,Tuple} = :center,
    columns_widths::Union{Nothing,Int,Vector} = nothing,
    footer::Union{Function,Nothing,Vector,Tuple} = nothing,
    footer_style::Union{String,Vector,Tuple} = TERM_THEME[].tb_footer,
    footer_justify::Union{Nothing,Symbol,Vector,Tuple} = :center,
    compact::Bool = false,
)

    # prepare some variables
    header_justify = something(header_justify, columns_justify)
    box = BOXES[box]

    # table info
    rows = TablesPkg.rows(tb)
    sch = TablesPkg.schema(rows)
    N_cols = length(sch.names)
    N_rows = length(rows) + 2

    # make sure arguemnts combination is valud
    assert_table_arguments(
        N_cols,
        N_rows,
        show_header,
        header,
        header_style,
        header_justify,
        columns_style,
        columns_justify,
        columns_widths,
        footer,
        footer_style,
        footer_justify,
        hpad,
        vpad,
    ) || return nothing

    # columns style
    columns_style, columns_justify, hpad =
        expand.([columns_style, columns_justify, hpad], N_cols)
    vpad = expand(vpad, N_rows)

    # headers and headers style
    if show_header
        header = isnothing(header) ? string.(sch.names) : header
        header_style, header_justify = expand.([header_style, header_justify], N_cols)
    end

    # get footer (if it's a function)
    if footer isa Function
        try
            footer_entries = footer.(map(c -> tb[c], sch.names))
            footer = string(footer) * ": " .* string.(footer_entries)
        catch
            @warn "Could not apply function $footer to table - types mismatch?"
            footer = fill("couldn't apply", N_cols)
        end
    end

    # get the max-width of each column
    widths = calc_columns_widths(
        N_cols,
        N_rows,
        columns_widths,
        show_header,
        header,
        tb,
        sch,
        footer,
        hpad,
    )

    # get the table values as vectors of strings
    rows_values = []
    for row in rows
        _row::Vector = []
        TablesPkg.eachcolumn(sch, row) do val, i, nm
            push!(_row, val isa AbstractRenderable ? val : string(val))
        end
        push!(rows_values, _row)
    end

    # get the height of each row
    heights = rows_heights(N_rows, show_header, header, rows_values, footer, vpad)
    # @info "sizes" widths heights  tb sch

    # ----------------------------- create table rows ---------------------------- #
    nrows = length(rows_values)
    lines::Vector{String} = []
    # @info "creating table" heights widths

    # create a row for the header
    show_header && push!(
        lines,
        table_row(
            make_row_cells(
                header,
                header_style,
                header_justify,
                widths,
                hpad,
                heights[1],
                vertical_justify,
            ),
            widths,
            box,
            :top,
            :head,
            :head_row,
            style,
            heights[1];
            # compact = true
        ),
    )

    # add one row at the time
    for (l, row) in enumerate(rows_values)
        # get the row's content
        I = l + 1
        row = make_row_cells(
            row,
            columns_style,
            columns_justify,
            widths,
            hpad,
            heights[I],
            vertical_justify,
        )

        # prep row params based on line number, header etc...
        if l == 1 && show_header
            bottom = if nrows < 2
                :bottom
            elseif nrows > 2
                :row
            else
                :foot_row
            end
            top = show_header ? nothing : :top
            mid = :mid
            _compact = (show_header && (box != BOXES[:NONE])) ? false : compact

            # add additional rows
        elseif l == nrows
            top, mid, bottom, _compact =
                nothing, :mid, isnothing(footer) ? :bottom : :foot_row, false
        else
            top, mid, bottom, _compact = nothing, :mid, :row, compact
        end

        # add it in
        push!(
            lines,
            table_row(
                row,
                widths,
                box,
                top,
                mid,
                bottom,
                style,
                heights[I];
                compact = _compact,
            ),
        )
    end

    # add footer
    if !isnothing(footer)
        # get footer style
        footer_justify = something(footer_justify, columns_justify)
        footer_style, footer_justify = expand.([footer_style, footer_justify], N_cols)

        push!(
            lines,
            table_row(
                make_row_cells(
                    footer,
                    footer_style,
                    footer_justify,
                    widths,
                    hpad,
                    heights[end],
                    vertical_justify,
                ),
                widths,
                box,
                nothing,
                :foot,
                :bottom,
                style,
                heights[end],
            ),
        )
    end

    lines = split(fillin(join(lines, "\n")), "\n")

    segments = Segment.(lines)
    return Table(segments, Measure(segments))
end

""" 
    Table(data::Union{AbstractVector, AbstractMatrix}; kwargs...)

Construct `Table` from `Vector` and `Matrix`
"""
Table(data::Union{AbstractVector,AbstractMatrix}; kwargs...) =
    Table(TablesPkg.table(data); kwargs...)

""" 
Table(data::AbstractDict; kwargs...)

Construct `Table` from a `Dict`.
The Dict's keys make up the table header if none is assigned.
"""
Table(data::AbstractDict; header = nothing, kwargs...) = Table(
    hcat(values(data)...);
    header = isnothing(header) ? string.(collect(keys(data))) : header,
    kwargs...,
)

"""
    function table_row(
        cells::Vector,
        widths::Vector,
        box::Symbol,
        top_level::Symbol,
        mid_level::Symbol,
        bottom_level::Symbol,
        box_style::String,
        row_height::Int;
        compact = false,
    )

Create a single row of a `Table` renderable. 

Each row is made up of an upper, mid and bottom section. The
upper and bottom sections are created by rows of the `Box` type.
The mid section is made up of the row's cells and dividing lines.

## Arguments
- cells: vector of cells content. Of length equal to the number of columns
- widths: vector of width of each cell.
- box: name of the `Box` used to construct the cell's lines
- top/mid/bottom_level: name of the `Box` level to be used for construction
- box_style: styling to be applied to box
- row_height: height of the row
- compact: if true avoids adding a top layer to the row
"""
function table_row(
    cells::Vector,
    widths::Vector,
    box,
    top_level::Union{Nothing,Symbol},
    mid_level::Symbol,
    bottom_level::Symbol,
    box_style,
    row_height::Int;
    compact::Bool = false,
)
    # get box characters
    mid_level = getfield(box, mid_level)

    l = vLine(row_height; style = box_style, char = mid_level.left)
    m = vLine(row_height; style = box_style, char = mid_level.vertical)
    r = vLine(row_height; style = box_style, char = mid_level.right)

    if row_height == 1
        l, m, r = string.((l, m, r))
    end

    # create row
    # @info "row" Measure(cells[1]) Measure(m) cells[1]*m
    mid = if length(widths) > 1
        l * foldl((a, b) -> a * m * b, cells[1:end]) * r
    else
        l * cells[1] * r
    end
    bottom = apply_style(get_row(box, widths, bottom_level), box_style)

    return if !isnothing(top_level)
        string(vstack(apply_style(get_row(box, widths, top_level), box_style), mid, bottom))
    else
        string(compact ? mid : vstack(mid, bottom))
    end
end

"""
    cell(x::AbstractString, hor_pad::Int, h::Int, w::Int, justify::Symbol, style::String, vertical_justify::Symbol)

Create a Table's row's cell from a string - apply styling and vertical/horizontal justification.
"""
function cell(
    x::AbstractString,
    hor_pad::Int,
    h::Int,
    w::Int,
    justify::Symbol,
    style::String,
    vertical_justify::Symbol,
)
    content = do_by_line(
        y -> apply_style(" " * pad(y, w - 2, justify) * " ", style),
        str_trunc(x, w - hor_pad),
    )
    return vertical_pad(content, h, vertical_justify)
end

"""
    cell(x::AbstractString, hor_pad::Int, h::Int, w::Int, justify::Symbol, style::String, vertical_justify::Symbol)

Create a Table's row's cell from a renderable - apply styling and vertical/horizontal justification.
"""
cell(
    x::AbstractRenderable,
    hor_pad::Int,
    h::Int,
    w::Int,
    justify::Symbol,
    style::String,
    vertical_justify::Symbol,
) = vertical_pad(do_by_line(y -> pad(y, w, justify), string(x)), h, vertical_justify)

"""
    make_row_cells(
        entries::Union{Tuple, Vector}, 
        style::Vector{String}, 
        justify::Vector{Symbol},
        widths::Vector{Int},
        height::Int, 
        vertical_justify::Symbol,
    ) 

Create a row's cell from a vector of 'entries' (renderables or strings).
"""
make_row_cells(
    entries::Union{Tuple,Vector},
    style::Vector{String},
    justify::Vector{Symbol},
    widths::Vector{Int},
    hor_pad::Vector{Int},
    height::Int,
    vertical_justify::Symbol,
) = map(
    i -> cell(
        entries[i],
        hor_pad[i],
        height,
        widths[i],
        justify[i],
        style[i],
        vertical_justify,
    ),
    1:length(entries),
)

end

rint(x) = (Int ∘ round)(x)
fint(x) = (Int ∘ floor)(x)
cint(x) = (Int ∘ ceil)(x)

is_last(v) = eachindex(v) .== lastindex(v)
is_first(v) = eachindex(v) .== firstindex(v)

"""
  loop_last(v)

  Returns an iterable yielding tuples (is_last, value).
"""
loop_last(v) = zip(is_last(v), v)

loop_firstlast(v) = zip(is_first(v), is_last(v), v)

"""
  get_lr_widths(width::Int)

To split something with `width` in 2, get the lengths
of the left/right widths.

When width is even that's easy, when it's odd we need to
be careful.
"""
function get_lr_widths(width::Int)::Tuple{Int,Int}
    iseven(width) && return (rint(width / 2), rint(width / 2))
    return (fint(width / 2), cint(width / 2))
end

"""
Get a clean string representation of an expression
"""
expr2string(e::Expr) = replace_multi(
    string(e),
    '\n' => "",
    ' ' => "",
    r"#=.*=#" => "",
    "begin" => "",
    "end" => "",
)

"""
  get_file_format(nbytes; suffix="B")

Return a string with formatted file size.
"""
function get_file_format(nbytes; suffix = "B")
    for unit in ("", "K", "M", "G", "T", "P", "E", "Z", "Y")
        nbytes < 1024 && return string(round(nbytes; digits = 2), ' ', unit, suffix)
        nbytes = nbytes / 1024
    end
end

"""
    calc_nrows_ncols(n, aspect::Union{Nothing,Number,NTuple} = nothing)

Computes the number of rows and columns to fit a given number `n` of subplots in a figure with aspect `aspect`.
If `aspect` is `nothing`, chooses the best fir between a default and a unit aspect ratios.

Adapted from: stackoverflow.com/a/43366784
"""
function calc_nrows_ncols(n, aspect::Union{Nothing,Number,NTuple} = nothing)
    h, w = if isnothing(aspect)
        r1, c1 = calc_nrows_ncols(n, DEFAULT_ASPECT_RATIO[])
        r2, c2 = calc_nrows_ncols(n, 1)  # unit aspect - square
        return r1 * c1 < r2 * c2 ? (r1, c1) : (r2, c2)  # choose the best fit
    elseif aspect isa Number
        (one(aspect), aspect)
    else
        aspect
    end
    factor = √(n / (h * w))
    rows = floor(Int, h * factor)
    cols = floor(Int, w * factor)
    row_first = w < h
    while rows * cols < n
        if row_first
            rows += 1
        else
            cols += 1
        end
        row_first = !row_first
    end
    return rows, cols
end

"""
    get_bg_color(style::String)

Add "on_" to background style info.
"""
get_bg_color(style::String) = startswith(style, "on_") ? style : "on_" * style
get_bg_color(style::Nothing) = style

import Term.Tables: Table
import Term.Layout: PlaceHolder

t = 1:5
data = hcat(t, ones(length(t)), string.(ones(length(t)) .* 100000))

t1 = Table(data)
t2 = Table(
    data;
    header = ["Num", "Const.", "Values"],
    header_style = "bold white",
    columns_style = ["dim", "bold", "red"],
)
t3 = Table(
    data;
    header = ["Num", "Const.", "Values"],
    header_style = "bold white",
    columns_style = ["dim", "bold", "red"],
    hpad = [1, 2, 5],
    columns_justify = [:center, :right, :left],
    vpad = 1,
)
t4 = Table(data; footer = ["get", "a", "footer"], footer_justify = :center)

if VERSION >= v"1.7.1"
    t5 = Table(data; footer = sum, footer_justify = :center, footer_style = "dim bold")

    t7 = Table(data; columns_widths = [25, 7, 7], footer = sum, box = :SIMPLE)
end

ph1 = PlaceHolder(25, 5)
ph2 = PlaceHolder(23, 9)
ph3 = PlaceHolder(22, 11)

data = Dict(
    "first\ncol." => [ph1, ph2, ph3],
    "second\ncol." => [ph3, ph2, ph3],
    "third\ncol." => [ph2, ph2, ph1],
)

t6 = Table(data)

X = rand(RNG, 5, 3)
t8 = Table(
    X;
    columns_widths = [12, 10, 22],
    hpad = 2,
    columns_justify = [:left, :center, :left],
)

# save tables as strings to files
if VERSION >= v"1.7.1"
    tbls = [t1, t2, t3, t4, t5, t6, t7, t8]
else
    tbls = [t1, t2, t3, t4, nothing, t6, nothing, t8]
end

@testset "TABLE" begin
    for (i, t) in enumerate(tbls)
        isnothing(t) && continue
        name = string("table_$i")

        IS_WIN || @compare_to_string(cleanstring(t), name)
    end

    # test table with problems
    VERSION >= v"1.7.1" &&
        Table(data; columns_widths = [25, 7, 7, 12, 41, 52], footer = sum, box = :SIMPLE)
end

"""

    This example show's how to use Term's errors functionality


Term provides functionality to produce styled and informative error
messages and tracestacks. This is not active by default as not everybody
might want this, but it's easier to turn on.

NOTE: this is a preliminary feature, there might be bugs and not all error
types may be correctly represented. While generally useful, it might be best
to hold back on this feature for code that needs to reliably print accurate
error information.
"""

import Term: install_term_stacktrace, hLine

install_term_stacktrace()
install_term_logger()
print(hLine("Fancy Errors"; style = "bold blue"))

"""
Done!

Now error messages will be fancy!

To run this example uncomment one of the lines below to find the 
corresponding error message
"""

# ------------  MethodError
# 1 - "a"

# ------------  DomainError
# sqrt(-1)

# ------------  UndefVarError
# println(x)

# ------------  BoundsError
# v = collect(1:10)
# v[20]

# ------------  DivideError
# div(2, 0)

# ------------  StackOverflowError
# a() = b()
# b() = a()
# a()

# ------------  KeyError
# mydict = Dict(:a=>"a", :b=>"b")
# mydict["a"]

# ------------  InexactError
# Int(2.5)

# ------------  UndefKeywordError
# function my_func(;my_arg::Int)
#     return my_arg + 1
# end
# my_func()

# ------------  DimensionMismatch
m = zeros(20, 20)
n = zeros(5, 4)
m .+ n

# ------------  Errors with type creation

struct MyType
    x::Int
    y
    z::String
end

MyType(x::Int, y::Int) = MyType(x, y, 1)
MyType(x::Int) = MyType(x, 0)

MyType(1)

using Term
import Term.Renderables: Renderable
import Term: rint
import Term: inspect
using Term.Layout
import Term.Measures: height

import MyterialColors: orange_light, blue_light, green_light

"""
Convert HSL values to RGB values, return a markup color string.
"""
function hsl2rgb(h, s, l)  # pragma: no cover
    C = (1 - abs(2 * l - 1)) * s
    X = C * (1 - abs(mod(h / 60, 2) - 1))
    M = l - C / 2

    if 0 ≤ h < 60
        r, g, b = C, X, 0
    elseif 60 ≤ h < 120
        r, g, b = X, C, 0
    elseif 120 ≤ h < 180
        r, g, b = 0, C, X
    elseif 180 ≤ h < 240
        r, g, b = 0, X, C
    elseif 240 ≤ h < 300
        r, g, b = X, 0, C
    elseif 300 ≤ h ≤ 360
        r, g, b = C, 0, X
    end

    r = (Int ∘ round)((r + M) * 255)
    g = (Int ∘ round)((g + M) * 255)
    b = (Int ∘ round)((b + M) * 255)

    return "($r, $g, $b)"
end

function make_julia_circles()
    circle = """
    oooo    
 oooooooooo 
oooooooooooo
oooooooooooo
 oooooooooo 
    oooo    """

    # create circles
    green = Panel(
        RenderableText(circle; style = "#389826 bold");
        fit = true,
        style = "dim #389826",
        justify = :center,
        padding = (2, 2, 0, 0),
        title = "Made",
        title_style = "default bold red",
    )
    red = Panel(
        RenderableText(circle; style = "#CB3C33 bold");
        fit = true,
        style = "dim #CB3C33",
        justify = :center,
        padding = (2, 2, 0, 0),
        subtitle = "with",
        subtitle_style = "default bold #b656e3",
        subtitle_justify = :right,
    )
    purple = Panel(
        RenderableText(circle; style = "#9558B2 bold");
        fit = true,
        style = "dim #9558B2",
        justify = :center,
        padding = (2, 2, 0, 0),
        subtitle = "Term",
        subtitle_style = "default bold #389826",
    )

    hspacer = Spacer(green.measure.h, green.measure.w / 2 + 1)
    line = Spacer(1, green.measure.w * 2 + 6)
    circles =
        line / (hspacer * green * hspacer) / (red * Spacer(purple.measure.h, 2) * purple)
    return circles
end

function make_rgb_colors(; max_width = 88)
    colors = ""

    for y in 0:5
        for x in 0:max_width
            h = x / max_width
            l = 0.1 + (((5 - y) / 5) * 0.7)
            color = hsl2rgb(h * 360, 0.9, l)
            bg = hsl2rgb(h * 360, 0.9, l + 0.7 / 10)

            colors *= "{$color on_$bg}▄{/$color on_$bg}"
            # colors *= "{$color on_$bg}▬▄x{/$color on_$bg}"
        end
        colors *= "\n"
    end

    return colors
end

function rainbow_maker(N)
    R = range(30, 200; length = N)
    G = range(200, 60; length = N)
    B = range(50, 200; length = N)
    colors = []
    for n in 1:N
        r, g, b = rint(R[n]), rint(G[n]), rint(B[n])
        push!(colors, "($r,$g,$b)")
    end
    return colors
end

circles = make_julia_circles() # 42 x 17

_code_style = "yellow italic bold"

bfc = rainbow_maker(10)
basic_features = Panel(
    """
    {bright_red bold underline}Features{/bright_red bold underline}

{bold $(bfc[1])}✔{/bold $(bfc[1])}{white} {blue}Colored text{/blue}{/white}
{bold $(bfc[2])}✔{/bold $(bfc[2])}{white} {italic}italic{/italic}, {bold}bold{/bold}, {underline}underline{/underline}, {striked}striked{/striked}, {inverse}inverse{/inverse}{/white}
{bold $(bfc[3])}✔{/bold $(bfc[3])}{white} styling {$_code_style}@macros{/$_code_style}{/white}
{bold $(bfc[4])}✔{/bold $(bfc[4])}{white} {italic white}markup{/italic white} style syntax{/white}
{bold $(bfc[5])}✔{/bold $(bfc[5])}{white} progress bars{/white}
{bold $(bfc[6])}✔{/bold $(bfc[6])}{white} Code introspection and REPR
{bold $(bfc[7])}✔{/bold $(bfc[7])}{white} logging{/white}
{bold $(bfc[8])}✔{/bold $(bfc[8])}{white} stacktraces{/white}
{bold $(bfc[9])}✔{/bold $(bfc[9])}{white} syntax highlighting{/white}
{bold $(bfc[10])}✔{/bold $(bfc[10])}{white} Markdown parsing{/white}
""";
    width = 70,
    padding = (2, 2, 1, 2),
    justify = :center,
    style = "default blue dim",
    title = "Term.jl",
    title_style = "default bright_blue bold",
    subtitle = "https://github.com/FedeClaudi/Term.jl",
    subtitle_style = "default dim",
    subtitle_justify = :right,
)

colors_info = TextBox(
    """{bold bright_green}Colors{/bold bright_green}
      {$(green_light) bold}✔{/$(green_light) bold} 8-bit colors
      {$(green_light) bold}✔{/$(green_light) bold} 16-bit colors
      {$(green_light) bold}✔{/$(green_light) bold} hex colors
      {$(green_light) bold}✔{/$(green_light) bold} rgb colors
      {$(green_light) bold}✔{/$(green_light) bold} colors conversion
    """;
    width = 25,
    padding = (0, 0, 0, 0),
)
colors = make_rgb_colors(; max_width = 103)

_lorem = """朗眠裕安無際集正聞進士健音社野件草売規作独特認権価官家複入豚末告設悟自職遠氷育教載最週場仕踪持白炎組特曲強真雅立覧自価宰身訴側善論住理案者券真犯著避銀楽験館稿告
"""
lorem_description = TextBox(
    """{bold bright_yellow}Text reshaping{/bold bright_yellow}
      {$(orange_light) bold}✔{/$(orange_light) bold} reshaping.
      {$(orange_light) bold}✔{/$(orange_light) bold} justification
      {$(orange_light) bold}✔{/$(orange_light) bold} Asian languages support
    """;
    width = 30,
    padding = (0, 0, 0, 0),
)
lorem1 = TextBox(_lorem; width = 62, fit = false, padding = (0, 0, 0, 0))
lorem2 = TextBox(_lorem; width = 42, fit = false, padding = (0, 0, 0, 0))

expr = :(2x + 2π / θ)
tree = Renderable(sprint(Tree, Float64))
dendo = Renderable(sprint(inspect, expr))
renderables_info = TextBox(
    """{bold bright_blue}Renderables types{/bold bright_blue}
      {bold $(blue_light)}✔{/bold $(blue_light)} Panel
      {bold $(blue_light)}✔{/bold $(blue_light)} TextBox
      {bold $(blue_light)}✔{/bold $(blue_light)} hLine
      {bold $(blue_light)}✔{/bold $(blue_light)} vLine
      {bold $(blue_light)}✔{/bold $(blue_light)} Tree
      {bold $(blue_light)}✔{/bold $(blue_light)} Dendogram


    """;
    width = 30,
    padding = (0, 0, 0, 0),
)

line = hLine(140; style = "bold dim grey35", box = :HEAVY)

layout_text = TextBox(
    """{bold bright_cyan}Renderables layout{/bold bright_cyan}
      {bold bright_cyan}✔{/bold bright_cyan} Horizontal stacking
      {bold bright_cyan}✔{/bold bright_cyan} Vertical stacking
      {bold bright_cyan}✔{/bold bright_cyan} Left justify
      {bold bright_cyan}✔{/bold bright_cyan} Center justify
      {bold bright_cyan}✔{/bold bright_cyan} Right justify
      {bold bright_cyan}✔{/bold bright_cyan} Shorthands {bold bright_blue}*,/{/bold bright_blue}
    """;
    width = 30,
    padding = (0, 0, 0, 0),
)

p1 = Panel(; width = 20, style = "#80bbe8")
p1b = Panel(; width = 34, style = "#80bbe8")
p2 = Panel(; width = 28, style = "#5692bf")
p3 = Panel(; width = 34, style = "#316c99 bold")
p3b = Panel(; width = 20, style = "#316c99 bold")
_space = Spacer(layout_text.measure.h, 1)

layout_example =
    hstack(lvstack(p1, p2, p3), cvstack(p1b, p2, p3b), rvstack(p1, p2, p3); pad = 1)

layout_example = cvstack(
    "" / RenderableText(
        "{bold #81bae6} Left/center/right justify and stack renderables to create layouts",
    ),
    layout_example,
)

using Markdown
import MyterialColors:
    pink_light, deep_purple_light, indigo_light, amber_light, teal_light, salmon_light
import Term.TermMarkdown: parse_md
styles =
    (pink_light, teal_light, indigo_light, amber_light, deep_purple_light, salmon_light)
rens =
    map(
        s -> Panel(; width = 20, height = 8, box = :SQUARE, background = "on_$s"),
        styles,
    ) |> collect
g = grid(rens)

t = parse_md(
    md"""
# Markdown parsing

Term parses `MD` types - markdown content - with style!

!!! tip "Docs"
    Have a look at the docs for more info!
    [docs](https://fedeclaudi.github.io/Term.jl/stable/)

Julia's docstring are parsed as Markdown, and Term turns markdown into styled terminal output. 
So you can use term to print styled docstrings and other info to the REPL. 

```julia
import Term: termshow

termshow(print)  # prints styled docstring to console
```

---
| Col1 | Col2 | Col3 | Col4 |
|:---------- | :----------: |:------------:|:------------:|
| ONE    | TWO |   THREE           |      FOUR        |
| ONE    | TWO  | THREE | FOUR|


!!! tip "Tables"
        The table above was parsed from a markdown to a `Table` renderable
        Term has a really awesome `Table` renderable, you should check it out!


""";
    width = 100,
)

# ----------------------------------- print ---------------------------------- #
# width is 140
print("\n"^10)

readme =
    (
        Spacer(circles.measure.h, 10) *
        circles *
        Spacer(circles.measure.h, 8) *
        basic_features
    ) / (Spacer(2, 140) / line) / (
        Spacer(colors_info.measure.h, 3) *
        colors_info *
        Spacer(colors_info.measure.h, 3) *
        (Spacer(1, 100) / colors)
    ) / line /
    (Spacer(lorem_description.measure.h, 3) * lorem_description * lorem1 * lorem2) / line /
    (
        Spacer(tree.measure.h, 3) *
        renderables_info *
        tree *
        Spacer(tree.measure.h, 5) *
        dendo
    ) / line / (Spacer(layout_text.measure.h, 3) * layout_text * layout_example) / line / (
        Spacer(height(t), 20) *
        vLine(height(t); style = "dim") *
        "  " *
        t *
        "  " *
        vLine(height(t); style = "dim")
    )

print(Spacer(readme.measure.h, 10) * readme)

"""
This example shows how to create Tree visualizations.


The easiest starting point is a `Dict` object with the info we want
to show in the tree
"""

import Term: Tree, Theme

data = Dict("a" => 1, "b" => Int64, "c" => [1, 2, 3], "d" => "a b c"^100)

print(Tree(data))

"""
`Tree` has several parameters that can be used to change the appearance
"""

print("\n\n")
for guides in (:standardtree, :boldtree, :asciitree)
    Tree(data; guides = guides) |> print
end

# set the colors!
print("\n\n")
theme = Theme(
    tree_mid = "green",
    tree_terminator = "green",
    tree_skip = "green",
    tree_dash = "green",
    tree_trunc = "green",
    tree_pair = "red",
    tree_keys = "blue",
    tree_max_leaf_width = 44,
)
print(Tree(data; theme = theme))

"""
Tree can handle nested data too!
"""
data = Dict(
    "lvl1" => Dict(
        "lvl2" => Dict("a" => 1, "b" => 3),
        "l2a" => "nested dicts rule!",
        "l2b" => "wohoo",
    ),
)

print(Tree(data))

# ---------------------------------------------------------------------------- #
#                                AbstractButton                                #
# ---------------------------------------------------------------------------- #
abstract type AbstractButton <: AbstractWidget end

"""
set the buttoon's state to :presed.
"""
function press_button(b::AbstractButton, ::Union{SpaceBar,Enter})
    if b.status == :not_pressed
        b.lastpressed = Dates.value(now())
        b.status = :pressed
        isnothing(b.callback) || return b.callback(b)
    else
        b.status = :not_pressed
    end
    return nothing
end

button_controls =
    Dict('q' => quit, Esc() => quit, Enter() => press_button, SpaceBar() => press_button)

function on_layout_change(b::AbstractButton, m::Measure)
    b.internals.measure = m
end

"""
    make_button_panel(message, color, text_color, pressed, active, w, h; kwargs...)

Create a panel to display a button.
"""
function make_button_panel(message, color, text_color, pressed, active, w, h; kwargs...)
    if pressed == :active
        style = "$(text_color) on_$(color)"
        background = color
    else
        style = active ? color : "dim $color"
        background = ""
    end

    return Panel(
        "{$text_color on_$(background)}$message{/$text_color on_$(background)}",
        style = style,
        width = w,
        height = h,
        justify = get(kwargs, :justify, :center),
        background = background,
        kwargs...,
    )
end

# ---------------------------------------------------------------------------- #
#                                    Button                                    #
# ---------------------------------------------------------------------------- #
# ------------------------------- constructors ------------------------------- #

"""
    Button

A button widget.
It's display changes when pressed.
A callback can be set to be called when the button is pressed.
"""
@with_repr mutable struct Button <: AbstractButton
    internals::WidgetInternals
    controls::AbstractDict
    message::String
    status::Symbol
    callback::Union{Nothing,Function}
    lastpressed::Int
    color::String
    text_color::String
    kwargs
end

function Button(
    message::String;
    controls::AbstractDict = button_controls,
    text_color = "bold white",
    color = "red",
    on_draw::Union{Nothing,Function} = nothing,
    on_activated::Function = on_activated,
    on_deactivated::Function = on_deactivated,
    kwargs...,
)
    return Button(
        WidgetInternals(Measure(), nothing, on_draw, on_activated, on_deactivated, false),
        controls,
        message,
        :not_pressed,
        nothing,
        0,
        color,
        text_color,
        kwargs,
    )
end

# ----------------------------------- frame ---------------------------------- #
function frame(b::Button; kwargs...)
    isnothing(b.internals.on_draw) || b.internals.on_draw(b)

    status = if b.status == :pressed
        currtime = Dates.value(now())

        if currtime - b.lastpressed > 100
            b.status = :not_pressed
            :inactive
        else
            :active
        end
    else
        :inactive
    end

    return make_button_panel(
        b.message,
        b.color,
        b.text_color,
        status,
        isactive(b),
        b.internals.measure.w,
        b.internals.measure.h;
        kwargs...,
    )
end

# ---------------------------------------------------------------------------- #
#                                 TOGGLE BUTTON                                #
# ---------------------------------------------------------------------------- #
# ------------------------------- constructors ------------------------------- #
"""
A button. Pressing it toggles its status between 
activated and not.
"""
@with_repr mutable struct ToggleButton <: AbstractButton
    internals::WidgetInternals
    controls::AbstractDict
    message::String
    status::Symbol
    callback::Union{Nothing,Function}
    lastpressed::Int
    color::String
    text_color::String
    kwargs
end

function ToggleButton(
    message::String;
    controls::AbstractDict = button_controls,
    text_color = "bold white",
    color = "red",
    on_draw::Union{Nothing,Function} = nothing,
    on_activated::Function = on_activated,
    on_deactivated::Function = on_deactivated,
    kwargs...,
)
    return ToggleButton(
        WidgetInternals(Measure(), nothing, on_draw, on_activated, on_deactivated, false),
        controls,
        message,
        :not_pressed,
        nothing,
        0,
        color,
        text_color,
        kwargs,
    )
end

# ----------------------------------- frame ---------------------------------- #
function frame(b::ToggleButton; kwargs...)
    isnothing(b.internals.on_draw) || b.internals.on_draw(b)

    status = if b.status == :pressed
        :active
    else
        :inactive
    end

    return make_button_panel(
        b.message,
        b.color,
        b.text_color,
        status,
        isactive(b),
        b.internals.measure.w,
        b.internals.measure.h;
        kwargs...,
    )
end

module Trees

import AbstractTrees: print_tree, TreeCharSet, children
using InteractiveUtils

import Term: replace_multi, highlight, reshape_text, TERM_THEME, Theme

import ..Renderables: AbstractRenderable, RenderableText
import ..Style: apply_style
import ..Segments: Segment
import ..Measures: Measure
import ..Panels: Panel

export Tree

# ---------------------------------------------------------------------------- #
#                                    GUIDES                                    #
# ---------------------------------------------------------------------------- #

treeguides = Dict(
    :standardtree => TreeCharSet("├", "└", "│", "─", "⋮", " ⇒ "),
    :roundedtree => TreeCharSet("├──", "╰─", "│", "─", "⋮", " ⇒ "),
    :boldtree => TreeCharSet("┣━━", "┗━━", "┃", "━", "⋮", " ⇒ "),
    :asciitree => TreeCharSet("+--", "`--", "|", "--", "...", " => "),
)

# ---------------------------------------------------------------------------- #
#                                     TREE                                     #
# ---------------------------------------------------------------------------- #

const _TREE_PRINTING_TITLE = Ref{Union{Nothing,String}}(nothing)

"""
    print_node(io, node) 

Core function to enable fancy tree printing. Styles the leaf/key of each node.
"""
function print_node(io, node; kw...)
    theme::Theme = TERM_THEME[]

    if isnothing(_TREE_PRINTING_TITLE[]) # print node
        styled = if node isa AbstractString
            highlight(node, :string; theme = theme)
        else
            styled = highlight(string(node); theme = theme)
        end
        reshaped = reshape_text(styled, theme.tree_max_leaf_width)
        print(io, reshaped)
    else # print title
        title = _TREE_PRINTING_TITLE[]
        print(io, apply_style(title, theme.tree_title))
    end

    _TREE_PRINTING_TITLE[] = nothing
end

"""
    print_key(io, k; kw...)

Print a tree's node's key with some style.
"""
function print_key(io, k; kw...)
    s = TERM_THEME[].tree_keys
    print(io, apply_style("{s}" * string(k) * "{/s}"))
end

"""
    style_guides(tree::String, guides::TreeCharSet, theme::Theme)

Apply style to a tree's guides by inserting it into its string representation.
Not ideal as it will affect the style of other elements with the same characters 
like Panels, but ok for no.
"""
function style_guides(tree::String, guides::TreeCharSet, theme::Theme)
    return replace_multi(
        tree,
        guides.mid => apply_style(guides.mid, theme.tree_mid),
        guides.terminator => apply_style(guides.terminator, theme.tree_terminator),
        guides.skip => apply_style(guides.skip, theme.tree_skip),
        guides.dash => apply_style(guides.dash, theme.tree_dash),
        guides.trunc => apply_style(guides.trunc, theme.tree_trunc),
        strip(guides.pair) => apply_style(string(strip(guides.pair)), theme.tree_pair),
    )
end

"""
    Tree

Renderable tree.
"""
struct Tree <: AbstractRenderable
    segments::Vector{Segment}
    measure::Measure
end

"""
    Tree(
        tree;
        guides::Union{TreeCharSet,Symbol} = :standardtree,
        theme::Theme = TERM_THEME[],
        printkeys::Union{Nothing,Bool} = true,
        print_node_function::Function = print_node,
        print_key_function::Function = print_key,
        title::Union{String, Nothing}=nothing,
        prefix::String = "  ",
        kwargs...,
    )

Constructor for `Tree`

It uses `AbstractTrees.print_tree` to get a string representation of `tree` (any object
compatible with the `AbstractTrees` packge). Applies style to the string and creates a 
renderable `Tree`.

Arguments:
- `tree`: anything compatible with `AbstractTree`
- `guides`: if a symbol, the name of preset tree guides types. Otherwise an instance of
    `AbstractTrees.TreeCharSet`
- `theme`: `Theme` used to set tree style.
- `printkeys`: If `true` print keys. If `false` don't print keys. 
- `print_node_function`: Function used to print nodes.
- `print_key_function`: Function used to print keys.
- `title`: Title of the tree.
- `prefix`: Prefix to be used in `AbstractTrees.print_tree`


For other kwargs look at `AbstractTrees.print_tree`
"""
function Tree(
    tree;
    guides::Union{TreeCharSet,Symbol} = :standardtree,
    theme::Theme = TERM_THEME[],
    printkeys::Union{Nothing,Bool} = true,
    print_node_function::Function = print_node,
    print_key_function::Function = print_key,
    title::Union{String,Nothing} = nothing,
    prefix::String = "  ",
    kwargs...,
)
    _TREE_PRINTING_TITLE[] = title
    _theme = TERM_THEME[]
    TERM_THEME[] = theme

    # print tree
    guides = guides isa Symbol ? treeguides[guides] : guides
    tree = sprint(
        io -> print_tree(
            print_node_function,
            print_key_function,
            io,
            tree;
            charset = guides,
            printkeys = printkeys,
            prefix = prefix,
            kwargs...,
        ),
    )

    # style keys
    rx = Regex("(?<=$(guides.dash)) [\\w.,\":\\[\\]\\d]+ (?=$(strip(guides.pair)))")
    tree = replace(
        tree,
        rx => SubstitutionString(
            "{$(theme.tree_keys)}" * s"\g<0>" * "{/$(theme.tree_keys)}",
        ),
    )

    # style guides
    tree = style_guides(tree, guides, theme)

    # turn into a renderable
    rt = RenderableText(tree)

    # restore theme
    TERM_THEME[] = _theme
    return Tree(rt.segments, rt.measure)
end

# ---------------------------------------------------------------------------- #
#                                HIERARCHY TREE                                #
# ---------------------------------------------------------------------------- #
"""
Apply style for the type whose hierarchy Tree we are making
"""
style_T(T) = "{orange1 italic underline}$T{/orange1 italic underline}"

"""
    make_hierarchy_dict(x::Vector{DataType}, T::DataType, Tsubs::AbstractDict)::AbstractDict

Recursively create a dictionary with the types hierarchy for `T`.
`Tsubs` carries information about T's subtypes.
The AbstractDict is made backwards. From  the deepest levels up.
"""
function make_hierarchy_dict(x::NTuple, T::DataType, Tsubs::AbstractDict)::AbstractDict
    data = Dict()
    prev = ""
    for (n, y) in enumerate(x)
        if n == 1
            continue
        elseif n < length(x)
            subs = Dict()
            for s in subtypes(y)
                if s == T
                    subs[style_T(s)] = Tsubs
                else
                    subs[string(s)] = nothing
                end
            end

            if n == 2
                data = subs
            else
                subs[prev] = data
                data = subs
            end

            prev = string(y)
        end
    end
    return data
end

"""
    Tree(T::DataType)::Tree

Construct a `Tree` visualization of `T`'s types hierarchy
The key is in costructing the actual hierarchy tree recursively. 
"""
function Tree(T::DataType)::Tree
    # create a dictionary of types hierarchy
    subs = Dict(string(s) => nothing for s in subtypes(T))
    data = make_hierarchy_dict(supertypes(T), T, subs)

    # define a fn to avoid printing nodes 
    s = TERM_THEME[].tree_mid
    fn(io::IO, x) =
        length(children(x)) > 0 ? print(io, apply_style("{$s}┬{/$s}")) : print(io, "")

    # change style of pair
    _style = TERM_THEME[].tree_pair
    TERM_THEME[].tree_pair = "hidden"

    # print tree
    _tree = Tree(data; printkeys = true, print_node_function = fn)
    TERM_THEME[].tree_pair = _style

    return _tree
end

end

module Links
import ..Measures: Measure, width
import ..Measures
import ..Segments
import ..Segments: Segment
import ..Style: apply_style
import ..Renderables: RenderableText, AbstractRenderable
import ..Renderables
import ..Layout: pad
import Term: textlen, TERM_THEME, cleantext, excise_link_display_text, remove_ansi
import Term

export Link

"""
    struct LinkString <: AbstractString
        link::String
        width::Int
    end

`LinkString` behaves like a sting, but it's sneaky.
It keeps track of a link which has different length as a string
and when printed. So we override a lot of the normal string's behavior
to get it to work with renderables.
"""
struct LinkString <: AbstractString
    link::String
    width::Int
end

"""
    LinkString(s::String)

Construct a LinkString from a normal string, taking
into account that there might be a link in there, 
so get the right width.
"""
function LinkString(s::String)
    link_width, additional_text_w = 0, 0
    for line in split(s, "\n")
        link_txt = excise_link_display_text(line)
        link_width = max(link_width, width(link_txt))
        additional_text = split(remove_ansi(line), "8;;\e\\")
        length(additional_text) > 1 &&
            (additional_text_w = max(additional_text_w, width(additional_text[2])))
    end
    LinkString(s, link_width + additional_text_w + 3)
end

LinkString(l::LinkString) = l

Base.:*(s::Union{SubString,String}, l::LinkString) =
    LinkString(s * l.link, textlen(s) + l.width)
Base.:*(l::LinkString, s::Union{SubString,String}) =
    LinkString(l.link * s, textlen(s) + l.width)
Base.:/(s::Union{SubString,String}, l::LinkString) =
    LinkString(s / l.link, max(textlen(s), l.width))
Base.:/(l::LinkString, s::Union{SubString,String}) =
    LinkString(l.link / s, max(textlen(s), l.width))

Segments.Segment(l::LinkString) = Segment(l, Measure(1, l.width))
Term.textlen(l::LinkString) = l.width
Term.split_lines(l::LinkString) = Term.split_lines(l.link)

"""
    struct Link <: AbstractRenderable
        segments::Vector{Segment}
        measure::Measure
        link::LinkString
        style::String
        display_text::String
        link_dest::String
    end

A link renderable. With a link to an url or file path
and a text that gets displayed (and is clickable on most terminals).
Key to it working as a properly renderable is its `LinkString`
"""
struct Link <: AbstractRenderable
    segments::Vector{Segment}
    measure::Measure
    link::LinkString
    style::String
    display_text::String
    link_dest::String
end

Base.textwidth(l::LinkString) = l.width
Base.string(l::LinkString) = l
Base.convert(::String, l) = l
Base.print(io::IO, s::LinkString) = print(io, s.link)
Base.show(io::IO, ::MIME"text/plain", l::LinkString) = print(io, l.link)

"""
    Link(
        file_path::AbstractString,
        line_number::Union{Nothing,Integer} = nothing;
        style = TERM_THEME[].link,
    )

Build a link given a file path and line number.
"""
function Link(
    file_path::AbstractString,
    line_number::Union{Nothing,Integer} = nothing,
    display_text::Union{Nothing,String} = nothing;
    style = TERM_THEME[].link,
)
    link_dest =
        isnothing(line_number) ? "file://" * file_path : "file://$file_path#$line_number"
    isnothing(display_text) &&
        (display_text = isnothing(line_number) ? file_path : "$file_path:$line_number")
    link_text =
        "{$(style)}" *
        "\e]8;;" *
        link_dest *
        "\a" *
        display_text *
        "\e]8;;\a" *
        "{/$(style)}" |> apply_style

    link_measure = Measure(1, textlen(display_text))
    link_string = LinkString(link_text, link_measure.w)

    return Link(
        [Segment(link_string)],
        link_measure,
        link_string,
        style,
        display_text,
        link_dest,
    )
end

"""
---
    Renderables.RenderableText(
        link::Link,
        args...;
        style::Union{Nothing,String} = link.style,
        width::Int = link.measure.w,
        background::Union{Nothing,String} = nothing,
        justify::Symbol = :left,
    )

Custom constructor to make a `RenderableText` out of a `Link`,
specialized to take into account `Link`'s different sizes 
between displayed and actual text.
"""
function Renderables.RenderableText(
    link::Link,
    args...;
    style::Union{Nothing,String} = link.style,
    width::Int = link.measure.w,
    background::Union{Nothing,String} = nothing,
    justify::Symbol = :left,
)
    display_text =
        pad(cleantext(link.display_text), width - link.measure.w, justify; bg = background)
    link_text =
        "{$(style)}" *
        "\x1b]8;;$(link.link_dest)\x1b\\$display_text\x1b]8;;\x1b\\" *
        "{/$(style)}" |> apply_style
    link_string = LinkString(link_text, link.measure.w)

    return RenderableText(Segment[Segment(link_string)], link.measure, style)
end

end

import Term.Compositors:
    Compositor, update!, collect_elements, clean_layout_expr, parse_single_element_layout
import Term: Panel, Renderable

@testset "Compositor - expression" begin
    expr_1 = :(A(4, 12) * B(4, 12) / C(4, 12))
    expr_2 = :(hstack(A(4, 12), B(4, 12), C(4, 12)))
    expr_3 = :(vstack(A(4, 12), B(4, 12), C(4, 12); pad = 2))
    expr_4 = :(A(4, 12))

    @test parse_single_element_layout(expr_1) isa Vector{Expr}

    @test collect_elements(expr_2) == collect_elements(expr_1)
    @test collect_elements(expr_3) == collect_elements(expr_1)
    @test collect_elements(expr_4) == :(A(4, 12))

    @test clean_layout_expr(expr_1) == :((A * B) / C)
    @test clean_layout_expr(expr_2) == :(hstack(A, B, C))
    @test clean_layout_expr(expr_3) == :(vstack(pad = 2, A, B, C))
end

@testset "Compositor - creation" begin
    expr_1 = :(A(14, 12) * B(14, 12) / C(14, 12))

    C1 = Compositor(expr_1)
    C1_b = Compositor(expr_1; B = Panel(height = 14, width = 12))
    C2 = Compositor(:(hstack(A(14, 12), B(14, 12), C(14, 12))))

    C3 = Compositor(:(vstack(A(14, 20), B(14, 12), C(14, 12); pad = 2)))

    update!(C3, :B, Panel(height = 14, width = 12))
    update!(C3, :A, Panel(height = 14, width = 20))
    update!(C3, :A, Panel(height = 14, width = 20))

    C4 = Compositor(:(vstack(A(5, 10), B(20, 15))))
    update!(C4; A = Panel(height = 5, width = 10), B = Panel(height = 20, width = 15))
    @test_logs (:warn, r"Could not update compositor") update!(C4, :FOO, Panel())

    C5 = Compositor(:(A(100, 55) * B(20, 15)))
    # @test_logs (:warn, r"Shape mismatch while updating compositor element") update!(
    #     C5,
    #     :A,
    #     Panel(; width=20),
    # )

    compositors = [C1, C1_b, C2, C3]

    if !Sys.iswindows()
        for (i, t) in enumerate(compositors)
            IS_WIN || @compare_to_string(cleanstring(t), "compositor_$i")

            # coverage
            @test Renderable(t) isa RenderableText
            print(devnull, t)
            show(devnull, MIME("text/plain"), t)
            show(devnull, t)
        end
    end
end

import Term.Trees: Tree
import Term: hLine, vLine

function pprint(tree::Tree)
    print(" " * hLine(tree.measure.w; style = "red"))
    print(vLine(tree.measure.h; style = "red") * tree)
    return println(tree.measure)
end

tree_dict = Dict(
    "nested\nasdasdsada\nsdasdsad\nsadasdasdasd\nsadasasdasdas\nsfsdfdsfds\nfdsfsdfsdf\ndsfsdfd" =>
        Dict("n1" => 1, "n2" => 2),
)

tree_dict_1 =
    Dict("nested" => Dict("n1" => 1, "n2" => 2), "nested2" => Dict("n1" => "a", "n2" => 2))

tree_dict_2 = Dict(
    "nested" => Dict("n1" => 1, "n2" => 2),
    "leaf2" => 2,
    "leaf" => 2,
    "leafme" => "v",
    "canopy" => "test",
)

tree_dict_3 = Dict(
    "nested" => Dict(
        "deeper" => Dict("aleaf" => "unbeliefable", "leaflet" => "level 3"),
        "n2" => Int,
        "n3" => 1 + 2,
    ),
    "nested2" => Dict("n1" => "a", "n2" => 2),
)

tree_dict_4 = Dict(
    "nested" => Dict(
        "deeper" => Dict(
            "aleaf" => "unbeliefable",
            "leaflet" => "level 3",
            "sodeep" => Dict("a" => 4),
        ),
        "n2" => Int,
        "n3" => 1 + 2,
        "adict" => Dict("x" => 2),
    ),
    "nested2" => Dict("n1" => "a", "n2" => 2),
)

print("\n"^20)

for dd in (tree_dict, tree_dict_1, tree_dict_2, tree_dict_3, tree_dict_4)
    pprint(Tree(dd))
    print("\n")
end

module Consoles
import Term: ACTIVE_CONSOLE_WIDTH, ACTIVE_CONSOLE_HEIGHT
export console_height,
    console_width,
    cursor_position,
    up,
    beginning_previous_line,
    prev_line,
    next_line,
    down,
    clear,
    hide_cursor,
    show_cursor,
    line,
    erase_line,
    cleartoend,
    move_to_line,
    change_scroll_region,
    savecursor,
    restorecursor,
    Console,
    enable,
    disable

const STDOUT = stdout
const STDERR = stderr

# ---------------------------------------------------------------------------- #
#                                CURSOR CONTROL                                #
# ---------------------------------------------------------------------------- #
"""
Save the current cursor position
"""
savecursor(io::IO = stdout) = write(io, "\e[s")

"""
Restore a previously saved cursor position
"""
restorecursor(io::IO = stdout) = write(io, "\e[u")

"""
Get cursor position
"""
cursor_position(io::IO = stdout) = write(io, "\e[6n")

# --------------------------------- movement --------------------------------- #

"""
Move cursor to the beginning of the previous line
"""
beginning_previous_line(io::IO = stdout) = write(io, "\e[F")

"""
Move cursor up one one or more lines
"""

prev_line(io::IO = stdout, n::Int = 1) = write(io, "\e[" * string(n) * "F")

up(io::IO = stdout, n::Int = 1) = write(io, "\e[" * string(n) * "A")

"""
Move cursor down one or more lines
"""
next_line(io::IO = stdout, n::Int = 1) = write(io, "\e[" * string(n) * "E")

down(io::IO = stdout, n::Int = 1) = write(io, "\e[" * string(n) * "B")

"""
Move cursor to a specific line
"""
move_to_line(io::IO = stdout, n::Int = 1) = write(io, "\e[" * string(n) * ";1H")

# ---------------------------------- display --------------------------------- #
"""
    clear(io::IO = stdout)

Clear terminal from anything printed in the REPL.
"""
clear(io::IO = stdout) = write(io, "\e[2J")
cleartoend(io::IO = stdout) = write(io, "\e[0J")

"""
Hide cursor
"""
hide_cursor(io::IO = stdout) = write(io, "\e[?25l")

"""
Show cursor
"""
show_cursor(io::IO = stdout) = write(io, "\e[?25h")

"""
write a new line.
"""
line(io::IO = stdout, i = 1) = write(io, "\n"^i)

"""
Erase last line in console.
"""
erase_line(io::IO = stdout) = write(io, "\e[2K")

"""
Change the position of the scrolling region in the terminal.

See: http://www.sweger.com/ansiplus/EscSeqScroll.html
"""
function change_scroll_region(io::IO = stdout, n::Int = 1)
    write(io, "\e[1;" * string(n) * "r")  # from row 1 to n, all columns
    return down(io, n)
end

# ---------------------------------------------------------------------------- #
#                                    CONSOLE                                   #
# ---------------------------------------------------------------------------- #
"""
    console_height()

Get the current console height.
"""
console_height(io::IO = stdout) = something(ACTIVE_CONSOLE_HEIGHT[], displaysize(io)[1])

"""
    console_width()

Get the current console width.
"""
console_width(io::IO = stdout) = something(ACTIVE_CONSOLE_WIDTH[], displaysize(io)[2])

mutable struct Console
    height
    width
end

Console(width) = Console(console_height(), width)
Console() = Console(console_height(), console_width())
Base.displaysize(c::Console) = (c.height, c.width)

function enable(console::Console)
    ACTIVE_CONSOLE_WIDTH[] = console.width
    console
end

function disable(console::Console)
    ACTIVE_CONSOLE_WIDTH[] = nothing
    console
end
end

using Term

# necessary to create the "renderable" type
import Term.Renderables: AbstractRenderable
import Term.Measures: Measure
import Term.Segments: Segment

# for styling
import Term: apply_style

# define a new subtype of AbstractRenderable
struct QR <: AbstractRenderable
    segments::Vector{Segment}
    measure::Measure
end

"""
    QR(qr::BitMatrix)

Construct a QR renderable from a BitMatrix of pixel values. 

The half block `▄` is used, this allows for 2 colors per REPL line
by separately setting the foreground and background colors. 
Each "pixel" in the function body thus represents two pixels in the`qr` matrix,
the entry at (i, j) and (i+1, j).
"""
function QR(qr::BitMatrix)
    blk = "(0, 0, 0)"
    pixels = Dict(
        [1, 1] => "{white on_white}▄{/white on_white}" |> apply_style,
        [1, 0] => "{white on_$blk}▄{/white on_$blk}" |> apply_style,
        [0, 1] => "{$blk on_white}▄{/$blk on_white}" |> apply_style,
        [0, 0] => "{$blk on_$blk}▄{/$blk on_$blk}" |> apply_style,
    )

    out = []
    for row in 1:2:(size(qr, 1) - 1)
        out_row = String[]
        for col in 1:size(qr, 2)
            px = pixels[qr[row:(row + 1), col]]
            push!(out_row, px)
        end
        push!(out, join(out_row))
    end

    segments = Segment.(out)
    QR(segments, Measure(segments))
end

# hand made QR code bitmatrix :)
qr = rand(Bool, 20, 20) |> BitArray
qr[1:5, 1:5] .= 1
qr[16:20, 1:5] .= 1
qr[1:5, 16:20] .= 1
qr[16:20, 16:20] .= 1

description = RenderableText("""
    {bright_blue}Scan this QR to discover the secret behind beautiful {/bright_blue}
    {bright_blue}terminal output in your REPL.{/bright_blue}

    Just kidding, the QR code is fake, just use Term.jl

    But seriously, this should work with proper QR codes

    
    {bold white}What will you use this for?{/bold white}
""")

# embed the QR renderable in a panel
Panel(
    QR(qr) * description,
    fit = true,
    title = "scan me",
    title_justify = :center,
    padding = (4, 4, 1, 1),
)

import Term.Measures: Measure, width, height, default_size
import Term: remove_markup, Panel

@testset "\e[34mMeasure - str" begin
    @test size(Measure("a"^10)) == (1, 10)

    for string in (
        "asadasda"^2,
        "~~±±||__ASdaSDvxcvxc\nasdfsiaudfhsdiufhndskjv",
        "dasdadsa\nsdfsd"^7,
        "asdasdsa|dfvcxvashfusdn\nfidsuhfsdf",
    )
        m = Measure(string)
        @test m.h == nlines(string)
        @test m.w == lw(string)
    end

    for string in (
        "[red]is my color"^2,
        "~~±±||__{red on_green}aasdas{bold}asdsad{/bold}asdas{/red on_green}xc\nasdfsiaudfhsdiufhndskjv",
        "dasda{#ffffff}dsa{#ffffff}\nsdfsd"^7,
        "asdasdsa|dfvcxvashf{bold}usdn\nfid[/bold]suhfsdf",
    )
        m = Measure(string)
        @test m.h == nlines(remove_markup(string))
        @test m.w == lw(remove_markup(string))
    end
end

# TODO test with renderables

@testset "\e34mMeasure - funcs" begin
    @test height("test") == 1
    @test width("test") == 4

    w = h = 5
    p = Panel(width = w, height = h)
    @test height(p) == h
    @test height(string(p)) == h
    @test width(p) == w

    s = first(p.segments)
    @test height(s) == 1
    @test width(s) == w

    @test size(Measure("foo") + Measure("testing")) == (2, 7)
end

@testset "\e34mMeasure - misc" begin
    console_width() >= 88 && (@test default_size() == (33, 88))
end

using Term
import Term.Tables: Table
import Term.Layout: PlaceHolder

install_term_stacktrace()

"""
    This is an example showing how to create tables in Term.jl

There's MANY options to tables, so we can't cover all of them here, head to the docs
for more info.
"""

t = 1:5
data = hcat(t, ones(length(t)), rand(Int8, length(t)))

"""
You can create data from `Matrix` and `Vector` objects
"""

print(Table(data))

"""
You can justify the table headers
"""

print(
    Table(
        data;
        header = ["Num", "Const.", "Values"],
        header_style = "bold white",
        columns_style = ["dim", "bold", "red"],
    ),
)

"""
For most of the options, you can either pass a single value
(which gets applied to a whole column/row) or a vector of values
to e.g. specify the style of each column independently.

You can use vertical/horizontal padding to space out the table.
"""

print(
    Table(
        data;
        header = ["Num", "Const.", "Values"],
        header_style = "bold white",
        columns_style = ["dim", "bold", "red"],
        hpad = [1, 2, 5],
        columns_justify = [:center, :right, :left],
        vpad = 1,
    ),
)

"""
You can also specify footers
"""

print(Table(data; footer = ["get", "a", "footer"], footer_justify = :center))

"""
    Or even use a function that gets applied column wise
"""

print(Table(data; footer = sum, footer_justify = :center, footer_style = "dim bold"))

"""
You can use different `Box` types to change the table style.
And you can create layouts with tables as you would with any
other renderables.
"""

print(
    (Table(data; box = :ROUNDED, style = "red") * " " * Table(data; box = :HEAVY)) /
    Table(data; box = :SIMPLE_HEAVY, style = "dim blue"),
)

"""
Tables can also be created from `Dict` objects and can include other
renderables.
"""

ph1 = PlaceHolder(5, 25)
ph2 = PlaceHolder(9, 23)
ph3 = PlaceHolder(11, 22)

data = Dict(
    "first\ncol." => [ph1, ph2, ph3],
    "second\ncol." => [ph3, ph2, ph3],
    "third\ncol." => [ph2, ph2, ph1],
)

print(Table(data))

import MyterialColors: orange_light, teal, purple_light, blue_light

"""
Definition of several type of columns for progress bars.
Used in progress.jl.
"""

# ---------------------------------------------------------------------------- #
#                                    columns                                   #
# ---------------------------------------------------------------------------- #
abstract type AbstractColumn <: AbstractRenderable end

setwidth!(col::AbstractColumn, width::Int) = nothing

# ---------------------------------------------------------------------------- #
#                                 TEXT COLUMNS                                 #
# ---------------------------------------------------------------------------- #
# ---------------------------- description column ---------------------------- #
mutable struct DescriptionColumn <: AbstractColumn
    job::ProgressJob
    segments::Vector{Segment}
    measure::Measure
    text::String

    function DescriptionColumn(job::ProgressJob; style::String = orange_light)
        seg = Segment(job.description, style)
        return new(job, [seg], seg.measure, seg.text)
    end
end

update!(col::DescriptionColumn, args...)::String = col.text

mutable struct TextColumn <: AbstractColumn
    job::ProgressJob
    segments::Vector{Segment}
    measure::Measure
    text::String

    function TextColumn(job::ProgressJob; style::String = blue_light, text = "")
        seg = Segment(text, style)
        return new(job, [seg], seg.measure, seg.text)
    end
end

update!(col::TextColumn, args...)::String = col.text

# ----------------------------- separator column ----------------------------- #
struct SeparatorColumn <: AbstractColumn
    job::ProgressJob
    segments::Vector{Segment}
    measure::Measure
    text::String

    function SeparatorColumn(job::ProgressJob)
        seg = Segment("●", TERM_THEME[].progress_accent)
        return new(job, [seg], Measure(1, 1), seg.text)
    end
end

update!(col::SeparatorColumn, args...)::String = col.text

struct SpaceColumn <: AbstractColumn
    job::ProgressJob
    segments::Vector{Segment}
    measure::Measure
    text::String

    function SpaceColumn(job::ProgressJob; width = 1)
        seg = Segment(" "^width, TERM_THEME[].progress_accent)
        return new(job, [seg], seg.measure, seg.text)
    end
end

update!(col::SpaceColumn, args...)::String = col.text

# ----------------------------- completed column ----------------------------- #
struct CompletedColumn <: AbstractColumn
    job::ProgressJob
    segments::Vector{Segment}
    measure::Measure
    text::String
    padwidth::Int
    style::String

    function CompletedColumn(job::ProgressJob; style::String = TERM_THEME[].text_accent)
        if isnothing(job.N)
            seg = Segment(" "^10)
            return new(job, [seg], seg.measure, "", 0, style)
        else
            width = length(string(job.N)) * 2 + 1
            seg = Segment(" "^width)
            text = apply_style(
                "{$style}/{/$style}{($(TERM_THEME[].text_accent)) underline}$(job.N){/($(TERM_THEME[].text_accent)) underline}",
            )
            return new(job, [seg], seg.measure, text, length(digits(job.N)), style)
        end
    end
end

function update!(col::CompletedColumn, color::String, args...)::String
    isnothing(col.job.N) && return apply_style(string(col.job.i), col.style)
    return apply_style(lpad(string(col.job.i), col.padwidth) * col.text, color * " bold")
end

# ----------------------------- percentage column ---------------------------- #
struct PercentageColumn <: AbstractColumn
    job::ProgressJob
    segments::Vector{Segment}
    measure::Measure

    function PercentageColumn(job::ProgressJob)
        seg = Segment(" "^4) # "xxx %
        return new(job, [seg], seg.measure)
    end
end

function update!(col::PercentageColumn, args...)::String
    isnothing(col.job.N) && return ""
    frac = rint(col.job.i / col.job.N * 100)
    p = string(frac)
    return "\e[2m" * (frac == 100 ? p : lpad(p, 3)) * "%\e[0m"
end

# ----------------------------- downloaded column ---------------------------- #
struct DownloadedColumn <: AbstractColumn
    job::ProgressJob
    segments::Vector{Segment}
    measure::Measure
    tot_size::String

    function DownloadedColumn(job::ProgressJob)
        tot_size = get_file_format(job.N)
        seg = Segment(" "^(length(tot_size) * 2 + 1))
        return new(job, [seg], seg.measure, tot_size)
    end
end

function update!(col::DownloadedColumn, args...)::String
    isnothing(col.job.N) && return ""
    completed = get_file_format(col.job.i)

    return lpad(completed * "/" * col.tot_size, col.measure.w)
end

# ---------------------------------------------------------------------------- #
#                                TIMING COLUMNS                                #
# ---------------------------------------------------------------------------- #
# ------------------------------ elapsed column ------------------------------ #

struct ElapsedColumn <: AbstractColumn
    job::ProgressJob
    segments::Vector{Segment}
    measure::Measure
    style::String
    padwidth::Int

    ElapsedColumn(job::ProgressJob; style = TERM_THEME[].progress_elapsedcol_default) =
        new(job, [], Measure(1, 6 + 9), style, 6)
end

function update!(col::ElapsedColumn, args...)::String
    isnothing(col.job.startime) && return " "^(col.measure.w)
    elapsedtime = (now() - col.job.startime).value  # in ms

    # format elapsed message
    msg = if elapsedtime < 1000
        string(elapsedtime, "ms")
    elseif elapsedtime < (60 * 1000)
        # under a minute
        string(round(elapsedtime / 1000; digits = 2), "s")
    else
        # show minutes
        string(round(elapsedtime / (60 * 1000); digits = 2), "min")
    end

    msg = lpad(str_trunc(msg, col.padwidth), col.padwidth)
    return apply_style("elapsed: $(msg)", col.style)
end

# -------------------------------- ETA column -------------------------------- #

struct ETAColumn <: AbstractColumn
    job::ProgressJob
    segments::Vector{Segment}
    measure::Measure
    style::String
    padwidth::Int

    ETAColumn(job::ProgressJob; style = TERM_THEME[].progress_etacol_default) =
        new(job, [], Measure(1, 9 + 11), style, 9)
end

function update!(col::ETAColumn, args...)::String
    isnothing(col.job.startime) && return " "^(col.measure.w)
    isnothing(col.job.N) && return " "^(col.measure.w)

    # get remaining time in ms
    elapsed = (now() - col.job.startime).value  # in ms
    perc = col.job.i / col.job.N
    remaining = elapsed * (1 - perc) / perc

    # format elapsed message
    msg = if remaining < 1000
        string(round(remaining; digits = 0), "ms")
    elseif remaining < (60 * 1000)
        # under a minute
        string(round(remaining / 1000; digits = 2), "s")
    else
        # show minutes
        string(round(remaining / (60 * 1000); digits = 2), "min")
    end

    msg = lpad(str_trunc(msg, col.padwidth), col.padwidth)

    return apply_style("remaining: $(msg)", col.style)
end

# ---------------------------------------------------------------------------- #
#                               PROGRESS COLUMNS                               #
# ---------------------------------------------------------------------------- #

# ------------------------------ progress column ----------------------------- #
mutable struct ProgressColumn <: AbstractColumn
    job::ProgressJob
    segments::Vector{Segment}
    measure::Measure
    nsegs::Int
    completed_char::Char
    remaining_char::Char

    ProgressColumn(
        job::ProgressJob;
        completed_char::Char = '━',
        remaining_char::Char = ' ',
    ) = new(job, Vector{Segment}(), Measure(0, 0), 0, completed_char, remaining_char)
end

function setwidth!(col::ProgressColumn, width::Int)
    col.measure = Measure(1, width)
    return col.nsegs = width
end

function update!(col::ProgressColumn, color::String, args...)::String
    completed = rint(col.nsegs * col.job.i / col.job.N)
    remaining = col.nsegs - completed
    return apply_style(
        "{" *
        color *
        " bold}" *
        col.completed_char^(completed) *
        "{/" *
        color *
        " bold}" *
        col.remaining_char^(remaining),
    )
end

# ------------------------------ spinner columns ----------------------------- #

SPINNERS = Dict(
    :dot => Dict(
        "period" => 100,
        "frames" => [
            "( ●    )",
            "(  ●   )",
            "(   ●  )",
            "(    ● )",
            "(     ●)",
            "(    ● )",
            "(   ●  )",
            "(  ●   )",
            "( ●    )",
            "(●     )",
        ],
    ),
    :circle => Dict("period" => 125, "frames" => ["◐", "◓", "◑", "◒"]),
    :toggle => Dict("period" => 250, "frames" => ["⦾⦿", "⦿⦾"]),
    :toggle2 => Dict("period" => 250, "frames" => ["◯", "⬤"]),
    :bar => Dict(
        "period" => 100,
        "frames" => [
            "(=   )",
            "(==  )",
            "(=== )",
            "( ===)",
            "(  ==)",
            "(   =)",
            "(   =)",
            "(  ==)",
            "( ===)",
            "(====)",
            "(=== )",
            "(==  )",
            "(=   )",
        ],
    ),
    :greek => Dict("period" => 350, "frames" => ["ϴ", "Ω", "Φ", "Ο"]),
)

mutable struct SpinnerColumn <: AbstractColumn
    job::ProgressJob
    segments::Vector{Segment}
    measure::Measure
    frames::Vector{String}
    Δt::Float64                 # how frequently to update display, in milliseconds
    frameidx::Int
    nframes::Int
    lastupdated::Int
    lasttext::String

    function SpinnerColumn(
        job::ProgressJob;
        spinnertype::Symbol = :dot,
        style = TERM_THEME[].progress_spiner_default,
    )
        spinnerdata = copy(SPINNERS[spinnertype])

        spinnerdata["frames"] =
            map(frame -> apply_style(frame, style), spinnerdata["frames"])

        seg = Segment(spinnerdata["frames"][1])

        return new(
            job,
            [seg],
            seg.measure,
            spinnerdata["frames"],
            spinnerdata["period"],
            1,
            length(spinnerdata["frames"]),
            0,
            spinnerdata["frames"][1],
        )
    end
end

function update!(col::SpinnerColumn, args...)::String
    col.job.started || return " "^(col.measure.w)
    col.job.finished &&
        return "{$(TERM_THEME[].progress_spinnerdone_default)}✔{/$(TERM_THEME[].progress_spinnerdone_default)}"

    t = (now() - col.job.startime).value

    if t - col.lastupdated ≥ col.Δt
        col.lastupdated = t
        col.frameidx = col.frameidx == col.nframes ? 1 : col.frameidx + 1
        col.lasttext = col.frames[col.frameidx]
    end

    return col.lasttext
end

# ---------------------------------------------------------------------------- #
#                                COLUMNS PRESETS                               #
# ---------------------------------------------------------------------------- #

function get_columns(columnsset::Symbol)::Vector{DataType}
    return if columnsset ≡ :minimal
        [DescriptionColumn, ProgressColumn]
    elseif columnsset ≡ :default
        [
            DescriptionColumn,
            SeparatorColumn,
            ProgressColumn,
            SeparatorColumn,
            CompletedColumn,
            PercentageColumn,
        ]
    elseif columnsset ≡ :spinner
        [DescriptionColumn, SpaceColumn, SpinnerColumn, SpaceColumn, CompletedColumn]
    elseif columnsset ≡ :detailed
        # extensive
        [
            DescriptionColumn,
            SeparatorColumn,
            ProgressColumn,
            SeparatorColumn,
            CompletedColumn,
            PercentageColumn,
            SeparatorColumn,
            ElapsedColumn,
            ETAColumn,
        ]
    else
        @warn "Columns name not recognized: $columnsset"
        get_columns(:minimal)
    end
end

"""
    This example shows how to use Term's styled logging

It's as simple as calling one function, Term takes care of the rest
so you can use Julia's logging functionality as you would normally
"""

import Term: install_term_logger, uninstall_term_logger, Panel

# install term's logger as the global logger
install_term_logger()

# log
@info "my log!"

"""
as you can see the output is similar to the default logging system, with just
a couple more details. However you can now add markdown style to your
log messages
"""

@warn "tell us if this was {bold red}undexpected!{/bold red}"

"""
but there's more!
Just like in the normal logging system you can pass additional arguments to the logging macro.
Term's logger prints them with additional information, and some style of course.
"""

x = collect(1:2:20)
y = x * x'
name = "the name is {bold blue}Term{/bold blue}"
p1 = Panel("text")

print('\n'^3)
@error "{italic green bold}fancy logs!{/italic green bold}" x y name √9 install_term_logger p1

"""
You can reset Julia's default logger like this:
"""

uninstall_term_logger()
@error "{italic green bold}fancy logs!{/italic green bold}" x y name √9 install_term_logger p1

import Term: install_term_logger, uninstall_term_logger, TermLogger
using Term.Logs: handle_progress
using Term.Progress

import ProgressLogging
import UUIDs: uuid4

struct MyLogsStruct
    x::String
    y::Vector
    z::Int
end

@testset "\e[34mLOGS test" begin
    install_term_logger()
    println("\nTesting logging, stdout temporarily disabled")

    output = @capture_out begin
        @info "my log!"

        @warn "tell us if this was {bold red}undexpected!{/bold red}"

        x = collect(1:2:20)
        y = x * x'
        name = "the name is [bold blue]Term[/bold blue]"
        p1 = Panel("text")

        @error "[italic green bold]fancy logs![/italic green bold]" x y name √9 install_term_logger p1

        @info """asdada asdasd\nasdada;
        asdadaada
        asdadaxc

        sdfs
        s""" 1 + 2

        @info MyStruct("aa a"^100, zeros(200), 4)

        @info "A" zeros(100, 100) zeros(10) zeros(100, 100, 100)
        @info "B" (1, 2)
        @info "C" Panel()
        @info "D" Dict{Symbol,Number}(Symbol(x) => x for x in 1:100)
    end

    # IS_WIN || @compare_to_string output "logs.txt"

    uninstall_term_logger()
end

# @testset "\e[34mLOGS handle_progress" begin
#     logger = TermLogger(devnull, TERM_THEME[])
#     for fraction in (nothing, 0.0, 0.5, 1.0)
#         handle_progress(logger, ProgressLogging.Progress(id = uuid4(), fraction = fraction))
#     end

#     @test true
# end

import Term.Renderables: Renderable

using Term.Layout

import Term:
    Measure,
    RenderableText,
    Spacer,
    vLine,
    hLine,
    cleantext,
    textlen,
    chars,
    Panel,
    vstack,
    center!,
    leftalign!,
    rightalign!,
    leftalign,
    center,
    rightalign,
    lvstack,
    cvstack,
    rvstack,
    default_width

@testset "Layout - pad" begin
    @test pad("aaa", 20, :left) == "aaa                 "
    @test pad("aaa", 20, :right) == "                 aaa"
    @test pad("aaa", 20, :center) == "        aaa         "
    @test pad("aaa", 10, 20) == "          aaa                    "

    p = Panel(height = 10, width = 20)
    pad!(p, 20, 20)
    @test p isa Panel
    @test size(p.measure) == (10, 60)

    p = Panel(height = 10, width = 20)
    pad!(p; width = 30)
    @test p isa Panel
    @test size(p.measure) == (10, 30)
end

@testset "Layout - vertical pad" begin
    @test vertical_pad("ab", 5, :top) == "ab\n  \n  \n  \n  "
    @test vertical_pad("ab", 5, :bottom) == "  \n  \n  \n  \nab"
    @test vertical_pad("ab", 5, :center) == "  \n  \nab\n  \n  "

    @test vertical_pad("ab", 5, 5) == "  \n  \n  \n  \n  \nab\n  \n  \n  \n  \n  "

    p = Panel(height = 10, width = 20)
    @test string(vertical_pad(p, 4, 4)) ==
          "                    \n                    \n                    \n                    \n\e[0m\e[22m╭──────────────────╮\e[22m\e[0m\n\e[22m│\e[22m                  \e[22m│\e[22m\n\e[22m│\e[22m                  \e[22m│\e[22m\n\e[22m│\e[22m                  \e[22m│\e[22m\n\e[22m│\e[22m                  \e[22m│\e[22m\n\e[22m│\e[22m                  \e[22m│\e[22m\n\e[22m│\e[22m                  \e[22m│\e[22m\n\e[22m│\e[22m                  \e[22m│\e[22m\n\e[22m│\e[22m                  \e[22m│\e[22m\n\e[0m\e[22m╰──────────────────╯\e[22m\e[0m\e[0m\n                    \n                    \n                    \n                    "

    vertical_pad!(p, 4, 4)
    @test p isa Panel
    @test size(p.measure) == (18, 20)

    p = Panel(height = 10, width = 20)
    vertical_pad!(p; height = 30)
    @test p isa Panel
    @test size(p.measure) == (30, 20)

    p = Panel(height = 2, width = 4)
    @test string(vertical_pad(p; height = 5, method = :top)) ==
          "\e[0m\e[22m╭──╮\e[22m\e[0m\n\e[22m│\e[22m  \e[22m│\e[22m\n\e[0m\e[22m╰──╯\e[22m\e[0m\e[0m\n    \n    "
    @test string(vertical_pad(p; height = 5, method = :bottom)) ==
          "    \n    \n\e[0m\e[22m╭──╮\e[22m\e[0m\n\e[22m│\e[22m  \e[22m│\e[22m\n\e[0m\e[22m╰──╯\e[22m\e[0m\e[0m"
    @test string(vertical_pad(p; height = 5, method = :center)) ==
          "    \n\e[0m\e[22m╭──╮\e[22m\e[0m\n\e[22m│\e[22m  \e[22m│\e[22m\n\e[0m\e[22m╰──╯\e[22m\e[0m\e[0m\n    "
end

@testset "\e[34mlayout - spacer" begin
    sizes = [(22, 1), (44, 123), (21, 1), (4334, 232)]
    for (w, h) in sizes
        spacer = Spacer(h, w)
        @test size(spacer.measure) == (h, w)

        spacer = Spacer(h + 0.1, w + 0.1)
        @test size(spacer.measure) == (h, w)
    end
end

@testset "\e[34mlayout - justification" begin
    make_panels() = (Panel(width = 5), Panel(width = 10), Panel(width = 15))

    # right justify
    p1, p2, p3 = make_panels()

    rightalign!(p1, p2, p3)
    @test p1 isa Panel
    @test p1.measure.w == p2.measure.w == p3.measure.w

    # right justify
    p1, p2, p3 = make_panels()

    center!(p1, p2, p3)
    @test p1 isa Panel
    @test p1.measure.w == p2.measure.w == p3.measure.w

    # right justify
    p1, p2, p3 = make_panels()
    leftalign!(p1, p2, p3)
    @test p1 isa Panel
    @test p1.measure.w == p2.measure.w == p3.measure.w

    # convenience functions
    p1, p2, p3 = make_panels()
    pp = lvstack(p1, p2, p3)
    @test pp isa Renderable
    @test pp.measure.w == 15
    @test string(pp) ==
          "\e[0m\e[22m╭───╮\e[22m\e[0m          \n\e[22m│\e[22m   \e[22m│\e[22m          \n\e[0m\e[22m╰───╯\e[22m\e[0m\e[0m          \n\e[0m\e[22m╭────────╮\e[22m\e[0m     \n\e[22m│\e[22m        \e[22m│\e[22m     \n\e[0m\e[22m╰────────╯\e[22m\e[0m\e[0m     \n\e[0m\e[22m╭─────────────╮\e[22m\e[0m\n\e[22m│\e[22m             \e[22m│\e[22m\n\e[0m\e[22m╰─────────────╯\e[22m\e[0m\e[0m"
    @test p1 isa Panel
    @test p1.measure.w == 5

    p1, p2, p3 = make_panels()
    pp = cvstack(p1, p2, p3)
    @test pp isa Renderable
    @test pp.measure.w == 15
    @test string(pp) ==
          "     \e[0m\e[22m╭───╮\e[22m\e[0m     \n     \e[22m│\e[22m   \e[22m│\e[22m     \n     \e[0m\e[22m╰───╯\e[22m\e[0m\e[0m     \n  \e[0m\e[22m╭────────╮\e[22m\e[0m   \n  \e[22m│\e[22m        \e[22m│\e[22m   \n  \e[0m\e[22m╰────────╯\e[22m\e[0m\e[0m   \n\e[0m\e[22m╭─────────────╮\e[22m\e[0m\n\e[22m│\e[22m             \e[22m│\e[22m\n\e[0m\e[22m╰─────────────╯\e[22m\e[0m\e[0m"
    @test p1 isa Panel
    @test p1.measure.w == 5

    p1, p2, p3 = make_panels()
    pp = rvstack(p1, p2, p3)
    @test pp isa Renderable
    @test pp.measure.w == 15
    @test string(pp) ==
          "          \e[0m\e[22m╭───╮\e[22m\e[0m\n          \e[22m│\e[22m   \e[22m│\e[22m\n          \e[0m\e[22m╰───╯\e[22m\e[0m\e[0m\n     \e[0m\e[22m╭────────╮\e[22m\e[0m\n     \e[22m│\e[22m        \e[22m│\e[22m\n     \e[0m\e[22m╰────────╯\e[22m\e[0m\e[0m\n\e[0m\e[22m╭─────────────╮\e[22m\e[0m\n\e[22m│\e[22m             \e[22m│\e[22m\n\e[0m\e[22m╰─────────────╯\e[22m\e[0m\e[0m"
    @test p1 isa Panel
    @test p1.measure.w == 5
end

@testset "\e[34mlayout - vLine " begin
    for h in [1, 22, 55, 11]
        line = vLine(h)
        @test length(line.segments) == h
        @test line.measure.h == h
    end

    lines = [(22, "bold"), (55, "red on_green")]
    for (h, style) in lines
        line = vLine(h; style = style)
        @test length(line.segments) == h
        @test line.measure.h == h
    end
    line = vLine(5; style = "red")
    @test line.segments[1].text == "\e[31m│\e[39m\e[0m"

    for box in (:MINIMAL_DOUBLE_HEAD, :DOUBLE, :ASCII, :DOUBLE_EDGE)
        @test vLine(22; box = box).measure.h == 22
    end

    panel = Panel(height = 5, width = 20)
    @test length(vLine(panel).segments) == 5
    @test vLine().measure.h == displaysize(stdout)[1]
end

@testset "\e[34mlayout - hLine " begin
    for w in [1, 342, 433, 11, 22]
        line = hLine(w)
        @test length(line.segments) == 1
        @test textlen(line.segments[1].text) == w
        @test line.measure.w == w
    end

    for box in (:MINIMAL_DOUBLE_HEAD, :DOUBLE, :ASCII, :DOUBLE_EDGE)
        @test hLine(22; box = box).measure.w == 22
        @test hLine(22, "title"; box = box).measure.w == 22
    end

    for style in ("bold", "red on_green", "blue")
        @test textlen(hLine(11; style = style).segments[1].text) == 11
        @test textlen(hLine(11, "ttl"; style = style).segments[1].text) == 11
    end

    panel = Panel(height = 5, width = 20)
    @test hLine().measure.w == TEST_CONSOLE_WIDTH
    @test textlen(hLine(panel).segments[1].text) == 20
end

@testset "\e[34mlayout - stack strings" begin
    s1 = "."^50
    s2 = ".\n"^5 * "."
    @test s1 / s2 isa String
end

function testlayout(p, w, h)
    _p = string(p)
    widths = textwidth.(cleantext.(split(_p, "\n")))
    @test length(unique(widths)) == 1

    @test p.measure.w == w
    @test textlen(cleantext(p.segments[1].text)) == w
    @test length(chars(cleantext(p.segments[1].text))) == w

    @test p.measure.h == h
    @test length(p.segments) == h
end

@testset "\e[34mlayout - renderable" begin
    r1 = RenderableText("."^100; width = 25)
    r2 = RenderableText("."^100; width = 50)

    r = r1 / r2
    @test size(r.measure) == (8, 50)

    h1, h2 = hLine(22), hLine(33)
    @test size(Measure(h1 / h2)) == (2, 33)

    r1 = RenderableText("."^100; width = 25)
    r2 = RenderableText("."^100; width = 50)

    r = r1 * r2
    @test size(r.measure) == (5, 75)

    # stack other renderables
    h1, h2 = vLine(22), vLine(33)
    @test size(Measure(h1 * h2)) == (33, 2)
end

@testset "\e[34mlayout - panels" begin
    p1 = Panel()
    p2 = Panel(height = 3, width = 24)
    p3 = Panel("this {red}panel{/red}"^5; width = 30, fit = false)

    testlayout(p2 * p2, p2.measure.w + p2.measure.w, 3)
    testlayout(p1 / p2, TEST_CONSOLE_WIDTH, 6)

    testlayout(p2 * p1, p1.measure.w + p2.measure.w, 3)
    testlayout(p2 / p1, TEST_CONSOLE_WIDTH, 6)

    w = p1.measure.w + p2.measure.w + p3.measure.w
    testlayout(p1 * p2 * p3, w, 5)
    testlayout(p1 / p2 / p3, TEST_CONSOLE_WIDTH, 11)
    testlayout(p3 * p1 * p2, w, 5)
    testlayout(p3 / p1 / p2, TEST_CONSOLE_WIDTH, 11)
end

@testset "\e[34mlayout - placeholder" begin
    ph = PlaceHolder(2, 4)
    @test length(ph.segments) == 2
    @test size(ph.measure) == (2, 4)
    @test string(ph) == "\e[2m╲ ╲ \e[22m\n\e[2m ╲ ╲\e[22m"

    @test string(PlaceHolder(12, 25)) ==
          "\e[2m╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲\e[22m\n\e[2m ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ \e[22m\n\e[2m╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲\e[22m\n\e[2m ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ \e[22m\n\e[2m╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲\e[22m\n\e[2m ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ \e[22m\n\e[2m╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲\e[22m\n\e[2m ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ \e[22m\n\e[2m╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲\e[22m\n\e[2m ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ \e[22m\n\e[2m╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲\e[22m\n\e[2m ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ \e[22m"

    p = Panel(height = 4, width = 8)
    @test size(PlaceHolder(p).measure) == size(p.measure)
end

@testset "Layout - h/vstack with pad" begin
    p1, p2, p3 = PlaceHolder(5, 5), PlaceHolder(5, 5), PlaceHolder(6, 3)

    @test string(hstack(p1, p2, p3; pad = 10)) ==
          "\e[2m╲ ╲ ╲\e[22m          \e[2m╲ ╲ ╲\e[22m          \e[2m╲ ╲\e[22m\n\e[2m ╲ ╲ \e[22m          \e[2m ╲ ╲ \e[22m          \e[2m ╲ \e[22m\n\e[2m╲ ╲ ╲\e[22m          \e[2m╲ ╲ ╲\e[22m          \e[2m╲ ╲\e[22m\n\e[2m ╲ ╲ \e[22m          \e[2m ╲ ╲ \e[22m          \e[2m ╲ \e[22m\n\e[2m╲ ╲ ╲\e[22m          \e[2m╲ ╲ ╲\e[22m          \e[2m╲ ╲\e[22m\n                              \e[2m ╲ \e[22m"
    @test string(hstack(p1, p2, p3; pad = 0)) ==
          "\e[2m╲ ╲ ╲\e[22m\e[2m╲ ╲ ╲\e[22m\e[2m╲ ╲\e[22m\n\e[2m ╲ ╲ \e[22m\e[2m ╲ ╲ \e[22m\e[2m ╲ \e[22m\n\e[2m╲ ╲ ╲\e[22m\e[2m╲ ╲ ╲\e[22m\e[2m╲ ╲\e[22m\n\e[2m ╲ ╲ \e[22m\e[2m ╲ ╲ \e[22m\e[2m ╲ \e[22m\n\e[2m╲ ╲ ╲\e[22m\e[2m╲ ╲ ╲\e[22m\e[2m╲ ╲\e[22m\n          \e[2m ╲ \e[22m"

    @test string(vstack(p1, p2, p3; pad = 0)) ==
          "\e[2m╲ ╲ ╲\e[22m\n\e[2m ╲ ╲ \e[22m\n\e[2m╲ ╲ ╲\e[22m\n\e[2m ╲ ╲ \e[22m\n\e[2m╲ ╲ ╲\e[22m\n\e[2m╲ ╲ ╲\e[22m\n\e[2m ╲ ╲ \e[22m\n\e[2m╲ ╲ ╲\e[22m\n\e[2m ╲ ╲ \e[22m\n\e[2m╲ ╲ ╲\e[22m\n\e[2m╲ ╲\e[22m  \n\e[2m ╲ \e[22m  \n\e[2m╲ ╲\e[22m  \n\e[2m ╲ \e[22m  \n\e[2m╲ ╲\e[22m  \n\e[2m ╲ \e[22m  "
    @test string(vstack(p1, p2, p3; pad = 3)) ==
          "\e[2m╲ ╲ ╲\e[22m\n\e[2m ╲ ╲ \e[22m\n\e[2m╲ ╲ ╲\e[22m\n\e[2m ╲ ╲ \e[22m\n\e[2m╲ ╲ ╲\e[22m\n     \n     \n     \n\e[2m╲ ╲ ╲\e[22m\n\e[2m ╲ ╲ \e[22m\n\e[2m╲ ╲ ╲\e[22m\n\e[2m ╲ ╲ \e[22m\n\e[2m╲ ╲ ╲\e[22m\n     \n     \n     \n\e[2m╲ ╲\e[22m  \n\e[2m ╲ \e[22m  \n\e[2m╲ ╲\e[22m  \n\e[2m ╲ \e[22m  \n\e[2m╲ ╲\e[22m  \n\e[2m ╲ \e[22m  "
end

using Term.Boxes
import Term: Segment

@testset "\e[34mBOX" begin
    testbox = Term.Boxes.Box(
        "ASCII",
        """
        +--+
        | ||
        |-+|
        | ||
        |-+|
        |-+|
        | ||
        +--+
        """,
    )

    @test string(testbox) == "Box\e[2m(ASCII)\e[0m"

    @suppress_out begin
        @test_nothrow println(stdout, testbox)
    end

    _bstring = Term.Boxes.fit(Term.Boxes.BOXES[:ASCII], [1, 1, 1, 1, 1, 1, 1, 1])
    @test _bstring ==
          "+---------------+\n| | | | | | | | |\n|-+-+-+-+-+-+-+-|\n| | | | | | | | |\n|-+-+-+-+-+-+-+-|\n|-+-+-+-+-+-+-+-|\n| | | | | | | | |\n+---------------+"

    # test get row
    @test get_row(Term.Boxes.BOXES[:ROUNDED], [3], :top) == "╭───╮"
    @test get_row(Term.Boxes.BOXES[:ROUNDED], 3, :top) == "╭─╮"
    @test get_row(Term.Boxes.BOXES[:ROUNDED], [3, 5], :top) == "╭───┬─────╮"

    # test get title row with no justification
    tr = get_title_row(:top, Term.Boxes.BOXES[:ROUNDED], nothing; width = 22, style = "red")
    @test tr isa Segment
    @test tr.measure.w == 22

    # test title row with justification
    left = get_title_row(
        :top,
        Term.Boxes.BOXES[:ROUNDED],
        "test";
        width = 22,
        justify = :left,
        title_style = "blue",
        style = "red",
    )
    @test left.measure.w == 22
    @test left.text ==
          "\e[31m╭──── \e[34mtest\e[39m\e[31m\e[31m ──────────╮\e[39m\e[0m\e[39m"

    right = get_title_row(
        :top,
        Term.Boxes.BOXES[:ROUNDED],
        "test";
        width = 22,
        justify = :right,
        title_style = "blue",
        style = "red",
    )
    @test right.measure.w == 22
    @test right.text ==
          "\e[31m╭─────────── \e[34mtest\e[39m\e[31m\e[31m ───╮\e[39m\e[0m\e[39m"

    center = get_title_row(
        :top,
        Term.Boxes.BOXES[:ROUNDED],
        "test";
        width = 22,
        justify = :center,
        title_style = "blue",
        style = "red",
    )
    @test center.measure.w == 22
    @test center.text ==
          "\e[31m╭─────── \e[34mtest\e[39m\e[31m\e[31m ───────╮\e[39m\e[0m\e[39m"

    for width in (15, 21, 33, 58), justify in (:left, :center, :right)
        line = get_title_row(
            :top,
            Term.Boxes.BOXES[:DOUBLE],
            "test";
            width = width,
            justify = justify,
            title_style = "on_green",
            style = "blue bold",
        )

        @test line.measure.w == width
    end
end

import Term: Panel, TextBox, apply_style, default_width, str_trunc
import Term.Layout: PlaceHolder

@testset "\e[34mPanel - no content" begin
    @test size(Panel(height = 4, width = 10)) == (4, 10)

    for style in ("default", "red", "on_blue")
        @testpanel(Panel(fit = true, style = style), 2, 3)
        @testpanel(Panel(), 3, TEST_CONSOLE_WIDTH)
        @testpanel(Panel(height = 4, width = 12, style = style), 4, 12)
    end
end

@testset "\e[34mPanel - basic shape" begin
    @testpanel(Panel("MYTEXT"; height = 10, width = 60), 10, 60)
    @testpanel(Panel("MYTEXT"; width = 60), 3, 60)
    @testpanel(Panel("MYTEXT"), 3, TEST_CONSOLE_WIDTH)
    @testpanel(Panel("MYTEXT", fit = true), 3, 12)

    @testpanel(Panel("MYTEXT"; height = 10, width = 60, padding = (4, 4, 2, 2)), 10, 60)
    @testpanel(Panel("MYTEXT"; width = 60, padding = (4, 4, 2, 2)), 7, 60)
    @testpanel(Panel("MYTEXT"; padding = (4, 4, 2, 2)), 7, TEST_CONSOLE_WIDTH)
    @testpanel(Panel("MYTEXT"; padding = (4, 4, 2, 2), fit = true), 7, 16)
end

@testset "\e[34mPanel - fit overflow" begin
    inside = Panel("MYTEXT"^50; height = 10)
    @testpanel(inside, 10, 80)
    @testpanel(Panel(inside / inside, fit = true), 42, TEST_CONSOLE_WIDTH,)
    @testpanel(Panel(inside / inside, fit = false), 42, TEST_CONSOLE_WIDTH,)
end

@testset "\e[34mPANEL - fit - measure" begin
    for style in ("default", "red", "on_blue")
        # ----------------------------- text only content ---------------------------- #
        _kw = (fit = true, style = style)
        @testpanel(Panel("t"; _kw...), 3, 7)
        @testpanel(Panel("test"; _kw...), 3, 10)
        @testpanel(Panel("1234\n123456789012"; _kw...), 4, 18)
        @testpanel(Panel("나랏말싸미 듕귁에 달아"; _kw...), 3, 28)
        @testpanel(Panel("나랏말싸미 듕귁에 달아\n1234567890123456789012"; _kw...), 4, 28)
        @testpanel(Panel("°"^500; _kw...), 9, TEST_CONSOLE_WIDTH)

        # ------------------------------- nested panels ------------------------------ #
        @testpanel(Panel(Panel("test"; _kw...); _kw...), 5, 16)

        @testpanel(
            Panel(Panel(Panel("°"; _kw...); _kw...); fit = true, style = style),
            7,
            19,
        )
    end
end

@testset "\e[34mPANEL - nofit - measure" begin
    for style in ("default", "red", "on_blue")
        @testpanel(Panel("t"; style = style, fit = false), 3, TEST_CONSOLE_WIDTH)
        @testpanel(Panel("test"; style = style, fit = false), 3, TEST_CONSOLE_WIDTH)
        @testpanel(
            Panel("1234\n123456789012"; style = style, fit = false),
            4,
            TEST_CONSOLE_WIDTH
        )
        @testpanel(Panel("나랏말싸미 듕귁에 달아"; style = style, fit = false), 3, TEST_CONSOLE_WIDTH)
        @testpanel(
            Panel("나랏말싸미 듕귁에 달아\n1234567890123456789012"; style = style, fit = false),
            4,
            TEST_CONSOLE_WIDTH,
        )
        for justify in (:left, :center, :right)
            # ----------------------------- text only content ---------------------------- #
            _kw = (justify = justify, style = style)
            _nofit = (; fit = false, _kw...)
            @testpanel(Panel("°"^1500; _nofit...), 23, TEST_CONSOLE_WIDTH)

            # ------------------------------- nested panels ------------------------------ #
            @testpanel(Panel(Panel("test", fit = true); _nofit...), 5, TEST_CONSOLE_WIDTH)

            # @testpanel(Panel(Panel(Panel("°", fit=true); _nofit...); _nofit...), nothing, TEST_CONSOLE_WIDTH)

            # NOTE: using a panel with arbitrary long text can fail testing on wide terminals, since
            # the final `height` can vary (github.com/FedeClaudi/Term.jl/issues/112)
            @testpanel(Panel(Panel("°"^250); _nofit...), 14, TEST_CONSOLE_WIDTH)

            @testpanel(
                Panel(Panel("test"; _kw...); fit = false),
                nothing,
                TEST_CONSOLE_WIDTH
            )

            @testpanel(
                Panel(
                    Panel("t1"; fit = true, _kw...),
                    Panel("t2"; fit = true, _kw...);
                    fit = false,
                ),
                8,
                TEST_CONSOLE_WIDTH
            )

            @testpanel(
                Panel(
                    [Panel("t1"; fit = true, _kw...), Panel("t2"; fit = true, _kw...)];
                    fit = false,
                ),
                8,
                TEST_CONSOLE_WIDTH
            )

            _kw = (fit = false, height = 8, width = 30)
            @testpanel(Panel(Panel("test"; width = 22); _kw...), 8, 30)

            @testpanel(Panel(Panel("test"; width = 42); _kw...), 8, 30)

            @testpanel(
                Panel(
                    Panel("test"; height = 12, width = 42);
                    fit = false,
                    height = 8,
                    width = 30,
                ),
                8,
                30,
            )
        end
    end
end

@testset "\e[34mPANEL - FIT - measure" begin
    @testpanel(Panel("t"; fit = true), 3, 7)
    @testpanel(Panel("test"; fit = true), 3, 10)
    @testpanel(Panel("1234\n123456789012"; fit = true), 4, 18)
    @testpanel(Panel("나랏말싸미 듕귁에 달아"; fit = true), 3, 28)
    @testpanel(Panel("나랏말싸미 듕귁에 달아\n1234567890123456789012"; fit = true), 4, 28)
    for justify in (:left, :center, :right)
        # ----------------------------- text only content ---------------------------- #
        _kw = (fit = true, justify = justify)
        @testpanel(Panel("°"^1500; _kw...), nothing, TEST_CONSOLE_WIDTH)

        # ------------------------------- nested panels ------------------------------ #
        @testpanel(Panel(Panel("test", fit = true); _kw...), 5, 16)

        @testpanel(Panel(Panel(Panel("°", fit = true); _kw...); _kw...), 7, 19)

        @testpanel(
            Panel(Panel("°"^250, fit = true); _kw...),
            # WIDE_TERM ? nothing : 8,
            14,
            TEST_CONSOLE_WIDTH
        )

        @testpanel(Panel(Panel("test"; _kw...); fit = true), 5, 16)

        @testpanel(Panel(Panel(Panel("°"; _kw...); _kw...); fit = true), 7, 19,)

        @testpanel(Panel(Panel("t1"; _kw...), Panel("t2"; _kw...); fit = true), 8, 14,)

        _kw = (fit = true, width = 30, height = 8)
        @testpanel(Panel(Panel("test"; width = 22); _kw...), 8, 28)

        @testpanel(Panel(Panel("test"; width = 42); _kw...), 8, 48)

        @testpanel(Panel(Panel("test"; height = 12, width = 42); _kw...), 14, 48)
    end
end

@testset "PANEL - centered title style" begin
    for (i, just) in enumerate([:left, :center, :right])
        p = Panel(
            title = "test",
            width = 40,
            title_justify = just,
            title_style = "italic red",
        )
        @testpanel(p, nothing, 40)
        IS_WIN || @compare_to_string(p, "centered_title_panel_$(i)")

        p = Panel(title = "test", width = 50, title_justify = just)
        IS_WIN || @compare_to_string(p, "centered_title_panel_$(i+3)")
        @testpanel(p, nothing, 50)
    end

    p = Panel(
        title = "test",
        title_justify = :left,
        subtitle = "aaaaa",
        subtitle_justify = :right,
        width = 22,
    )
    IS_WIN || @compare_to_string(p, "centered_titile_panel_7")
end

@testset "PANEL - small panel with title" begin
    for (i, w) in enumerate((5, 9, 10, 11, 12, 13, 14, 15))
        for (j, title) in enumerate(("aa", "aaaa", "aaaaaa", "adadasdoajdoaidjaldad"))
            for (k, just) in enumerate([:left, :center, :right])
                p = Panel(;
                    width = w,
                    title = title,
                    title_justify = just,
                    style = "hidden",
                )
                IS_WIN || @compare_to_string(p, "small_panel_title_$(i)_$(j)_$(k)")
            end
        end
    end
end

@testset "PANEL - compare to string" begin
    pts = """
Lorem{red} ipsum dolor s{/red}it amet, consectetur adipiscing elit,
ed do eiusmod tempor {bold blue}incididu{underline}nt ut labore et dolore magna aliqua. Ut enim ad minim
veniam, quis nos{/underline}trud exercitation ullamco laboris nisi ut aliquip ex 
ea commodo consequat. Duis aute {/bold blue}{red on_black}irure dolor in reprehenderit 
in voluptate velit esse cillum dolore eu fugiat nulla 
pariatur. Excepteur sint occaecat{/red on_black} cupidatat non proident, 
sunt in {green}culpa qui officia{/green} deserunt mollit anim 
id est laborum."""

    pts = replace(pts, "\n" => "")

    pts2 = replace(
        """
Lorem ipsum {bold}dolor sit{/bold} amet, consectetur adipiscing elit,
ed do e{red}iusmod tempor incididunt{/red} ut {bold}labore et {underline}dolore{/underline} magna aliqua.{/bold} Ut enim ad minim
veniam, quis{green} nostrud exercitation {on_black}ullamco laboris nisi ut aliquip ex {/on_black}
ea commodo consequat.{blue} Duis aute irure dolor in{/blue} reprehenderit 
in voluptate velit{/green} esse {italic}cillum dolore{/italic}{red} eu{/red}{italic green} fugiat {/italic green}nulla 
pariatur. Excepteur{red} sint{/red}{blue} occaecat cupidatat {/blue}non proident, 
sunt in culpa qui {italic}officia{/italic} deserunt mollit anim 
id est laborum.""",
        "\n" => "",
    )

    @testpanel(Panel(pts2; fit = false, width = 44), nothing, 44)
    @testpanel(Panel(pts2; fit = false, width = 51), nothing, 51)
    @testpanel(Panel(pts2; fit = false, width = 67), nothing, 67)

    circle = """
          oooo    
       oooooooooo 
      oooooooooooo
      oooooooooooo
       oooooooooo 
          oooo    """
    p = Panel(circle; fit = true, padding = (2, 2, 0, 0))
    @test string(p) ==
          "\e[0m\e[22m╭────────────────╮\e[22m\e[0m\n\e[22m│\e[22m      oooo      \e[22m│\e[22m\n\e[22m│\e[22m   oooooooooo   \e[22m│\e[22m\n\e[22m│\e[22m  oooooooooooo  \e[22m│\e[22m\n\e[22m│\e[22m  oooooooooooo  \e[22m│\e[22m\n\e[22m│\e[22m   oooooooooo   \e[22m│\e[22m\n\e[22m│\e[22m      oooo      \e[22m│\e[22m\n\e[0m\e[22m╰────────────────╯\e[22m\e[0m\e[0m"

    p = Panel(
        "test"^25;
        height = 22,
        width = 49,
        box = :HEAVY,
        justify = :center,
        title = "description",
        title_justify = :center,
        title_style = "bold bright_blue",
        padding = (2, 4, 4, 2),
        fit = false,
    )
    @test size(p.measure) == (22, 49)

    p = Panel(
        "test"^25;
        height = 22,
        width = 49,
        box = :SIMPLE,
        justify = :center,
        title = "description",
        title_justify = :center,
        title_style = "bold bright_blue",
        padding = (2, 4, 4, 2),
        fit = false,
    )
    @test size(p.measure) == (22, 49)

    p = Panel(
        PlaceHolder(60, 30);
        height = 22,
        width = 49,
        box = :HEAVY,
        justify = :center,
        title = "description",
        title_justify = :center,
        title_style = "bold bright_blue",
        padding = (2, 0, 2, 0),
        fit = false,
    )
    @test size(p.measure) == (22, 49)
end

@testset "\e[34mPANEL - titles" begin
    style = "red"
    for fit in (true, false)
        for justify in (:left, :center, :right)
            @testpanel(
                Panel(
                    "°"^50;
                    title = "test",
                    title_style = style,
                    title_justify = justify,
                    subtitle = "subtest",
                    subtitle_style = style,
                    subtitle_justify = justify,
                    fit = fit,
                ),
                3,
                fit ? nothing : default_width(),
            )
        end
    end
end

@testset "\e[34mPanel - padding" begin
    p = Panel("°"^24; padding = (4, 4, 2, 2), fit = false)
    @testpanel(p, 7, default_width())

    p = Panel("°"^24; padding = (4, 4, 2, 2), fit = true)
    @testpanel(p, 7, 34)
end

@testset "\e[34mPanel - background" begin
    p = Panel(
        RenderableText(
            "testste";
            style = "white on_red",
            background = "on_blue",
            width = 25,
        );
        background = "green",
    )
    IS_WIN || @compare_to_string p "panel_background_1"

    p = Panel(apply_style(
        """
    asasd
asdasadas
asdsasdasdsadasdsa
ads
    """,
        "on_blue",
    ); background = "on_red", fit = true)

    IS_WIN || @compare_to_string p "panel_background_2"
end

@testset "\e[34mPANEL - UnicodePlots" begin
    # using UnicodePlots; pl = lineplot(1:2; padding=0, margin=0); str = UnicodePlots.no_ansi_escape(string(pl))
    str = """
     ┌────────────────────────────────────────┐
    2│⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⡠⠊│
     │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⡠⠔⠁⠀⠀│
     │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⠔⠊⠀⠀⠀⠀⠀│
     │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⡠⠊⠁⠀⠀⠀⠀⠀⠀⠀│
     │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⡠⠔⠁⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
     │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⠔⠊⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
     │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⡠⠊⠁⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
     │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⡠⠔⠁⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
     │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⠔⠊⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
     │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⡠⠊⠁⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
     │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⡠⠔⠁⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
     │⠀⠀⠀⠀⠀⠀⠀⠀⢀⠔⠊⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
     │⠀⠀⠀⠀⠀⢀⡠⠊⠁⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
     │⠀⠀⠀⡠⠔⠁⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
    1│⣀⠔⠊⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀│
     └────────────────────────────────────────┘
     ⠀1⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀2⠀"""
    p = Panel(str; fit = true, style = "hidden")
    @test Term.remove_ansi(string(p)) == """
    ╭───────────────────────────────────────────╮
    │ ┌────────────────────────────────────────┐│
    │2│⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⡠⠊││
    │ │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⡠⠔⠁⠀⠀││
    │ │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⠔⠊⠀⠀⠀⠀⠀││
    │ │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⡠⠊⠁⠀⠀⠀⠀⠀⠀⠀││
    │ │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⡠⠔⠁⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀││
    │ │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⠔⠊⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀││
    │ │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⡠⠊⠁⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀││
    │ │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⡠⠔⠁⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀││
    │ │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⠔⠊⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀││
    │ │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⡠⠊⠁⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀││
    │ │⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⡠⠔⠁⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀││
    │ │⠀⠀⠀⠀⠀⠀⠀⠀⢀⠔⠊⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀││
    │ │⠀⠀⠀⠀⠀⢀⡠⠊⠁⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀││
    │ │⠀⠀⠀⡠⠔⠁⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀││
    │1│⣀⠔⠊⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀││
    │ └────────────────────────────────────────┘│
    │ ⠀1⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀2⠀│
    ╰───────────────────────────────────────────╯"""
end

@testset "\e[34mPANEL - nested panels macro" begin
    pns = @nested_panels Panel(
        Panel("inner", Panel("out", Panel("deep")); style = "green"),
        Panel("inner2 "^25; height = 5),
        "test",
        RenderableText("adasdasda"),
        Panel(; style = "red on_black");
        height = 20,
        style = "red",
    )

    IS_WIN || @compare_to_string(pns, "panels_layout_macro")

    pns = @nested_panels Panel(
        Panel(Panel()),
        Panel(Panel("red"); style = "red on_black"),
        Panel(),
        Panel(; style = "red"),
        "done";
        height = 20,
        style = "red",
    )

    IS_WIN || @compare_to_string(pns, "panels_layout_macro2")

    pns = @nested_panels Panel()
    IS_WIN || @compare_to_string(pns, "panels_layout_macro3")

    pns = @nested_panels Panel(Panel())
    IS_WIN || @compare_to_string(pns, "panels_layout_macro4")

    pns = @nested_panels Panel(Panel("a"), Panel("b"))
    IS_WIN || @compare_to_string(pns, "panels_layout_macro5")

    pns = @nested_panels Panel(Panel("a"), Panel("b"; style = "green"); style = "red")
    IS_WIN || @compare_to_string(pns, "panels_layout_macro6")
end

@testset "PANEL - constructors" begin
    p1, p2 = Panel(; width = 5), Panel(; width = 8)
    p = Panel([p1, p2])
    IS_WIN || @compare_to_string(string(p), "panels_constructors_1")

    p = Panel(string.([p1, p2]))
    IS_WIN || @compare_to_string(string(p), "panels_constructors_2")
end

using Term.Prompts
import Term.Prompts: validate_answer, AnswerValidationError

@testset "Prompt, Creation" begin
    basic = Prompt("basic prompt?")
    basic_with_color = Prompt("basic prompt?", "red")

    type_prompt = TypePrompt(Int, "Gimme a number")
    type_prompt_style = TypePrompt(Int, "Gimme a number", "bold red")

    opts = OptionsPrompt(["one", "two"], "What option?")
    opts_style = OptionsPrompt(["one", "two"], "What option?", "red", "green")

    default = DefaultPrompt(["yes", "no"], 1, "asking", "red", "green", "blue")
    default = DefaultPrompt(["yes", "no"], 1, "asking")
end

basic = Prompt("basic prompt?")
basic_with_color = Prompt("basic prompt?", "red")

type_prompt = TypePrompt(Int, "Gimme a number")
type_prompt_style = TypePrompt(Int, "Gimme a number", "bold red")

opts = OptionsPrompt(["one", "two"], "What option?")
opts_style = OptionsPrompt(["one", "two"], "What option?", "red", "green")

default = DefaultPrompt(["yes", "no"], 1, "asking", "red", "green", "blue")

all_prompts =
    (basic, basic_with_color, type_prompt, type_prompt_style, opts, opts_style, default)

IS_WIN || @testset "Prompt, printing" begin
    for (i, p) in enumerate(all_prompts)
        @compare_to_string(sprint(print, p), "prompt_print_$i")
        @compare_to_string(sprint(println, p), "prompt_print_$(i)_ln")
        @compare_to_string(sprint(tprintln, p), "prompt_print_$(i)_t")
        @compare_to_string(sprint(tprintln, p), "prompt_print_$(i)_tln")
    end
end

@testset "Prompt, validation" begin
    @test validate_answer("test", basic) == "test"

    @test_throws AnswerValidationError validate_answer("sdadas", type_prompt)
    @test validate_answer("1", type_prompt) == 1

    @test isnothing(validate_answer("asdada", opts))
    @test validate_answer("one", opts) == "one"

    @test validate_answer("", default) == "yes"
end

using Term.LiveWidgets
import Term.LiveWidgets:
    ArrowDown,
    ArrowUp,
    ArrowLeft,
    ArrowRight,
    DelKey,
    HomeKey,
    EndKey,
    PageUpKey,
    PageDownKey,
    Enter,
    SpaceBar,
    Esc,
    Del

import Term.LiveWidgets:
    newline,
    addspace,
    del,
    addchar,
    WidgetInternals,
    PlaceHolderWidget,
    menu_activate_next,
    menu_return_value,
    multi_select_toggle,
    next_page,
    next_line,
    prev_page,
    prev_line,
    home,
    toend,
    activate_next_widget,
    activate_prev_widget,
    AppInternals,
    toggle_help,
    get_active,
    on_layout_change

import Term.Compositors: Compositor
import Term.Consoles: Console, enable, disable
import Term: Measure, AbstractRenderable

import OrderedCollections: OrderedDict

# ---------------------------------------------------------------------------- #
#                                 basic widgets                                #
# ---------------------------------------------------------------------------- #

@testset "WidgetInternals" begin
    w = TextWidget("a")

    @test w.internals.active isa Bool
    @test w.internals.measure isa Measure
    @test isnothing(w.internals.on_draw)
    @test w.internals.on_activated isa Function
    @test w.internals.on_deactivated isa Function
end

@testset "TextWidget" begin
    texts = ["test", "This is  long test"^25]
    panel = [true, false]

    for (i, t) in enumerate(texts), (j, p) in enumerate(panel)
        widget = TextWidget(t; as_panel = p)
        asframe = frame(widget)

        IS_WIN || @compare_to_string(asframe, "widget_text_$(i)_$(j)")

        @test asframe isa AbstractRenderable
        @test widget.controls isa AbstractDict
        @test widget.internals isa WidgetInternals
    end
end

@testset "InputBox" begin
    ib = InputBox()

    @test isnothing(ib.input_text)
    addchar(ib, 'a')
    addchar(ib, 'b')
    del(ib, Del())
    addspace(ib, SpaceBar())
    newline(ib, Enter())
    addchar(ib, 'c')

    @test ib.input_text == "a \nc"
    @test ib.controls isa AbstractDict
    @test ib.internals isa WidgetInternals
    @test ib.internals.measure == Measure(5, 80)

    as_frame = frame(ib)
    @test as_frame isa AbstractRenderable
    IS_WIN || @compare_to_string as_frame "widget_inputbox"
end

@testset "PlaceHolderWidget" begin
    ph = PlaceHolderWidget(5, 20, "test", "red")

    @test ph.controls isa AbstractDict
    @test ph.internals isa WidgetInternals
    @test ph.internals.measure == Measure(5, 20)

    as_frame = frame(ph)
    @test as_frame isa AbstractRenderable
    IS_WIN || @compare_to_string as_frame "widget_placeholder"
end

# ---------------------------------------------------------------------------- #
#                                     MENU                                     #
# ---------------------------------------------------------------------------- #

@testset "SimpleMenu" begin
    for (i, w) in enumerate((50, 100))
        for (j, orientation) in enumerate((:vertical, :horizontal))
            for (k, style) in enumerate(("red", "green"))
                mn = SimpleMenu(
                    ["one", "two", "three"];
                    width = w,
                    layout = orientation,
                    active_style = style,
                    inactive_style = "dim",
                )

                @test mn.controls isa AbstractDict
                @test mn.internals isa WidgetInternals

                # if orientation != :vertical
                #     @test mn.internals.measure == Measure(3, w)
                # else
                #     @test mn.internals.measure == Measure(w, 3)
                # end

                IS_WIN || @compare_to_string frame(mn) "widget_simplemenu_$(i)_$(j)_$(k)"

                menu_activate_next(mn, 1)
                IS_WIN || @compare_to_string frame(mn) "widget_simplemenu_$(i)_$(j)_$(k)_b"

                @test menu_return_value(mn, Enter()) == 2
            end
        end
    end
end

@testset "ButtonsMenu" begin
    for (i, w) in enumerate((50, 100))
        for (j, orientation) in enumerate((:vertical, :horizontal))
            for (k, style) in enumerate(("red", "green"))
                for (l, height) in enumerate((5, 10))
                    mn = ButtonsMenu(
                        ["one", "two", "three"];
                        width = w,
                        layout = orientation,
                        active_style = style,
                        inactive_style = "dim",
                        height = height,
                    )

                    @test mn.controls isa AbstractDict
                    @test mn.internals isa WidgetInternals

                    # if orientation == :vertical
                    #     @test mn.internals.measure == Measure(height, w)
                    # else
                    #     @test mn.internals.measure == Measure(w, height)
                    # end

                    IS_WIN ||
                        @compare_to_string frame(mn) "widget_buttonsmenu_$(i)_$(j)_$(k)_($l)"

                    menu_activate_next(mn, 1)
                    IS_WIN ||
                        @compare_to_string frame(mn) "widget_buttonsmenu_$(i)_$(j)_$(k)_$(l)_b"

                    @test menu_return_value(mn, Enter()) == 2
                end
            end
        end
    end
end

@testset "MultiSelectMenu" begin
    for (i, w) in enumerate((50, 100))
        for (k, style) in enumerate(("red", "green"))
            mn = MultiSelectMenu(
                ["one", "two", "three"];
                width = w,
                active_style = style,
                inactive_style = "dim",
            )

            @test mn.controls isa AbstractDict
            @test mn.internals isa WidgetInternals
            @test mn.internals.measure == Measure(3, w)

            IS_WIN || @compare_to_string frame(mn) "widget_multiselectmenu_$(i)_$(k)"

            menu_activate_next(mn, 1)
            IS_WIN || @compare_to_string frame(mn) "widget_multiselectmenu_$(i)_$(k)_b"

            multi_select_toggle(mn, SpaceBar())
            @test menu_return_value(mn, Enter()) == [2]
        end
    end
end

# ---------------------------------------------------------------------------- #
#                                Pager & Gallery                               #
# ---------------------------------------------------------------------------- #

@testset "Pager" begin
    txt =
        "Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor\nincididunt ut labore et dolore magna aliqua.\nUt enim ad minim veniam, quis nostrud exercitation\nullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in\nvoluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserun\n mollit anim id est laborum."^5

    for (i, w) in enumerate((30, 60))
        for (j, h) in enumerate((20, 40))
            for (k, ln) in enumerate((true, false))
                pag = Pager(txt; width = w, height = h, line_numbers = ln, title = "test")

                @test pag.controls isa AbstractDict
                @test pag.internals isa WidgetInternals
                @test pag.internals.measure == Measure(h, w)
                @test pag.content isa Vector{String}

                LiveWidgets.prev_line(pag, 'a')
                LiveWidgets.next_line(pag, 'a')
                LiveWidgets.prev_line(pag, 'a')
                next_page(pag, 'a')
                prev_page(pag, 'a')
                next_page(pag, 'a')

                home(pag, HomeKey())
                toend(pag, EndKey())
                prev_page(pag, ArrowLeft())

                IS_WIN || @compare_to_string frame(pag) "widget_pager_$(i)_$(j)_$(k)"
            end
        end
    end
end

@testset "Gallery" begin
    for (i, w) in enumerate((56, 80))
        for (j, h) in enumerate((20, 40))
            for (k, sp) in enumerate((true, false))
                gal = Gallery(
                    [TextWidget("aaa"), Pager("aaa" .^ 200)];
                    height = h,
                    width = w,
                    show_panel = sp,
                )

                @test gal.internals isa WidgetInternals
                @test gal.controls isa AbstractDict
                @test gal.widgets isa Vector

                IS_WIN || @compare_to_string frame(gal) "widget_gal_$(i)_$(j)_$(k)"

                activate_prev_widget(gal, 1)
                activate_next_widget(gal, 1)
                activate_next_widget(gal, 1)

                IS_WIN || @compare_to_string frame(gal) "widget_gal_$(i)_$(j)_$(k)_b"

                @test get_active(gal) isa AbstractWidget
            end
        end
    end
end

# ---------------------------------------------------------------------------- #
#                                      APP                                     #
# ---------------------------------------------------------------------------- #

@testset "App Layout Only" begin
    layout = :((r(10, 0.5) * g(10, 0.5)) / b(10, 1.0))

    for (j, h) in enumerate((20, 40))
        for (k, e) in enumerate((true, false))
            app = App(
                layout;
                height = h,
                expand = e,
                help_message = """
                This is just an example of how to create a simple app without any specific content.

                !!! note
                    You can make apps too!
                """,
            )

            @test app.internals isa AppInternals
            @test app.measure isa Measure
            @test app.controls isa AbstractDict
            @test app.widgets isa AbstractDict
            @test app.compositor isa Compositor

            IS_WIN || @compare_to_string frame(app) "single_widghet_app_$(j)_$(k)"

            IS_WIN ||
                @compare_to_string sprint(print, app) "single_widghet_app_$(j)_$(k)_print"

            toggle_help(app)
            IS_WIN || @compare_to_string frame(app) "single_widghet_app_$(j)_$(k)_help"
            toggle_help(app)
            IS_WIN || @compare_to_string frame(app) "single_widghet_app_$(j)_$(k)_nohelp"

            sleep(1)
        end
    end
end

@testset "App Single Widget" begin
    for (i, w) in enumerate((0.5, 20))
        for (j, h) in enumerate((20, 40))
            for (k, e) in enumerate((true, false))
                app = App(TextWidget("a"^100); width = w, height = h, expand = e)

                @test app.internals isa AppInternals
                @test app.measure isa Measure
                @test app.controls isa AbstractDict
                @test app.widgets isa AbstractDict
                @test app.compositor isa Compositor

                # IS_WIN || @compare_to_string frame(app) "app_single_widget_$(i)_$(j)_$(k)"

                # IS_WIN ||
                #     @compare_to_string sprint(print, app) "app_single_widget_$(i)_$(j)_$(k)_print"

                # toggle_help(app)
                # IS_WIN ||
                #     @compare_to_string frame(app) "app_single_widget_$(i)_$(j)_$(k)_help"
                # toggle_help(app)
                # IS_WIN ||
                #     @compare_to_string frame(app) "app_single_widget_$(i)_$(j)_$(k)_nohelp"

                # c1, c2 = Console(30), Console(90)

                # for (m, c) in enumerate((c1, c2, c1))
                #     enable(c)
                #     on_layout_change(app)
                #     # IS_WIN ||
                #     #     @compare_to_string frame(app) "app_single_widget_$(i)_$(j)_$(k)_$(m)"
                #     disable(c)
                # end

                sleep(1)
            end
        end
    end
end

@testset "App complete" begin
    rgb_visualizer = TextWidget("")

    R = InputBox(title = "R value", style = "red", title_justify = :center)
    G = InputBox(title = "G value", style = "green", title_justify = :center)
    B = InputBox(title = "B value", style = "blue", title_justify = :center)

    button = Button("random"; color = "light_slate_grey", text_color = "white")

    widgets = OrderedDict{Symbol,AbstractWidget}(
        :A => rgb_visualizer,
        :R => R,
        :G => G,
        :B => B,
        :b => button,
    )

    layout = :(A(22, 0.4) * (R(6, 0.6) / G(6, 0.6) / B(6, 0.6) / b(4, 0.6)))
    app = App(layout; widgets = widgets)

    # IS_WIN || @compare_to_string frame(app) "app_complete"

    # c1, c2 = Console(30), Console(90)

    # for (m, c) in enumerate((c1, c2, c1))
    #     enable(c)
    #     on_layout_change(app)
    #     # IS_WIN || @compare_to_string frame(app) "app_complete_$(m)"
    #     disable(c)
    # end

    # sleep(1)
end

import Term: inspect, expressiontree, typestree, Dendogram, Tree
import Term.Consoles: console_width
import Term: remove_ansi

# define expressions
e1 = :(2x + 3y + 2)
e2 = :(2x + 3 + 2 + 2y)
e3 = :(2x^(3 + y))
e4 = :(1 + 1 - 2x^2)
e5 = :(mod(22, 6))
e6 = :(2x^(3 + y) + 2z)
e7 = :(2x + 3 * √(3x^2))
e8 = :(print(lstrip("test")))
expressions = (e1, e2, e3, e4, e5, e6, e7, e8)

# save expressions to file (for later comparisons)
if !(Base.get_bool_env("CI", false) || Base.get_bool_env("PKGEVAL", false) || Base.get_bool_env("JULIA_PKGEVAL", false))
    for (i, e) in enumerate(expressions)
        tofile(string(Dendogram(e)), "./txtfiles/dendo_expr_$i.txt")
        tofile(string(Tree(e)), "./txtfiles/tree_expr_$i.txt")
        tofile(sprint((io, e) -> show(io, expressiontree(e)), e), "./txtfiles/exptree_expr_$i.txt")
    end
end

@testset "Inspect: expressions" begin
    for (i, e) in enumerate(expressions)
        dendo = Dendogram(e)
        tree = Tree(e)

        @test dendo isa Dendogram
        IS_WIN || @test fromfile("./txtfiles/dendo_expr_$i.txt") == cleanstring(dendo)

        @test tree isa Tree
        IS_WIN || @test fromfile("./txtfiles/tree_expr_$i.txt") == cleanstring(tree)

        IS_WIN || @test fromfile("./txtfiles/exptree_expr_$i.txt") == cleansprint((io, e) -> show(io, expressiontree(e)), e)

        show(devnull, inspect(e))
    end
end

Sys.islinux() && @testset "Introspect types" begin
    @compare_to_string typestree(Integer, prefix = "xxxx") "typestree_Integer"
    @compare_to_string typestree(Integer, prefix = "xxxx") "typestree_Integer_prefix"
    @compare_to_string typestree(Int64) "typestree_Int64"

    # machine dependent
    # @compare_to_string typestree(AbstractFloat, prefix = "xxxx") "typestree_AbstractFloat"
    # @compare_to_string typestree(AbstractFloat, prefix = "xxxx") "typestree_AbstractFloat_prefix"
    # @compare_to_string typestree(Float64) "typestree_Float64"
end

abstract type Structy end

struct MyStr <: Structy
    x::Int
    y::Vector
end
MyStr(x) = MyStr(x, x)
dosmth(m::MyStr) = print(m.x)

false && @testset "Introspect custom types and funcs" begin
    # intro = @capture_out inspect(MyStr)
    # IS_WIN || @compare_to_string intro "introspection_MyStr"

    # intro = @capture_out inspect(Panel)
    # IS_WIN || @compare_to_string intro "introspection_Panel"

    intro = @capture_out inspect(print)
    if VERSION ≥ v"1.12"
        IS_WIN || @compare_to_string remove_ansi(intro) "introspection_print"
    end
end

import Base.StackTraces: StackFrame
import MyterialColors: pink, indigo_light
import Term: read_file_lines

# ---------------------------------------------------------------------------- #
#                                     MISC                                     #
# ---------------------------------------------------------------------------- #

function get_frame_file(frame::StackFrame)
    file = string(frame.file)
    file = Base.fixup_stdlib_path(file)
    Base.stacktrace_expand_basepaths() &&
        (file = something(Base.find_source_file(file), file))
    Base.stacktrace_contract_userdir() && (file = Base.contractuser(file))

    return if isnothing(file)
        ""
    else
        basename(file)
    end
end
"""
    function frame_module end 

Get the Module a function is defined in, as a string
"""
function frame_module(frame::StackFrame)::Union{Nothing,String}
    m = Base.parentmodule(frame)

    if m !== nothing
        while parentmodule(m) !== m
            pm = parentmodule(m)
            pm == Main && break
            m = pm
        end
    end
    m = !isnothing(m) ? string(m) : frame_module(string(frame.file))

    isnothing(m) && return frame_module(get_frame_file(frame))
    return m
end

frame_module(t::Tuple) = frame_module(t[1])

"""
Get module from file path.
"""
frame_module(path::String) = startswith(path, "./") ? "Base" : nothing

"""
Get module for a pointer obj
"""
frame_module(pointer::Ptr) = frame_module(StackTraces.lookup(pointer)[1])
frame_module(iip::Base.InterpreterIP) = string(iip.mod)

"""
    should_skip

A frame should skip if it's in Base or an installed package.
"""
function should_skip(frame::StackFrame, modul)
    mod = something(modul, frame)
    f = get_frame_file(frame)

    bad = mod ∈ ["Base", nothing, "VSCodeServer", "REPL"]
    bad = bad || mod ∈ STACKTRACE_HIDDEN_MODULES[]

    return bad || (
        contains(f, r"[/\\].julia[/\\]") ||
        contains(f, r"julia[/\\]stdlib") ||
        contains(f, r"julia[/\\]lib") ||
        contains(f, "julialang.language") ||
        contains(f, "libjulia")
    )
end
should_skip(frame::StackFrame, hide::Bool, args...) =
    hide ? should_skip(frame, args...) : false
should_skip(pointer::Ptr, args...) = should_skip(StackTraces.lookup(pointer)[1], args...)
should_skip(pointer::Ptr, hide::Bool, args...) =
    hide ? should_skip(pointer, args...) : false
should_skip(iip::Base.InterpreterIP, args...) = true
should_skip(iip::Base.InterpreterIP, hide::Bool, args...) = true

"""
    parse_kw_func_name(frame::StackFrame)

Kw function calls have a weird name, parse arguments to get 
a proper function signature.
"""
function parse_kw_func_name(frame::StackFrame)::String
    linfo = frame.linfo
    def = linfo.def

    if isa(def, Method)
        sig = linfo.specTypes
        argnames = Base.method_argnames(def)
        ftypes = map(i -> fieldtype(sig, i), 1:length(argnames)) |> collect

        kwargs = map(
            i -> fieldname(ftypes[2], i) => fieldtype(ftypes[2], 1),
            1:length(fieldnames(ftypes[2])),
        )

        # get function name and name/type of args and kwargs
        func = replace(string(def.name), "##kw" => "") * "("
        func *= join(
            map(i -> string(argnames[i]) * "::" * string(ftypes[i]), 4:length(ftypes)),
            ", ",
        )
        !isempty(kwargs) && begin
            func *= "; " * join(["$k::$v" for (k, v) in kwargs], ", ")
        end
        func *= ")"
    else
        func = string(sprint(StackTraces.show_spec_linfo, frame))
    end
    return func
end

"""
    get_frame_function_name

Get and stylize a function's name/signature
"""
function get_frame_function_name(frame::StackFrame, ctx::StacktraceContext)
    # get the name of the error function
    func = sprint(StackTraces.show_spec_linfo, frame)
    try
        (contains(func, "##kw") || contains(func, "kwerr")) &&
            (func = parse_kw_func_name(frame))
    catch
    end

    # format function name
    func = replace(
        func,
        r"(?<group>^[^(]+)" => SubstitutionString(
            "{$(ctx.theme.func)}" * s"\g<0>" * "{/$(ctx.theme.func)}",
        ),
    )

    return RenderableText(reshape_code_string(func, ctx.func_name_w))
end

# ---------------------------------------------------------------------------- #
#                              render source code                              #
# ---------------------------------------------------------------------------- #

"""
    render_error_code_line(frame::StackFrame; δ=2)

Create a `Panel` showing formatted Julia code for a frame's error line. 
The parameter `δ` speciies how many lines above/below the error line to show. 
"""
function render_error_code_line(ctx::StacktraceContext, frame::StackFrame; δ = 2)
    # get code as string
    error_source = nothing
    try
        error_source = load_code_and_highlight(string(frame.file), Int(frame.line); δ = δ)
    catch
        error_source = nothing
    end
    (isnothing(error_source) || length(error_source) == 0) && return nothing

    code_error_panel = Panel(
        str_trunc(apply_style(error_source), ctx.code_w - 4; ignore_markup = true);
        fit = δ == 0,
        style = δ > 0 ? "$(ctx.theme.text_accent) dim" : "dim",
        width = ctx.code_w,
        subtitle_justify = :center,
        subtitle = δ > 0 ? "error line" : nothing,
        subtitle_style = "default $(ctx.theme.text_accent)",
        height = δ > 0 ? nothing : 1,
        padding = (0, 1, 0, 0),
    )
    return "  " * RenderableText("│\n╰─"; style = "dim") * (code_error_panel)
end

"""
    function add_stack_frame! end

Create a Term visualization of info and metadata about a 
stacktrace frame.
"""
function add_stack_frame! end

"""
    add_stack_frame!(frame::StackFrame, ctx::StacktraceContext, num::Int;  kwargs...)

Renders a panel with:
 - frame number
 - function name/signature
 - source code at error line
"""
function add_stack_frame!(
    content,
    frame::StackFrame,
    ctx::StacktraceContext,
    as_panel::Bool,
    num::Int;
    δ = 3,
    kwargs...,
)
    # get the name of the error function
    func = get_frame_function_name(frame, ctx)

    # get other information about the function 
    inline =
        frame.inlined ? RenderableText("inlined"; style = "bold dim $(ctx.theme.text)") : ""
    c = frame.from_c ? RenderableText("from C"; style = "bold dim $(ctx.theme.text)") : ""

    # make function line
    func_line = (frame.inlined || frame.from_c) ? func / hstack(inline, c; pad = 1) : func

    # make file line & load source code around error and render it
    panel_content = if length(string(frame.file)) > 0
        # get a link renderable pointing to error
        if TERM_SHOW_LINK_IN_STACKTRACE[] == true
            # source_file = Link(string(frame.file), frame.line; style = "underline dim")
            source_file = RenderableText(
                apply_style(string(frame.file) * ":$(frame.line)", "underline dim");
                width = ctx.func_name_w,
            )
            _out = func_line / source_file
        else
            _out = func_line
        end
        error_source = render_error_code_line(ctx, frame; δ = δ)
        isnothing(error_source) || (_out /= error_source)
        _out
    else
        func_line
    end

    # make panel and add it to content
    panel = if as_panel
        Panel(
            panel_content;
            title_style = "$(ctx.theme.err_btframe_panel) bold",
            padding = (2, 2, 0, 0),
            fit = false,
            width = ctx.frame_panel_w,
            kwargs...,
        )
    else
        pad("   " * panel_content; width = ctx.frame_panel_w, method = :right)
    end

    numren = vertical_pad("{dim}($num){/dim} ", height(panel), :center)
    push!(content, numren * panel)
end

add_stack_frame!(content, pointer::Ptr{Nothing}, args...; δ = 3, kwargs...) =
    add_stack_frame!(content, StackTraces.lookup(pointer)[1], args...; δ = δ, kwargs...)

add_stack_frame!(content, pointer::Base.InterpreterIP, args...; δ = 3, kwargs...) =
    RenderableText("pointer")

"""
    add_new_module_name!(content, ctx::StacktraceContext, curr_modul)

When a frame belonging to a module different from the previous one is shown, 
print the new module's name.
"""
function add_new_module_name!(content, ctx::StacktraceContext, curr_module)
    push!(
        content,
        hLine(
            ctx.module_line_w,
            "{default $(ctx.theme.text_accent)}In module {$(ctx.theme.err_accent) bold}$(curr_module){/$(ctx.theme.err_accent) bold}{/default $(ctx.theme.text_accent)}";
            style = "$(ctx.theme.err_accent) dim",
        ),
    )
end

"""
    add_number_frames_skipped!(content, ctx, to_skip, num, bt, n_skipped, skipped_frames_modules)

Add some text explaining how many frames were skipped from the stacktrace visualization
and to which modules they belonged. 
"""
function add_number_frames_skipped!(
    content,
    ctx::StacktraceContext,
    to_skip,
    num,
    bt,
    n_skipped,
    skipped_frames_modules,
)
    if (to_skip == false || num == length(bt) - 1) && n_skipped > 0
        color = ctx.theme.err_btframe_panel
        accent = ctx.theme.err_accent

        # get the name of the modules
        modules = join(unique(string.(filter(!isnothing, skipped_frames_modules))), ", ")
        modules = filter(x -> x != "nothing", modules)
        in_mod = length(modules) == 0 ? "" : "in {$accent}$modules{/$accent}"
        word = n_skipped > 1 ? "frames" : "frame"

        # render
        push!(
            content,
            cvstack(
                hLine(ctx.module_line_w; style = "$color dim"),
                RenderableText(
                    "Skipped {bold}$n_skipped{/bold} $word $in_mod";
                    width = ctx.frame_panel_w,
                    justify = :center,
                    style = color,
                ),
                hLine(ctx.module_line_w; style = "$color dim");
                pad = 0,
            ),
        )
    end
end

"""
    render_backtrace(bt::Vector; reverse_backtrace = true, max_n_frames = 30)

Main error backtrace rendering function. 
It renders each frame in a stacktrace after some filtering (e.g. to hide frames in BASE).
It takes care of hiding frames when there's a large number of them. 
"""
function render_backtrace(
    ctx::StacktraceContext,
    bt::Vector;
    reverse_backtrace = true,
    max_n_frames = 30,
    hide_frames = true,
)
    length(bt) == 0 && return RenderableText("")
    if reverse_backtrace
        bt = reverse(bt)
    end

    # get the module each frame's code line is defined in
    frames_modules = frame_module.(bt)

    """
    Define a few variables to keep track of during stack 
    trace rendering. These are used when some frames are hidden
    to keep track of how many and in which module they were, 
    and to know when to print a message to indicate that
    the stack trace entered a new module.
    """

    added_skipped_message = false
    N = length(bt)
    prev_frame_module = nothing # keep track of the previous' frame module
    n_skipped = 0  # keep track of number of frames skipped (e.g in Base)
    skipped_frames_modules = []
    tot_frames_added = 0

    # render each frame
    content = AbstractRenderable[]
    curr_module = nothing
    for (num, frame) in enumerate(bt)
        # if the current frame's module differs from the previous one, show module name
        curr_module =
            (num > 1 && !isnothing(curr_module)) ?
            something(frames_modules[num], curr_module) : frames_modules[num]

        # get params for rendering
        frame_panel_kwargs = if num == 1  # first frame is highlighted
            Dict(
                :subtitle => reverse_backtrace ? "TOP LEVEL" : "ERROR LINE",
                :subtitle_style =>
                    reverse_backtrace ? "$(ctx.theme.text_accent)" :
                    "bold $(ctx.theme.text_accent)",
                :subtitle_justify => :right,
                :style => ctx.theme.err_btframe_panel,
            )
        elseif num == length(bt)  # last frame is highlighted
            Dict(
                :subtitle => reverse_backtrace ? "ERROR LINE" : "TOP LEVEL",
                :subtitle_style =>
                    reverse_backtrace ? "bold $(ctx.theme.text_accent)" :
                    "$(ctx.theme.text_accent)",
                :subtitle_justify => :right,
                :style => ctx.theme.err_btframe_panel,
            )

        else  # inside frames are printed without an additional panel around
            Dict(:style => "hidden")
        end
        δ = num in (1, length(bt)) ? 2 : 0
        to_skip =
            should_skip(frame, hide_frames, curr_module) &&
            num ∉ [1, length(bt)] &&
            STACKTRACE_HIDE_FRAMES[]

        # keep track of frames being skipped
        if num ∉ [1, length(bt)]
            # skip extra panels for long stack traces
            if tot_frames_added > max_n_frames &&
               num < length(bt) - 5 &&
               added_skipped_message == false
                skipped_line = hLine(
                    ctx.module_line_w,
                    "{bold dim}$(N - max_n_frames - 2){/bold dim}{$(ctx.theme.err_btframe_panel) dim} frames skipped{/$(ctx.theme.err_btframe_panel) dim}";
                    style = "$(ctx.theme.err_btframe_panel) dim",
                )
                push!(content, skipped_line)
                added_skipped_message = true

            else
                # show number of frames skipped
                if to_skip == false && n_skipped > 0
                    add_number_frames_skipped!(
                        content,
                        ctx,
                        to_skip,
                        num,
                        bt,
                        n_skipped,
                        skipped_frames_modules,
                    )
                end

                # skip
                if to_skip
                    n_skipped += 1
                    push!(skipped_frames_modules, frames_modules[num])
                    continue
                else
                    n_skipped, skipped_frames_modules = 0, []
                    tot_frames_added += 1
                end
            end
        else
            if num == length(bt) && n_skipped > 0
                add_number_frames_skipped!(
                    content,
                    ctx,
                    to_skip,
                    num,
                    bt,
                    n_skipped,
                    skipped_frames_modules,
                )
            end
            tot_frames_added += 1
        end

        # mark switch to a new module
        (curr_module != prev_frame_module && !to_skip && !isnothing(curr_module)) &&
            add_new_module_name!(content, ctx, curr_module)

        # add frame if not hidden
        to_skip || add_stack_frame!(
            content,
            frame,
            ctx,
            num ∈ [1, length(bt)],
            num;
            δ = δ,
            frame_panel_kwargs...,
        )

        isnothing(curr_module) || (prev_frame_module = curr_module)
    end

    # create an overall panel
    return Panel(
        cvstack(content..., pad = 1);
        padding = (2, 2, 1, 1),
        subtitle = "Error Stack",
        style = "$(ctx.theme.er_bt) dim",
        subtitle_style = "bold $(ctx.theme.er_bt) default",
        title = "Error Stack",
        title_style = "bold $(ctx.theme.er_bt) default",
        fit = false,
        justifty = :left,
        width = ctx.out_w,
    )
end

module Tprint

import Term:
    unescape_brackets, escape_brackets, has_markup, reshape_text, NOCOLOR, cleantext
import Term: highlight as highlighter
import ..Measures: Measure
import ..Renderables: AbstractRenderable, trim_renderable, RenderableText
import ..Style: apply_style
import ..Layout: hstack
import ..Consoles: console_width

export tprint, tprintln

function sprint_no_color(x)
    o = sprint(print, x)
    NOCOLOR[] && (o = cleantext(o))
    return o
end

"""
    tprint

Similar to standard lib's `print` function but with added
**styling functionality**

!!! tip "highlighting"
    Set `highlight=true` to automatically highlight the output.
"""
function tprint end

tprint(x; highlight = true) = tprint(stdout, x; highlight = highlight)

tprint(io::IO, x; highlight = true) = tprint(io, string(x); highlight = highlight)

"""
---
    tprint(x::AbstractString)

Apply style to a string and print it
"""
function tprint(io::IO, x::AbstractString; highlight = true)
    x = (highlight ? apply_style ∘ highlighter : apply_style)(x)

    x =
        Measure(x).w <= console_width(io) ? x :
        string(RenderableText(string(x), width = console_width(io)))
    print(io, sprint_no_color(x))
end

"""
---
    tprint(x::AbstractRenderable)

Print an `AbstractRenderable`.

Equivalent to `print(x)`
"""
function tprint(io::IO, x::AbstractRenderable; highlight = true)
    w = console_width()
    x = x.measure.w > console_width() ? trim_renderable(x, w) : x
    print(io, sprint_no_color(x))
end

function tprint(io::IO, args...; highlight = true)
    for (n, arg) in enumerate(args)
        tprint(io, arg; highlight = highlight)

        (n < length(args) && args[n + 1] isa AbstractRenderable) || print(io, " ")
    end
    return nothing
end

function tprint(args...; highlight = true)
    for (n, arg) in enumerate(args)
        tprint(arg; highlight = highlight)

        if n < length(args)
            args[n + 1] isa AbstractRenderable || print(" ")
        end
    end
    return nothing
end

"""
---
    tprintln

Similar to standard lib's `println` function but with added
styling functionality.
"""

tprintln(args...; highlight = true) = tprint(args..., "\n"; highlight = highlight)
tprintln(io::IO, args...; highlight = true) =
    tprint(io, args..., "\n"; highlight = highlight)

end

module Introspection

using InteractiveUtils
import InteractiveUtils: supertypes as getsupertypes
import OrderedCollections: OrderedDict
import MyterialColors: pink, pink_light, orange, grey_dark, light_green

import Term:
    highlight,
    escape_brackets,
    join_lines,
    unescape_brackets,
    split_lines,
    do_by_line,
    expr2string,
    default_width,
    TERM_THEME,
    highlight_syntax,
    load_code_and_highlight,
    str_trunc,
    reshape_text

import ..Renderables: RenderableText
import ..Panels: Panel
import ..Dendograms: Dendogram
import ..Trees: Tree
import ..Layout: hLine, vLine, Spacer, rvstack, lvstack
import ..Tprint: tprintln
import ..Repr: termshow
using ..LiveWidgets
import ..LiveWidgets: ArrowDown, ArrowUp, KeyInput
import ..TermMarkdown: parse_md
import ..Consoles: console_width, console_height
import ..Style: apply_style
import ..Compositors: Compositor
import ..Links: Link

include("_inspect.jl")

export inspect, typestree, expressiontree

# ---------------------------------------------------------------------------- #
#                                TYPES HIERARCHY                               #
# ---------------------------------------------------------------------------- #
"""
    typestree(T)
    typestree(io::IO, T)

Print the type hierarchy for `T` in a pretty format. This is 
done using colors, indentation and unicode for maximal readability.
The output included all supertypes, and one level of subtypes.

This function is not exported, so to use it you need to 
use the `Term.typestree` syntax, or import it manually by
`import Term: typestree`

# Example
Below is an example showing the type tree for `Integer`. Note 
that the colors of the output are not included in this docstring.
```jldoctest
julia> Term.typestree(Integer)
╭────────────── Types hierarchy ───╮
│                                  │
│  Number                          │
│ ━━━━━━━━                         │
│    │                             │
│    ├── Complex                   │
│    └── Real                      │
│        ├── Rational              │
│        ├── AbstractIrrational    │
│        ├── Integer               │
│        │   ├── Signed            │
│        │   ├── Unsigned          │
│        │   └── Bool              │
│        └── AbstractFloat         │
│                                  │
╰──────────────────────────────────╯
```
"""
typestree(io::IO, T::DataType) = print(
    io,
    Panel(
        Tree(T);
        title = "Types hierarchy",
        style = "$(TERM_THEME[].emphasis) dim",
        title_style = orange * " default",
        title_justify = :right,
        fit = true,
        padding = (1, 4, 1, 1),
    ),
)

typestree(T::DataType) = typestree(stdout, T)

function expressiontree(io::IO, e::Expr)
    _expr = expr2string(e)
    tree = Tree(e)

    return print(
        io,
        Panel(
            tree;
            title = _expr,
            title_style = "$(TERM_THEME[].emphasis_light) default bold",
            title_justify = :center,
            style = grey_dark,
            fit = tree.measure.w > default_width(),
            width = max(tree.measure.w, default_width()),
            subtitle = "inspect",
            subtitle_justify = :right,
            justify = :center,
            padding = (1, 1, 1, 1),
        ),
    )
end
expressiontree(e::Expr) = expressiontree(stdout, e)

# ---------------------------------------------------------------------------- #
#                                EXPR. DENDOGRAM                               #
# ---------------------------------------------------------------------------- #

function inspect(io::IO, expr::Expr)
    _expr = expr2string(expr)
    dendo = Dendogram(expr)

    return print(
        io,
        Panel(
            dendo;
            title = _expr,
            title_style = "$(TERM_THEME[].emphasis_light) default bold",
            title_justify = :center,
            style = TERM_THEME[].emphasis,
            fit = true,
            subtitle = "inspect",
            subtitle_justify = :right,
            justify = :center,
            padding = (1, 1, 1, 1),
        ),
    )
end

# ---------------------------------------------------------------------------- #
#                             INTROSPECT DATATYPES                             #
# ---------------------------------------------------------------------------- #

function style_methods(
    methods::Union{Vector{Base.Method},Base.MethodList},
    docstrings::Vector,
    width::Int,
)
    mets = []
    fn_col = TERM_THEME[].func
    panel_col = TERM_THEME[].text_accent
    col = TERM_THEME[].inspect_highlight

    for (i, (m, docs)) in enumerate(zip(methods, docstrings))
        # method code
        code = split(string(m), " in ")[1] |> highlight_syntax
        code = reshape_text(apply_style(code), width; ignore_markup = true)

        # get docstring
        docs = if !isnothing(docs)
            docs = parse_md(something(docs, ""); width = width)
        else
            docs = "{green}No docstring found{/green}"
        end
        docs = hLine(width, "DocString"; style = "green") / docs / ""

        # method source
        modul = "{default}Source: {bold $col}" * string(m.module) * "{/bold $col}{/default}"
        source = "{dim}$(m.file):$(m.line){/dim}"

        out = code / "" / docs
        push!(mets, out / hLine(width; style = "dim") / modul / source)
    end
    return mets
end

"""
    inspect(T::DataType; documentation::Bool=false, constructors::Bool=true, methods::Bool=true, supertypes::Bool=true)

Inspect a `DataType` to show info such as docstring, constructors and methods.
Flags can be used to choose the level of detail in the information presented:
 - documentation: show docstring with `termshow`
 - constructors: show `T` constructors
 - methods: show methods using `T` in their signature
 - supertypes: show methods using `T`'s supertypes in their signature
"""
function inspect(T::Union{Union,DataType};)
    # get app size
    layout = :(A(4, 1.0) / B(30, 1.0))
    comp = Compositor(layout)
    widget_width = comp.elements[:B].w - 6

    # get fields
    theme = TERM_THEME[]
    field_names = apply_style.(string.(fieldnames(T)), theme.repr_accent)
    field_types = apply_style.(map(f -> "::" * string(f), T.types), theme.repr_type)

    line = vLine(length(field_names); style = theme.repr_name)
    space = Spacer(length(field_names), 1)
    fields = rvstack(field_names...) * space * lvstack(string.(field_types)...)
    type_name = apply_style(string(T), theme.repr_name * " bold")

    # get each method as a Pager
    type_methods = style_methods(get_methods_with_docstrings(T)..., widget_width - 12)
    methods_pagers =
        map(
            m -> Pager(
                string(m[2]);
                title = "Method $(m[1]) of $(length(type_methods))",
                width = widget_width,
                page_lines = comp.elements[:B].h - 8,
            ),
            enumerate(type_methods),
        ) |> collect

    # create app
    menu = ButtonsMenu(
        ["Info", "Methods"];
        width = comp.elements[:A].w,
        height = comp.elements[:A].h - 1,
        layout = :horizontal,
    )

    # define widgets that go inside the top level Gallery
    gallery_widgets = [
        Pager( # first widget is a pager with struct info
            string(
                Panel(
                    type_name / ("  " * line * fields);
                    fit = false,
                    width = widget_width - 10,
                    justify = :center,
                    title = "Fields",
                    title_style = "bright_blue bold",
                    style = "bright_blue dim",
                ) / hLine(widget_width - 10; style = "dim") / "" / Tree(T),
            );
            width = comp.elements[:B].w - 1,
            page_lines = comp.elements[:B].h - 7,
        ),
        Gallery(  # inner gallery shows each method
            methods_pagers;
            width = comp.elements[:B].w - 1,
            height = comp.elements[:B].h - 2,
            show_panel = false,
        ),
    ]

    # make the app out of a menu and the top level gallery
    widgets = OrderedDict(
        :A => menu,
        :B => Gallery(
            gallery_widgets;
            controls = Dict(),
            width = comp.elements[:B].w,
            height = comp.elements[:B].h - 1,
            show_panel = false,
        ),
    )

    transition_rules = Dict(ArrowDown() => Dict(:A => :B), ArrowUp() => Dict(:B => :A))

    function cb(app)
        app.widgets[:B].active = app.widgets[:A].active
    end

    app = App(layout, widgets, transition_rules; on_draw = cb)
    play(app; transient = false)
    return nothing
end

function inspect(F::Function; documentation::Bool = true)
    hLine("inspecting: $F", style = "$(TERM_THEME[].text_accent)") |> print

    documentation && begin
        termshow(F)
        print("\n"^3)
    end
    nothing
end

end

"""
Showing how to use Term.jl to create styled console representation for your types.
"""

using Term: Panel, vLine, rvstack, lvstack, RenderableText, @with_repr, termshow

struct myType
    name::String
    height::Int
    width::Int
    mass::Float64
end

""" Custom show method """
function Base.show(io::IO, ::MIME"text/plain", obj::myType)
    fields = (:height, :width, :mass)

    info = map(f -> RenderableText(string(f); style = "bold"), fields)
    vals = map(
        f -> RenderableText(" " * string(getfield(obj, f)); style = "bright_blue"),
        fields,
    )
    obj_details = rvstack(info...) * vLine(3; style = "dim") * lvstack(vals...)

    return print(
        io,
        Panel(
            obj_details;
            title = obj.name,
            style = "red dim",
            title_style = "default bright_red bold",
            fit = true,
            padding = (2, 2, 1, 1),
        ),
    )
end

obj = myType("Rocket", 10, 10, 99.9)

# or just use our macro!

@with_repr mutable struct myRocket
    width::Int
    height::Int
    mass::Float64
    engines_activity::Vector

    manufacturer::String
end

obj = myRocket(10, 50, 5000, [1.1, 123123, 1], "NASA")

module Repr
using InteractiveUtils
import Markdown
import CodeTracking: @code_string, @which, code_string

import Term:
    str_trunc,
    escape_brackets,
    highlight,
    do_by_line,
    unescape_brackets,
    split_lines,
    TERM_THEME,
    default_width,
    plural,
    reshape_text,
    remove_markup,
    reshape_code_string

import ..Layout: vLine, rvstack, lvstack, Spacer, vstack, cvstack, hLine, pad, hstack
import ..Renderables: RenderableText, info, AbstractRenderable
import ..Consoles: console_width
import ..Panels: Panel, TextBox
import ..Style: apply_style
import ..Tprint: tprint, tprintln
import ..Tables: Table
import ..TermMarkdown: parse_md
import ..Measures: height

export @with_repr, termshow, install_term_repr, @showme

include("_repr.jl")
include("_inspect.jl")

"""
    termshow

Styled string representation of any object.

`termshow` prints to stdout (or any other IO) a styled
representation of the object.
Dedicated methods create displays for specify types such as `Dict`
or `Vector`.
"""
function termshow end

"""
---
    termshow(io::IO, obj)

Generic method for any object not caught by dedicated methods.
Creates a `Panel` with the object's fields and contents.
"""
termshow(io::IO, obj) = print(
    io,
    Panel(
        repr_get_obj_fields_display(obj);
        fit = true,
        subtitle = escape_brackets(string(typeof(obj))),
        subtitle_justify = :right,
        width = 40,
        justify = :center,
        style = TERM_THEME[].repr_panel,
        subtitle_style = TERM_THEME[].repr_name,
    ),
)

termshow(obj; kwargs...) = termshow(stdout, obj; kwargs...)

# ---------------------------------------------------------------------------- #
#                                     EXPR                                     #
# ---------------------------------------------------------------------------- #
"""
---
    termshow(io::IO, e::Expr; kwargs...)

Show an expression's head and arguments.
"""
function termshow(io::IO, e::Expr; kwargs...)
    content = repr_get_obj_fields_display(e)
    content = cvstack(
        "{$(TERM_THEME[].emphasis)}$(highlight(string(e))){/$(TERM_THEME[].emphasis)}",
        hLine(content.measure.w),
        content,
    )
    return print(
        io,
        Panel(
            content;
            fit = true,
            subtitle = escape_brackets(string(typeof(e))),
            subtitle_justify = :right,
            width = 40,
            justify = :center,
            style = TERM_THEME[].repr_panel,
            subtitle_style = TERM_THEME[].repr_name,
        ),
    )
end

# ---------------------------------------------------------------------------- #
#                                  DICTIONARY                                  #
# ---------------------------------------------------------------------------- #
"""
---
    termshow(io::IO, d::Dict; kwargs...)

Show a dictionary's keys and values and their data types.
"""
function termshow(io::IO, obj::AbstractDict; kwargs...)
    short_string(x) = str_trunc(string(x), 30)
    theme = TERM_THEME[]

    # prepare text renderables
    _keys = RenderableText.(short_string.(keys(obj)); style = theme.repr_accent * " bold")
    ktypes =
        RenderableText.(
            map(k -> "{{" * short_string(typeof(k)) * "}}", collect(keys(obj)));
            style = theme.repr_type * " dim",
        )
    vals = RenderableText.(short_string.(values(obj)); style = theme.repr_values * " bold")
    vtypes =
        RenderableText.(
            map(k -> "{{" * short_string(typeof(k)) * "}}", collect(values(obj)));
            style = theme.repr_type * " dim",
        )

    content = OrderedDict(
        :type => ktypes,
        :key => _keys,
        :arrow => RenderableText.(fill("=>", length(_keys)); style = theme.operator),
        :value => vals,
        :vtype => vtypes,
    )

    return print(
        io,
        Panel(
            Table(content; show_header = false, box = :NONE, hpad = 0, compact = true);
            fit = true,
            title = escape_brackets(string(typeof(obj))),
            title_justify = :left,
            width = 40,
            justify = :center,
            style = theme.repr_panel,
            title_style = theme.repr_name,
            padding = (2, 2, 1, 1),
            subtitle_justify = :right,
        ),
    )
end

# ---------------------------------------------------------------------------- #
#                                ABSTRACT ARRAYS                               #
# ---------------------------------------------------------------------------- #
"""
---
    termshow(io::IO, mtx::AbstractMatrix; kwargs...)

Show a matrix content as a 2D table visualization.
"""
termshow(io::IO, mtx::AbstractMatrix; kwargs...) = print(
    io,
    repr_panel(
        mtx,
        matrix2content(mtx),
        "{$(TERM_THEME[].text_accent)}$(size(mtx, 1)) × $(size(mtx, 2)){/$(TERM_THEME[].text_accent)}{default} {/default}",
    ),
)

"""
---
    termshow(io::IO, vec::Union{Tuple,AbstractVector}; kwargs...)

Show a vector's content as a 1D table visualization.
"""
termshow(io::IO, vec::Union{Tuple,AbstractVector}; kwargs...) = print(
    io,
    repr_panel(
        vec,
        vec2content(vec),
        "{$(TERM_THEME[].text_accent)}$(length(vec)){/$(TERM_THEME[].text_accent)}{default} items{/default}";
        justify = :left,
        fit = true,
        title = nothing,
    ),
)

"""
---
    termshow(io::IO, arr::AbstractArray; kwargs...)

Show the content of a multidimensional array as a series of 2D slices.
"""
function termshow(io::IO, arr::AbstractArray; kwargs...)
    I0 = CartesianIndices(size(arr)[3:end])
    I = I0[1:min(10, length(I0))]

    panel_style = TERM_THEME[].repr_array_panel
    panel_title_style = TERM_THEME[].repr_array_title

    panels::Vector{Union{Panel,Spacer}} = []
    for (n, i) in enumerate(I)
        i_string = join(string.(Tuple(i)), ", ")
        push!(
            panels,
            Panel(
                matrix2content(arr[:, :, i]; max_w = 60, max_items = 25, max_D = 5);
                subtitle = "[:, :, $i_string]",
                subtitle_justify = :right,
                width = 60,
                style = panel_style,
                subtitle_style = "default",
                fit = true,
            ),
        )
        push!(panels, Spacer(2, 1))
    end

    if (m = length(I0) - length(I)) > 0
        push!(
            panels,
            Panel(
                "{$panel_title_style bold underline}$m{/$panel_title_style bold underline}{$panel_title_style} $(plural("frame", m)) omitted{/$panel_title_style}";
                width = panels[end - 1].measure.w,
                style = panel_style,
            ),
        )
    end

    return print(
        io,
        repr_panel(
            arr,
            vstack(panels...),
            "{$(TERM_THEME[].text_accent)}" *
            join(string.(size(arr)), " × ") *
            "{/$(TERM_THEME[].text_accent)}",
            fit = true,
        ),
    )
end

"""
---
    termshow(io::IO, obj::DataType; kwargs...)

Show a type's arguments, constructors and docstring.
"""
function termshow(io::IO, obj::DataType; showdocs = true, kwargs...)
    theme = TERM_THEME[]
    ts = theme.repr_type

    field_names, field_types = [], []
    try
        field_names = apply_style.(string.(fieldnames(obj)), theme.repr_accent)
        field_types = apply_style.(map(f -> "::" * string(f), obj.types), ts)
    catch
        field_names = []
        field_types = []
    end

    line = vLine(length(field_names); style = theme.repr_name)
    space = Spacer(length(field_names), 1)
    fields = rvstack(field_names...) * space * lvstack(string.(field_types)...)

    type_name = apply_style(string(obj), theme.repr_name * " bold")
    if length(supertypes(obj)) > 1
        sup = supertypes(obj)[2]
        type_name *= " {$(theme.repr_array_text) dim}<: $sup{/$(theme.repr_array_text) dim}"
    end
    content =
        "    " * repr_panel(
            nothing,
            string(type_name / ("  " * line * fields)),
            nothing;
            fit = false,
            width = min(console_width() - 5, default_width(io)),
            justify = :center,
        )

    print(io, content)

    showdocs && begin
        # get docstring
        doc, _ = get_docstring(obj)
        doc = parse_md(doc; width = min(100, console_width()))
        doc = split_lines(doc)
        if (m = length(doc) - 100) > 0
            doc = [
                doc[1:min(100, length(doc))]...,
                "{dim bright_blue}$m $(plural("line", m)) omitted...{/dim bright_blue}",
            ]
        end
        doc = join(doc, "\n")
        print(io, hLine(console_width(), "Docstring"; style = "green dim", box = :HEAVY))
        tprint(io, doc)
    end
end

"""
---
    termshow(io::IO, fun::Function; kwargs...)

Show a function's methods and docstring.
"""
function termshow(io::IO, fun::Function; width = min(console_width(io), default_width(io)))
    theme = TERM_THEME[]
    # get methods
    methods_contents, N = style_function_methods(fun; width = width)

    m = N - 1
    panel =
        "   " * repr_panel(
            nothing,
            methods_contents,
            "{$(theme.text_accent)}$m{/$(theme.text_accent)} $(plural("method", m))",
            title = "Function: {bold $(theme.repr_array_text)}$(string(fun)){/bold $(theme.repr_array_text)}",
            width = width - 8,
            fit = false,
            justify = :left,
        )
    # @info "made panel" panel.measure  width console_width(io)

    # get docstring 
    doc, _ = get_docstring(fun)
    panel.measure.w < 45 && begin   # handle narrow console 
        doc = replace(string(doc), "```" => " ") |> Markdown.MD
    end
    doc = parse_md(doc; width = panel.measure.w - 4)
    doc = split_lines(doc)
    if (m = length(doc) - 100) > 0
        doc = [
            doc[1:min(100, length(doc))]...,
            "{dim $(theme.repr_array_text)}$m $(plural("line", m)) omitted...{/dim $(theme.repr_array_text)}",
        ]
    end
    print(io, panel)
    print(io, hLine(panel.measure.w, "Docstring"; style = "green dim", box = :HEAVY))
    print(io, "   " * RenderableText(join(doc, "\n"), width = width - 4))
end

# ---------------------------------------------------------------------------- #
#                                 INSTALL REPR                                 #
# ---------------------------------------------------------------------------- #
"""
    install_term_repr()

Make `term_show` be called every times something is shown in the REPL
"""
function install_term_repr()
    @eval begin
        import Term: termshow

        Base.show(io::IO, ::MIME"text/plain", num::Number) =
            tprint(io, string(num); highlight = true)

        Base.show(io::IO, num::Number) = tprint(io, string(num); highlight = true)

        Base.show(io::IO, ::MIME"text/plain", obj::AbstractDict) = termshow(io, obj)

        Base.show(io::IO, ::MIME"text/plain", obj::Union{AbstractArray,AbstractMatrix}) =
            termshow(io, obj)

        Base.show(io::IO, ::MIME"text/plain", fun::Function) = termshow(io, fun)

        Base.show(io::IO, ::MIME"text/plain", obj::DataType) = termshow(io, obj)

        Base.show(io::IO, ::MIME"text/plain", expr::Expr) = termshow(io, expr)
    end
end

# ---------------------------------------------------------------------------- #
#                                   WITH REPR                                  #
# ---------------------------------------------------------------------------- #

"""
    with_repr(typedef::Expr)

Function for the macro @with_repr which creates a `Base.show` method for a type.

The `show` method shows the field names/types for the 
type and the values of the fields.

# Example
```
@with_repr struct TestStruct2
    x::Int
    name::String
    y
end
```
"""
function with_repr(typedef::Expr)
    tn = typename(typedef) # the name of the type
    showfn = :(Base.show(io::IO, ::MIME"text/plain", obj::$tn) = termshow(io, obj))
    quote
        Core.@__doc__ $typedef
        $showfn
    end
end

"""
with_repr(typedef::Expr)

Function for the macro @with_repr which creates a `Base.show` method for a type.

The `show` method shows the field names/types for the 
type and the values of the fields.

# Example
```
@with_repr struct TestStruct2
x::Int
name::String
y
end
```
"""
macro with_repr(typedef::Expr)
    return esc(with_repr(typedef))
end

# ---------------------------------------------------------------------------- #
#                                    SHOW ME                                   #
# ---------------------------------------------------------------------------- #

macro showme(expr, show_all_methods = false)
    width = min(console_width(), 120)
    hLine(width, style = "dim") |> tprint

    # print info msg
    info_msg = String["""
    !!! note "@showme"
        Showing definition for *method* called by: \n
            $(expr)       
            
    ###### Arguments

    """]

    parse_md(info_msg) |> tprintln

    # print args types
    theme = TERM_THEME[]
    _type_color = theme.type
    _string_color = theme.string
    for i in 2:length(expr.args)
        arg = expr.args[i]
        arg = arg isa AbstractString ? "\"$arg\"" : arg
        "     {$(theme.emphasis)}⨀{/$(theme.emphasis)} {$(theme.text_accent) italic}$arg{/$(theme.text_accent) italic}{$_type_color}::$(typeof(arg)){/$_type_color}" |>
        tprintln
    end

    print("\n")

    quote
        code_source = @code_string $expr
        Markdown.parse("###### Method definition") |> tprintln
        code_source = Markdown.parse("""
        ```
        $code_source
        ```
        """)
        code = parse_md(code_source; width = $width + 2, lpad = false) |> string

        method = @which $expr
        source = "{dim}$(method.file):$(method.line){/dim} "

        rvstack(code, source) |> tprint

        if $show_all_methods
            println()
            tprintln(
                "    " * Panel(
                    style_function_methods(eval(method.name); max_n = 100)[1],
                    title = "all methods",
                    style = "dim",
                    padding = (4, 4, 1, 1),
                    title_style = "default",
                    width = $width - 4,
                ),
            )
        end
    end
end

end

module LiveWidgets
import REPL
import REPL.Terminals: raw!, AbstractTerminal
import REPL.TerminalMenus: readkey

function get_terminal()
    return @static if isdefined(REPL.TerminalMenus, :default_terminal)
        REPL.TerminalMenus.default_terminal()
    else
        REPL.TerminalMenus.terminal
    end
end

using Dates
import Base.Docs: doc as getdocs
using Markdown
using AbstractTrees
import MyterialColors: Palette, blue, pink

import MyterialColors: pink

import Term: default_width, reshape_text, TERM_THEME, fint, reshape_code_string, remove_ansi
import ..Renderables: AbstractRenderable, RenderableText
import ..Panels: Panel
import ..Measures: Measure
import ..Measures: width as get_width
import ..Measures: height as get_height
using ..Consoles
import ..Repr: @with_repr, termshow
import ..Style: apply_style
import ..Layout: Spacer, vLine, vstack, hLine, hstack, PlaceHolder
import ..Compositors: Compositor, render, update!
import ..Tprint: tprint
import ..TermMarkdown: parse_md

export AbstractWidget, refresh!, play, key_press, shouldupdate, frame, stop!
export Pager
export SimpleMenu, ButtonsMenu, MultiSelectMenu
export InputBox, TextWidget, Button, ToggleButton
export Gallery
export App
export ArrowDown,
    ArrowUp,
    ArrowLeft,
    ArrowRight,
    DelKey,
    HomeKey,
    EndKey,
    PageUpKey,
    PageDownKey,
    Enter,
    SpaceBar,
    Esc,
    Del

const LIVE_DEBUG = Ref(false)

# ----------------------------- keyboard controls ---------------------------- #
abstract type KeyInput end

struct ArrowLeft <: KeyInput end
struct ArrowRight <: KeyInput end
struct ArrowUp <: KeyInput end
struct ArrowDown <: KeyInput end
struct DelKey <: KeyInput end
struct HomeKey <: KeyInput end
struct EndKey <: KeyInput end
struct PageUpKey <: KeyInput end
struct PageDownKey <: KeyInput end
struct Enter <: KeyInput end
struct SpaceBar <: KeyInput end
struct Esc <: KeyInput end
struct Del <: KeyInput end

KEYs = Dict{Int,KeyInput}(
    13 => Enter(),
    27 => Esc(),
    32 => SpaceBar(),
    127 => Del(),
    1000 => ArrowLeft(),
    1001 => ArrowRight(),
    1002 => ArrowUp(),
    1003 => ArrowDown(),
    1004 => DelKey(),
    1005 => HomeKey(),
    1006 => EndKey(),
    1007 => PageUpKey(),
    1008 => PageDownKey(),
)

# ------------------------------- base widgets ------------------------------- #
include("abstract_widget.jl")
include("help.jl")
include("widgets.jl")
include("pager.jl")
include("buttons.jl")
include("menus.jl")

# -------------------------------- containers -------------------------------- #
include("abstract_container.jl")
include("gallery.jl")
include("app.jl")

include("keyboard_input.jl")

end

import Term:
    unescape_brackets,
    escape_brackets,
    unspace_commas,
    remove_markup,
    replace_text,
    reshape_text,
    remove_ansi,
    split_lines,
    join_lines,
    has_markup,
    cleantext,
    textwidth,
    has_ansi,
    textlen,
    fillin,
    chars,
    justify,
    str_trunc,
    reshape_code_string

import Term.Colors: nospaces
import Term.Style: apply_style
import Term.Measures: width as get_width

@testset "TU_markup" begin
    strings = [
        (
            "this is {red} some {blue} text {/blue} that I like{/red}",
            "this is  some  text  that I like",
        ),
        (
            "{bold underline} this is {red on_green} text {/red on_green} I like {/bold underline}",
            " this is  text  I like ",
        ),
    ]

    for (s1, s2) in strings
        @test has_markup(s1)
        @test remove_markup(s1) == s2
        @test cleantext(s1) == s2
        @test textlen(s1) == textwidth(s2)
    end

    @test remove_markup("text with {{double}} squares") == "text with {{double}} squares"
    @test !has_markup("text with {{double}} squares")

    text = "{red}asdasda{/green}a{blue}sda{/blue}sda{/red}"

    @test remove_markup(text) == "asdasdaasdasda"
    @test remove_markup(text; remove_orphan_tags = false) == "asdasda{/green}asdasda"
end

@testset "TU_ansi" begin
    apply_style("test{(.2, .5, .6)}coloooor{/(.2, .5, .6)}")
    strings = [
        (
            "this is \e[31m some \e[34m text \e[39m\e[31m that I like\e[39m",
            "this is  some  text  that I like",
            "\e[39m",
        ),
        (
            "\e[1m\e[4m this is \e[31m\e[42m text \e[39m\e[49m\e[4m I like \e[22m\e[24m",
            " this is  text  I like ",
            "\e[24m",
        ),
        (
            "test\e[38;2;51;128;153mcoloooor\e[39m and white",
            "testcoloooor and white",
            "\e[39m",
        ),
    ]

    for (s1, s2, ltag) in strings
        @test has_ansi(s1)
        @test remove_ansi(s1) == s2
    end
end

@testset "TU_replace_text" begin
    text = "abcdefghilmnopqrstuvz"

    @test replace_text(text, 0, 5, "aaa") == "aaafghilmnopqrstuvz"
    @test replace_text(text, 0, 5, ',') == ",,,,,fghilmnopqrstuvz"

    @test replace_text(text, 18, 21, "aaa") == "abcdefghilmnopqrstaaa"
    @test replace_text(text, 18, 21, ',') == "abcdefghilmnopqrst,,,"

    @test replace_text(text, 10, 15, "aaa") == "abcdefghilaaarstuvz"
    @test replace_text(text, 10, 15, ',') == "abcdefghil,,,,,rstuvz"

    @test nospaces("a (1, 2, 3) 4") == "a(1,2,3)4"

    @test unspace_commas("a, 2, 3") == "a,2,3"
end

@testset "TU_misc" begin
    @test chars("abcd") == ['a', 'b', 'c', 'd']

    strings = [
        "aaa\nadasda\nasdasda",
        """
        asdasd
adsada
asddsa""",
    ]
    for str in strings
        @test join_lines(split_lines(str)) == str
    end
end

@testset "TU_reshape" begin
    strings = [
        "Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.",
        "Lorem {red}ipsum dolor sit {underline}amet, consectetur{/underline} adipiscing elit, {/red}{blue}sed do eiusmod tempor incididunt{/blue} ut labore et dolore magna aliqua.",
        "Lorem{red}ipsumdolorsit{underline}amet, consectetur{/underline} adipiscing elit, {/red}seddoeiusmo{blue}dtemporincididunt{/blue}ut labore et dolore magna aliqua.",
        "ต้าอ่วยวาทกรรมอาว์เซี้ยว กระดี๊กระด๊า ช็อปซาดิสต์โมจิดีพาร์ตเมนต์ อินดอร์วิว สี่แยกมาร์กจ๊อกกี้ โซนี่บัตเตอร์ฮันนีมูน ยาวีแพลนหงวนสคริปต์ แจ็กพ็อตต่อรองโทรโข่งยากูซ่ารุมบ้า บอมบ์เบอร์รีวีเจดีพาร์ทเมนท์ บอยคอตต์เฟอร์รี่บึมมาราธอน ",
        "ต้าอ่วยวาท{red}กรรมอาว์เซี้ยว กระดี๊กระด๊า {/red}ช็อปซาดิสต์โมจิดีพาร์ตเม{blue underline}นต์ อินดอร์วิว สี่แยกมาร์กจ๊อกกี้ โซนี่บัตเต{/blue underline}อร์ฮันนีมูน ยาวีแพลนหงวนสคริปต์ แจ็กพ็อตต่อรองโทรโข่งยากูซ่ารุมบ้า บอมบ์เบอร์รีวีเจดีพาร์ทเมนท์ บอยคอตต์เฟอร์รี่บึมมาราธอน ",
        "국가유공자·상이군경 및 전몰군경의 유가족은 법률이 정하는 바에 의하여",
        "국{red}가유공자·상이군{bold}경 및 전{/bold}몰군경의 유{/red}가족은 법률이 정하는 바에 의하여",
        "朗眠裕安無際集正聞進士健音社野件草売規作独特認権価官家複入豚末告設悟自職遠氷育教載最週場仕踪持白炎組特曲強真雅立覧自価宰身訴側善論住理案者券真犯著避銀楽験館稿告",
        "┌────────────────┬────────────────┬────────────────┬────────────────┬──────────────",
        "┌────────────abcde────┬──────────── ────┬────────abcde fghi────────┬────────────────┬──────────────",
        "┌─────────{red}───ab{/red}cde────┬──────{green}────── ────┬────────abcde fghi{/green}────────┬────────────────┬──────────────",
        "┌──────────{red}────{/red}──┬{blue bold}────────────────┬──{/blue bold}──────────────┬────────────────┬──────────────end",
        "."^100,
        ".{red}|||{/red}...."^10,
        ".|||...."^10,
    ]

    width = 33
    debug = false
    for (i, txt) in enumerate(strings)
        reshaped = reshape_text(txt, width)
        lens = length.(split(cleantext(reshaped), '\n'))

        # println(width, lens)
        # println(apply_style(reshaped))
        # println("_"^width)

        if length(txt) == ncodeunits(txt) && !occursin('\n', txt)
            (debug && any(lens .> width)) && println(lens)
            @test all(lens .≤ width)
        end
        IS_WIN || @compare_to_string reshaped "reshaped_text_$(i)"
    end

    for width in (40, 60, 99)
        rh = reshape_text(strings[1], width)
        @test all(textlen.(split(rh, '\n'); remove_orphan_tags = true) .≤ width)
    end
end

@testset "Text justify" begin
    str = "Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua."
    _str = reshape_text(str, 50)

    IS_WIN || @compare_to_string(justify(str, 150), "justify")

    txt = "adsda\nadasda\nergeer\nxcvxvxvx\naasdada"
    IS_WIN || @compare_to_string(fillin(txt), "fill_in_1")
    IS_WIN || @compare_to_string(fillin(txt; bg = "red"), "fill_in_2")
end

@testset "str_trunc" begin
    str = "Lorem ipsum dolor sit amet,\n consectetur adipiscing elit, sed do eiusmod \ntempor incididunt ut labore et dolore\n magna aliqua."

    for (i, w) in enumerate((12, 51, 31))
        IS_WIN || @compare_to_string(str_trunc(str, w), "str_trunc_$(i)")
    end
end

@testset "code reshaping" begin
    codes = [
        "{#f2d777}Table{/#f2d777}(data::Matrix{Float64}; kwargs::Base.Pairs{Symbol, Union{}, Tuple{}, NamedTuple{(), Tuple{}}})",
        "{}}, Tuple{{}}, NamedTuple{(), Tuple{{}}}}){#f2d777}Table{/#f2d777}",
        "{#f2d777}Table{/#f2d777}(tb::Tables.MatrixTable{Matrix{Float64}}; box::Symbol, style::String, hpad::Int64, vpad::Int64, vertical_justify::Symbol, show_header::Bool, header::Nothing, header_style::String, header_justify::Nothing, columns_style::String, columns_justify::Symbol, columns_widths::Nothing, footer::Nothing, footer_style::String, footer_justify::Symbol, compact::Bool)",
        "{#f2d777}calc_columns_widths{/#f2d777}(N_cols::Int64, N_rows::Int64, columns_widths::Nothing, show_header::Bool, header::Tuple{String, String, String}, tb::Tables.MatrixTable{Matrix{Float64}}, sch::Tables.Schema{(:Column1, :Column2, :Column3), Tuple{Float64, Float64, Float64}}, footer::Nothing, hpad::Vector{Int64})",
        """(::Term.Tables.var"#1#3"{Tables.MatrixTable{Matrix{Float64}}})(c::Symbol)""",
    ]

    widths = (32, 65, 88)

    for (i, c) in enumerate(codes), (j, w) in enumerate(widths)
        reshaped = reshape_code_string(c, w)
        @test get_width(reshaped) <= w
        IS_WIN || @compare_to_string reshaped "reshaped_code_$(i)_$(j)"
    end
end

@testset "markup reshaping" begin
    txts = [
        "{red}dasda asda dadasda{green}aadasdad{/green}dad asd ad ad ad asdad{bold}adada ad as sad ad ada{/red}ad adas sd ads {/bold}",
        "{red}adasd ad sa dsa{green} ad {blue} sd d ads ad {/blue}da dad {/green} asdsa dad a {/red}",
        "{red}adasd ad sa dsa{bold} ad {blue} sd d ads ad {/blue}da dad {/bold} asdsa dad a {/red}",
        "{red}adasd ad sa dsa{green} ad {blue} sd d ads ad da dad {/green} asdsa ddfsf {/blue}ad a {/red}",
        "{on_red}adasd ad sa dsa{green} ad {on_black} sd d ads ad da{/on_black} dad {/green} asdsa ddfsf ad a {/on_red}",
        "{on_(25, 25, 25)}adasd ad sa dsa{green} ad {on_black} sd d ads ad da{/on_black} {white}dad{/white} asad {/green} asdsa ddfsf ad a {/on_(25, 25, 25)}",
        "{(220, 180, 150)} pink {bold}pink bold {dodger_blue2} pink bold blue {/dodger_blue2} pink bold {/bold} pink {on_(25, 55, 100)} pink on blue {/(220, 180, 150)} just on blue {/on_(25, 55, 100)} NOW SIMPLE WHITE {red} red red red {/red} white white {underline} underline underline {/underline}",
    ]
    widths = (32, 65, 20)

    for (i, txt) in enumerate(txts)
        for (j, w) in enumerate(widths)
            reshaped = reshape_text(txt, w)
            IS_WIN || @compare_to_string reshaped "reshaped_text_markuo_$(j)_$(i)"
        end
    end
end

"""
Collection of small widgets
"""

# ---------------------------------------------------------------------------- #
#                                  TEXT WIDGET                                 #
# ---------------------------------------------------------------------------- #

# ------------------------------- constructors ------------------------------- #
"""
TextWidget just shows a piece of text.
"""
@with_repr mutable struct TextWidget <: AbstractWidget
    internals::WidgetInternals
    controls::AbstractDict
    text::String
    as_panel::Bool
    panel_kwargs
end

text_widget_controls = Dict('q' => quit, Esc() => quit)

TextWidget(
    text::String;
    as_panel = false,
    on_draw::Union{Nothing,Function} = nothing,
    on_activated::Function = on_activated,
    on_deactivated::Function = on_deactivated,
    controls = text_widget_controls,
    kwargs...,
) = TextWidget(
    WidgetInternals(
        Measure(Measure(text).h, console_width()),
        nothing,
        on_draw,
        on_activated,
        on_deactivated,
        false,
    ),
    controls,
    text,
    as_panel,
    Dict{Symbol,Any}(kwargs),
)

on_layout_change(t::TextWidget, m::Measure) = t.internals.measure = m

# ----------------------------------- frame ---------------------------------- #
function frame(tw::TextWidget; kwargs...)
    isnothing(tw.internals.on_draw) || tw.internals.on_draw(tw)
    measure = tw.internals.measure

    style = get(tw.panel_kwargs, :style, "default")
    style = isactive(tw) ? "bold white " * style : style

    panel_kwargs = copy(tw.panel_kwargs)
    if :style ∈ keys(tw.panel_kwargs)
        panel_kwargs[:style] = panel_kwargs[:style] * (isactive(tw) ? " bold red" : " dim")
    else
        panel_kwargs[:style] = isactive(tw) ? " bold red" : "dim"
    end

    tw.as_panel && return Panel(
        tw.text;
        width = measure.w,
        height = measure.h,
        fit = false,
        panel_kwargs...,
    )

    txt = if !isactive(tw)
        reshape_text(tw.text, measure.w - 4)
    else
        _txt = reshape_text(tw.text, measure.w - 6)
        vLine(get_height(_txt)) * _txt |> string
    end

    return RenderableText(txt; width = measure.w - 4)
end

# ---------------------------------------------------------------------------- #
#                                   INPUT BOX                                  #
# ---------------------------------------------------------------------------- #

# ------------------------------- constructors ------------------------------- #
"""
InputBox collects and displays user input as text. 
"""
@with_repr mutable struct InputBox <: AbstractWidget
    internals::WidgetInternals
    controls::AbstractDict
    input_text::Union{Nothing,String}
    blinker_update::Int
    blinker_status::Symbol
    panel_kwargs::Dict{Symbol,Any}
end

"""
new line
"""
newline(ib::InputBox, ::Enter) = isnothing(ib.input_text) || (ib.input_text *= "\n")

""" insert space """
addspace(ib::InputBox, ::SpaceBar) = isnothing(ib.input_text) || (ib.input_text *= " ")

""" delete last character """
del(ib::InputBox, ::Del) =
    isnothing(ib.input_text) || begin
        textwidth(ib.input_text) > 0 && (ib.input_text = ib.input_text[1:(end - 1)])
    end

""" add character to input """
addchar(ib::InputBox, c::Char) =
    if isnothing(ib.input_text)
        ib.input_text = string(c)
    else
        ib.input_text *= c
    end

input_box_controls = Dict(
    Enter() => newline,
    SpaceBar() => addspace,
    Del() => del,
    Esc() => quit,
    Char => addchar,
)

function InputBox(;
    controls::AbstractDict = input_box_controls,
    on_draw::Union{Nothing,Function} = nothing,
    on_activated::Function = on_activated,
    on_deactivated::Function = on_deactivated,
    kwargs...,
)
    InputBox(
        WidgetInternals(
            Measure(5, console_width()),
            nothing,
            on_draw,
            on_activated,
            on_deactivated,
            false,
        ),
        controls,
        nothing,
        0,
        :off,
        kwargs,
    )
end

on_layout_change(ib::InputBox, m::Measure) = ib.internals.measure = m

# ----------------------------------- frame ---------------------------------- #
function frame(ib::InputBox; kwargs...)
    isnothing(ib.internals.on_draw) || ib.internals.on_draw(ib)

    # create blinking symbol
    currtime = Dates.value(now())
    if currtime - ib.blinker_update > 300
        ib.blinker_update = currtime
        ib.blinker_status = ib.blinker_status == :on ? :off : :on
    end
    blinker = if isactive(ib)
        ib.blinker_status == :on ? " " : "{on_white} {/on_white}"
    else
        ""
    end

    panel_kwargs = copy(ib.panel_kwargs)

    panel_kwargs[:style] = get(ib.panel_kwargs, :style, "") * (isactive(ib) ? "" : " dim")
    # get text to display
    text = isnothing(ib.input_text) ? "{dim}start typing...{/dim}" : ib.input_text * blinker
    measure = ib.internals.measure
    return Panel(text; width = measure.w, height = measure.h, panel_kwargs...)
end

# ---------------------------------------------------------------------------- #
#                                  PLACEHOLDER                                 #
# ---------------------------------------------------------------------------- #

"""
Widget with no content to be used as a placeholder for choosing app layout.
"""
mutable struct PlaceHolderWidget <: AbstractWidget
    internals::WidgetInternals
    controls::AbstractDict
    color::String
    style::String
    name::String
end

on_layout_change(ph::PlaceHolderWidget, m::Measure) = ph.internals.measure = m

function on_activated(ph::PlaceHolderWidget)
    ph.internals.active = true
    ph.style = "bold"
end
function on_deactivated(ph::PlaceHolderWidget)
    ph.internals.active = false
    ph.style = "dim"
end

function PlaceHolderWidget(
    h::Int,
    w::Int,
    name::String,
    color::String;
    on_draw::Union{Nothing,Function} = nothing,
    on_activated::Function = on_activated,
    on_deactivated::Function = on_deactivated,
)
    internals = WidgetInternals(
        Measure(h, w),
        nothing,
        on_draw,
        on_activated,
        on_deactivated,
        false,
    )

    PlaceHolderWidget(internals, text_widget_controls, color, "dim", name)
end

function frame(ph::PlaceHolderWidget; kwargs...)
    isnothing(ph.internals.on_draw) || ph.internals.on_draw(ph)
    m = ph.internals.measure
    return PlaceHolder(
        m.h,
        m.w;
        style = "$(ph.color) $(ph.style)",
        text = "$(ph.name) ($(m.h), $(m.w)",
    )
end

import Base.Docs: doc as getdocs
using Base.Docs: meta, Binding
import Markdown

"""
    get_docstring(obj)

Extract and style an object's docstring.
"""
function get_docstring(obj)
    # get doc and docstring
    doc = getdocs(obj)
    docstring = if isnothing(doc)
        "no docstring"
    else
        highlight(highlight(doc), :docstring)
    end
    return doc, unescape_brackets(docstring)
end

"""
    get_methods_with_docstrings(obj::Union{Union, DataType, Function})

Get the docstring for each method for an object (function/datatype).
"""
function get_methods_with_docstrings(
    obj::Union{Union,DataType,Function},
)::Tuple{Vector,Vector}
    # get the parent module and the methods list for the object
    mod = parentmodule(obj)
    mm = methods(obj)

    # get the module's multidoc
    binding = Binding(mod, Symbol(obj))
    dict = meta(mod)
    multidoc = dict[binding]

    # for each module, attempt to get the docstring as markdown
    docstrings = []
    for m in mm
        # cleanup signature
        sig = length(m.sig.types) == 1 ? Tuple{} : Tuple{m.sig.types[2:end]...}

        haskey(multidoc.docs, sig) || begin
            push!(docstrings, nothing)
            continue
        end
        docs = multidoc.docs[sig].text[1] |> Markdown.parse
        push!(docstrings, docs)
    end

    return mm, docstrings
end

using Term.Links
import Term.Links: LinkString
import Term.Layout: pad
import Term: RenderableText, Panel

clean_link(l) = sprint(print, l)

file = "/Users/federicoclaudi/Documents/Github/Term.jl/src/_tables.jl"
lineno = 234

l1 = Link(file)
l2 = Link(file, lineno)
l3 = Link(file, lineno; style = "red")

ren = RenderableText("abcd")
lr = RenderableText(l2 * ren)

@testset "LINK measure" begin
    @test l1.measure.w == 61
    @test l2.measure.w == 65
    @test l3.measure.w == 65

    ren_w = ren.measure.w
    @test (l1 * ren).measure.w == 61 + ren_w
    @test (l2 * ren).measure.w == 65 + ren_w
    @test (l3 * ren).measure.w == 65 + ren_w

    @test lr.measure.w == 69
    @test (lr * ren).measure.w == 73

    @test (l1 / l2).measure.w == 65
    @test (l1 / lr).measure.w == 69
end

@testset "LINK padding" begin
    for (ln, link) in enumerate((l1, l2, l3))
        for (j, met) in enumerate([:left, :center, :right])
            ll = pad(link; width = 80, method = :left)
            @test ll.measure.w == 80
            IS_WIN || @compare_to_string(clean_link(ll), "link_pad_$(ln)_$j")
        end
    end
end

IS_WIN || @testset "LINK and panel" begin
    for (ln, link) in enumerate((l1, l2, l3))
        for (i, fit) in enumerate([true, false])
            p0 = Panel(link; fit = fit)
            p1 = Panel(link / ren; fit = fit)
            p2 = Panel(link * ren; fit = fit)
            p3 = Panel(link; width = 50)
            p4 = Panel(link, p3; fit = fit)

            for (j, p) in enumerate([p0, p1, p2, p3, p4])
                @compare_to_string(clean_link(p), "link_panel_$(ln)_$(i)_$(j)")
            end
        end
    end
end

@testset "LINK coverage" begin
    s = "abcd"
    l = l1.link

    @test s * l isa LinkString
    @test s / l isa LinkString
    @test l / s isa LinkString

    @test textwidth(l) == l.width
    @test string(l) == l
    @test sprint(io -> show(io, MIME("text/plain"), l)) == sprint(io -> print(io, l))
end

"""
    Term.jl

Welcome to Term.jl! Term.jl is a Julia library for producing styled, beautiful terminal output.

# Documentation

See https://fedeclaudi.github.io/Term.jl for documentation.

# Demonstration

```julia
using Term
const term_demo = joinpath(dirname(pathof(Term)), "..", "README.jl")
include(term_demo) # view demo
less(term_demo) # see demo code
```

# Example

``` julia
``` julia
begin
    println(@green "this is green")
    println(@blue "and this is blue")
    println()
    println(@bold "this is bold")
    println(@underline "and this is underlined")
end
```
"""
module Term

using Unicode

const STACKTRACE_HIDDEN_MODULES = Ref(String[])
const STACKTRACE_HIDE_FRAMES = Ref(true)

const DEBUG_ON = Ref(false)

const ACTIVE_CONSOLE_WIDTH = Ref{Union{Nothing,Int}}(nothing)
const ACTIVE_CONSOLE_HEIGHT = Ref{Union{Nothing,Int}}(nothing)
const DEFAULT_CONSOLE_WIDTH = Ref{Int}(88)
const DEFAULT_STACKTRACE_WIDTH = Ref{Int}(140)
const NOCOLOR = Ref{Bool}(false)

default_width(io = stdout)::Int =
    min(DEFAULT_CONSOLE_WIDTH[], something(ACTIVE_CONSOLE_WIDTH[], displaysize(io)[2]))
default_stacktrace_width(io = stderr)::Int =
    min(DEFAULT_STACKTRACE_WIDTH[], something(ACTIVE_CONSOLE_WIDTH[], displaysize(io)[2]))

const DEFAULT_ASPECT_RATIO = Ref(4 / 3)  # 4:3 - 16:9 - 21:9

# general utils
include("_ansi.jl")
include("__text_utils.jl")
include("_utils.jl")
include("_text_reshape.jl")

# don't import other modules
include("measures.jl")
include("colors.jl")
include("theme.jl")
include("highlight.jl")

const TERM_THEME = Ref(Theme())

# used to disable links in stacktraces for testing
const TERM_SHOW_LINK_IN_STACKTRACE = Ref(true)

function update! end

# rely on other modules
include("style.jl")
include("segments.jl")
include("macros.jl")
include("_code.jl")

# renderables, rely heavily on other modules
include("boxes.jl")
include("console.jl")
include("renderables.jl")
include("layout.jl")
include("link.jl")
include("panels.jl")
include("errors.jl")
include("tprint.jl")
include("trees.jl")
include("dendograms.jl")
include("tables.jl")
include("markdown.jl")
include("repr.jl")
include("compositors.jl")
include("grid.jl")

# interactive
include("Live/live.jl")
include("introspection.jl")
include("progress.jl")
include("logs.jl")
include("prompt.jl")
include("annotations.jl")

export RenderableText, Panel, TextBox, @nested_panels
export TERM_THEME, highlight
export @red, @black, @green, @yellow, @blue, @magenta, @cyan, @white, @default
export @bold, @dim, @italic, @underline, @style
export tprint, tprintln
export install_term_stacktrace,
    install_term_logger, uninstall_term_logger, install_term_repr
export vLine, hLine
export @with_repr, termshow, @showme
export Compositor
export grid
export inspect
export Pager

# ----------------------------------- base ----------------------------------- #
using .Measures

# ----------------------------------- style ---------------------------------- #

using .Colors: NamedColor, BitColor, RGBColor, get_color

using .Style: apply_style

using .Segments: Segment

# -------------------------------- renderables ------------------------------- #
using .Boxes

using .Consoles: console_height, console_width

using .Renderables: AbstractRenderable, Renderable, RenderableText

using .Layout

using .Links

using .Panels: Panel, TextBox, @nested_panels

# define additional methods for measure functions

Measures.width(seg::Segment) = seg.measure.w
Measures.width(ren::AbstractRenderable) = ren.measure.w

Measures.height(seg::Segment) = seg.measure.h
Measures.height(ren::AbstractRenderable) = ren.measure.h

"""
    Measure(seg::Segment) 

gives the measure of a segment
"""
Measures.Measure(seg::Segment) = seg.measure

"""
    Measure(segments::AbstractVector)

gives the measure of a vector of segments
"""
Measures.Measure(segments::AbstractVector) =
    if length(segments) == 0
        Measure(0, 0)  # nothing we can do here
    else
        Measure(sum(Measures.height.(segments)), maximum(Measures.width.(segments)))
    end

# ---------------------------------- others ---------------------------------- #
using .Errors: install_term_stacktrace, render_backtrace, StacktraceContext

using .Logs: install_term_logger, uninstall_term_logger, TermLogger

using .Tprint: tprint, tprintln

using .Trees: Tree

using .Dendograms: Dendogram

using .Tables: Table

using .Compositors: Compositor

using .TermMarkdown: parse_md

using .Repr: @with_repr, termshow, install_term_repr, @showme

using .Grid

# -------------------------------- interactive ------------------------------- #
using .LiveWidgets

# ----------------------------- using interactive ---------------------------- #
using .Progress: ProgressBar, ProgressJob, with, @track

using .Introspection: inspect, typestree, expressiontree, inspect

using .Prompts

include("__precompilation.jl")

end

module Progress

using Dates
import Parameters: @with_kw
import UUIDs: UUID

import Term:
    rint, textlen, str_trunc, loop_last, get_file_format, update!, default_width, TERM_THEME
import ..Tprint: tprint, tprintln
import ..Style: apply_style
import ..Consoles:
    console_width,
    hide_cursor,
    show_cursor,
    move_to_line,
    cleartoend,
    change_scroll_region,
    console_height,
    up,
    down,
    erase_line,
    savecursor,
    restorecursor

import ..Renderables: AbstractRenderable
import ..Measures: Measure
import ..Segments: Segment
import ..Colors: RGBColor
import ..Layout: hLine

export ProgressBar,
    ProgressJob,
    addjob!,
    start!,
    stop!,
    update!,
    removejob!,
    with,
    @track,
    render,
    foreachprogress

# ---------------------------------------------------------------------------- #
#                               PROGRESS BAR JOB                               #
# ---------------------------------------------------------------------------- #

# ------------------------------- constructors ------------------------------- #
"""
    ProgressJob

Single `job` whose progress we're tracking with a progress bar.

Each progress bar can have multiple jobs running at the same time, and more can
be added/removed at any time. Each `ProgressJob` keeps track of the state (progress)
of each of these jobs. `ProgressJob` is also rendered to create the visual display
of the progress bar.

Arguments:
- `id` specifies the job;s unique id
- `i`: keeps track of the progress (number of completed steps)
- `N`: total number of steps in the task at hand. Optional, set to `nothing` when not known
- `description`: a bit of text describing what the job is
- `columns`: set of `AbstractColumn` used to represent the job's information
- `columns_kwargs`: additional information passed to each column when created (e.g. to set style)
- `width`: width of the progress bar display
- `started`: whether the job was started or not.
- `stopped`: whether the job was stopped (finished job)
- `startime`: time at which job was started
- `stoptime`: time at which job was stopped
- `transient`: if truee the job's visual display disappears when `stopped=true`
"""
mutable struct ProgressJob
    id::Union{Int,UUID}

    i::Int   # keep track of progress
    N::Union{Nothing,Int}

    description::String
    columns::Any
    columns_kwargs::Dict
    width::Int

    started::Bool
    finished::Bool
    startime::Union{Nothing,DateTime}
    stoptime::Union{Nothing,DateTime}
    transient::Bool

    """
        ProgressJob(
            id::Union{Int, UUID},
            N::Union{Int, Nothing},
            description::String,
            columns::Vector{DataType},
            width::Int,
            columns_kwargs::Dict,
            transient::Bool,
        )

    Constructor for a `ProgressJob`.

    See also [`addjob!`](@ref), [`start!`](@ref), [`stop!`](@ref), [`update!`](@ref), [`redender`](@ref)
    """
    function ProgressJob(
        id::Union{Int,UUID},
        N::Union{Int,Nothing},
        description::String,
        columns::Vector{DataType},
        width::Int,
        columns_kwargs::Dict,
        transient::Bool,
    )
        return new(
            id,
            0,
            N,
            description,
            columns,
            columns_kwargs,
            width,
            false,
            false,
            nothing,
            nothing,
            transient,
        )
    end
end

Base.show(io::IO, ::MIME"text/plain", job::ProgressJob) =
    print(io, "Progress job $(job.id) \e[2m(started: $(job.started))\e[0m")

"""
    start!(job::ProgressJob)

Start a newly created `ProgressJob`.

When starting a job, take care of creating instance of `AbstractColumns`
to display the job's progress. If `N` is nothing, remove any `ProgressColumn`
"""
function start!(job::ProgressJob)
    job.started && return nothing

    # if the job doesn't have a defined `N`, we can't have a progress column display
    if isnothing(job.N)
        filter!(c -> c != ProgressColumn, job.columns)

        # but we should have a spinner column if there isnt one.
        !any(job.columns .== SpinnerColumn) && push!(job.columns, SpinnerColumn)
    end

    # create columns type instances, passing the appropriate keyword arguments
    csymbol(c) = Symbol(split(string(c), ".")[end])
    function makecol(c)
        return if haskey(job.columns_kwargs, csymbol(c))
            c(job; job.columns_kwargs[csymbol(c)]...)
        else
            c(job)
        end
    end
    job.columns = map(c -> makecol(c), job.columns)

    # if there's a progress column, set its width
    if !isnothing(job.N) && any(map(c -> c isa ProgressColumn, job.columns))
        # get the progress column width
        spaces = length(job.columns) - 1
        colwidths = sum(c -> c.measure.w, job.columns)
        bcol_width = job.width - colwidths - spaces

        # set width
        setwidth!.(job.columns, bcol_width)
    end

    # start job
    job.started = true
    job.startime = now()
    return nothing
end

"""
    update!(job::ProgressJob; i = nothing)

Update a job's progress `i` by setting its value or adding `+1`.
"""
function update!(job::ProgressJob; i = nothing)
    if !isnothing(job.N) && job.i ≥ job.N
        stop!(job)
    else
        job.i += something(i, 1)
    end
    return nothing
end

"""
    stop!(job::ProgressJob)

Stop a running job.
"""
function stop!(job::ProgressJob)
    job.stoptime = now()
    job.finished = true
    sleep(0.05)
    return nothing
end

# ---------------------------------------------------------------------------- #
#                                    COLUMNS                                   #
# ---------------------------------------------------------------------------- #
# load columns types definitions
include("_progress.jl")

# ---------------------------------------------------------------------------- #
#                                  PROGRESS BAR                                #
# ---------------------------------------------------------------------------- #
"""
    RenderStatus

Keep track of rendering information for a `ProgressBar`
"""
Base.@kwdef mutable struct RenderStatus
    rendered::Bool = false
    nlines::Int = 0
    maxnlines::Int = 0
    hline::String = ""
    scrollline::Int = 0
end

# ------------------------------- constructors ------------------------------- #
"""
    ProgressBar

Progressbar Type, stores information required
to render progress bar renderables for each `ProgressJob` assigned.

ProgressBar takes care of the work needed to setup/update progress bar(s)
visualizations. Each individual bar corresponds to a (running) `ProgressJob`
and `ProgressJob` itself is what actually creates the visuals.
Most of the work done by ProgressBar is to handling terminal stuff, move
cursor position, change scrolling regions, clear/update sections etc.


Arguments:
    - `jobs`: vector of `ProgressJob` to assign to the progress bar (more can added later)
    - `width`: width of the visualization, if `expand=false`
    - `columns`: which columns to show? Either a vector of column types or the name of a preset
    - `column_kwargs`: keyword arguments to pass to each column
    - `transient`: if true jobs disappear when done (and the whole pbar when all jobs are done)
    - `colors`: set of 3 `RGBColor` to change the color of the progress bar with progress
    - `Δt`: delay between refreshes of the visualization.
    - `buff`: `IOBuffer` used to render the progress bars
    - `running`: true if the progress bar is active
    - `paused`: false when the bar is running but briefly paused (e.g. to update `jobs`)
    - `task`: references a `Task` for updating the progress bar in parallel
    - `renderstatus`: a `RenderStatus` instance
    - `extra_info`: a `Dict{String,<:Any}` to show extra information.
"""
mutable struct ProgressBar
    jobs::Vector{ProgressJob}
    width::Int

    columns::Vector{DataType}
    columns_kwargs::Dict

    transient::Bool
    colors::Union{String,Vector{RGBColor}}
    Δt::Float64

    buff::IOBuffer  # will be used to store temporarily re-directed stdout
    running::Bool
    paused::Bool
    task::Union{Task,Nothing}
    renderstatus::Any
    extra_info::Dict{String,<:Any}
end

"""
    ProgressBar(;
        width::Int = $(default_width()),
        columns::Union{Vector{DataType}, Symbol} = :default,
        columns_kwargs::Dict = Dict(),
        expand::Bool = false,
        transient::Bool = false,
        colors::Vector{RGBColor} = [
            RGBColor("(1, .05, .05)"),
            RGBColor("(.05, .05, 1)"),
            RGBColor("(.05, 1, .05)"),
        ],
        refresh_rate::Int = 60,  # FPS of rendering
        extra_info::Dict{String,<:Any} = Dict{String,Any}(),
    )

Create a ProgressBar instance.
"""
function ProgressBar(;
    width::Int                              = default_width(),
    columns::Union{Vector{DataType},Symbol} = :default,
    columns_kwargs::Dict                    = Dict(),
    expand::Bool                            = false,
    transient::Bool                         = false,
    colors::Union{String,Vector{RGBColor}}  = [RGBColor("(1, .05, .05)"), RGBColor("(.05, .05, 1)"), RGBColor("(.05, 1, .05)")],
    refresh_rate::Int                       = 60,  # FPS of rendering
    extra_info::Dict{String,<:Any}          = Dict{String,Any}(),
)
    columns = columns isa Symbol ? get_columns(columns) : columns

    # check that width is large enough
    width = expand ? console_width() - 5 : min(max(width, 20), console_width() - 5)

    return ProgressBar(
        Vector{ProgressJob}(),
        width,
        columns,
        columns_kwargs,
        transient,
        colors,
        1 / refresh_rate,
        IOBuffer(),
        false,
        false,
        nothing,
        RenderStatus(),
        extra_info,
    )
end

Base.show(io::IO, ::MIME"text/plain", pbar::ProgressBar) =
    print(io, "Progress bar \e[2m($(length(pbar.jobs)) jobs)\e[0m")

# ---------------------------------------------------------------------------- #
#                                    METHODS                                   #
# ---------------------------------------------------------------------------- #
# --------------------------------- edit pbar -------------------------------- #
"""
    addjob!(
            pbar::ProgressBar;
            description::String="Running...",
            N::Union{Int, Nothing}=nothing,
            start::Bool=true,
            transient::Bool=false,
            id=nothing
        )::ProgressJob

Add a new `ProgressJob` to a running `ProgressBar`

See also: [`removejob!`](@ref), [`getjob`](@ref)
"""
function addjob!(
    pbar::ProgressBar;
    description::String = "Running...",
    N::Union{Int,Nothing} = nothing,
    start::Bool = true,
    transient::Bool = false,
    id = nothing,
    columns_kwargs::Dict = Dict(),
)::ProgressJob
    pbar.running && print("\n")

    # create Job
    pbar.paused = true
    id = isnothing(id) ? length(pbar.jobs) + 1 : id
    kwargs = merge(pbar.columns_kwargs, columns_kwargs)
    job = ProgressJob(id, N, description, pbar.columns, pbar.width, kwargs, transient)

    # start job
    start && start!(job)
    push!(pbar.jobs, job)
    pbar.paused = false
    render(job, pbar)
    return job
end

"""
    removejob!(pbar::ProgressBar, job::ProgressJob)

Remove a `ProgressJob` from a `ProgressBar`.

See also: [`addjob!`](@ref), [`getjob`](@ref)
"""
function removejob!(pbar::ProgressBar, job::ProgressJob)
    pbar.paused = true
    stop!(job)
    deleteat!(pbar.jobs, findfirst(j -> j.id == job.id, pbar.jobs))
    return pbar.paused = false
end

"""
    getjob(pbar::ProgressBar, id)

Get a `ProgressBar`'s `ProgressJob` by `id`.
"""
function getjob(pbar::ProgressBar, id)
    idx = findfirst(j -> j.id == id, pbar.jobs)
    isnothing(idx) && return nothing
    return pbar.jobs[idx]
end

"""
    start!(pbar::ProgressBar)

Start a `ProgressBar` and run a `Task` to update its visuals.

Starts a parallel `Task` for updating the `ProgressBar`
visualization while other code runs. The task is stopped
when the progress bar is set to have `running=false`

See also [`stop!`](@ref)
"""
function start!(pbar::ProgressBar)
    pbar.running = true
    print("\n"^(length(pbar.jobs)))
    return nothing
end

"""
    stop!(pbar::ProgressBar)

Stop a running `ProgressBar`.

Stops the `Task` updating the progress bar
visuals too, and if the progress bar was
`transient` it clears up the visuals.
"""
function stop!(pbar::ProgressBar)
    pbar.paused = true
    pbar.running = false

    # if transient, delete
    if pbar.transient
        # move cursor to stale scrollregion and clear
        move_to_line(stdout, console_height())
        for i in 1:(pbar.renderstatus.nlines + 2)
            erase_line(stdout)
            up(stdout)
        end
    else
        print("\n")
    end

    # restore scrollbar region
    change_scroll_region(stdout, console_height())
    show_cursor()
    pbar.transient || print("\n")
    return nothing
end

# --------------------------------- rendering -------------------------------- #
"""
    render(job::ProgressJob, pbar::ProgressBar)::String

Render a `ProgressJob`
"""
function render(job::ProgressJob, pbar::ProgressBar)::String
    color = jobcolor(pbar, job)
    return apply_style(join(update!.(job.columns, color), " "))
end

"""
    render(job::ProgressJob, pbar::ProgressBar)::String

Render a `ProgressJob`
"""
function render(job::ProgressJob)::String
    color = jobcolor(job)
    return apply_style(join(update!.(job.columns, color), " "))
end

"""
    render(job::ProgressJob, pbar::ProgressBar)::String

Render a `ProgressBar`.

When a progress bar is first rendered, this function uses
ANSI codes to change the scrolling region of the terminal
window to create a space at the bottom where the bar's visuals
can be displayed. This allows for thext printed to `stdout` to
still be visualized. On subsequent calls, this function
ensures that the height of the reserved space matches the
number of running jobs.

All fo this requires a bit of careful work in moving the
cursor around and doing ANSI magic.
"""
function render(pbar::ProgressBar)
    # check if running
    pbar.running || return nothing

    # remove completed, transient jobs
    for job in pbar.jobs
        if job.finished && job.transient
            removejob!(pbar, job)
        end
    end

    # get variables
    njobs, height = 1 + length(pbar.jobs) + length(pbar.extra_info), console_height()
    iob = pbar.buff

    # on the first render, create sticky region
    if !pbar.renderstatus.rendered
        print(iob, "\n"^(njobs))
        pbar.renderstatus.scrollline = height - njobs
        change_scroll_region(iob, pbar.renderstatus.scrollline)

        pbar.renderstatus.rendered = true
        pbar.renderstatus.hline =
            string(hLine(pbar.width, "progress"; style = "blue dim")) * "\n"
        pbar.renderstatus.nlines = njobs
        pbar.renderstatus.maxnlines = njobs

    elseif njobs > pbar.renderstatus.maxnlines
        # if we need more lines, scroll
        write(iob, "\n"^(njobs - pbar.renderstatus.maxnlines))

        # set scroll region
        pbar.renderstatus.maxnlines = njobs
        pbar.renderstatus.scrollline = height - pbar.renderstatus.maxnlines
        change_scroll_region(iob, pbar.renderstatus.scrollline)
    end

    # move cursor to scrollregion and clear
    move_to_line(iob, pbar.renderstatus.scrollline + 1)
    cleartoend(iob)

    # render the progressbars
    write(iob, pbar.renderstatus.hline)
    for (last, job) in loop_last(pbar.jobs)
        contents = render(job, pbar)
        coda = last ? "" : "\n"
        write(iob, contents * coda)
    end

    # render the extra information
    if !isempty(pbar.extra_info)
        max_len = maximum(length.(keys(pbar.extra_info)))
        for (k, v) in pbar.extra_info
            write(iob, "\n" * k * " "^(max_len - length(k)) * " : " * string(v))
        end
    end

    # restore position and write
    move_to_line(iob, pbar.renderstatus.scrollline)
    return print(String(take!(iob)))
end

# ---------------------------------------------------------------------------- #
#                                     WITH                                     #
# ---------------------------------------------------------------------------- #
"""
    with(expr, pbar::ProgressBar)

Wrap an expression to run code in the context of a progress bar.

Ensures that the progress bar is correctly created and distroyed
even if code within the loop whose progress we're monitoring causes
and error. Since `render` changes the scrollregion in the terminal,
we need to make sure that we can restore things no matter what.

# Examples
```julia
pbar = ProgressBar()
with(pbar) do
    job = addjob!(pbar; description="Running")
    for i in 1:500
        update!(job)
        sleep(.0025)
    end
end
```
"""
function with(expr, pbar::ProgressBar)
    # @info expr expr.args

    val = nothing
    try
        start!(pbar)

        task = Threads.@spawn expr()
        while !istaskdone(task) && pbar.running
            pbar.paused || render(pbar)
            sleep(pbar.Δt)
        end
        stop!(pbar)
        val = fetch(task)
    catch err
        stop!(pbar)
        rethrow()
        quit()
    end
    stop!(pbar)
    return val
end

# ---------------------------------------------------------------------------- #
#                                     TRACK                                    #
# ---------------------------------------------------------------------------- #

"""
    @track(ex)

Macro to wrap a loop in a progress bar.

Like [`with`](@ref) it wraps the expression code
in a try/finally statement to ensure that the
progress bar is correctly stopped in any situation.

# Examples
```julia
@track for i in 1:10
    sleep(0.1)
end
```
"""
macro track(ex)
    iter = esc(ex.args[1].args[2])
    i = esc(ex.args[1].args[1])
    body = esc(ex.args[2])
    quote
        __pbar = ProgressBar()
        __pbarjob = addjob!(__pbar; N = length($iter))
        with(__pbar) do
            for $i in $iter
                update!(__pbarjob)
                $body
            end
        end
    end
end

const FOREACH_PROGRESS = ProgressBar(transient = true)

"""
    foreachprogress(f, iter[, pbar; parallel=false, transient=true, description])

Apply `f` to every element in iterator `iter`, showing a progress bar.
This function can be nested.

## Arguments

- `pbar::Term.Progress.ProgressBar = Term.FOREACH_PROGRESS`: The progress bar to use. By
    default, uses a global progress bar, but it is recommended to explicitly pass in
    a progress bar.
- `parallel`: Whether to use `Threads.@threads` to speed up the loop.
- `transient = true`: See `Term.Progress.addjob!`
- `description = true`: See `Term.Progress.addjob!`

## Examples

Simple loop passing in a progress bar:

```julia
foreachprogress(1:10, Term.ProgressBar(); description = "Working...") do i
    @info i
    sleep(0.1)
end
```

Simple loop using the global progress bar (use with care):

```julia
foreachprogress(1:10; description = "Working...") do i
    @info i
    sleep(0.1)
end
```

Nesting a loop inside another:

```julia
pbar = Term.ProgressBar()
foreachprogress(1:100, pbar,   description = "Outer    ", parallel=true) do i
    foreachprogress(1:5, pbar, description = "    Inner") do j
        sleep(rand() / 5)
    end
end
```

Speeding up the loop using threads by passing `parallel`:

```julia
foreachprogress(1:50; description = "Working...", parallel=true) do i
    @info i
    sleep(0.1)
end
```
"""
function foreachprogress(
    f,
    iter,
    pbar = FOREACH_PROGRESS;
    n = _getn(iter),
    transient = true,
    parallel = false,
    columns_kwargs = Dict(),
    kwargs...,
)
    task = nothing
    try
        # Only handle rendering of progress bar if it is not already running.
        # This allows nesting of `foreachprogress`
        if !pbar.running
            # If starting the progress bar, clear any previous jobs
            pbar.jobs = ProgressJob[]
            start!(pbar)
            task = Threads.@spawn _startrenderloop(pbar)
        end

        # The job tracks the iteration through `iter`
        job = addjob!(
            pbar;
            N = n,
            transient = transient,
            columns_kwargs = columns_kwargs,
            kwargs...,
        )
        if parallel
            Threads.@threads for elem in iter
                f(elem)
                update!(job)
            end
        else
            for elem in iter
                f(elem)
                update!(job)
            end
        end
        stop!(job)
    catch
        rethrow()
    finally
        if !isnothing(task)
            stop!(pbar)
        end
    end
end

_getn(iter) = _getn(iter, Base.IteratorSize(iter))
_getn(iter, ::Union{Base.HasLength,<:Base.HasShape}) = length(iter)
_getn(_, _) = nothing

function _startrenderloop(pbar)
    while pbar.running
        pbar.paused || render(pbar)
        sleep(pbar.Δt)
    end
end

# ------------------------------- general utils ------------------------------ #
"""
jobcolor(job::ProgressJob)

Get the RGB color of of a progress bar's bar based on progress.
"""
function jobcolor(pbar::ProgressBar, job::ProgressJob)
    isnothing(job.N) && return "white"
    pbar.colors isa String && return pbar.colors

    α = 0.8 * job.i / job.N
    β = max(sin(π * job.i / job.N) * 0.7, 0.4)

    c1, c2, c3 = pbar.colors
    r = string(rint((0.8 - α) * c1.r + β * c2.r + α * c3.r))
    g = string(rint((0.8 - α) * c1.g + β * c2.g + α * c3.g))
    b = string(rint((0.8 - α) * c1.b + β * c2.b + α * c3.b))
    return "(" * r * ", " * g * ", " * b * ")"
end

const PbarCol1 = RGBColor("(1, .05, .05)")
const PbarCol2 = RGBColor("(.05, .05, 1)")
const PbarCol3 = RGBColor("(.05, 1, .05)")

function jobcolor(job::ProgressJob)
    isnothing(job.N) && return "white"

    α = 0.8 * job.i / job.N
    β = max(sin(π * job.i / job.N) * 0.7, 0.4)

    c1, c2, c3 = PbarCol1, PbarCol2, PbarCol3
    r = string(rint((0.8 - α) * c1.r + β * c2.r + α * c3.r))
    g = string(rint((0.8 - α) * c1.g + β * c2.g + α * c3.g))
    b = string(rint((0.8 - α) * c1.b + β * c2.b + α * c3.b))
    return "(" * r * ", " * g * ", " * b * ")"
end

end

import Term.Style: apply_style
import Term: tprint, tprintln, get_file_format, reshape_text

@testset "\e[34mStyle\e[0m" begin
    @test apply_style("test") == "test"

    @test apply_style("{red}test{/red}") == "\e[31mtest\e[39m"

    @test apply_style("{red}te{blue on_green}s{/blue on_green}t{/red}") ==
          "\e[31mte\e[34m\e[42ms\e[39m\e[49m\e[31mt\e[39m"

    @test apply_style("{red}\ntest{bold} sdfsfsd{/bold}sdfsdf{/red}") ==
          "\e[31m\ntest\e[1m sdfsfsd\e[22m\e[31msdfsdf\e[39m"

    @test apply_style("""
    test {red} sdfsdf
    fdsf{/red} {bold} sfsdfp{green} sdfsdp{/green}sdsdfs
    pdfsdp{/bold}""") ==
          "test \e[31m sdfsdf\nfdsf\e[39m \e[1m sfsdfp\e[32m sdfsdp\e[39msdsdfs\npdfsdp\e[22m"

    # check that parentheses are escaped correctly
    @test apply_style("This and that {{something}} for") ==
          "This and that {{something}} for"
end

@testset "Style with nested tags" begin
    txt = "{red}adasd ad sa dsa{green} ad {blue} sd d ads ad {/blue}da dad {/green} asdsa dad a {/red}"
    @test apply_style(txt) ==
          "\e[31madasd ad sa dsa\e[32m ad \e[34m sd d ads ad \e[39m\e[32mda dad \e[39m\e[31m asdsa dad a \e[39m"

    txt = "{red}adasd ad sa dsa{bold} ad {blue} sd d ads ad {/blue}da dad {/bold} asdsa dad a {/red}"
    @test apply_style(txt) ==
          "\e[31madasd ad sa dsa\e[1m ad \e[34m sd d ads ad \e[39m\e[31mda dad \e[22m\e[31m asdsa dad a \e[39m"

    txt = "{red}adasd ad sa dsa{green} ad {blue} sd d ads ad da dad {/green} asdsa ddfsf {/blue}ad a {/red}"
    @test apply_style(txt) ==
          "\e[31madasd ad sa dsa\e[32m ad \e[34m sd d ads ad da dad \e[39m\e[31m asdsa ddfsf \e[39mad a \e[39m"

    txt = "{on_red}adasd ad sa dsa{green} ad {on_black} sd d ads ad da{/on_black} dad {/green} asdsa ddfsf ad a {/on_red}"
    @test apply_style(txt) ==
          "\e[41madasd ad sa dsa\e[32m ad \e[40m sd d ads ad da\e[49m\e[32m\e[41m dad \e[39m\e[41m asdsa ddfsf ad a \e[49m"

    txt = "{on_(25, 25, 25)}adasd ad sa dsa{green} ad {on_black} sd d ads ad da{/on_black} {white}dad{/white} asad {/green} asdsa ddfsf ad a {/on_(25, 25, 25)}"
    @test apply_style(txt) ==
          "\e[48;2;25;25;25madasd ad sa dsa\e[32m ad \e[40m sd d ads ad da\e[49m\e[32m\e[48;2;25;25;25m \e[37mdad\e[39m\e[32m asad \e[39m\e[48;2;25;25;25m asdsa ddfsf ad a \e[49m"

    txt = "{(220, 180, 150)} pink {bold}pink bold {dodger_blue2} pink bold blue {/dodger_blue2} pink bold {/bold} pink {on_(25, 55, 100)} pink on blue {/(220, 180, 150)} just on blue {/on_(25, 55, 100)} NOW SIMPLE WHITE {red} red red red {/red} white white {underline} underline underline {/underline}"
    @test apply_style(txt) ==
          "\e[38;2;220;180;150m pink \e[1mpink bold \e[38;5;27m pink bold blue \e[39m\e[38;2;220;180;150m pink bold \e[22m\e[38;2;220;180;150m pink \e[48;2;25;55;100m pink on blue \e[39m just on blue \e[49m NOW SIMPLE WHITE \e[31m red red red \e[39m white white \e[4m underline underline \e[24m"
end

@testset "Style with nested tags and reshaping" begin
    txts = [
        "{red}adasd ad sa dsa{green} ad {blue} sd d ads ad {/blue}da dad {/green} asdsa dad a {/red}",
        "{red}adasd ad sa dsa{bold} ad {blue} sd d ads ad {/blue}da dad {/bold} asdsa dad a {/red}",
        "{red}adasd ad sa dsa{green} ad {blue} sd d ads ad da dad {/green} asdsa ddfsf {/blue}ad a {/red}",
        "{on_red}adasd ad sa dsa{green} ad {on_black} sd d ads ad da{/on_black} dad {/green} asdsa ddfsf ad a {/on_red}",
        "{on_(25, 25, 25)}adasd ad sa dsa{green} ad {on_black} sd d ads ad da{/on_black} {white}dad{/white} asad {/green} asdsa ddfsf ad a {/on_(25, 25, 25)}",
        "{(220, 180, 150)} pink {bold}pink bold {dodger_blue2} pink bold blue {/dodger_blue2} pink bold {/bold} pink {on_(25, 55, 100)} pink on blue {/(220, 180, 150)} just on blue {/on_(25, 55, 100)} NOW SIMPLE WHITE {red} red red red {/red} white white {underline} underline underline {/underline}",
    ]

    sizes = (25, 33, 61)

    for (i, txt) in enumerate(txts)
        for (j, w) in enumerate(sizes)
            IS_WIN ||
                @compare_to_string apply_style(reshape_text(txt, w)) "nested_tags_reshape_$(i)_$(j)"
            IS_WIN ||
                @compare_to_string reshape_text(apply_style(txt), w) "nested_tags_reshape_$(i)_$(j)_reverse"
        end
    end
end

@testset "\e[34mTprint\e[0m" begin
    stprint(x) = chomp(sprint(tprint, x; context = stdout))
    stprintln(x) = chomp(sprint(tprintln, x; context = stdout))

    # ------------------------------- with strings ------------------------------- #
    @test stprint("test") == "test"
    # @test stprintln("test") == "test "

    @test stprint("{red}test{/red}") == "\e[31mtest\e[39m"
    # @test stprintln("{red}test{/red}") == "\e[31mtest\e[39m "

    @test stprint("{red}te{blue on_green}s{/blue on_green}t{/red}") ==
          "\e[31mte\e[34m\e[42ms\e[39m\e[49m\e[31mt\e[39m"
    # @test stprintln("{red}te{blue on_green}s{/blue on_green}t{/red}") == "\e[31mte\e[34m\e[42ms\e[39m\e[49m\e[31mt\e[39m "

    @test stprint("{red}\ntest{bold} sdfsfsd{/bold}sdfsdf{/red}") ==
          "\e[31m\ntest\e[1m sdfsfsd\e[22m\e[31msdfsdf\e[39m"
    # @test stprintln("{red}\ntest{bold} sdfsfsd{/bold}sdfsdf{/red}") == "\e[31m\ntest\e[1m sdfsfsd\e[22m\e[31msdfsdf\e[39m "

    @test stprint("""
    test {red} sdfsdf
    fdsf{/red} {bold} sfsdfp{green} sdfsdp{/green}sdsdfs
    pdfsdp{/bold}""") ==
          "test \e[31m sdfsdf\nfdsf\e[39m \e[1m sfsdfp\e[32m sdfsdp\e[39msdsdfs\npdfsdp\e[22m"

    @test stprint("This and that {{something}} for") == "This and that {{something}} for"
end

@testset "\e[34mTmisc\e[0m" begin
    @test get_file_format(1024) == "1.0 KB"
    @test get_file_format(10243312) == "9.77 MB"
end

# ---------------------------------------------------------------------------- #
#                                 ABSTRACT MENU                                #
# ---------------------------------------------------------------------------- #
"""
    AbstractMenu

Objects of type AbstractMenu present the user with a few options
and let them select one by moving around with the up/down keys 
and using Enter to select an option.
"""
abstract type AbstractMenu <: AbstractWidget end

# --------------------------------- controls --------------------------------- #

""" set next item to active """
menu_activate_next(mn::AbstractMenu, ::Any) = mn.active = min(mn.active + 1, mn.n_titles)

""" set previous item to active """
menu_activate_prev(mn::AbstractMenu, ::Any) = mn.active = max(1, mn.active - 1)

""" quit menu and return value"""
function menu_return_value(mn::AbstractMenu, ::Enter)
    quit(mn)
    return mn.active
end

vert_menu_controls = Dict(
    ArrowDown() => menu_activate_next,
    ArrowUp() => menu_activate_prev,
    Enter() => menu_return_value,
    Esc() => quit,
    'q' => quit,
)

hor_menu_controls = Dict(
    ArrowRight() => menu_activate_next,
    ArrowLeft() => menu_activate_prev,
    Enter() => menu_return_value,
    Esc() => quit,
    'q' => quit,
)

function on_layout_change(mn::AbstractMenu, m::Measure)
    mn.internals.measure = m
end

# ---------------------------------------------------------------------------- #
#                                CONCRETE MENUS                                #
# ---------------------------------------------------------------------------- #
# -------------------------------- simple menu ------------------------------- #
"""
Simple text based menu. 
The currently selected option is highlighted with a different style.
"""
@with_repr mutable struct SimpleMenu <: AbstractMenu
    internals::WidgetInternals
    controls::AbstractDict
    titles::Vector{String}
    n_titles::Int
    active_style::String
    inactive_style::String
    active::Int
    layout::Symbol

    function SimpleMenu(
        titles::Vector;
        controls::Union{Nothing,AbstractDict} = nothing,
        width = default_width(),
        active_style::String = "white bold",
        inactive_style::String = "dim",
        layout::Symbol = :vertical,
        on_draw::Union{Nothing,Function} = nothing,
        on_activated::Function = on_activated,
        on_deactivated::Function = on_deactivated,
    )
        controls = something(
            controls,
            layout == :vertical ? vert_menu_controls : hor_menu_controls,
        )

        return new(
            WidgetInternals(
                Measure(length(titles), width),
                nothing,
                on_draw,
                on_activated,
                on_deactivated,
                false,
            ),
            controls,
            titles,
            length(titles),
            active_style,
            inactive_style,
            1,
            layout,
        )
    end
end

""" 
    active_title(mn::SimpleMenu, i::Int, width::Int)

Return the title of the i-th item of the menu with the active style.
"""
function active_title(mn::SimpleMenu, i::Int, width::Int)
    return RenderableText(mn.titles[i]; style = mn.active_style, width = width) |> string
end

""" 
    inactive_title(mn::SimpleMenu, i::Int, width::Int)

Return the title of the i-th item of the menu with the inactive style.
"""
function inactive_title(mn::SimpleMenu, i::Int, width::Int)
    return RenderableText(mn.titles[i]; style = mn.inactive_style, width = width) |> string
end

function frame(mn::SimpleMenu; kwargs...)
    active_symbol = "❯"
    titles = mn.titles

    # get size
    m = mn.internals.measure
    max_titles_width =
        mn.layout == :vertical ?
        min(m.w, maximum(get_width.(titles)) + textwidth(active_symbol) + 1) : m.w

    # make and stack title
    titles = map(
        i ->
            i == mn.active ? active_title(mn, i, max_titles_width) :
            inactive_title(mn, i, max_titles_width),
        1:length(titles),
    )
    return if mn.layout == :vertical
        vstack(titles...)
    else
        hstack(titles...)
    end
end

# ------------------------------- buttons menu ------------------------------- #
"""
Simple menu in which each option is a `Panel` object.
Styling reflects which option is currently selected
"""
@with_repr mutable struct ButtonsMenu <: AbstractMenu
    internals::WidgetInternals
    controls::AbstractDict
    titles::Vector{String}
    active_style::Vector
    inactive_style::Vector
    active_background::Vector
    inactive_background::Vector
    n_titles::Int
    active::Int
    layout::Symbol
    panel_kwargs

    function ButtonsMenu(
        titles::Vector;
        controls::Union{Nothing,AbstractDict} = nothing,
        width::Int = console_width(),
        active_color::Union{Vector,String} = "black",
        active_background::Union{Vector,String} = "white",
        inactive_color::Union{Vector,String} = "dim",
        inactive_background::Union{Vector,String} = "default",
        layout::Symbol = :vertical,
        height::Union{Nothing,Int} = length(titles),
        on_draw::Union{Nothing,Function} = nothing,
        on_activated::Function = on_activated,
        on_deactivated::Function = on_deactivated,
        panel_kwargs...,
    )
        controls = something(
            controls,
            layout == :vertical ? vert_menu_controls : hor_menu_controls,
        )

        # get parameters for each button
        n = length(titles)
        active_color = active_color isa String ? repeat([active_color], n) : active_color
        active_background =
            active_background isa String ? repeat([active_background], n) :
            active_background
        inactive_color =
            inactive_color isa String ? repeat([inactive_color], n) : inactive_color
        inactive_background =
            inactive_background isa String ? repeat([inactive_background], n) :
            inactive_background
        @assert length(active_color) == n "Incorrect number of values for `active_color`"
        @assert length(active_background) == n "Incorrect number of values for `active_background`"
        @assert length(inactive_color) == n "Incorrect number of values for `inactive_color`"
        @assert length(inactive_background) == n "Incorrect number of values for `inactive_background`"

        measure = if layout == :vertical
            Measure(something(height, length(titles)), width)
        else
            hmax = layout == :vertical ? fint(height / n) : height
            Measure(something(height, hmax), width)
        end

        return new(
            WidgetInternals(measure, nothing, on_draw, on_activated, on_deactivated, false),
            controls,
            titles,
            active_color,
            inactive_color,
            active_background,
            inactive_background,
            length(titles),
            1,
            layout,
            panel_kwargs,
        )
    end
end

"""
    active_title(mn::ButtonsMenu, i::Int, width::Int, height::Int; panel_kwargs...)

Return the title of the i-th item of the menu with the active style.
"""
function active_title(mn::ButtonsMenu, i::Int, width::Int, height::Int; panel_kwargs...)
    active_color, active_background = mn.active_style[i], mn.active_background[i]
    return Panel(
        "{$(active_color) on_$(active_background)}" *
        mn.titles[i] *
        "{/$(active_color) on_$(active_background)}";
        background = active_background,
        style = "$(active_color) on_$(active_background)",
        width = width,
        justify = get(panel_kwargs, :justify, :center),
        box = get(panel_kwargs, :box, :SQUARE),
        height = height,
        panel_kwargs...,
    )
end

"""
    inactive_title(mn::ButtonsMenu, i::Int, width::Int, height::Int; panel_kwargs...)

Return the title of the i-th item of the menu with the inactive style.  
"""
function inactive_title(mn::ButtonsMenu, i::Int, width::Int, height::Int; panel_kwargs...)
    inactive_color, inactive_background = mn.inactive_style[i], mn.inactive_background[i]
    return Panel(
        "{$(inactive_color) on_$(inactive_background)}" *
        mn.titles[i] *
        "{/$(inactive_color) on_$(inactive_background)}";
        background = inactive_background,
        style = inactive_color,
        width = width,
        justify = get(panel_kwargs, :justify, :center),
        box = get(panel_kwargs, :box, :SQUARE),
        height = height,
        panel_kwargs...,
    )
end

function frame(mn::ButtonsMenu; kwargs...)
    m, n = mn.internals.measure, mn.n_titles
    button_width = mn.layout == :vertical ? m.w : fint(m.w / n)
    button_height = mn.layout == :vertical ? fint(m.h / n) : m.h

    # make and stack title
    titles = map(
        i ->
            i == mn.active ?
            active_title(mn, i, button_width, button_height; mn.panel_kwargs...) :
            inactive_title(mn, i, button_width, button_height; mn.panel_kwargs...),
        1:(mn.n_titles),
    )
    return if mn.layout == :vertical
        vstack(titles...)
    else
        hstack(titles...)
    end
end

# ---------------------------------------------------------------------------- #
#                                 MULTI SELECT                                 #
# ---------------------------------------------------------------------------- #

"""
Menu variant for selecting multiple options. 
Color indicates current active option, ticks selected options
"""
@with_repr mutable struct MultiSelectMenu <: AbstractMenu
    internals::WidgetInternals
    controls::AbstractDict
    options::Vector
    active_style::String
    inactive_style::String
    options_width::Int
    selected::Vector{Int}
    active::Int
    n_titles::Int
    selected_sym::String
    notselected_sym::String
end

"""
quit and return selection.
"""
function menu_return_value(mn::MultiSelectMenu, ::Enter)
    quit(mn)
    return mn.selected
end

"""
Toggle selection status of current active option
"""
function multi_select_toggle(mn::MultiSelectMenu, ::SpaceBar)
    active = mn.active
    if active ∈ mn.selected
        deleteat!(mn.selected, mn.selected .== active)
    else
        push!(mn.selected, active)
    end
end

multi_select_controls = Dict(
    ArrowDown() => menu_activate_next,
    ArrowUp() => menu_activate_prev,
    SpaceBar() => multi_select_toggle,
    Enter() => menu_return_value,
    Esc() => quit,
    'q' => quit,
)

function MultiSelectMenu(
    options::Vector;
    controls::AbstractDict = multi_select_controls,
    active_style::String = "white bold",
    inactive_style::String = "dim",
    width::Int = console_width(),
    on_draw::Union{Nothing,Function} = nothing,
    on_activated::Function = on_activated,
    on_deactivated::Function = on_deactivated,
)
    selected_sym = apply_style("✔ ", active_style)
    notselected_sym = apply_style("□ ", inactive_style)

    max_titles_width = min(width, maximum(get_width.(options)) + 2)

    MultiSelectMenu(
        WidgetInternals(
            Measure(length(options), width),
            nothing,
            on_draw,
            on_activated,
            on_deactivated,
            false,
        ),
        controls,
        options,
        active_style,
        inactive_style,
        max_titles_width,
        Int[],
        1,
        length(options),
        selected_sym,
        notselected_sym,
    )
end

function make_option(mn::MultiSelectMenu, i::Int, isactive::Bool, isselected::Bool)
    sym = isselected ? mn.selected_sym : mn.notselected_sym
    style = isactive ? mn.active_style : mn.inactive_style

    return RenderableText(
        sym * "{$style}" * mn.options[i] * "{/$style}";
        width = mn.options_width,
    )
end

function frame(mn::MultiSelectMenu; kwargs...)
    isnothing(mn.internals.on_draw) || mn.internals.on_draw(mn)

    options = map(i -> make_option(mn, i, i == mn.active, i ∈ mn.selected), 1:(mn.n_titles))
    return vstack(options)
end

using Term
using Term.Layout

function make_logo()
    circle = """
        oooo    
     oooooooooo 
    oooooooooooo
    oooooooooooo
     oooooooooo 
        oooo    """

    # create circles
    green = Panel(
        RenderableText(circle; style = "#389826 bold");
        fit = true,
        style = "dim #389826",
        justify = :center,
        padding = (2, 2, 0, 0),
        title = "{italic default}Made",
        title_style = "bold red",
    )
    red = Panel(
        RenderableText(circle; style = "#CB3C33 bold");
        fit = true,
        style = "dim #CB3C33",
        justify = :center,
        padding = (2, 2, 0, 0),
        subtitle = "{italic default}with",
        subtitle_style = "bold #b656e3",
        subtitle_justify = :right,
    )
    purple = Panel(
        RenderableText(circle; style = "#9558B2 bold");
        fit = true,
        style = "dim #9558B2",
        justify = :center,
        padding = (2, 2, 0, 0),
        subtitle = "{italic default}Term",
        subtitle_style = "bold #389826",
    )

    indigo = "#42A5F5"

    as_code(x) = "{orange1 italic}`$x`{/orange1 italic}"

    # create "spacers" and stack renderables
    hspacer = Spacer(green.measure.h, green.measure.w / 2 + 1)
    line = Spacer(1, green.measure.w * 2 + 6)
    circles =
        line / (hspacer * green * hspacer) / (red * Spacer(purple.measure.h, 2) * purple)

    main = TextBox(
        """Term.jl is a {#9558B2}Julia{/#9558B2} package for creating styled terminal outputs.

        Term provides a simple {italic green4 bold}markup language{/italic green4 bold} to add {bold bright_blue}color{/bold bright_blue} and {bold underline}styles{/bold underline} to your text.
        More complicated text layout can be created using $(as_code("Renderable")) objects such 
        as $(as_code("Panel")) and $(as_code("TextBox")).
        These can also be nested and stacked to create {italic pink3}fancy{/italic pink3} and {underline}informative{/underline} terminal outputs for your Julia code""";
        width = 35,
        height = circles.measure.h,
        fit = false,
    )
    content = circles * vLine(main.measure.h; style = indigo * " dim") * main

    # add second message
    second_message = RenderableText(
        """
        Term.jl can also be used to create {underline}fancy{/underline} $(as_code("logging")) and $(as_code("error")) messages. 

        Check the examples and documentation for more information!
        Term.jl is under {bold}active{/bold} development, get in touch for questions or ideas on how to improve it!""";
        width = content.measure.w,
    )
    hline = hLine(content.measure.w; style = indigo * " dim")
    content = content / hline / second_message

    # add a final message
    msg = """{#75b6e0}Term.jl is based on the {underline}Python{/underline} library {orange1 italic}Rich{/orange1 italic} by {/#75b6e0}Will McGugan. 
                        {dim}https://github.com/Textualize/rich{/dim}"""

    logo =
        Panel(
            content;
            title = "Term.jl",
            title_style = "bold $indigo",
            style = "dim $indigo",
            subtitle = "https://github.com/FedeClaudi/Term.jl",
            subtitle_justify = :right,
            subtitle_style = "dim",
            fit = false,
        ) / "" / (Spacer(2, 12) * msg)

    return logo
end

print(make_logo())

import Term.Measures: default_size
import Term.Layout: PlaceHolder
import Term: Renderable, AbstractRenderable

@testset "Grid - simple" begin
    h, w = default_size()
    n = 3
    nm1 = n - 1
    lo = (n, n)

    @test size(grid(layout = lo).measure) == (h * n, w * n)
    @test size(grid(layout = lo, pad = 2).measure) == (h * n + 2nm1, w * n + 2nm1)
    @test size(grid(layout = lo, pad = (5, 1)).measure) == (h * n + 1nm1, w * n + 5nm1)
    @test size(grid(layout = lo, pad = (5, 3)).measure) == (h * n + 3nm1, w * n + 5nm1)
    @test size(grid(layout = lo, pad = (0, 0)).measure) == (h * n, w * n)

    # test passing renderables
    h, w = 5, 10
    rens = fill(PlaceHolder(h, w), 9)

    @test size(grid(rens).measure) == (3h, 3w)
    @test size(grid(rens; aspect = 1).measure) == (3h, 3w)

    @test size(grid(rens[1:8]; aspect = 0.5).measure) == (4h, 2w)
    @test size(grid(rens[1:8]; aspect = 2).measure) == (2h, 4w)

    @test size(grid(rens; pad = (2, 1)).measure) == (3h + 2 * 1, 3w + 2 * 2)
    @test size(grid(rens; pad = (2, 1), aspect = 0.5).measure) == (29, 22)
    @test size(grid(rens; pad = (2, 1), aspect = 1.5).measure) == (17, 46)

    g = grid(
        rens;
        pad = (2, 1),
        aspect = (12, 12),
        placeholder = PlaceHolder(5, 10; style = "red"),
    )
    @test size(g.measure) == (17, 34)

    @test grid(Any[Panel(width = 10 + i) for i in 1:4]) isa AbstractRenderable

    # matrix, fold singletons
    @test grid([Panel() Panel()]) isa AbstractRenderable
    @test grid(reshape([Panel()], 1, 1)) isa AbstractRenderable
end

@testset "Grid - placeholders" begin
    nr, nc = 3, 2
    h, w = 5, 15
    g = grid(nothing; layout = (nr, nc), placeholder_size = (h, w))
    @test size(g.measure) == (nr * h, nc * w)

    g = grid(; layout = (nr, nc), placeholder_size = (h, w))
    @test size(g.measure) == (nr * h, nc * w)
end

@testset "Grid - layout fit" begin
    h, w = 10, 20
    panels = collect(
        Panel("{on_$c} {/on_$c}", height = h, width = w) for c in (
            :bright_red,
            :bright_green,
            :bright_blue,
            :bright_yellow,
            :bright_magenta,
            :bright_cyan,
            :bright_black,
            :bright_white,
        )
    )

    # auto layout (default placeholder)
    for i in 2:length(panels)
        g = grid(panels[1:i])
        nc, nr = if i ≤ 3
            (i, 1)
        else
            (ceil(Int, i / 2), 2)
        end
        @test size(g.measure) == (h * nr, w * nc)
    end

    # matrix, explicit
    @test size(grid(reshape(panels[1:4], 2, 2)).measure) == (2h, 2w)

    # vector, half explicit
    @test size(grid(panels, layout = (nothing, 4)).measure) == (2h, 4w)
    @test size(grid(panels, layout = (2, nothing)).measure) == (2h, 4w)

    # vector, explicit
    @test size(grid(panels; layout = (2, 4)).measure) == (2h, 4w)
    @test size(grid(panels; layout = (2, 4), order = :row).measure) == (2h, 4w)

    # best fit
    panels = fill(Panel(height = h, width = w), 9)

    @test size(grid(panels[1:4]).measure) == (2h, 2w)  # 4 best fits onto a (2, 2) grid with unit ar
    @test size(grid(panels[1:6]).measure) == (2h, 3w)  # 6 best fits onto a (2, 3) grid with 4:3 ar
    @test size(grid(panels[1:9]).measure) == (3h, 3w)  # 9 best fits onto a (3, 3) grid with unit ar
end

@testset "Grid - types" begin
    @test grid((a = Panel(), b = Panel())) isa Renderable
    @test grid((Panel(), Panel())) isa Renderable
end

@testset "Grid - complex layout" begin
    rens = [
        Panel(height = 5, width = 10),
        Panel(height = 5, width = 15),
        Panel(height = 5, width = 20),
        Panel(height = 10, width = 20),
        Panel(height = 15, width = 20),
    ]
    g = grid(rens, layout = :((_ * a) / (b * _ * c) / (d * e)))
    @test size(g.measure) == (25, 45)

    # repeated in layout
    g = grid(rens, layout = :((_ * a) / (b * _ * c * c) / (d * e)))
    @test size(g.measure) == (25, 65)

    # named tuple
    g = grid((a = rens[1], b = rens[2]); layout = :((_ * a) / (b * _)))
    @test size(g.measure) == (10, 25)
end

module Panels

import Term:
    join_lines, ltrim_str, default_width, remove_ansi, get_bg_color, textlen, TERM_THEME

import ..Renderables: AbstractRenderable, RenderablesUnion, Renderable, RenderableText
import ..Layout: pad, vstack, Padding, lvstack
import ..Style: apply_style
import ..Segments: Segment
import ..Measures: Measure
import ..Measures: height as get_height
import ..Measures: width as get_width
import ..Consoles: console_width, console_height
using ..Boxes

export Panel, TextBox, @nested_panels

abstract type AbstractPanel <: AbstractRenderable end

# ---------------------------------------------------------------------------- #
#                                     PANEL                                    #
# ---------------------------------------------------------------------------- #
"""
    Panel

`Renderable` with a panel surrounding some content:

```
    ╭──────────╮
    │ my panel │
    ╰──────────╯
```

---

When constructing a Panel, several keyword arguments can be used to set
its appearance:
- box::Symbol sets the `Box` type for the Panel's border
- style::String  sets the box's style (e.g., color)
- title::Union{String,Nothing}  sets the Panel's title
- title_style::Union{Nothing,String} sets the title's style
- title_justify::Symbol     sets the location of the title
- subtitle::Union{String,Nothing}  sets the Panel's subtitle
- subtitle_style::Union{Nothing,String}  sets the subtitle's style
- subtitle_justify::Symbol  sets the location of the subtitle
- justify::Symbol sets text's alignment (:left, :rigth, :center, :justify)
"""
mutable struct Panel <: AbstractPanel
    segments::Vector
    measure::Measure

    """
        Panel(x1, x2; kwargs...)

    Catch construction with exactly two items passed
    """
    function Panel(x1, x2; kwargs...)
        # this is necessary to handle the special case in which 2 objs are passed
        # but they are not segments/measure
        return if x1 isa Vector && x2 isa Measure
            new(x1, x2)
        else
            Panel(vstack(x1, x2); kwargs...)
        end
    end
end

Base.size(p::Panel) = size(p.measure)

"""
    Panel(; 
        fit::Bool = false,
        height::Int = 2,
        width::Int = $(default_width()),
        padding::Union{Vector,Padding,NTuple} = Padding(0, 0, 0, 0),
        kwargs...,  
    )

Construct a `Panel` with no content.

### Examples
```
julia> Panel(height=5, width=10)
╭────────╮
│        │
│        │
│        │
╰────────╯

julia> Panel(height=3, width=5)
╭───╮
│   │
╰───╯
```
"""
function Panel(;
    fit::Bool = false,
    height::Int = 2,
    width::Int = default_width(),
    padding::Union{Vector,Padding,NTuple} = Padding(0, 0, 0, 0),
    kwargs...,
)
    # get panel measure
    panel_measure = if fit
        # hardcoded size of empty 'fitted' panel
        Measure(2, 3)
    else
        Measure(height - 1, width)
    end

    # get empty content measure
    content = ""
    content_measure = Measure(0, 0)

    # make panel
    return Panel(
        content;
        fit = fit,
        panel_measure = panel_measure,
        content_measure = content_measure,
        Δw = padding.left + padding.right + 2,
        Δh = padding.top + padding.bottom,
        height = height,
        width = width,
        padding = Padding(padding),
        kwargs...,
    )
end

"""
    Panel(
        content::Union{AbstractString,AbstractRenderable};
        fit::Bool = false,
        padding::Union{Nothing,Padding,NTuple} = nothing,
        kwargs...,
    )

Construct a `Panel` around an `AbstractRenderable` or `AbstractString`.

This is the main Panel-creating function, it dispatches to other methods based
on the value of `fit` to either fith the `Panel` to its content or vice versa.

`kwargs` can be used to set various aspects of the `Panel`'s appearance like
the presence and style of titles, box type etc... see [render](@ref) below.
"""
function Panel(
    content::Union{AbstractString,AbstractRenderable};
    fit::Bool = false,
    padding::Union{Nothing,Padding,NTuple} = nothing,
    width::Int = default_width(),
    kwargs...,
)
    padding = if isnothing(padding)
        if get(kwargs, :style, "default") == "hidden"
            Padding(0, 0, 0, 0)
        else
            Padding(2, 2, 0, 0)
        end
    else
        Padding(padding)
    end

    # estimate content and panel size 
    content_width = content isa AbstractString ? Measure(content).w : content.measure.w
    panel_width = if fit
        content_width + padding.left + padding.right + 2
    else
        width
    end

    # if too large, set fit=false
    fit = if fit
        (!isa(content, AbstractString) ? panel_width <= console_width() : true)
    else
        false
    end
    width = fit ? min(panel_width, console_width()) : width

    # @debug "Ready to make panel" content content_width panel_width width console_width() fit
    return Panel(content, Val(fit), padding; width = width, kwargs...)
end

"""
    content_as_renderable(content, width, Δw, justify)

Convert any input content to a renderable
"""
content_as_renderable(
    content,
    width::Int,
    Δw::Int,
    justify::Symbol,
    background::Union{String,Nothing},
)::RenderableText =
    RenderableText(content; width = width - Δw, background = background, justify = justify)

"""

    Panel(
        content::Union{AbstractString,AbstractRenderable},
        ::Val{true},
        padding::Padding;
        height::Union{Nothing,Int} = nothing,
        width::Union{Nothing,Int} = nothing,
        trim::Bool = true,
        kwargs...,
    )

Construct a `Panel` fitting the content's width.

!!! warning
    If the content is larger than the console terminal's width, it will get trimmed to avoid overflow, unless `trim=false` is given.
"""
function Panel(
    content::Union{AbstractString,AbstractRenderable},
    ::Val{true},
    padding::Padding;
    height::Union{Nothing,Int} = nothing,
    width::Int,
    background::Union{Nothing,String} = nothing,
    justify::Symbol = :left,
    kwargs...,
)
    Δw = padding.left + padding.right + 2
    Δh = padding.top + padding.bottom

    # create content
    # @info "panel fit" width height Δw Δh background
    content = content_as_renderable(content, width, Δw, justify, background)

    # estimate panel size
    panel_measure = Measure(
        max(something(height, 0), content.measure.h + padding.top + padding.bottom + 2),
        max(width, content.measure.w + padding.left + padding.right + 2),
    )

    # @debug "Creating fitted panel" content.measure panel_measure content
    return render(
        content;
        panel_measure = panel_measure,
        content_measure = content.measure,
        Δw = Δw,
        Δh = Δh,
        padding = padding,
        background = background,
        justify = justify,
        kwargs...,
    )
end

"""
    Panel(
        content::Union{AbstractString,AbstractRenderable},
        ::Val{false},
        padding::Padding;
        height::Union{Nothing,Int} = nothing,
        width::Int = $(default_width()),
        kwargs...,
    )

Construct a `Panel` fitting content to it.

!!! tip
    Content that is **too large** to fit in the given width will be trimmed. 
    To avoid trimming, set ```fit=true``` when calling panel. 

"""
function Panel(
    content::Union{AbstractString,AbstractRenderable},
    ::Val{false},
    padding::Padding;
    height::Union{Nothing,Int} = nothing,
    width::Int = default_width(),
    background::Union{Nothing,String} = nothing,
    justify::Symbol = :left,
    kwargs...,
)
    Δw = padding.left + padding.right + 2
    Δh = padding.top + padding.bottom

    # if the content is too large, resize it to fit the panel's width.
    content = content_as_renderable(content, width, Δw, justify, background)
    height = something(height, content.measure.h + Δh + 2)
    panel_measure = Measure(height, width)
    # @info "panel nofit" width  Δw Δh height panel_measure background content.measure

    # if the content is too tall, exclude some lines
    if content.measure.h > height - Δh - 2
        lines_to_drop = content.measure.h - height + Δh + 3
        omit_msg = RenderableText(
            "... content omitted ...",
            style = "dim",
            width = content.measure.w,
            justify = :center,
            background = background,
        )

        segments = if lines_to_drop < content.measure.h
            Segment[
                content.segments[1:(end - lines_to_drop)]...
                omit_msg.segments[1]
            ]
        else
            # [omit_msg.segments[1]]
            [content.segments[1]]
        end
        content = Renderable(segments, Measure(segments))
    end

    # @debug "creating not fitted panel" content.measure panel_measure width Δw 
    return render(
        content;
        panel_measure = panel_measure,
        content_measure = content.measure,
        Δw = Δw,
        Δh = Δh,
        padding = padding,
        background = background,
        justify = justify,
        kwargs...,
    )
end

"""
    Panel(renderables; kwargs...)

`Panel` constructor for creating a panel out of multiple renderables at once.
"""
Panel(renderables::Vector{RenderablesUnion}; kwargs...) =
    Panel(vstack(renderables...); kwargs...)

Panel(texts::Vector{AbstractString}; kwargs...) = Panel(join_lines(texts); kwargs...)
Panel(ren::Vector; kwargs...) = Panel(vstack(ren); kwargs...)
Panel(ren, renderables...; kwargs...) = Panel(vstack(ren, renderables...); kwargs...)

# ---------------------------------- render ---------------------------------- #

"""
    makecontent_line(cline, panel_measure, justify, background, padding, left, right)::Segment

Create a Panel's content line.
"""
function makecontent_line(
    cline::Segment,
    panel_measure::Measure,
    justify::Symbol,
    background::Union{Nothing,String},
    padding::Padding,
    left::String,
    right::String,
    Δw::Int,
)::Segment
    line = pad(cline, panel_measure.w - Δw, justify, ; bg = background).text
    line = pad(line, padding.left, padding.right; bg = background)
    return Segment(typeof(cline.text)(left * line * right))
end

"""
    render(
        content;
        box::Symbol = :ROUNDED,
        style::String = "default",
        title::Union{String,Nothing} = nothing,
        title_style::Union{Nothing,String} = nothing,
        title_justify::Symbol = :left,
        subtitle::Union{String,Nothing} = nothing,
        subtitle_style::Union{Nothing,String} = nothing,
        subtitle_justify::Symbol = :left,
        justify::Symbol = :left,
        text_justify::Bool=false,
        panel_measure::Measure,
        content_measure::Measure,
        Δw::Int,
        Δh::Int,
        padding::Padding,
    )::Panel

Construct a `Panel`'s content.
"""
function render(
    content::Union{Renderable,RenderableText};
    box::Symbol = TERM_THEME[].box,
    style::String = TERM_THEME[].line,
    title::Union{String,Nothing} = nothing,
    title_style::Union{Nothing,String} = nothing,
    title_justify::Symbol = :left,
    subtitle::Union{String,Nothing} = nothing,
    subtitle_style::Union{Nothing,String} = nothing,
    subtitle_justify::Symbol = :left,
    justify::Symbol = :left,
    panel_measure::Measure,
    content_measure::Measure,
    Δw::Int,
    Δh::Int,
    padding::Padding,
    background::Union{Nothing,String} = nothing,
    kwargs...,
)::Panel
    background = get_bg_color(background)
    # @info "calling render" content content_measure background

    # create top/bottom rows with titles
    box = BOXES[box]  # get box object from symbol
    top = get_title_row(
        :top,
        box,
        title;
        width = panel_measure.w,
        style = style,
        title_style = title_style,
        justify = title_justify,
    )

    bottom = get_title_row(
        :bottom,
        box,
        subtitle;
        width = panel_measure.w,
        style = style,
        title_style = subtitle_style,
        justify = subtitle_justify,
    )

    # get left/right vertical lines
    σ(s) = apply_style("{" * style * "}" * s * "{/" * style * "}")
    left, right = σ(box.mid.left), σ(box.mid.right)

    # get an empty padding line
    empty = if isnothing(background)
        [Segment(left * " "^(panel_measure.w - 2) * right)]
    else
        [Segment(left * "{$background}" * " "^(panel_measure.w - 2) * "{/$background}" * right)]
    end
    # @debug "rendering" panel_measure Δw

    # check if we need extra lines at the bottom to reach target height
    n_extra = if content_measure.h < panel_measure.h - Δh - 2
        panel_measure.h - content_measure.h - Δh - 2
    else
        0
    end
    # create segments
    initial_segments = Segment[
        top,                                        # top border
        repeat(empty, padding.top)...,              # top padding
    ]

    # content
    content_sgs::Vector{Segment} = if content.measure.w > 0
        map(
            s -> makecontent_line(
                s,
                panel_measure,
                justify,
                background,
                padding,
                left,
                right,
                Δw,
            ),
            content.segments,
        )
    else
        []
    end

    final_segments = Segment[
        repeat(empty, n_extra)...,                  # lines to reach target height
        repeat(empty, padding.bottom)...,           # bottom padding
        bottom * "\e[0m",                           # bottom border
    ]

    segments = vcat(initial_segments, content_sgs, final_segments)
    return Panel(segments, Measure(segments))
end

# ---------------------------------------------------------------------------- #
#                              PANEL LAYOUT MACRO                              #
# ---------------------------------------------------------------------------- #

"""
    function parse_layout_args end

Parse the arguments of a `Expr(:call, :Panel, ...)` to 
add a keyword argument to fix the panel's width. 
A few diferent menthods are defined to handle different combinations
of args/kwargs for the Panel call.
"""
function parse_layout_args end

""" `Panel` had no args/kwargs """
function parse_layout_args(depth)
    w = console_width()
    Δw = 6
    kwargs_arg = Expr(:parameters, Expr(:kw, :width, w - Δw * depth))
    content_args = []
    return kwargs_arg, content_args
end

""" `Panel`'s args did not start with an `Expr` (e.g. a string) """
function parse_layout_args(depth, firstarg, args...)
    w = console_width()
    Δw = 6
    kwargs_arg = Expr(:parameters, Expr(:kw, :width, w - Δw * depth))
    return kwargs_arg, [firstarg, args...]
end

""" `Panels`'s first argument was an `Expr`, nested content! """
function parse_layout_args(depth, firstarg::Expr, args...)
    w = console_width()
    Δw = 6

    if firstarg.head == :parameters
        kwargs_arg = Expr(:parameters, Expr(:kw, :width, w - Δw * depth), firstarg.args...)
        content_args = collect(args)
    else
        kwargs_arg = Expr(:parameters, Expr(:kw, :width, w - Δw * depth))
        # content_args = length(args) > 1 ? collect(args[2:end]) : []
        content_args = [firstarg, args...]
    end

    # @debug "in here" firstarg args kwargs_arg content_args

    return kwargs_arg, content_args
end

"""
    fix_layout_width(panel_call::Expr, depth::Int)::Expr

Go through an `Expr` with a `:call` to a `Panel` and add a keyword
argument expression with the correct `width` (using `parse_layout_args`).
Also go through any other argument to the call to fix inner panels' width.
"""
function fix_layout_width(panel_call::Expr, depth::Int)::Expr
    # @debug "Starting" panel_call.args
    kwargs_arg, content_args = parse_layout_args(depth, panel_call.args[2:end]...)

    # @debug "got ready" content_args kwargs_arg
    for (i, arg) in enumerate(content_args)
        !isa(arg, Expr) && continue

        if arg.head == :call && arg.args[1] == :Panel
            content_args[i] = fix_layout_width(arg, depth + 1)
        end
    end
    return Expr(:call, :Panel, kwargs_arg, content_args...)
end

"""
    macro nested_panels(layout_call)

Macro to automate layout of multiple nested `Panel`. The width of the
panels is automatically adjusted based on the depth of eeach nested level.

Uses `fix_layout_width` recursively to add a keyword argument `width` to each
`Panel`.
"""
macro nested_panels(layout_call)
    if layout_call.head != :call || layout_call.args[1] != :Panel
        error("Layout only works for nested `Panel`")
    end

    layout_call = fix_layout_width(layout_call, 0)
    quote
        $layout_call
    end |> esc
end

# ---------------------------------------------------------------------------- #
#                                    TextBox                                   #
# ---------------------------------------------------------------------------- #

TextBox(args...; kwargs...) = Panel(args...; box = get(kwargs, :box, :NONE), kwargs...)

end

import OrderedCollections: OrderedDict
import Highlights: Lexers

using Highlights: Highlights
using Highlights.Format

# ------------------------------- highlighting ------------------------------- #
highlight_regexes = OrderedDict(
    :number => (r"(?<group>(?<![a-zA-Z0-9_#])\d+(\.\d*)?+([eE][+-]?\d*)?)",),
    :operator => (
        r"(?<group>(?<!\{)\/)",
        r"(?<group>(?![\:\<])[\+\-\*\%\^\&\|\!\=\>\<\~\[\]×])",
    ),
    :string => (r"(?<group>[\'\"][\w\n]*[\'\"])",),
    :code => (r"(?<group>([\`]{3}|[\`]{1})(\n|.)*?([\`]{3}|[\`]{1}))",),
    :expression => (r"(?<group>\:\(+.+[\)])",),
    :symbol => (r"(?<group>(?<!\:)(?<!\:)\:\w+)",),
    # :emphasis_light => (r"(?<group>[\[\]\(\)])", r"(?<group>@\w+)"),
    :type => (r"(?<group>\:\:[\w\.]*)", r"(?<group>\<\:\w+)"),
)

"""
    highlight(text::AbstractString, theme::Theme)

Highlighs a text introducing markup to style semantically
relevant segments, colors specified by a theme object.
"""
function highlight(
    text::AbstractString;
    theme::Theme = TERM_THEME[],
    ignore_ansi::Bool = false,
)
    (has_ansi(text) && !ignore_ansi) && return text

    # highlight with regexes 
    for (symb, rxs) in pairs(highlight_regexes)
        markup = getfield(theme, symb)
        open, close = "{$markup}", "{/$markup}"
        for rx in rxs
            text = replace(text, rx => SubstitutionString(open * s"\g<0>" * close))
        end
    end

    return text
end

"""
    highlight(text::AbstractString, theme::Theme, like::Symbol)

Hilights an entire text as if it was a type of semantically
relevant text of type :like.
"""
highlight(text::AbstractString, like::Symbol; theme::Theme = TERM_THEME[]) =
    apply_style(text, getfield(theme, like))

# shorthand to highlight objects based on type
highlight(x; theme = TERM_THEME[]) = apply_style(string(x), theme(x)) # capture all other cases

# ------------------------------ Highlighters.jl ----------------------------- #

"""
    Format.render(io::IO, ::MIME"text/ansi", tokens::Format.TokenIterator)

custom ANSI lexer for Highlighters.jl
"""
function Format.render(io::IO, ::MIME"text/ansi", tokens::Format.TokenIterator)
    for (str, id, style) in tokens
        fg = style.fg.active ? map(Int, (style.fg.r, style.fg.g, style.fg.b)) : ""
        bg = style.bg.active ? map(Int, (style.bg.r, style.bg.g, style.bg.b)) : nothing

        bold = style.bold ? "bold" : ""
        italic = style.italic ? "italic" : ""
        underline = style.underline ? "underline" : ""
        bg = isnothing(bg) ? "" : "on_$(bg)"
        markup = "$fg $(bg) $(bold) $(italic) $(underline)"
        if length(strip(markup)) > 0
            print(io, "{$markup}$str{/$markup}")
        else
            print(io, str)
        end
    end
end

"""
    highlight_syntax(code::AbstractString; style::Bool=true) 

Highlight Julia code syntax in a string.
"""
function highlight_syntax(code::AbstractString; style::Bool = true)
    txt = sprint(
        Highlights.highlight,
        MIME("text/ansi"),
        escape_brackets(code),
        Lexers.JuliaLexer,
        CodeTheme;
        context = stdout,
    )
    style && (txt = apply_style(txt))
    return remove_markup(txt)
end

"""
    load_code_and_highlight(path::AbstractString, lineno::Int; δ::Int=3, width::INt=120)

Load a file, get the code and format it. Return styled text
"""
function load_code_and_highlight(path::AbstractString, lineno::Int; δ::Int = 3)::String
    η = countlines(path)
    @assert lineno > 0 "lineno must be ≥1"
    @assert lineno ≤ η "lineno $lineno too high for file with $(η) lines"

    lines = read_file_lines(path, lineno - δ, lineno + δ)
    linenos = first.(lines)
    code =
        [highlight_syntax((δ == 0 ? lstrip(ln[2]) : ln[2]); style = true) for ln in lines]
    code = split(join(code), "\n")

    # clean
    clean(line) = replace(replace(line, "    {/    }" => ""), '\r' => "")  # NOTE: julia `1.6` compat
    codelines = clean.(code)  # [10-δ:10+δ]
    linenos = linenos  # [10-δ:10+δ]

    # format
    _len = textlen ∘ lstrip
    dedent = 100
    for ln in codelines
        if _len(ln) > 1
            dedent = min(dedent, textlen(ln) - _len(ln))
        end
    end
    dedent = dedent < 1 ? 1 : dedent

    cleaned_lines = []
    for (n, line) in zip(linenos, codelines)
        # style
        symb, color = if n == lineno
            "{red bold}❯{/red bold}", "white"
        else
            " ", "grey39"
        end

        line = textlen(line) > 1 ? lpad(line[dedent:end], 8) : line
        push!(cleaned_lines, symb * " {$color}$n{/$color} " * line)
    end

    return join(cleaned_lines, "\n")
end

"""
    load_code_and_highlight(path::AbstractString)::String

Load and highlight the syntax of an entire file
"""
function load_code_and_highlight(path::AbstractString)::String
    lines = readlines(path)
    code = [highlight_syntax(ln; style = true) for ln in lines]

    # clean
    clean(line) = replace(line, "    {/    }" => "")
    codelines = clean.(code)
    return join(codelines, "\n")
end

import Term: inspect, expressiontree, typestree, Dendogram, Tree
import Term.Consoles: console_width
import Term: remove_ansi

# define expressions
e1 = :(2x + 3y + 2)
e2 = :(2x + 3 + 2 + 2y)
e3 = :(2x^(3 + y))
e4 = :(1 + 1 - 2x^2)
e5 = :(mod(22, 6))
e6 = :(2x^(3 + y) + 2z)
e7 = :(2x + 3 * √(3x^2))
e8 = :(print(lstrip("test")))
expressions = (e1, e2, e3, e4, e5, e6, e7, e8)

bool_env(key, default = "false") = tryparse(Bool, get(ENV, key, default))

# save expressions to file (for later comparisons)
if !(bool_env("CI") || bool_env("PKGEVAL") || bool_env("JULIA_PKGEVAL"))
    for (i, e) in enumerate(expressions)
        tofile(string(Dendogram(e)), "./txtfiles/dendo_expr_$i.txt")
        tofile(string(Tree(e)), "./txtfiles/tree_expr_$i.txt")
        tofile(sprint(expressiontree, e), "./txtfiles/exptree_expr_$i.txt")
    end
end

@testset "Inspect: expressions" begin
    if !Sys.iswindows()
        # dendogram
        for (i, e) in enumerate(expressions)
            dendo = Dendogram(e)
            tree = Tree(e)

            @test dendo isa Dendogram
            @test fromfile("./txtfiles/dendo_expr_$i.txt") == cleanstring(dendo)

            @test tree isa Tree
            @test fromfile("./txtfiles/tree_expr_$i.txt") == cleanstring(tree)

            @test fromfile("./txtfiles/exptree_expr_$i.txt") ==
                  cleansprint(expressiontree, e)

            inspect(devnull, e)
        end
        typestree(devnull, Float64)
        redirect_stdout(devnull) do
            typestree(Float64)
            expressiontree(:(1 + 2.0))
        end
    end
end

@testset "Introspect types and funcs" begin
    abstract type Structy end

    struct MyStr <: Structy
        x::Int
        y::Vector
    end
    MyStr(x) = MyStr(x, x)

    dosmth(m::MyStr) = print(m.x)

    # intro = @capture_out begin
    #     inspect(MyStr; methods = true, supertypes = true)
    # end
    # intro = remove_ansi(intro)
    # @test intro isa String

    # intro = @capture_out begin
    #     inspect(Panel; methods = true, supertypes = true,)
    # end
    # @compare_to_string(intro, "introspection_panel")
    # @test_nothrow inspect(Panel; methods = true, supertypes = true)

    intro = @capture_out begin
        inspect(print)
    end
    intro = remove_ansi(intro)
    # @compare_to_string(intro, "introspection_print")
    @test intro isa String
end

"""
Reshaping strings with Julia code requires particular care
"""
function reshape_code_string(code, width::Int)
    # highlight syntax
    code = apply_style(highlight(code; ignore_ansi = false); leave_orphan_tags = true)

    # reshape
    code = reshape_text(code, width; ignore_markup = true)
    return code
end

module Layout

import Parameters: @with_kw

import Term:
    rint,
    get_lr_widths,
    textlen,
    cint,
    fint,
    rtrim_str,
    ltrim_str,
    do_by_line,
    get_bg_color,
    TERM_THEME,
    string_type

import Term: justify as justify_text
import ..Renderables: RenderablesUnion, Renderable, AbstractRenderable, RenderableText
import ..Consoles: console_width, console_height
import ..Measures: Measure, height, width
import ..Boxes: get_lrow, get_rrow
import ..Style: apply_style
import ..Segments: Segment, get_string_types
using ..Boxes

export Padding, vstack, hstack, pad, pad!, vertical_pad, vertical_pad!
export Spacer, vLine, hLine, PlaceHolder
export leftalign!, center!, rightalign!
export leftalign, center, rightalign
export lvstack, cvstack, rvstack
export Placeholder

# ---------------------------------------------------------------------------- #
#                                    PADDING                                   #
# ---------------------------------------------------------------------------- #
"""
    Padding

Stores information about ammount of padding.
"""
@with_kw struct Padding
    left::Int
    right::Int
    top::Int
    bottom::Int
end

Padding(padding::Tuple) = Padding(padding...)

"""
    pad(text::AbstractString, target_width::Int, method::Symbol)::String

Pad a string to width: `target_width` by adding empty spaces strings " ".
Where the spaces are added depends on the justification `method` ∈ (`:left`, `:center`, `:right`, `:justify`).

#### Examples

``` julia
julia> pad("ciao", 10, :left)
"ciao      "

julia> pad("ciao", 10, :center)
"   ciao   "

julia> pad("ciao", 10, :right)
"      ciao"
```
"""
function pad(text::AbstractString, target_width::Int, method::Symbol; bg = nothing)
    bg = get_bg_color(bg)
    occursin('\n', text) &&
        return do_by_line(ln -> pad(ln, target_width, method; bg = bg), text)

    # get total padding size
    lw = width(text)
    lw ≥ target_width && return text
    return pad(text, target_width, method, lw; bg = bg)
end

"""
    function pad(text::AbstractString, target_width::Int, method::Symbol, lw::Int; bg = nothing)::String

complete string padding but knowing line width of the string.
Useful in cases the line width needs to be enforced instead of obtained through `width(text)`, e.g.
when paddnig a `Link`'s text.
"""
function pad(text::AbstractString, target_width::Int, method::Symbol, lw::Int; bg = nothing)
    stype = string_type(text)
    npads = target_width - lw
    # println("TEXT ", text, " NPADS ", npads, " METHOD ", method, " lw ", lw)
    if method ≡ :left
        p = isnothing(bg) ? ' '^npads : "{$bg}" * ' '^npads * "{/$bg}"
        return text * p |> stype
    elseif method ≡ :right
        p = isnothing(bg) ? ' '^npads : "{$bg}" * ' '^npads * "{/$bg}"
        return p * text |> stype
    else
        nl, nr = get_lr_widths(npads)
        l = isnothing(bg) ? ' '^nl : "{$bg}" * ' '^nl * "{/$bg}"
        r = isnothing(bg) ? ' '^nr : "{$bg}" * ' '^nr * "{/$bg}"
        t = l * text * r
        return t |> stype
    end
end

"""
---
    pad(text::AbstractString, left::Int = 0, right::Int = 0)

Pad a string by a fixed ammount to the left and to the right.
"""
function pad(text::AbstractString, left::Int = 0, right::Int = 0; bg = nothing)
    stype = string_type(text)
    if isnothing(bg)
        (' '^max(0, left) * text * ' '^max(0, right)) |> stype
    else
        l = "{$bg}" * ' '^max(0, left) * "{/$bg}"
        r = "{$bg}" * ' '^max(0, right) * "{/$bg}"
        (l * text * r) |> stype
    end
end

"""
    pad(s::Segment, left::Int = 0, right::Int = 0; kwargs...)

Pad a segment.
"""
pad(s::Segment, left::Int = 0, right::Int = 0; kwargs...) = Segment(
    pad(s.text, left, right; kwargs...),
    Measure(s.measure.h, s.measure.w + left + right),
)

function pad(s::Segment, width::Int, method::Symbol; kwargs...)
    return if width <= s.measure.w
        s
    else
        Segment(
            pad(s.text, width, method, s.measure.w; kwargs...),
            Measure(s.measure.h, width),
        )
    end
end

"""
---
    pad(segments::AbstractVector{Segment}, left::Int = 0, right::Int = 0)

Pad a renderable's segments to the left and the right.
"""
pad(segments::AbstractVector{Segment}, left::Int = 0, right::Int = 0; kwargs...) =
    map((s) -> pad(s, left, right; kwargs...), segments)

"""
---
    pad(ren::AbstractRenderable, left::Int, right::Int)

Pad an `AbstractRenderable` by padding each of its segments.
"""
function pad(ren::AbstractRenderable, left::Int, right::Int; kwargs...)
    segments = pad(ren.segments, left, right; kwargs...)
    return Renderable(segments, Measure(segments))
end

"""
---
    pad(ren::AbstractRenderable; width::Int)


Pad a renderable to achieve a target width.

!!! note
    The padding is added to the left and to the right as needed to achieve the target width.
    The resulting renderable object will be **center** in the target space.

#### Example
```
julia> pad(RenderableText("ciao"); width=10)
    ciao   
```
"""
function pad(ren::AbstractRenderable; width::Int, method = :center)
    ren.measure.w >= width && return ren

    if method == :center
        nl, nr = get_lr_widths(width - ren.measure.w)
    elseif method == :right
        nl, nr = 0, width - ren.measure.w
    else
        nl, nr = width - ren.measure.w, 0
    end
    return pad(ren, nl, nr)
end

"""
    pad!(ren::AbstractRenderable, left::Int, right::Int)

In place version for padding a renderable.
"""
function pad!(ren::AbstractRenderable, left::Int, right::Int)
    ren.segments = pad(ren.segments, left, right)
    ren.measure = Measure(ren.segments)
    nothing
end

"""
    pad!(ren::AbstractRenderable; width::Int)

In place version for padding a renderable to achieve a given width.
"""
function pad!(ren::AbstractRenderable; width::Int)
    ren.measure.w >= width && return ren
    nl, nr = get_lr_widths(width - ren.measure.w)
    return pad!(ren, nl, nr)
end

# ------------------------------- vertical pad ------------------------------- #

"""
vertical_pad(text, target_height::Int, method::Symbol)::String

Vertically pad a string to height: `target_height` by adding empty strings above/below " ".
Where the spaces are added depends on the justification `method` ∈ (:top, :center, :bottom).
"""
function vertical_pad(text::AbstractString, target_height::Int, method::Symbol)
    # get total padding size
    h = height(text)
    h ≥ target_height && return text

    npads = target_height - h
    return if method ≡ :bottom
        vertical_pad(text, npads, 0)
    elseif method ≡ :top
        vertical_pad(text, 0, npads)
    else
        above, below = get_lr_widths(npads)
        vertical_pad(text, above, below)
    end
end

# vertical_pad(text::AbstractString; height::Int, method::Symbol=:center) = vertical_pad(text, height, method)

"""
    vertical_pad(text::AbstractString, above::Int = 0, below::Int = 0)

Vertical pad a string by a fixed ammount to above and below.
"""
function vertical_pad(text::AbstractString, above::Int = 0, below::Int = 0)
    stype = string_type(text)
    space = ' '^(width(text))
    return stype(vstack(fill(space, above)..., text, fill(space, below)...))
end

"""
    vertical_pad(segments::AbstractVector{Segment}, above::Int = 0, below::Int = 0)

Pad a renderable's segments to the above and the below.
"""
function vertical_pad(segments::AbstractVector{Segment}, above::Int = 0, below::Int = 0)
    space = ' '^(segments[1].measure.w)
    above::Vector{Segment} = fill(Segment(space), above)
    below::Vector{Segment} = fill(Segment(space), below)
    return [above..., segments..., below...]
end

"""
    vertical_pad(ren::AbstractRenderable, above::Int, below::Int)

Pad a renderable, vertically.
"""
function vertical_pad(ren::AbstractRenderable, above::Int, below::Int)
    segments = vertical_pad(ren.segments, above, below)
    return Renderable(segments, Measure(segments))
end

"""
vertical_pad(ren::AbstractRenderable; height::Int)

Vertical pad a renderable to achieve a target height.
"""
function vertical_pad(ren::AbstractRenderable; height::Int, method = :center)
    ren.measure.h >= height && return ren
    if method == :center
        n_above, n_below = get_lr_widths(height - ren.measure.h)
    elseif method == :bottom
        n_above, n_below = height - ren.measure.h, 0
    elseif method == :top
        n_above, n_below = 0, height - ren.measure.h
    end
    return vertical_pad(ren, n_above, n_below)
end

"""
    verti0cal_pad!(ren::AbstractRenderable, above::Int, below::Int)

In place version for vertically padding a renderable.
"""
function vertical_pad!(ren::AbstractRenderable, above::Int, below::Int)
    ren.segments = vertical_pad(ren.segments, above, below)
    return ren.measure = Measure(ren.segments)
end

"""
    pad!(ren::AbstractRenderable; width::Int)

In place version for padding a renderable to achieve a given width.
"""
function vertical_pad!(ren::AbstractRenderable; height::Int)
    nl, nr = get_lr_widths(height - ren.measure.h)
    return vertical_pad!(ren, nl, nr)
end

# ---------------------------------------------------------------------------- #
#                                    JUSTIFY                                   #
# ---------------------------------------------------------------------------- #
"""
    leftalign(renderables::RenderablesUnion...)

Pad two (or more) renderables so that they have the same width and they
are left-aligned.

NOTE: the renderables returned  have different type and potentially different size
    from the inputs

# Examples
```julia
p1 = Panel(; width=25)
p2 = Panel(; width=50)
p1, p2 = leftalign(p1, p2)
print(p1/p2)


╭───────────────────────╮                         
╰───────────────────────╯                         
╭────────────────────────────────────────────────╮
╰────────────────────────────────────────────────╯
```
"""
function leftalign(renderables::RenderablesUnion...)
    length(renderables) < 2 && return renderables
    renderables = Renderable.(renderables)
    width = maximum(map(r -> r.measure.w, renderables))
    return map(r -> pad(r, 0, width - r.measure.w), renderables)
end

"""
    leftalign!(renderables::RenderablesUnion...)

In place version of leftalign. 

# Examples
```julia
p1 = Panel(; width=25)
p2 = Panel(; width=50)
leftalign!(p1, p2)
print(p1/p2)


╭───────────────────────╮                         
╰───────────────────────╯                         
╭────────────────────────────────────────────────╮
╰────────────────────────────────────────────────╯
"""
function leftalign!(renderables::RenderablesUnion...)
    length(renderables) < 2 && return renderables
    renderables = Renderable.(renderables)
    width = maximum(map(r -> r.measure.w, renderables))
    for ren in renderables
        pad!(ren, 0, width - ren.measure.w)
    end
end

"""
    center(renderables::RenderablesUnion... )

Pad two (or more) renderables so that they have the same width and they
are centered.

NOTE: the renderables returned  have different type and potentially different size
    from the inputs

# Examples
```julia
p1 = Panel(; width=25)
p2 = Panel(; width=50)
p1, p2 = center(p1, p2)
print(p1/p2)

             ╭───────────────────────╮             
             ╰───────────────────────╯             
╭────────────────────────────────────────────────╮
╰────────────────────────────────────────────────╯
```
"""
function center(renderables::RenderablesUnion...)
    length(renderables) < 2 && return renderables
    renderables = Renderable.(renderables)
    width = maximum(map(r -> r.measure.w, renderables))
    renderables = map(r -> pad(r; width = width), renderables)
    return renderables
end

"""
    center!(renderables::RenderablesUnion... )

In place version of `center`.


# Examples
```julia
p1 = Panel(; width=25)
p2 = Panel(; width=50)
center!(p1, p2)
print(p1/p2)

             ╭───────────────────────╮             
             ╰───────────────────────╯             
╭────────────────────────────────────────────────╮
╰────────────────────────────────────────────────╯
```
"""
function center!(renderables::RenderablesUnion...)
    length(renderables) < 2 && return renderables
    renderables = Renderable.(renderables)
    width = maximum(map(r -> r.measure.w, renderables))
    for ren in renderables
        pad!(ren; width = width)
    end
end

"""
    rightalign(renderables::RenderablesUnion... )

Pad two (or more) renderables so that they have the same width and they
are right aligned.

NOTE: the renderables returned  have different type and potentially different size
    from the inputs

# Examples
```julia
p1 = Panel(; width=25)
p2 = Panel(; width=50)
p1, p2 = rightalign(p1, p2)
print(p1/p2)

                         ╭───────────────────────╮
                         ╰───────────────────────╯
╭────────────────────────────────────────────────╮
╰────────────────────────────────────────────────╯
```
"""
function rightalign(renderables::RenderablesUnion...)
    length(renderables) < 2 && return renderables
    renderables = Renderable.(renderables)
    width = maximum(map(r -> r.measure.w, renderables))
    renderables = map(r -> pad(r, width - r.measure.w, 0), renderables)
    return renderables
end

"""
    rightalign!(renderables::RenderablesUnion... )

In place version of `rightalign`.
# Examples
```julia
p1 = Panel(; width=25)
p2 = Panel(; width=50)
rightalign!(p1, p2)
print(p1/p2)

                         ╭───────────────────────╮
                         ╰───────────────────────╯
╭────────────────────────────────────────────────╮
╰────────────────────────────────────────────────╯
```
"""
function rightalign!(renderables::RenderablesUnion...)
    length(renderables) < 2 && return renderables
    renderables = Renderable.(renderables)
    width = maximum(map(r -> r.measure.w, renderables))

    for ren in renderables
        pad!(ren, width - ren.measure.w, 0)
    end
end

# ---------------------------------------------------------------------------- #
#                                   STACKING                                   #
# ---------------------------------------------------------------------------- #

vstack(s1::String, s2::String; pad::Int = 0) = s1 * '\n'^(pad + 1) * s2

""" 
    vstack(renderables...)

Vertically stack a variable number of renderables to give a new renderable
"""
function vstack(renderables::RenderablesUnion...; pad::Int = 0)
    renderables = leftalign(renderables...)
    segments = if pad > 0
        foldl((a, b) -> a / ('\n'^pad) / b, renderables).segments
    else
        vcat(
            map(
                r -> r isa AbstractRenderable ? getfield(r, :segments) : Segment(r),
                renderables,
            )...,
        )
    end
    return Renderable(segments, Measure(segments))
end

vstack(renderables::Union{AbstractVector,Tuple}; kwargs...) =
    vstack(renderables...; kwargs...)

"""
    hstack(r1::RenderablesUnion, r2::RenderablesUnion   )

Horizontally stack two renderables to give a new renderable.
"""
function hstack(r1::RenderablesUnion, r2::RenderablesUnion; pad::Int = 0)
    r1 = r1 isa AbstractRenderable ? r1 : Renderable(r1)
    r2 = r2 isa AbstractRenderable ? r2 : Renderable(r2)

    # get dimensions of final renderable
    h1 = r1.measure.h
    h2 = r2.measure.h
    Δh = abs(h2 - h1)

    # make sure both renderables have the same number of segments
    if h1 > h2
        s1 = r1.segments
        s2 = vcat(r2.segments, fill(Segment(' '^(r2.measure.w)), Δh))
    elseif h1 < h2
        s1 = vcat(r1.segments, fill(Segment(' '^(r1.measure.w)), Δh))
        s2 = r2.segments
    else
        s1, s2, = r1.segments, r2.segments
    end

    # combine segments
    stype = get_string_types(s1, s2)
    segments = [
        Segment(
            stype(ss1.text * ' '^pad * ss2.text),
            Measure(1, ss1.measure.w + pad + ss2.measure.w),
        ) for (ss1, ss2) in zip(s1, s2)
    ]
    return Renderable(segments, Measure(segments))
end

""" 
    hstack(renderables...)

Horizonatlly stack a variable number of renderables.
"""
function hstack(renderables...; pad::Int = 0)
    renderable = Renderable()
    for (i, ren) in enumerate(renderables)
        renderable = hstack(renderable, ren; pad = i == 1 ? 0 : pad)
    end
    return renderable
end

# --------------------------------- operators -------------------------------- #

"""
    Operators for more coincise layout of renderables
"""

Base.:/(r1::RenderablesUnion, r2::RenderablesUnion) = vstack(r1, r2)

Base.:*(r1::AbstractRenderable, r2::AbstractRenderable) = hstack(r1, r2)
Base.:*(r1::AbstractString, r2::AbstractRenderable) = hstack(r1, r2)
Base.:*(r1::AbstractRenderable, r2::AbstractString) = hstack(r1, r2)

# --------------------------- convenience functions -------------------------- #

"""
    lvstack(renderables::RenderablesUnion...)

Left align renderables and then vertically stack.
"""
lvstack(renderables::RenderablesUnion...; kwargs...)::Renderable =
    vstack(leftalign(renderables...)...; kwargs...)

"""
    lvstack(renderables::RenderablesUnion...)

Center align renderables and then vertically stack.
"""
cvstack(renderables::RenderablesUnion...; kwargs...)::Renderable =
    vstack(center(renderables...)...; kwargs...)

"""
    lvstack(renderables::RenderablesUnion...)

Right align renderables and then vertically stack.
"""
rvstack(renderables::RenderablesUnion...; kwargs...)::Renderable =
    vstack(rightalign(renderables...)...; kwargs...)

rvstack(renderables::Union{Tuple,AbstractVector}; kwargs...) =
    rvstack(renderables...; kwargs...)
cvstack(renderables::Union{Tuple,AbstractVector}; kwargs...) =
    cvstack(renderables...; kwargs...)
lvstack(renderables::Union{Tuple,AbstractVector}; kwargs...) =
    lvstack(renderables...; kwargs...)

# ---------------------------------------------------------------------------- #
#                                LINES & SPACER                                #
# ---------------------------------------------------------------------------- #
abstract type AbstractLayoutElement <: AbstractRenderable end

# ---------------------------------- spacer ---------------------------------- #
"""
        Spacer

A box of empty text with given width and height.
"""
mutable struct Spacer <: AbstractLayoutElement
    segments::Vector{Segment}
    measure::Measure
end

function Spacer(height::Int, width::Int; char::Char = ' ')
    seg = Segment(char^width)
    return Spacer(fill(seg, height), Measure(height, seg.measure.w))
end

Spacer(height::Number, width::Number; char::Char = ' ') =
    Spacer(rint(height), rint(width); char = char)

# ----------------------------------- vline ---------------------------------- #
"""
    vLine

A multi-line renderable with each line made of a | to create a vertical line.
"""
mutable struct vLine <: AbstractLayoutElement
    segments::Vector{Segment}
    measure::Measure
end

"""
    vLine(
        height::Int;
        style::String = TERM_THEME[].line,
        box::Symbol = TERM_THEME[].box,
        char::Union{Char,Nothing} = nothing,
    )

Create a `vLine` given a height and, optionally, style information.
"""
function vLine(
    height::Int;
    style::String = TERM_THEME[].line,
    box::Symbol = TERM_THEME[].box,
    char::Union{Char,Nothing} = nothing,
)
    char = isnothing(char) ? BOXES[box].head.left : char
    line = apply_style("{" * style * "}" * char * "{/" * style * "}\e[0m")
    return vLine(fill(Segment(line), height), Measure(height, 1))
end

"""
    vLine(ren::AbstractRenderable; kwargs...)

Construct a vLine with the same height as a renderable.
"""
vLine(ren::AbstractRenderable; kwargs...) = vLine(ren.measure.h; kwargs...)

"""
    vLine(; style::Union{String, Nothing}=nothing, box::Symbol=:ROUNDED)

Create a `vLine` as tall as the `stdout` console.
"""
vLine(; style::String = TERM_THEME[].line, box::Symbol = TERM_THEME[].box) =
    vLine(console_height(stdout); style = style, box = box)

# ----------------------------------- hLine ---------------------------------- #

"""
    hLine

A 1-line renderable made of repeated character from a Box.
"""
mutable struct hLine <: AbstractLayoutElement
    segments::Vector{Segment}
    measure::Measure
end

"""
    hLine(width::Number, style::Union{String, Nothing}; box::Symbol=TERM_THEME[].box)

Create a styled `hLine` of given width.
"""
hLine(width::Int; style::String = TERM_THEME[].line, box::Symbol = TERM_THEME[].box) =
    hLine([Segment(BOXES[box].row.mid^width * "\e[0m", style)], Measure(1, width))

"""
    hLine(width::Number, text::String; style::Union{String, Nothing}=nothing, box::Symbol=TERM_THEME[].box)

Creates an hLine object with texte centered horizontally.
"""
function hLine(
    width::Number,
    text::String;
    style::String = TERM_THEME[].line,
    box::Symbol = TERM_THEME[].box,
    pad_txt::Bool = true,
)
    box = BOXES[box]
    text = apply_style(text) * "{$style}"
    tl, tr = get_lr_widths(textlen(text))
    lw, rw = get_lr_widths(width)
    _pad = pad_txt ? " " : get_lrow(box, 1, :top; with_left = false)

    line =
        "{$style}" *
        get_lrow(box, lw - tl, :top; with_left = false) *
        _pad *
        text *
        _pad *
        "{$style}" *
        get_rrow(box, rw - tr, :top; with_right = false) *
        "{/$style}{/$style}" *
        "\e[0m"

    return hLine([Segment(line)], Measure(1, width))
end

"""
    hLine(; style::Union{String, Nothing}=nothing, box::Symbol=TERM_THEME[].box)

Construct an `hLine` as wide as the `stdout`.
"""
hLine(; style::String = TERM_THEME[].line, box::Symbol = TERM_THEME[].box) =
    hLine(console_width(stdout); style = style, box = box)

"""
    hLine(text::AbstractString; style::Union{String, Nothing}=nothing, box::Symbol=TERM_THEME[].box)

Construct an `hLine` as wide as the `stdout` with centered text.
"""
hLine(
    text::AbstractString;
    style::String = TERM_THEME[].line,
    box::Symbol = TERM_THEME[].box,
) = hLine(console_width(stdout), text; style = style, box = box)

"""
    hLine(ren::AbstractRenderable; kwargs)

Construct an hLine with same width as a renderable.
"""
hLine(ren::AbstractRenderable; kwargs...) = hLine(ren.measure.w; kwargs...)

# -------------------------------- PlaceHolder ------------------------------- #

"""
    mutable struct PlaceHolder <: AbstractLayoutElement
        segments::Vector{Segment}
        measure::Measure
    end
A `renderable` used as a place holder when creating layouts (e.g. with `grid`).

# Examples
```julia

println(PlaceHolder(25, 10))

╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲
╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ 
╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲
╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ 
╲ ╲ ╲ (25 × 10) ╲ ╲ ╲ ╲
╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ 
╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲
╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ 
╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲
╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ ╲ 
```
"""
mutable struct PlaceHolder <: AbstractLayoutElement
    segments::Vector{Segment}
    measure::Measure
end

function place_holder_line(w, i)
    if w > 1
        if w % 2 == 0
            left, right = w ÷ 2, w ÷ 2
            line = i == 0 ? "╲ "^(left) : " ╲"^(right)
        else
            left = cint(w / 2)
            line = i == 0 ? "╲ "^(left) : " ╲"^(left)
            line = ltrim_str(line, w)
        end

    else
        line = i == 0 ? '╲' : ' '
    end
    return line
end

"""
    PlaceHolder(
        h::In,
        w::Int;
        style::String = "dim",
        text::Union{Nothing,String} = nothing,
    )

Create a `PlaceHolder` with additional style information.
"""
function PlaceHolder(
    h::Int,
    w::Int;
    style::String = "dim",
    text::Union{Nothing,String} = nothing,
)
    # create lines of renderable
    b1 = place_holder_line(w, 0)
    b2 = place_holder_line(w, 1)
    lines::Vector{Segment} = map(i -> Segment(i % 2 != 0 ? b1 : b2, style), 1:h)

    # insert renderable size at center
    text = something(text, "($h × $w)")
    text = "  " * text * "  "
    text = width(text) % 2 == 0 ? " " * text : text
    l = width(text)

    if l < (w / 2) && w > 13
        f = w < 30 ? 2.5 : 3
        _w = cint(ncodeunits(lines[1].text) / f)
        _l = cint(l / 2)

        original = lines[cint(h / 2)].text
        lines[cint(h / 2)] = Segment(
            ltrim_str(original, _w - _l) *
            "{default bold white}" *
            text *
            "{/default bold white}{$style}" *
            rtrim_str(original, _w + _l),
        )
    end

    return PlaceHolder(lines, Measure(lines))
end

PlaceHolder(ren::AbstractRenderable; kwargs...) =
    PlaceHolder(ren.measure.h, ren.measure.w; kwargs...)

end

import Term.Renderables: Renderable, RenderableText, AbstractRenderable, trim_renderable
import Term: Panel
import Term.Segments: Segment
import Term: fillin, apply_style

@testset "\e[34mSegment" begin
    seg = Segment("test", "default")
    @test seg.text == "\e[22mtest\e[22m"
    @test seg.measure.w == 4

    @test_nothrow println(seg)

    seg = Segment("test", "red")
    @test seg.text == "\e[31mtest\e[39m"
    @test seg.measure.w == 4

    seg = Segment("aa\n{blue}123{/blue}")
    @test size(seg.measure) == (2, 3)

    seg = Segment("test")
    @test seg * "test" isa Segment
    @test (seg * "t2").text == "testt2"
    @test ("t2" * seg).text == "t2test"
    @test (seg * seg).text == "testtest"

    s = @capture_out show(seg)
    @test s == string(s)
end

@testset "\e[34mRenderables - RenderableText basic" begin
    lorem = "Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore"
    r = RenderableText(lorem)

    @test size(r.measure) == (2, TEST_CONSOLE_WIDTH)

    r2 = RenderableText(r)
    @test size(r.measure) == (2, TEST_CONSOLE_WIDTH)

    width = 22
    r = RenderableText(lorem; width = width)
    @test string(r) ==
          "Lorem ipsum dolor     \nsit amet, consectetur \n adipiscing elit,     \nsed do eiusmod tempor \n incididunt ut labore "
    @test r.measure.w == width

    r = RenderableText(lorem; width = width, style = "red")
    @test string(r) ==
          "\e[31mLorem ipsum dolor     \e[39m\n\e[31msit amet, consectetur \e[39m\n\e[31m adipiscing elit,     \e[39m\n\e[31msed do eiusmod tempor \e[39m\n\e[31m incididunt ut labore \e[39m"
    @test r.measure.w == width

    @test string(RenderableText("a string")) == "a string"
    @test string(RenderableText("a\nstring")) == "a     \nstring"

    @test_nothrow @capture_out show(r)

    @test sprint(io -> show(io, MIME("text/plain"), r)) == string(r) * "\n"
end

@testset "\e[34mRenderables - RenderableText basic" begin
    lorem = "Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore"
    width = 30

    IS_WIN || begin
        r = RenderableText(lorem, width = width, justify = :right)
        @compare_to_string(r, "renderable_text_1")

        r = RenderableText(lorem, width = width, justify = :center, background = "on_red")
        @compare_to_string(r, "renderable_text_2")
    end
end

@testset "\e[34mRenderables - RenderableText shape" begin
    lorem = "Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum."
    for (i, w) in enumerate([10, 12, 15, 18, 23, 25, 60])
        t = RenderableText(lorem; width = w)
        @testpanel(t, nothing, w)
        IS_WIN || @compare_to_string(t, "rend_text_shape_$(i)")
    end
end

@testset "\e[34mRenderables - trim renderables" begin
    IS_WIN || begin
        r = trim_renderable(RenderableText("aa bb"^100), 25)
        @compare_to_string(r, "trim_renderables_1")

        r = trim_renderable(Panel("aa bb"^100), 25)
        @compare_to_string(r, "trim_renderables_2")
    end
end

@testset "Renderables reshaped text markup" begin
    txt = "{red}dasda asda dadasda{green}aadasdad{/green}dad asd ad ad ad asdad{bold}adada ad as sad ad ada{/red}ad adas sd ads {/bold}"
    IS_WIN || @compare_to_string(Panel(txt; width = 30), "reshaped_rend_with_markup_1")
    IS_WIN ||
        @compare_to_string(RenderableText(txt; width = 30), "reshaped_rend_with_markup_2")

    txt = "{(220, 180, 150)}dasda {bold}asda dadasda{dodger_blue2}aadasdad{/dodger_blue2}dad asd ad{/bold} ad ad asdad{on_(25, 55, 100)}adada ad as sad ad ada{/(220, 180, 150)}ad adas sd ads {/on_(25, 55, 100)} NOW SIMPLE {red} adasd aads a asd ads a{/red} dasiudh asjdnasdiuasda {underline} asdnaisudnadaiuda sjduiabdiabd aduas {/underline}"
    IS_WIN || @compare_to_string(Panel(txt; width = 30), "reshaped_rend_with_markup_3")
    IS_WIN ||
        @compare_to_string(RenderableText(txt; width = 30), "reshaped_rend_with_markup_4")

    txt = "{(220, 180, 150)}dasda {bold}asda dadasda{dodger_blue2}aadasdad{/dodger_blue2}dad asd ad{/bold} ad ad asdad{on_(25, 55, 100)}adada ad as sad ad ada{/(220, 180, 150)}ad adas sd ads {/on_(25, 55, 100)} NOW SIMPLE {red} adasd aads a asd ads a{/red} dasiudh asjdnasdiuasda {underline} asdnaisudnadaiuda sjduiabdiabd aduas {/underline}"
    IS_WIN || @compare_to_string(
        Panel(apply_style(txt); width = 30),
        "reshaped_rend_with_markup_5"
    )
    IS_WIN || @compare_to_string(
        RenderableText(apply_style(txt); width = 30),
        "reshaped_rend_with_markup_6"
    )
end

"""
    @style "text" style1 style2...

Applies a sequence of styles to a piece of text, such that

    println(@style "my text" bold green underline)

will print `my text` as bold, green and underlined
"""
macro style(text, styles...)
    markup = join(styles, " ")
    quote
        local txt = $(esc(text))
        with_markup = "{$($markup)}$txt{/$($markup)}"
        apply_style(with_markup)
    end
end

# ------------------------- macros generating macros ------------------------- #
"""
Macro to create macros such as `@green` which colors text accordingly
"""
macro make_color_macro(color)
    quote
        macro $(esc(color))(text)
            color_str = $(string(color))
            quote
                local txt = $(esc(text))
                code = ANSICode(get_color($color_str); bg = false)
                styled = apply_style(txt)
                string(code.open * styled * code.close)
            end
        end
    end
end

"""
Macro to create macros such as `@underline` which styles text accordingly.
"""
macro make_mode_macro(mode)
    quote
        macro $(esc(mode))(text)
            mode_str = $(string(mode))
            quote
                local txt = $(esc(text))
                code = CODES[Symbol($mode_str)]
                styled = apply_style(txt)
                code.open * styled * code.close
            end
        end
    end
end

# ---------------------------------- colors ---------------------------------- #
@make_color_macro black
@make_color_macro red
@make_color_macro green
@make_color_macro yellow
@make_color_macro blue
@make_color_macro magenta
@make_color_macro cyan
@make_color_macro white
@make_color_macro default

# ----------------------------------- modes ---------------------------------- #
@make_mode_macro bold
@make_mode_macro dim
@make_mode_macro italic
@make_mode_macro underline

"""
    This example shows how to use panels in Term.jl

A `Panel` prints a piece of content surrounded by a border.
It's one of the best and easiest way to style your terminal output,
especially if you nest multiple panels or use Term's layout functionality
to create a structured terminal output.
"""

import Term: Panel

# Creating a panel is very simple

print(Panel("This is my first panel!"))

"""
By default Panel expands to fit its content. 
You can use different options to change this behavior.
"""

print("\n\n")
print(
    Panel("this panel has fixed width, text on the left"; width = 66, justify = :left),
    Panel("this one too, but the text is at the center!"; width = 66, justify = :center),
    Panel("the text is here!"; width = 66, justify = :right),
    Panel("this one fits its content"; fit = true),
    Panel("this one fits the terminal window size!"; width = 30),
)

"""
As you can see you can also specify how the panel's content should be justified. 
Of course you can use markup styled text in your panel.
"""

print("\n\n")
print(
    Panel(
        "{red}This is the panel's first line.{/red}",
        "{bold green}and this is another, panel just stacks all inputs into one piece of content{/bold green}";
        fit = true,
    ),
)

"""
When it comes to style, panel offers a lot of options.
You can style the box itself and have titles and subtitles.
"""

print("\n\n")

print(
    Panel("content "^10; title = "My Panel", title_style = "bold red", width = 44),
    Panel(
        "content "^10;
        subtitle = "another panel",
        subtitle_style = "dim underline",
        subtitle_justify = :right,
        width = 44,
    ),
    Panel("content "^10; box = :ASCII_DOUBLE_HEAD, style = "red", width = 44),
    Panel("content "^10; box = :DOUBLE, style = "blue", width = 44),
    Panel("content "^10; fit = true, padding = (0, 0, 0, 0)),
    Panel("content "^10; fit = true, padding = (4, 4, 0, 0)),
    Panel("content "^10; fit = true, padding = (2, 2, 2, 2)),
)

"""
Finally, you can layout panels to create structured content
"""

print("\n\n")
pleft = Panel("content "^30; box = :DOUBLE, style = "blue", width = 66)
pright = Panel(
    "content {red}with style{/red} "^26;
    title = "My Panel",
    title_style = "bold red",
    width = 44,
)

print(
    Panel(
        pleft / pright;
        style = "green dim",
        title_style = "green",
        title = "vertically stacked!",
        title_justify = :center,
        subtitle = "styled by Term.jl",
        subtitle_justify = :right,
        subtitle_style = "dim",
        justify = :center,
    ),
)

module Colors

import Term: NAMED_COLORS, COLORS_16b, ANSICode, rint, CODES, CODES_16BIT_COLORS

export NamedColor, BitColor, RGBColor, get_color

"""
    nospaces(text::AbstractString)

Remove all spaces from a string.
"""
nospaces(text::AbstractString) = replace(text, " " => "")

# ----------------------------- types definition ----------------------------- #
"""
    AbstractColor

Abstract color type.
"""
abstract type AbstractColor end

Base.show(io::IO, color::AbstractColor) = print(io, "$(typeof(color))")

struct NamedColor <: AbstractColor
    color::String
end

struct BitColor <: AbstractColor
    color::String
end

struct RGBColor <: AbstractColor
    r::Int
    g::Int
    b::Int
end

function RGBColor(s)
    to_number(x) = '.' ∈ x ? parse(Float64, x) : parse(Int, x)
    r, g, b = to_number.(match(RGB_REGEX, s).captures)
    if r < 1 || g < 1 || b < 1
        r *= 255
        g *= 255
        b *= 255
    end
    return RGBColor(rint(r), rint(g), rint(b))
end

"""
    ANSICode(color; bg::Bool=false)

Create ANSI tags for colors.
"""
function ANSICode(color::NamedColor; bg::Bool = false)
    Δ = bg ? 40 : 30
    v = CODES[color.color]
    return ANSICode("\e[$(Δ + v)m", "\e[$(Δ+9)m")
end

function ANSICode(color::BitColor; bg::Bool = false)
    Δ = bg ? 48 : 38
    v = CODES_16BIT_COLORS[color.color]
    return ANSICode("\e[$Δ;5;$(v)m", "\e[$(Δ+1)m")
end

function ANSICode(color::RGBColor; bg::Bool = false)
    Δ = bg ? 48 : 38
    rgb = "$(color.r);$(color.g);$(color.b)"
    return ANSICode("\e[$Δ;2;$(rgb)m", "\e[$(Δ+1)m")
end

# --------------------------------- is color? -------------------------------- #

RGB_REGEX = r"\(\s*([\d\.]{1,3})\s*,\s*([\d\.]{1,3})\s*,\s*([\d\.]{1,3})\s*\)"
HEX_REGEX = r"#(?:[0-9a-fA-F]{3}){1,2}$"

"""
    is_named_color(string::String)::Bool

Check if a string represents a named color.
"""
is_named_color(string)::Bool = string ∈ NAMED_COLORS || string ∈ COLORS_16b

"""
    is_rgb_color(string::String)::Bool

Check if a string represents a RGB color.
"""
is_rgb_color(string)::Bool = !occursin("on_", string) && occursin(RGB_REGEX, string)

"""
    is_hex_color(string::String)::Bool

Check if a string represents a hex color.
"""
is_hex_color(string)::Bool = !occursin("on_", string) && occursin(HEX_REGEX, string)

"""
    is_color(string::String)::Bool

Check if a string represents color information, of any type.
"""
is_color(string)::Bool =
    is_named_color(string) || is_rgb_color(string) || is_hex_color(string)

"""
    is_background(string::String)::Bool

Check if a string represents background color information, of any type.
"""
function is_background(string)::Bool
    stripped = nospaces(string)
    length(stripped) < 3 && return false
    return stripped[1:3] == "on_" && is_color(stripped[4:end])
end

# --------------------------------- get color -------------------------------- #
"""
    hex2rgb(hex::String)

Converts a string hex color code to a RGB color
"""
function hex2rgb(hex)::RGBColor
    to_int(h) = parse(Int, h; base = 16)
    r, g, b = [to_int(hex[i:(i + 1)]) for i in (2, 4, 6)]
    return RGBColor(r, g, b)
end

"""
    get_color(string::String; bg=false)::AbstractColor

Extract a color type from a string with color information.
"""
function get_color(string; bg = false)::AbstractColor
    bg && (string = nospaces(string)[4:end])

    if is_named_color(string)
        return if string ∈ COLORS_16b
            BitColor(COLORS_16b[findfirst(c -> c == string, COLORS_16b)])
        elseif string ∈ NAMED_COLORS
            NamedColor(NAMED_COLORS[findfirst(c -> c == string, NAMED_COLORS)])
        end
    elseif is_rgb_color(string)
        return RGBColor(string)
    else
        # convert hex to rgb
        return hex2rgb(string)
    end
end

end

"""
    columns_widths

Get the width of each column in a `Table`.

If user passed a `columns_widths` argument use that, otherwise
compute the width of each column based on the size of its contents
including the header and footer.
"""
function calc_columns_widths(
    N_cols::Int,
    N_rows::Int,
    columns_widths::Union{Nothing,Vector,Int},
    show_header::Bool,
    header::Union{Tuple,AbstractVector,String,Nothing},
    tb::TablesPkg.AbstractColumns,
    sch,  # table schema
    footer::Union{Tuple,AbstractVector,String,Nothing},
    hpad::Union{Nothing,Int,AbstractVector},
)
    if !isnothing(columns_widths)
        columns_widths = expand(columns_widths, N_cols)
        return columns_widths
    end

    headers_widths = show_header ? collect(width.(header)) : zeros(N_cols)
    data_widths = collect(map(c -> max(width.(tb[c])...), sch.names))
    footers_widths = isnothing(footer) ? zeros(N_cols) : collect(width.(footer))
    widths = hcat(headers_widths, data_widths, footers_widths)

    hpad = isa(hpad, Int) ? fill(hpad, N_rows) : hpad
    widths = Int.([mapslices(x -> max(x...), widths; dims = 2)...] .+ hpad * 2)
    return widths
end

"""
    rows_heights

Get the height of each row in a `Table`
"""
function rows_heights(N_rows::Int, show_header::Bool, header, rows_values, footer, vpad)
    headers_height = show_header ? max(height.(header)...) : 0
    data_heights = collect(map(r -> max(height.(r)...), rows_values))
    footers_height = isnothing(footer) ? 0 : max(height.(footer)...)
    vpad = isa(vpad, Int) ? fill(vpad, N_rows) : vpad
    heights = [headers_height, data_heights..., footers_height] .+ vpad .* 2
    return heights
end

"""
    expand

Expand single `Table` arguments into a vector if necessary.
"""
expand(v::Vector, N::Int) = v
expand(v::Union{Symbol,String,Int}, N::Int) = fill(v, N)

"""
    assert_table_arguments

Check that arguments passed to `Table` match the Table's shape.
Single arguments are fine, but when a vector is passed it should have the appropriate size.
"""
function assert_table_arguments(
    N_cols,
    N_rows,
    show_header,
    header,
    header_style,
    header_justify,
    columns_style,
    columns_justify,
    columns_widths,
    footer,
    footer_style,
    footer_justify,
    hpad,
    vpad,
)
    # check header
    problems = []
    if !isnothing(header) && show_header
        length(header) != N_cols &&
            push!(problems, "Got header with length $(length(header)), expected $N_cols")
        (!isa(header_style, String) && length(header_style) != N_cols) && push!(
            problems,
            "Got header_style with length $(length(header_style)), expected $N_cols",
        )
        (!isa(header_justify, Symbol) && length(header_justify) != N_cols) && push!(
            problems,
            "Got header_justify with length $(length(header_justify)), expected $N_cols",
        )
    end

    # check columns
    (!isa(columns_style, String) && length(columns_style) != N_cols) && push!(
        problems,
        "Got columns_style with length $(length(columns_style)), expected $N_cols",
    )
    (!isa(columns_justify, Symbol) && length(columns_justify) != N_cols) && push!(
        problems,
        "Got columns_justify with length $(length(columns_justify)), expected $N_cols",
    )
    columns_widths isa Vector &&
        length(columns_widths) != N_cols &&
        push!(
            problems,
            "Got columns_widths with length $(length(columns_widths)), expected $N_cols",
        )

    # check footer
    if !isnothing(footer)
        isa(footer, Function) ||
            (length(footer)) != N_cols && push!(
                problems,
                "Got footer with length $(length(footer)), expected $N_cols",
            )
        (!isa(footer_style, String) && length(footer_style) != N_cols) && push!(
            problems,
            "Got footer_style with length $(length(footer_style)), expected $N_cols",
        )
        (!isa(footer_justify, Symbol) && length(footer_justify) != N_cols) && push!(
            problems,
            "Got footer_justify with length $(length(footer_justify)), expected $N_cols",
        )
    end

    # check hpad
    (!isa(hpad, Int) && length(hpad) != N_cols) &&
        push!(problems, "Got hpad with length $(length(hpad)), expected $N_cols")
    (!isa(vpad, Int) && length(vpad) != N_rows) &&
        push!(problems, "Got vpad with length $(length(vpad)), expected $N_rows")

    # if there were problems, alert user and fail gracefully
    if length(problems) > 0
        @warn "Failed to create Term.Table"
        warn_color = "yellow_light"
        tprintln.("  {$warn_color}" .* problems .* "{/$warn_color}"; highlight = true)
    end
    return length(problems) == 0
end

"""
A `Gallery` containes multiple widgets, but only shows one at the time. 
"""
@with_repr mutable struct Gallery <: AbstractWidgetContainer
    internals::WidgetInternals
    controls::AbstractDict
    widgets::Vector{AbstractWidget}
    active::Int
    show_panel::Bool
    title::String
end

gallery_controls = Dict(
    ArrowRight() => activate_next_widget,
    ArrowLeft() => activate_prev_widget,
    'q' => quit,
    Esc() => quit,
)

function Gallery(
    widgets::Vector;
    controls = gallery_controls,
    height::Int = console_height() - 5,
    width::Int = console_width(),
    show_panel::Bool = true,
    title::String = "Widget",
    on_draw::Union{Nothing,Function} = nothing,
    on_activated::Function = on_activated,
    on_deactivated::Function = on_deactivated,
)
    # set widgets size
    Δ = show_panel ? 4 : 0
    measure = Measure(height, width)
    for wdg in widgets
        on_layout_change(wdg, Measure(measure.h - Δ, measure.w - Δ))
    end

    gal = Gallery(
        WidgetInternals(measure, nothing, on_draw, on_activated, on_deactivated, false),
        controls,
        widgets,
        1,
        show_panel,
        title,
    )
    set_as_parent(gal)
    return gal
end

function on_layout_change(gal::Gallery, m::Measure)
    gal.internals.measure = m
    Δ = gal.show_panel ? 4 : 0
    for wdg in gal.widgets
        on_layout_change(wdg, Measure(m.h - Δ, m.w - Δ))
    end
end

# ----------------------------------- frame ---------------------------------- #
function frame(gal::Gallery; kwargs...)
    isnothing(gal.internals.on_draw) || gal.internals.on_draw(gal)

    content = frame(get_active(gal))
    gal.show_panel || return content

    style = gal.show_panel && isactive(gal) ? "dim" : "hidden"

    Panel(
        content;
        title = gal.show_panel ? "$(gal.title) $(gal.active)/$(length(gal.widgets))" :
                nothing,
        justify = :center,
        style = style,
        title_style = "default",
        title_justify = :center,
        fit = false,
        width = gal.internals.measure.w,
        height = gal.internals.measure.h,
        padding = (1, 1, 1, 1),
    )
end

import Term: Tree, TERM_THEME, LightTheme
import OrderedCollections: OrderedDict

trees = [
    Dict(
        "nestedasdasdsadasdasdsadsadasdasdasdsadasasdasdassfsdfdsfdsfdsfsdfsdfdsfsdfd" =>
            Dict("n1" => 1, "n2" => 2),
    ),
    Dict("nested" => Dict("n1" => 1, "n2" => 2), "nested2" => Dict("n1" => "a", "n2" => 2)),
    Dict(
        "nested" => Dict("n1" => 1, "n2" => 2),
        "leaf2" => 2,
        "leaf" => 2,
        "leafme" => "v",
        "canopy" => "test",
        ["a"] => :test,
    ),
    Dict(
        "nested" => Dict(
            "deeper" => Dict("aleaf" => "unbeliefable", "leaflet" => "level 3"^20),
            "n2" => Int,
            "n3" => 1 + 2,
        ),
        "nested2" => Dict("n1" => "a", "n2" => 2),
    ),
    Dict(
        "nested" => Dict(
            "deeper" => Dict(
                "aleaf" => "unbeliefable",
                "leaflet" => "level 3",
                "sodeep" => Dict("a" => 4),
            ),
            "n2" => Int,
            "n3" => 1 + 2,
            "adict" => Dict("x" => 2),
        ),
        "nested2" => Dict("n1" => "a", "n2" => 2),
    ),
    OrderedDict(3 => OrderedDict(3 => 8, 1 => "a"), 2 => OrderedDict(3 => 8, 1 => "a")),
    OrderedDict(2 => 1, 3 => OrderedDict(4 => 2, "a" => 2, "b" => 1)),
    [1, 2, [2, 3, 4]],
    [
        1,
        [2, [3, 4], "a"^200],
        :c,
        OrderedDict(2 => "a", 1 => :ok, "a" => 2, :test => [1, 2]),
    ],
    Int,
    String,
    :(print, :(x, y)),
]

@testset "\e[34mTree" begin
    thm1 = TERM_THEME[]
    thm2 = LightTheme

    for (i, theme) in enumerate((thm1, thm2))
        for (j, guides_type) in enumerate((:standardtree, :boldtree, :asciitree))
            for (k, tree) in enumerate(trees)
                if VERSION ≥ v"1.7"  # ! not sure why but this fails in older versions: segmentation fault
                    IS_WIN || @compare_to_string string(
                        Tree(
                            tree;
                            theme = theme,
                            guides = guides_type,
                            printkeys = true,
                            title = "tree_$(i)_$(j)_$(k)",
                        ),
                    ) "tree_$(i)_$(j)_$(k)"
                end
            end
        end
    end

    # test with no errors
    @test_nothrow Tree(Float64)
    @test_nothrow Tree(AbstractFloat)

    # test printing
    @test sprint(io -> show(io, Tree(trees[1]))) ==
          "\e[38;5;117mTree <: AbstractRenderable\e[0m \e[2m(h:10, w:80)\e[0m"
    @test sprint(io -> show(io, MIME("text/plain"), Tree(trees[1]).segments[1])) ==
          "Segment{String} \e[2m(size: Measure (h: 1, w: 80))\e[0m"
end

module Compositors

import MyterialColors: Palette, blue, pink

using ..Layout
import ..Layout: PlaceHolder
import ..Measures: width, height, default_size
import ..Renderables: AbstractRenderable, RenderableText, Renderable
import ..Repr: @with_repr, termshow
import ..Consoles: console_height, console_width
import Term: highlight, update!, fint

export Compositor

include("_compositor.jl")

"""
    mutable struct LayoutElement
        id::Symbol
        h::Int
        w::Int
        renderable::Union{Nothing,String,AbstractRenderable}
        placeholder::PlaceHolder
    end

Stores a refence to an element of a `Compositor` layout.
Rendering a `Compositor` renders the renderable associated with 
each `LayoutElement` if there is one, the placeholder otherwise.
"""

@with_repr mutable struct LayoutElement
    id::Symbol
    h::Int
    w::Int
    renderable::Union{Nothing,String,AbstractRenderable}
    placeholder::PlaceHolder

    function LayoutElement(
        id::Symbol,
        h::Number,
        w::Number,
        renderable::Union{Nothing,String,AbstractRenderable},
        placeholder::PlaceHolder;
        max_w::Int = console_width(),
        max_h::Int = console_height(),
    )
        h = h isa Int ? h : fint(max_h * h)
        w = w isa Int ? w : fint(max_w * w)
        return new(id, h, w, renderable, placeholder)
    end
end

Base.size(e::LayoutElement) = (e.h, e.w)

"""
    mutable struct Compositor
        layout::Expr
        elements::Dict{Symbol,LayoutElement}
    end

A layout compositor, creates an updatable layout from an expression.
"""
mutable struct Compositor
    layout::Expr
    elements::Dict{Symbol,Union{Nothing,LayoutElement}}
end

"""
    Compositor(layout::Expr; hpad::Int = 0, vpad::Int = 0, check::Bool = true, kwargs...)

Constructor. Parses a layout expression and creates LayoutElements for 
each element in the expression.
"""
function Compositor(
    layout::Expr;
    hpad::Int = 0,
    vpad::Int = 0,
    placeholder_size = nothing,
    check::Bool = true,
    max_w::Int = console_width(),
    max_h::Int = console_height(),
    kwargs...,
)
    elements = get_elements_and_sizes(layout; placeholder_size = placeholder_size)
    names = map(e -> first(e.args), elements)

    # create renderables
    colors = if length(elements) > 1
        getfield.(Palette(blue, pink; N = length(elements)).colors, :string)
    else
        [pink]
    end

    renderables = Dict(
        n => extract_renderable_from_kwargs(e.args...; check = check, kwargs...) for
        (n, e) in zip(names, elements)
    )

    placeholders = Dict(
        n => compositor_placeholder(e.args..., n ≡ :_ ? "hidden" : c) for
        (n, c, e) in zip(names, colors, elements)
    )

    # create layout elements
    layout_elements = Dict(
        n => LayoutElement(
            n,          # symbol
            e.args[2],  # height
            e.args[3],  # width
            renderables[n],
            placeholders[n];
            max_w = max_w,
            max_h = max_h,
        ) for (n, e) in zip(names, elements)
    )

    # edit layout expression to add padding and remove size info
    expr = string(clean_layout_expr(copy(layout)))

    hpad > 0 && (expr = replace(expr, "*" => "* Spacer(1, $hpad) *"))
    vpad > 0 && (expr = replace(expr, "/" => "/ Spacer($vpad, 1) /"))

    expr = Meta.parse(expr)

    # handle the edge case with a single element
    expr = expr isa Expr ? expr : Expr(:call, expr)

    return Compositor(expr, layout_elements)
end

Renderable(compositor::Compositor) = Renderable(string(compositor))

# ---------------------------------- update ---------------------------------- #
"""
    function update!(
        compositor::Compositor,
        id::Symbol,
        content::Union{String,AbstractRenderable},
    )

Update a `LayoutElement` in a `Compositor` with new content.
If the content's measure doesn't match the pre-defined size of 
the `LayoutElement`, it prints a warning message.
"""
function update!(
    compositor::Compositor,
    id::Symbol,
    content::Union{String,AbstractRenderable},
)
    # check that the id is valid
    haskey(compositor.elements, id) || begin
        @warn highlight("Could not update compositor - id: `$id` is not in the layout")
        return
    end

    # if content is too small, pad it
    elem = compositor.elements[id]
    height(content) < elem.h &&
        (content = vertical_pad(content; height = elem.h, method = :top))
    width(content) < elem.w && (content = pad(content; width = elem.w, method = :right))

    # check that the shapes match
    if elem.w > width(content) || elem.h > height(content)
        content_shape = "{red}$(height(content)) × $(width(content)){/red}"
        target_shape = "{bright_blue}$(elem.h) × $(elem.w){/bright_blue}"
        @warn "Shape mismatch while updating compositor element {yellow}`$id`{/yellow}.\nGot $content_shape, expected $target_shape"
    end

    # update content
    compositor.elements[id].renderable = content
end

function update!(compositor::Compositor; kwargs...)
    for (id, content) in kwargs
        update!(compositor, id, content)
    end
    compositor
end

# ---------------------------------------------------------------------------- #
#                                   rendering                                  #
# ---------------------------------------------------------------------------- #
"""
    render(compositor::Compositor; show_placeholders = false)

Render a compositor's current layout. 

Get a renderable from each `LayoutElement` in the compositor
and evaluate the layout expression interpolating the renderables.
"""
function render(compositor::Compositor; show_placeholders = false)::AbstractRenderable
    # evaluate compositor
    elements = getfield.(values(compositor.elements), :id)
    renderables = getfield.(values(compositor.elements), :renderable)
    placeholders = getfield.(values(compositor.elements), :placeholder)
    length(renderables) == 1 && return something(renderables[1], placeholders[1])

    components = if show_placeholders
        Dict(zip(elements, placeholders))
    else
        Dict(e => something(r, p) for (e, r, p) in zip(elements, renderables, placeholders))
    end
    return eval(interpolate_from_dict(compositor.layout, components))
end

Base.string(compositor::Compositor; kwargs...) = string(render(compositor; kwargs...))

Base.print(io::IO, compositor::Compositor; highlight = true, kwargs...) =
    println(io, string(compositor; kwargs...))

Base.print(compositor::Compositor; kwargs...) = Base.print(stdout, compositor; kwargs...)

"""
Base.show(io::IO, ::MIME"text/plain", compositor::Compositor)

Show a compositor.
"""
Base.show(io::IO, ::MIME"text/plain", compositor::Compositor) =
    println(io, string(compositor))

end

# ---------------------------------------------------------------------------- #
#                                PRECOMPILATION                                #
# ---------------------------------------------------------------------------- #
using PrecompileTools
PrecompileTools.verbose[] = false

@setup_workload begin
    txt = join(
        repeat(["this is a random {red}text{/red} to test {bold}precompilation"], 10),
        "\n",
    )

    mdtext = md"""
    # Markdown rendering in Term.jl
    ## two
    ### three
    #### four
    ##### five
    ###### six

    This is an example of markdown content rendered in Term.jl.
    You can use markdown syntax to make words **bold** and *italic* or insert `literals`.


    You markdown can include in-line latex ``\LaTeX  \frac{{1}}{{2}}`` and maths in a new line too:

    ```math
    f(a) = \frac{1}{2\pi}\int_{0}^{2\pi} (\alpha+R\cos(\theta))d\theta
    ```

    You can also have links: [Julia](http://www.julialang.org) and
    footnotes [^1] for your content [^named].

    And, of course, you can show some code too:

    ```julia
    function say_hi(x)
        print("Hello World")
    end
    ```

    ---

    You can use "quotes" to highlight a section:

    > Multi-line quotes can be helpful to make a 
    > paragraph stand out, so that users won't miss it!
    > You can use **other inline syntax** in you `quotes` too.

    but if you really need to grab someone's attention, use admonitions:

    !!! note
        You can use different levels

    !!! warning
        to send different messages

    !!! danger
        to your reader

    !!! tip "Wow!"
        Turns out that admonitions can be pretty useful!
        What will you use them for?

    ---

    Of course you can have classic lists:
    * item one
    * item two
    * And a sublist:
        + sub-item one
        + sub-item two

    and ordered lists too:
    1. item one
    2. item two
    3. item three


    !!! note "Tables"
        You can use the [Markdown table syntax](https://www.markdownguide.org/extended-syntax/#tables)
        to insert tables - Term.jl will convert them to Table object!

    | Term | handles | tables|
    |:---------- | ---------- |:------------:|
    | Row `1`    | Column `2` |              |
    | *Row* 2    | **Row** 2  | Column ``3`` |


    ----

    This is where you print the content of your foot notes:

    [^1]: Numbered footnote text.

    [^note]:
        Named footnote text containing several toplevel elements.
    """

    code = """
function render(
content::Union{Renderable,RenderableText};
box::Symbol = TERM_THEME[].box,
style::String = TERM_THEME[].line,
title::Union{String,Nothing} = nothing,
title_style::Union{Nothing,String} = nothing,
Δh::Int,
padding::Padding,
background::Union{Nothing,String} = nothing,
kwargs...,
)::Panel
background = get_bg_color(background)
# @info "calling render" content content_measure background

# create top/bottom rows with titles
box = BOXES[box]  # get box object from symbol
top = get_title_row(
    :top,
    box;
    title_style = title_style,
    justify = title_justify,
)

bottom = get_title_row(
    :bottom,
    box,
    subtitle;
    width = panel_measure.w,
)

# get left/right vertical lines
σ(s) = apply_style("\e[0m{" * style * "}" * s * "{/" * style * "}")
left, right = σ(box.mid.left), σ(box.mid.right)

# get an empty padding line
empty = if isnothing(background)
    [Segment(left * " "^(panel_measure.w - 2) * right)]
else
    [Segment(left * "{background}" * " "^(panel_measure.w - 2) * "{/background}" * right)]
end
"""

    junkio = IOBuffer()  # from https://github.com/timholy/SnoopCompile.jl/issues/308

    @compile_workload begin
        reshape_text(txt, 10)
        print(junkio, Panel())
        tprint(junkio, Panel())

        print(junkio, Panel(txt; fit = false, justify = :right, width = 25))
        print(
            junkio,
            Panel(
                txt;
                fit = true,
                title = "test",
                subtitle = "test",
                style = "red on_blue",
                background = "blue",
            ),
        )

        r = RenderableText(txt; width = 30, style = "red")
        r2 = RenderableText(txt)
        p = Panel(txt)
        r * p
        r / p

        hLine(10)
        hLine(100, "test"; style = "red")
        vLine()

        tprintln(junkio, mdtext)

        # repr
        termshow(junkio, Panel)
        termshow(junkio, print)
        termshow(junkio, zeros(100))
        termshow(junkio, zeros(100, 100))
        termshow(junkio, zeros(100, 100, 10))

        # errors
        ctx = StacktraceContext()
        bt = backtrace()

        render_backtrace(ctx, bt)
        render_backtrace(ctx, bt; hide_frames = false)

        code_h = highlight_syntax(code; style = true)
        reshape_code_string(code_h, 30)

        # load_code_and_highlight("src/panels.jl", 20)
    end
end

"""
    AbstractWidgetContainer

`AbstractWidgetContainer` contain multiple other widgets
and can coordinate their activity. 
AbstractWidgetContainer must have two obligatory fields on top of AbstractWidget's fields:
    widgets::Vector{AbstractWidget}
    active::Int
"""
abstract type AbstractWidgetContainer <: AbstractWidget end

"""
Set the parent of all widgets in `container` to `container`.
"""
set_as_parent(container::AbstractWidgetContainer) = map(
    w -> w.internals.parent = container,
    (container.widgets isa AbstractDict ? values(container.widgets) : container.widgets),
)

"""
Return the active widget in `container`.
"""
get_active(container::AbstractWidgetContainer) = container.widgets[container.active]

"""
Set the active widget in `container` to `active`.
"""
set_active(container::AbstractWidgetContainer, active) = container.active = active

"""
Set the active widget in `container` to the next widget.
"""
function activate_next_widget(widget::AbstractWidget, ::Any)
    widget.active = min(widget.active + 1, length(widget.widgets))
    return :stop
end

"""
Set the active widget in `container` to the previous widget.
"""
function activate_prev_widget(widget::AbstractWidget, ::Any)
    widget.active = max(widget.active - 1, 1)
    return :stop
end

using Term.LiveWidgets

println("Please choose a menu type:")
retval =
    App(SimpleMenu(["Simple", "Buttons", "MultiSelect"]); height = 3) |> LiveWidgets.play
print("\n\n")

# get the selected menu style
mn = if retval == 1
    println("\n This is an example of a SimpleMenu")
    SimpleMenu(["One", "Two", "Three"]; active_style = "white bold", inactive_style = "dim")
elseif retval == 2
    println("\n This is an example of a ButtonsMenu")
    ButtonsMenu(
        ["One", "Two", "Three"];
        active_background = ["green", "white", "red"],
        active_color = "bold black",
        inactive_color = ["green", "white", "red"],
        layout = :horizontal,
    )
elseif retval == 3
    println("\n This is an example of a MultiSelectMenu")
    MultiSelectMenu(["One ", "two", "three"])
end

println("\nPlease choose an option:")
retval = LiveWidgets.play(App(mn; height = mn.internals.measure.h); transient = false)

print("The menu returned the value: $retval")

import Term.Style: apply_style

@testset "\e[34mMACROS" begin
    @test (@green "string") == apply_style("{green}string{/green}")
    @test (@blue "string") == apply_style("{blue}string{/blue}")
    @test (@red "string") == apply_style("{red}string{/red}")

    @test (@bold "string") == apply_style("{bold}string{/bold}")
    @test (@italic "string") == apply_style("{italic}string{/italic}")
    @test (@underline "string") == apply_style("{underline}string{/underline}")

    @test (@style "string" bold underline) ==
          apply_style("{bold underline}string{/bold underline}")
    @test (@style "string" bold greeen) == apply_style("{bold greeen}string{/bold greeen}")
    @test (@style "string" red on_blue underline) ==
          apply_style("{red on_blue underline}string{/red on_blue underline}")
    @test (@style "string" bold italic) == apply_style("{bold italic}string{/bold italic}")

    # test with interpolations
    x = "test"
    @test (@red "aa $x aa") == "\e[31maa test aa\e[39m"
    @test (@bold "aa $x aa") == "\e[1maa test aa\e[22m"
    @test (@style "aa $x aa" green bold) == "\e[1m\e[32maa test aa\e[22m\e[39m"
end

module Annotations

import Term: fint, TERM_THEME, cleantext
import ..Renderables: AbstractRenderable, RenderableText, Renderable
import ..Segments: Segment
import ..Measures: Measure, height, width
import ..Layout: hLine, Spacer, vstack, hstack
import ..Panels: Panel
import ..Style: apply_style
import ..Consoles: console_width

export Annotation

# ---------------------------------------------------------------------------- #
#                                  DECORATION                                  #
# ---------------------------------------------------------------------------- #

"""
struct Decoration
    nun::Int
    position::Int
    underscore::hLine
    panel::Renderable
    style::String
end

A decoration storing a message to anotate a piece of text.
`Decoration`s are used by `Annotation` to annotate text.

A `Decoration` looks something like this when rendered.
```
────┬───                              
    │                                 
    │ ╭─────╮
    ╰─│ MSG │
      ╰─────╯
```
"""
struct Decoration
    nun::Int
    position::Int
    underscore::hLine
    panel::Renderable
    style::String
end

"""
    Decoration(num::Int, position::Int, message::String, underscore_width::Int, style::String)

Construct a `Decoration`. When preparing the `Panel` with the message, the `message` text
gets resized if its too large (based on `position` and `console_width`).

## Arguments
- `num` number of decoration (for `Annotation` with multiple decorations)
- `position` position of the decoration start in the text (position of the start of the underscore)
- `message` text going inside the message box
- `underscore_width`: the width of the underscore line. 
- `style`: color/style information
"""
function Decoration(
    num::Int,
    position::Int,
    message::String,
    underscore_width::Int,
    style::String,
)
    # create hLine underscore
    underscore = hLine(underscore_width, "┬"; pad_txt = false, style = "$style dim")

    # get the width of the text, see if it needs to be adjusted
    max_w = min(width(message), console_width() - position - 30)

    # create `Panel` and add the end of an "arrow" to the side.
    msg_panel = Panel(
        RenderableText(message; style = style, width = max_w);
        fit = true,
        style = "$style dim",
    )
    msg_panel =
        "{$style dim}│{/$style dim}" / "{$style dim}╰─{/$style dim}" *
        (Spacer(0, 1) / msg_panel)
    return Decoration(num, position, underscore, msg_panel, style)
end

""" halve and round a number """
half(x) = fint(x / 2)

""" Make a vector of `Spacer` objects of given widths"""
make_spaces(widths::Vector{Int})::Vector{Spacer} =
    collect(map(w -> Spacer(1, max(0, w)), widths))

""" hstack interleaved elements x ∈ X, y ∈ Y """
join_interleaved(X, Y) = hstack([x * y for (x, y) in zip(X, Y)]...) |> string |> apply_style

"""
    overlay_decorations(decorations::Vector{Decoration})

Overlayed rendering of multiple `Decoration` object.
Given multiple decorations, create a visualization like:

```
Panel(content; fit=true)                                                                 
──┬── ───┬───  ────┬───                                                                  
  │      │         │                                                                     
  │ ╭─────────────────────────────────╮                                                  
  ╰─│  this is the panel constructor  │                                                  
    ╰─────────────────────────────────╯                                                  
         │         │                                                                     
         │ ╭───────────────────────────────────────────╮                                 
         ╰─│  here you put what goes inside the panel  │                                 
           ╰───────────────────────────────────────────╯                                 
                   │                                                                     
                   │ ╭──────────────────────────────────────────────────────────────────╮
                   ╰─│  Setting this as `true` adjusts the panel's width to fit         │
                     │  `content`. Otherwise `Panel` will have a fixed width            │
                     ╰──────────────────────────────────────────────────────────────────╯
```

Note: we need all the underscores, the vertical lines to be in the right place
and for the `Panel` with heach message to be over the lines of the following
decorations. Spacing should be accounted to make sure all messages are visible. 

Note: this function is quite long and nasty, but it seems to work well.
"""
function overlay_decorations(decorations::Vector{Decoration})
    n = length(decorations)
    positions = getfield.(decorations, :position)

    # make sure decorations are in order based on position
    sorter = sortperm(positions)
    decorations = decorations[sorter]
    positions = positions[sorter]

    # get some info
    underscores_widths = width.(getfield.(decorations, :underscore))
    underscores_centers = half.(underscores_widths)

    # create the first line with all the underlines
    lines = []
    lpads = map(
        i ->
            i == 1 ? positions[1] :
            positions[i] - positions[i - 1] - underscores_widths[i - 1] + 2,
        1:n,
    )

    spaces = make_spaces(lpads)
    push!(lines, join_interleaved(spaces, getfield.(decorations, :underscore)))

    # make a second line with just verticals
    lpads = map(
        i ->
            i == 1 ? positions[1] + underscores_centers[1] - 1 :
            positions[i] - positions[i - 1] - underscores_centers[i - 1] +
            underscores_centers[i] - 1,
        1:n,
    )
    spaces = make_spaces(lpads)
    verts = map(d -> "{$(d.style) dim}│{/$(d.style) dim}", decorations)
    push!(lines, join_interleaved(spaces, verts))

    # render additional lines with their messages
    decs = Dict([i => decorations[i] for i in 1:n])
    rendering = 1
    while rendering <= n
        # get the pad to the left of the message panel
        lpad = rendering == 1 ? lpads[1] : sum(lpads[1:rendering]) + rendering

        # get each line of the message
        for i in 1:(decs[rendering].panel.measure.h)
            # get the panel segment & add space to put it in the right place
            ln = decs[rendering].panel.segments[i]
            pad_size = rendering == 1 ? lpad : lpad - 1
            line = " "^(pad_size) * string(ln)

            # add vertical segments for every other decoration to the side of the message panel
            if rendering < n
                for j in (rendering + 1):n
                    l = width(line)
                    pad_size = decorations[j].position - l + underscores_centers[j] - 1
                    pad_size < 0 && continue
                    space = " "^(pad_size)
                    _style = decorations[j].style
                    line *= space * "{$_style dim}│{/$_style dim}"
                end
            end

            # add to output
            push!(lines, line)
        end

        # add a line with the vertical elements of each decoration left to render
        if rendering < n
            line = " "^(positions[rendering] + underscores_centers[rendering])
            push!(
                lines,
                line *
                join_interleaved(spaces[(rendering + 1):end], verts[(rendering + 1):end]),
            )
        end

        rendering += 1
    end

    return join(lines, "\n")
end

# ---------------------------------------------------------------------------- #
#                                  ANNOTATION                                  #
# ---------------------------------------------------------------------------- #

"""
    struct  Annotation <: AbstractRenderable
        segments::Vector
        measure::Measure
    end

Represents a bit of text with some additional annotations. 
Annotations are additional messages that get printed below 
the main piece of text.

## Example
```julia
Annotation("This is the text", "text"=>"this is an annotation")
````
gives
```
This is the text                           
            ──┬─                           
              │                            
              │ ╭─────────────────────────╮
              ╰─│  this is an annotation  │
                ╰─────────────────────────╯
```

---
This bit:
```
──┬─                           
  │                            
  │ ╭─────────────────────────╮
  ╰─│  this is an annotation  │
    ╰─────────────────────────╯
```
is called a `Decoration`. 

A piece of text can have multiple decorations if multiple pares are 
passed in the function call above. 
"""
struct Annotation <: AbstractRenderable
    segments::Vector
    measure::Measure

    function Annotation(text::String)
        rt = RenderableText(text)
        return new(rt.segments, rt.measure)
    end
end

"""
    Annotation(text::String, annotations::Pair...; kwargs...)

Construct an `Annotation`.

The argument `annotations` is a set of `Pair`s denoting which parts
of `text` gets annotated, with what, and what style information each annotation
should have. These pairas can be of the form `String=>String` if no style information
is passed, otherwise `String=>(String, String)` where the first `String` in the 
parentheses is the annotation message and the second the style info. The first `String`
in the `Pair` should be a substring of `text` to denote where the annotation occurs.
"""
function Annotation(text::String, annotations::Pair...; kwargs...)
    @assert width(text) < console_width() && height(text) == 1 "Annotation can only annotate a single line, small enough to fit in the screen."
    rawtext = cleantext(text)

    # create decoration objects
    decorations = Decoration[]
    for (i, ann) in enumerate(annotations)
        match = findfirst(ann.first, rawtext)
        isnothing(match) && continue

        # get the message an style
        msg, style = if ann.second isa String
            ann.second, TERM_THEME[].annotation_color
        elseif ann.second isa Tuple
            ann.second
        else
            error("Decoration argument could not be understood: $ann")
        end

        # get the size of the annotation decoration
        underscore_width = match.stop - match.start + 3
        push!(decorations, Decoration(i, match.start - 1, msg, underscore_width, style))
    end
    # reverse!(decorations)

    decos = overlay_decorations(decorations)
    return Annotation(text / decos)
end

end

module Logs

using ProgressLogging: asprogress
using InteractiveUtils
using Dates: Dates
using Logging

import Term:
    Theme,
    textlen,
    escape_brackets,
    unescape_brackets,
    reshape_text,
    has_markup,
    rint,
    highlight,
    TERM_THEME,
    str_trunc,
    ltrim_str,
    default_width,
    NOCOLOR,
    cleantext

import ..Consoles: console_width, console_height, change_scroll_region, move_to_line
import ..Renderables: AbstractRenderable, RenderableText
import ..Style: apply_style
import ..Tprint: tprintln, tprint
import ..Boxes: BOXES
import ..Progress:
    ProgressBar,
    ProgressJob,
    DescriptionColumn,
    ProgressColumn,
    render,
    start!,
    stop!,
    addjob!,
    removejob!,
    update!,
    getjob,
    SeparatorColumn,
    PercentageColumn
import ..Measures: width, height
import ..Layout: hstack, rvstack, lvstack, vertical_pad, pad, vLine

export TermLogger, install_term_logger

DEFAULT_LOGGER = global_logger()

# ---------------------------- create term logger ---------------------------- #
"""
    TermLogger

Custom logger type.
"""
struct TermLogger <: AbstractLogger
    io::IO
    theme::Theme
    pbar::ProgressBar
end
TermLogger(theme::Theme = TERM_THEME[]) = TermLogger(stderr, theme)

function TermLogger(io::IO, theme::Theme = TERM_THEME[])
    return TermLogger(
        io,
        theme,
        ProgressBar(;
            transient = true,
            columns = [
                DescriptionColumn,
                SeparatorColumn,
                ProgressColumn,
                SeparatorColumn,
                PercentageColumn,
            ],
        ),
    )
end

# set logger beavior
Logging.min_enabled_level(logger::TermLogger) = Logging.Info

Logging.shouldlog(logger::TermLogger, level, _module, group, id) = true
Logging.catch_exceptions(logger::TermLogger) = true

# --------------------------- handle logger message -------------------------- #

"""
    print_closing_line(color::String, width::Int)

Print the final line of a log message with style and date info
"""
function print_closing_line(io::IO, color::String, width::Int = 48)
    tprintln(
        io,
        "  {$color bold dim}$(BOXES[:ROUNDED].bottom.left)" *
        "$(BOXES[:ROUNDED].row.mid)"^(width) *
        "{/$color bold dim}",
    )
    _date = Dates.format(Dates.now(), "e, dd u yyyy")
    _time = Dates.format(Dates.now(), "HH:MM:SS")
    pad = width - textlen(_date * _time) - 2
    return tprintln(
        io,
        " "^pad * "{dim}$_date{/dim} {bold dim underline}$_time{/bold dim underline}";
        highlight = false,
    )
end

"""
    handle_progress(logger::TermLogger, prog)

Handle progress information passed by `ProgressLogging`.

It creates/adds/removes `ProgressJob`s to the logger's
`ProgressBar` to create progress visualizations. 
"""
function handle_progress(logger::TermLogger, prog)
    pbar = logger.pbar
    pbar.running || start!(pbar)

    # if progress not started yet, ignore
    (isnothing(prog.fraction) || prog.fraction == 0) && return nothing

    # check if a job exists for this progress, or add one
    job = getjob(pbar, prog.id)
    job = if isnothing(job)
        addjob!(
            pbar;
            description = length(prog.name) > 0 ? prog.name : "running...",
            N = 100,
            transient = false,
            id = prog.id,
        )
    else
        job
    end

    # if done, remove job.
    if prog.done || prog.fraction == 1.0
        job.i = 100
        stop!(job)
    else
        update!(job; i = (Int ∘ floor)(prog.fraction * 100))
    end

    # render
    if all(map(j -> j.finished, pbar.jobs))
        map(j -> removejob!(pbar, j), pbar.jobs)
        stop!(pbar)
    else
        render(pbar)
    end
end

style_log_msg_kw_value(logger, v::Number) = (v, logger.theme.number)
style_log_msg_kw_value(logger, v::Symbol) = (v, logger.theme.symbol)
style_log_msg_kw_value(logger, v::AbstractString) = (v, logger.theme.string)
style_log_msg_kw_value(logger, v::Function) = (v, logger.theme.func)
style_log_msg_kw_value(logger, v::AbstractRenderable) =
    ("$(typeof(v))  \e[2m$(v.measure)\e[0m", "default")
style_log_msg_kw_value(logger, v) = (v, nothing)

function style_log_msg_kw_value(logger, v::AbstractVector)
    _style = logger.theme.number
    _size = length(v)
    v = escape_brackets(string(v))
    v = textlen(v) > 60 ? v[1:57] * "..." : v
    v *= "\n {$(logger.theme.text)}$(_size) {/$(logger.theme.text)}{dim}items{/dim}"
    return (v, _style)
end
function style_log_msg_kw_value(logger, v::Union{AbstractArray,AbstractMatrix})
    _style = logger.theme.number
    _size = size(v)
    v = str_trunc("$(typeof(v)) {dim}<: $(supertypes(typeof(v))[end-1]){/dim}", 60)
    v *=
        "\n {dim}shape: {default $(logger.theme.text)}" *
        join(string.(_size), " × ") *
        "{/default $(logger.theme.text)}{/dim}"
    return (v, _style)
end

"""
Create string display for a log message value.
"""
function log_value_display end

function log_value_display(x::AbstractArray)
    a = highlight(str_trunc(string(x), 1000); ignore_ansi = true)

    s = foldl((a, b) -> a * " × " * b, string.(size(x)))
    b = highlight("{bold dim}Size:  $(s){/bold dim}"; ignore_ansi = true)
    return a * "\n" * b
end

log_value_display(x::AbstractDict) =
    highlight(str_trunc(string(x), 1000); ignore_ansi = true)
log_value_display(x) = highlight(str_trunc(string(x), 1000);)

function print_log_message(io, logger, lvl, msg, _mod, file, line, kwargs)

    # get name of function where logging message was called from
    fname = ""
    for frame in stacktrace()
        if "$(frame.file)" == file && frame.line == line
            fname = ".{underline}$(frame.func){/underline}"
        end
    end
    fname = split(fname, ".")[end]

    # prepare styles
    color = if lvl == Logging.Info
        logger.theme.info
    elseif lvl == Logging.Debug
        logger.theme.debug
    elseif lvl == Logging.Warn
        logger.theme.warn
    elseif lvl == Logging.Error
        logger.theme.error
    else
        "#90CAF9"
    end
    outline_markup = "$color dim"
    vert = "{$outline_markup}" * BOXES[:ROUNDED].mid.left * "{/$outline_markup}"

    # ---------------------------------- message --------------------------------- #
    logmsg_color = logger.theme.logmsg
    msg = string(msg)
    msg = length(msg) > 1500 ? ltrim_str(msg, 1500 - 3) * "..." : msg

    # prepare the first line: function name and log message
    fn_color = logger.theme.func
    firstline = "{$color underline bold}@$(string(lvl)){/$color underline bold} {$fn_color }($(_mod)$fname):{/$fn_color }"

    # print first line
    msg = RenderableText(
        msg;
        width = console_width() - textlen(firstline) - 1,
        style = logmsg_color,
    )
    vline = "  " * vLine(msg.measure.h; style = outline_markup)
    tprint(io, (firstline / vline) * " " * msg; highlight = false)

    # --------------------------------- contents --------------------------------- #
    # if no kwargs we can just quit
    if length(kwargs) == 0
        print_closing_line(io, color)
        return nothing
    end

    """
        For each kwarg, get the type and the content, as string.
        Optionally trim these strings to ensure formatting is fine.
    """

    # Create display of type,k->v for each kwarg
    _types = map(t -> t isa Function ? Function : typeof(t), (collect(values(kwargs))))
    types_w = min(console_width() / 5, maximum(width.(string.(_types)))) |> round |> Int
    types_w = max(12, types_w)

    _keys = map(k -> highlight(string(k), theme = logger.theme), keys(kwargs))
    keys_w = min(console_width() / 5, maximum(width.(_keys))) |> round |> Int
    keys_ = max(12, keys_w)

    _vals = map(v -> log_value_display(v), collect(values(kwargs)))
    vals_w = min(console_width() / 5 * 3 - 7, maximum(width.(_vals)) - 7) |> round |> Int
    vals_w = max(12, vals_w)

    # function to format content, style and shape
    fmt_str(x, style::String, w::Int) = RenderableText(string(x); width = w, style = style)
    fmt_str(::Function, style::String, w::Int) =
        RenderableText("Function"; style = style, width = w)

    # get types, keys and values as RenderableText with style
    ks = fmt_str.(_keys, logger.theme.text_accent, keys_w)
    ts = fmt_str.(_types, "dim " * logger.theme.type, types_w)
    vs = fmt_str.(_vals, "", vals_w)

    # print all kwargs
    eq = "{$(logger.theme.operator)}={/$(logger.theme.operator)}"
    tprint(io, "  $vert"; highlight = false)
    print(io, "\n")
    for (t, k, v) in zip(ts, ks, vs)
        # get the height of the tallest piece of content on this line
        h = maximum(height.([k, v, t]))

        # make sure all renderables have the same height and each columns' renderable has the right width
        t = vertical_pad(pad(t; width = types_w, method = :left); height = h, method = :top)
        k = vertical_pad(pad(k; width = keys_w, method = :left); height = h, method = :top)
        v = vertical_pad(pad(v; width = vals_w, method = :right); height = h, method = :top)

        # make vertical line and =
        line = join(repeat(["  $vert"], h), "\n")
        equal = vertical_pad(eq, h, :top)

        ll = hstack(line, t, k, equal, v; pad = 1)
        tprint(io, ll)
    end
    print_closing_line(io, color)
end

"""
    handle_message(logger::TermLogger, lvl, msg, _mod, group, id, file, line; kwargs...)

Handle printing of log messages, with style!.

In addition to the log message and info such as file/line and time of log, 
it prints kwargs styled by their type.
"""
function Logging.handle_message(
    logger::TermLogger,
    lvl,
    msg,
    _mod,
    group,
    id,
    file,
    line;
    kwargs...,
)
    # handle log progress
    _progress = asprogress(lvl, msg, _mod, group, id, file, line; kwargs...)
    isnothing(_progress) || return handle_progress(logger, _progress)

    # generate log 
    logged = sprint(print_log_message, logger, lvl, msg, _mod, file, line, kwargs)

    # restore stdout
    NOCOLOR[] && (logged = cleantext(logged))
    print(logged)
end

# ---------------------------- install term logger --------------------------- #

"""
    install_term_logger(theme::Theme=theme)

Install `TermLogger` as the global logging system.

`theme::Theme` can be passed to specify the theme to use for styling objects.
"""
function install_term_logger(theme::Theme = TERM_THEME[])
    _logger = TermLogger(theme)
    return global_logger(_logger)
end

function uninstall_term_logger()
    logger = global_logger(DEFAULT_LOGGER)
    return logger
end

end

module Dendograms

import Term: fint, rint, cint, str_trunc, loop_firstlast, highlight, textlen, TERM_THEME

import ..Renderables: AbstractRenderable
import ..Boxes: get_rrow, get_lrow, get_row, BOXES
import ..Style: apply_style
import ..Segments: Segment
import ..Measures: Measure
import ..Layout: pad

export Dendogram, link

CELLWIDTH = 10
SPACING = 1

# ---------------------------------------------------------------------------- #
#                                     LEAF                                     #
# ---------------------------------------------------------------------------- #

"""
    Leaf <: AbstractRenderable

The terminal element of a `Dendogram`.
"""
struct Leaf <: AbstractRenderable
    segments::Vector{Segment}
    measure::Measure
    text::String
    midpoint::Int
end

"""
    Leaf(leaf)

Construct a `Leaf` out of any object.
"""
function Leaf(leaf)
    # get a string representation of the appropriate length
    leaf = string(leaf)
    leaf = if textlen(leaf) > CELLWIDTH
        str_trunc(leaf, CELLWIDTH)
    else
        pad(leaf, CELLWIDTH + 1, :center)
    end

    # create renderable Leaf
    midpoint = fint(textlen(leaf) / 2)
    seg = Segment(" " * leaf * " ", TERM_THEME[].dendo_leaves)
    return Leaf([seg], Measure(seg), leaf, midpoint)
end

function Base.string(leaf::Leaf, isfirst::Bool, islast::Bool, spacing::Int)
    l = isfirst ? "" : " "^spacing
    r = islast ? "" : " "^spacing
    return l * leaf.text * r
end

# ---------------------------------------------------------------------------- #
#                                   DENDOGRAM                                  #
# ---------------------------------------------------------------------------- #

"""
    Dendogram <: AbstractRenderable

A Dendogram tree renderable.
"""
struct Dendogram <: AbstractRenderable
    segments::Vector{Segment}
    measure::Measure
    midpoint::Int  # width of 'center'
end

"""
    Dendogram(head, args::Vector; first_arg=nothing, pretitle=nothing)

Construct a single `Dendogram`.

Construct a dendogram with one head node (`head`) and any number of leaves.

`first_arg` is used to create dendograms for `Expr` objects and gives special
status to an expression's first argument which gets printed with the head.
`pretitle` is used to create dendograms for `Expr`, pretitle is insrted as 
three `Segment`s (a string and an upward arrow) before the head of the dendogram.
"""
function Dendogram(head, args::Vector; first_arg = nothing, pretitle = nothing)
    # get leaves
    leaves = Leaf.(args)
    leaves_line =
        join(map(nl -> string(nl[3], nl[1], nl[2], SPACING), loop_firstlast(leaves)))
    width = textlen(leaves_line)

    # get tree structure line
    if length(leaves) > 1
        widths = fill(CELLWIDTH + 1 + SPACING, length(leaves) - 1)
        line = pad(
            replace_line_midpoint(get_row(BOXES[:SQUARE], widths, :top))[1],
            width,
            :center,
        )
    else
        widths = [CELLWIDTH]
        line = pad(string(BOXES[:SQUARE].bottom.vertical), CELLWIDTH, :center)
    end

    # get title
    title_style = TERM_THEME[].dendo_title
    pretitle_style = TERM_THEME[].dendo_pretitle
    line_style = TERM_THEME[].dendo_lines

    title = if isnothing(first_arg)
        pad(apply_style("$(head)", title_style), width, :center)
    else
        _title = ": {bold default underline $title_style}$first_arg{/bold default underline $title_style}"
        pad(apply_style("$(head)$_title", title_style * " dim"), width - 4, :center) * " "^4
    end

    # put together
    segments = [
        Segment(title),
        Segment(line, line_style),
        Segment(leaves_line, TERM_THEME[].dendo_leaves),
    ]

    # add 'pretitle' lines (for expressions only)
    if !isnothing(pretitle)
        prepend!(
            segments,
            [
                Segment(
                    " " * pad(str_trunc(pretitle, CELLWIDTH), width - 1, :center),
                    pretitle_style,
                ),
                Segment(" " * pad("⋀", width - 1, :center), "$line_style bold"),
                Segment(
                    " " * pad(string(BOXES[:SQUARE].bottom.vertical), width - 1, :center),
                    "$line_style dim",
                ),
            ],
        )
    end

    return Dendogram(segments, Measure(segments), rint(width / 2))
end

Dendogram(head, args...; kwargs...) = Dendogram(head, collect(args); kwargs...)

"""
    Dendogram(e::Expr; pretitle=nothing)

Create a Dendogram representation for an `Expr`. 
For expressions whose arguments are themselves `Expr` objects, dendograms
are created recursively. In the end all dendograms are linked using `link`
to create a single dendogram object (possibly nested).

`pretitle` is used to create dendograms for `Expr`, pretitle is insrted as 
three `Segment`s (a string and an upward arrow) before the head of the dendogram.
"""
function Dendogram(e::Expr; pretitle = nothing)
    length(e.args) == 1 && return Dendogram(e.head, e.args)

    # if there's no more nested expressions, return a dendogram
    !any(isa.(e.args[2:end], Expr)) && return Dendogram(
        e.head,
        e.args[2:end];
        first_arg = e.args[1],
        pretitle = replace(string(e), ' ' => ""),
    )

    # recursively get leaves, creating dendograms for sub expressions
    leaves = map(
        arg -> if arg isa Expr
            Dendogram(arg; pretitle = replace(string(arg), ' ' => ""))
        else
            Leaf(arg)
        end,
        length(e.args) > 2 ? e.args[2:end] : e.args,
    )

    # make dendogram by linking individual elements
    title = apply_style(
        "$(e.head): {bold underline default $(TERM_THEME[].dendo_title)}$(e.args[1]){/bold underline default $(TERM_THEME[].dendo_title)}",
        TERM_THEME[].dendo_title,
    )
    return link(leaves...; title = title, shifttitle = true, pretitle = pretitle)
end

# ---------------------------------------------------------------------------- #
#                                     LINK                                     #
# ---------------------------------------------------------------------------- #
"""
    link(dendos...; title="", shifttitle=false, pretitle=nothing)::Dendogram

Link a variable number of `Dendogram` and `Leaf` objects in a new `Dendogram`.

Create a `Dendogram` whose leaves are other leaves and dendograms. 
This is done carefully to ensure that all spacings are correct and text
is aligned as much as possible. 

Annoyingly, the code is very similar to that of `Dendogram` but different enough
that it can't be refactored into single functions.
"""
function link(dendos...; title = "", shifttitle = false, pretitle = nothing)::Dendogram
    # get the widths, spacing between branching points of the dendogram's line
    length(dendos) == 1 && return dendos[1]

    if length(dendos) > 2
        widths = collect(
            map(
                d -> if d[1] == 1
                    d[2].measure.w - 1
                else
                    d[2].measure.w + adjust_width(dendos[d[1] - 1], d[2]) - 1
                end,
                enumerate(dendos),
            ),
        )[2:end]
    else
        d1, d2 = dendos
        widths = (d1.measure.w - d1.midpoint) + d2.midpoint
    end

    # get elements of linking line
    line = get_row(BOXES[:SQUARE], widths, :top)
    line, midpoint = replace_line_midpoint(line; widths = widths .+ 1)
    LINES_STYLE = TERM_THEME[].dendo_lines
    TITLE_STYLE = TERM_THEME[].dendo_title

    title = if shifttitle
        pad(apply_style(title, TITLE_STYLE * " dim"), textwidth(line) - 5, :center) * " "^5
    else
        pad(apply_style(title, TITLE_STYLE), textwidth(line), :center)
    end
    space = " "^(dendos[1].midpoint)

    # ensure all elements have the right width
    width = sum(map(d -> d.measure.w, dendos)) - length(space)
    line = pad(line, width, :left)
    title = pad(title, width, :left)

    # create dendogram's segments
    segments = Segment[
        Segment(space * title),
        Segment(space * line, LINES_STYLE),
        *(dendos...).segments...,
    ]

    # add 'pretitle' lines (for expressions only)
    if !isnothing(pretitle)
        pretitle = str_trunc(pretitle, CELLWIDTH)
        l(txt) = fint(midpoint - textwidth(txt) / 2) + length(space)
        r(txt) = cint((width - midpoint - textwidth(txt) / 2))
        prepend!(
            segments,
            [
                Segment(
                    " "^l(pretitle) * pretitle * " "^r(pretitle),
                    TERM_THEME[].dendo_pretitle,
                ),
                Segment(" "^l("⋀") * "⋀" * " "^r("⋀"), "$LINES_STYLE bold"),
                Segment(
                    " "^l(BOXES[:SQUARE].bottom.vertical) *
                    BOXES[:SQUARE].bottom.vertical *
                    " "^r(BOXES[:SQUARE].bottom.vertical),
                    "$LINES_STYLE dim",
                ),
            ],
        )
    end

    return Dendogram(segments, Measure(segments), midpoint + length(space))
end

# ----------------------------------- utils ---------------------------------- #

"""
    adjust_width(x, y)::Int

Width correction factor.

When creating a link between dendograms, the width of the spacing
between branches of the dendogram line needs to be adjusted
depending on the type (`Leaf` or `Dendogram`) of the line.
"""
function adjust_width(x, y)::Int
    _x, _y = typeof(x), typeof(y)
    _x == _y && return 0
    _x == Dendogram && return y.midpoint
    return -x.midpoint
end

"""
    replace_line_midpoint(line::String; widths=nothing)

Replace the mid character of a dendogram tree line with a vertical line for the title.

If the mid character is also the location of a branch (one of the entries in `widths`),
then use the appropriate double branching character.
"""
function replace_line_midpoint(line::String; widths = nothing)
    w1 = prevind(line, rint(ncodeunits(line) / 2) - 1)
    w2 = nextind(line, rint(ncodeunits(line) / 2) + 1)

    char = BOXES[:SQUARE].bottom.vertical
    isnothing(widths) ||
        (textwidth(line[1:w1]) in widths && (char = BOXES[:SQUARE].row.vertical))
    line = line[1:w1] * char * line[w2:end]
    return line, length(line[1:w1])
end

end

using Term.Annotations
import Term: highlight_syntax, TERM_THEME, Panel

@testset "Annotations" begin
    ann = Annotation(
        highlight_syntax("Panel(content; fit=true)"),
        "Panel" => ("this is the struct constructor call", TERM_THEME[].func),
        "content" => ("here you put what goes inside the panel", "white"),
        "fit=true" => (
            "Setting this as `true` adjusts the panel's width to fit `content`. Otherwise `Panel` will have a fixed width",
            "blue_light",
        ),
    )
    IS_WIN || @compare_to_string(ann, "annotations_1")

    ann = Annotation(
        "This is an example of an annotation to display nicely some info",
        "example" => "very simple but important, pay attention!",
        "annotation" => ("is it \nhelpful?", "blue"),
        "some info" => ("hopefully useful", "italic green"),
    )
    IS_WIN || @compare_to_string(ann, "annotations_2")

    ann = Annotation(
        "{red}This is an example of an annotation to {bold}display{/bold} nicely some info{/red}",
        "example" => "very simple but important, pay attention!",
        "annotation" => ("is it \nhelpful?", "blue"),
        "some info" => ("hopefully useful", "italic green"),
    )
    IS_WIN || @compare_to_string(ann, "annotations_3")

    ann = Annotation(
        "{white}This is an example of an annotation to {bold}display{/bold} nicely some info{/white}",
        "some info" => ("hopefully useful", "italic green"),
        "example" => "very simple but important, pay attention!",
        "annotation" => (
            "is it helpful? This is a very long message to check that everything is working {red}correctly{/red}",
            "default",
        ),
    )
    IS_WIN || @compare_to_string(ann, "annotations_4")

    ann = Annotation(
        "{bold italic}this{/bold italic} has some style",
        "style" => (
            "style means {bright_blue}color{/bright_blue} or stuff like {bold}bold{/bold}",
            "bold red",
        ),
    )
    IS_WIN || @compare_to_string(ann, "annotations_5")

    code = highlight_syntax("Annotation(\"main text\", \"main\"=>\"most important\")")
    ann = Panel(
        Annotation(
            code,
            "\"main text\"" => "main message to be annotated",
            "\"main\"=>\"most important\"" => "annotation",
        );
        padding = (4, 4, 2, 1),
        title = "Annotation: usage",
        fit = true,
        title_style = "default green bold",
        title_justify = :center,
        style = "green dim",
    )
    IS_WIN || @compare_to_string(ann, "annotations_6")

    TERM_THEME[].annotation_color = "white"
    txt = """Annotation("main text", "this"=>"annotation: extra info", "main text"=>("with style", "green"))"""
    @test_throws AssertionError Annotation(
        highlight_syntax(txt),
        "Annotation" => "constructor",
        "main text" => "text to be annotated",
        "\"this\"=>\"annotation: extra info\"" => "simple annotation, no style",
        """"main text"=>("with style", "green"))""" => "annotation with extra style info",
    )
    # IS_WIN || @compare_to_string(ann, "annotations_7")

    # ann = Annotation(
    #     highlight_syntax(txt),
    #     "Annotation" => "contructor",
    #     "main text" => "text to be annotated.\nSubstrings of this will be annotated with extra info.",
    #     "\"this\"=>\"annotation: extra info\"" => "simple annotation, no style",
    #     """"main text"=>("with style", "green"))""" => "annotation with extra style info",
    # )
    # IS_WIN || @compare_to_string(ann, "annotations_8")

    # ex = "\"to annotate\"=>(\"annotation message\", \"red\")"
    # ann = Annotation(
    #     highlight_syntax(txt),
    #     "Annotation" => ("contructor", TERM_THEME[].func),
    #     "main text" => "text to be annotated.\nSubstrings of this will be annotated with extra info.",
    #     "\"this\"=>\"annotation: extra info\"" => "simple annotation, no style. Just passed as a `Pair`",
    #     """"main text"=>("with style", "green"))""" => (
    #         "annotation with extra style info: use a `Tuple` to specify both the annotation's message and additional style info. For example:\n\n $(highlight_syntax(ex))",
    #         "bright_green",
    #     ),
    # )
    # IS_WIN || @compare_to_string(ann, "annotations_9")
end

using Term
using Term.Annotations
import Term: highlight_syntax, TERM_THEME

Annotation(
    highlight_syntax("Panel(content; fit=true)"),
    "Panel" => ("this is the struct constructor call", TERM_THEME[].func),
    "content" => ("here you put what goes inside the panel", "white"),
    "fit=true" => (
        "Setting this as `true` adjusts the panel's width to fit `content`. Otherwise `Panel` will have a fixed width",
        "bright_blue",
    ),
) |> print

txt = """Annotation("main text", "this"=>"annotation: extra info", "main text"=>("with style", "green"))"""
ex = "\"to annotate\"=>(\"annotation message\", \"red\")"
ann = Annotation(
    highlight_syntax(txt),
    "Annotation" => ("constructor", TERM_THEME[].func),
    "main text" => "text to be annotated.\nSubstrings of this will be annotated with extra info.",
    "\"this\"=>\"annotation: extra info\"" => "simple annotation, no style. Just passed as a `Pair`",
    """"main text"=>("with style", "green"))""" => (
        "{white}annotation with extra style info: use a {red}`Tuple` to specify both the annotation's{/red} message and additional style info.{/white} For example:\n\n $(highlight_syntax(ex))",
        "bright_green",
    ),
)

@testset "\e[34mEXAMPLES" begin
    println("\nTesting examples, stdout temporarily disabled")
    @suppress_out begin
        include("../examples/custom_repr.jl")
        include("../examples/dendogram.jl")
        include("../examples/markdown_rendering.jl")
        include("../examples/tree.jl")
        include("../examples/tables.jl")
        include("../examples/text_panel.jl")
        include("../examples/text_style.jl")
    end
end

using Term
import Term.Progress: ProgressBar, start!, update!, stop!, with, @track, addjob!, render
import Term.Consoles: clear

tprint(hLine("progress bars"; style = "blue"))

"""
This example shows how to create progress bars visualizations in Term.

Progress bars in Term can handle multiple simultaneous tasks ('jobs') 
whose progress we can monitor (think of nested for loops). The
basic workflow involves creating a progress bars, adding jobs
and updating them to update the visual display

"""

pbar = ProgressBar()
job = addjob!(pbar; N = 100)
start!(pbar)
for i in 1:100
    update!(job)
    sleep(0.01)
    i % 25 == 0 && println("We can print from here too")
    render(pbar)
    # LiveDisplays.refresh!(pbar)
end
stop!(pbar)

"""
Or with multiple jobs
"""

pbar = ProgressBar(transient = true)
job = addjob!(pbar; N = 100)
job2 = addjob!(pbar; N = 50)
job3 = addjob!(pbar; N = 25)

start!(pbar)
for i in 1:100
    update!(job)
    i % 2 == 0 && update!(job2)
    i % 3 == 0 && update!(job3)
    sleep(0.01)
    render(pbar)
end
stop!(pbar)

"""
As you can see, the progress bar display stays as the bottom while the text is printed above.
To make that happen Term needs to mess around with your terminal, calling
`stop!` ensures that the normal terminal behavior is restored. If you
don't call `stop!` (e.g. because your code gave an error), then the 
terminal is not correctly restored. To avoid that we can use `with(pbar)`, this
will ensure that the progress bar is correctly stopped no matter what happens.

"""

pbar = ProgressBar(; expand = true)
job = addjob!(pbar; N = 100)

with(pbar) do
    for i in 1:100
        update!(job)
        sleep(0.01)
        i % 25 == 0 && println("We can print from here too")
    end
end

"""
As you can see, we don't need to call `start!` and `stop!` any more, `with` takes
care of that (even if there's an error in the loop).

Also, you might have noticed that `expand=true` makes the progress bar expand
to fill in all the available space. An alternative is to set the `width` value.

In addition to `width`, you can also use a convenient macro called @track
to wrap any loop with a progress bar display.
"""

@track for i in 1:100
    sleep(0.01)
end

"""
You can customize what kind of information should show in your progress bar and what it 
should look like. Each bit of information (the text, the percentage count...) is a 
"column" and you can choose which columns to display and in which order:
"""

for details in (:minimal, :default, :detailed)
    pbar = ProgressBar(; columns = details, width = 140)
    with(pbar) do
        job = addjob!(pbar; N = 100)
        for i in 1:100
            update!(job)
            sleep(0.02)
        end
    end
end

"""
Or you can create your choice of columns
"""

import Term.Progress: CompletedColumn, SeparatorColumn, ProgressColumn, DescriptionColumn

mycols = [DescriptionColumn, CompletedColumn, SeparatorColumn, ProgressColumn]
cols_kwargs = Dict(:DescriptionColumn => Dict(:style => "red bold"))

pbar = ProgressBar(; columns = mycols, columns_kwargs = cols_kwargs, width = 140)
with(pbar) do
    job = addjob!(pbar; N = 100)
    for i in 1:100
        update!(job)
        sleep(0.02)
    end
end

"""
As you can see you can use `cols_kwargs` to pass additional info to each column.

Sometimes you are not sure how many iterations your loop should run for.
In that case you can use spinners!
"""

import Term.Progress: SPINNERS

for spinner in keys(SPINNERS)
    columns_kwargs = Dict(
        :SpinnerColumn => Dict(:spinnertype => spinner, :style => "bold green"),
        :CompletedColumn => Dict(:style => "dim"),
    )

    pbar = ProgressBar(; columns = :spinner, columns_kwargs = columns_kwargs)
    with(pbar) do
        job = addjob!(pbar; description = "{orange1}$spinner...")
        for i in 1:250
            update!(job)
            sleep(0.0025)
        end
    end
end

"""
You can make your own column too! You just need to define a type and an update! method for them

"""

using Random

using Term.Progress
import Term.Progress:
    AbstractColumn, DescriptionColumn, CompletedColumn, SeparatorColumn, ProgressColumn
import Term.Segments: Segment
import Term.Measures: Measure

struct RandomColumn <: AbstractColumn
    job::ProgressJob
    segments::Vector{Segment}
    measure::Measure
    style::String

    function RandomColumn(job::ProgressJob; style = "red")
        txt = Segment(randstring(6), style)
        return new(job, [txt], txt.measure, style)
    end
end

function Progress.update!(col::RandomColumn, color::String, args...)::String
    txt = Segment(randstring(6), col.style)
    return txt.text
end

mycols = [DescriptionColumn, CompletedColumn, SeparatorColumn, ProgressColumn, RandomColumn]
cols_kwargs = Dict(:RandomColumn => Dict(:style => "green bold"))

pbar = ProgressBar(; columns = mycols, columns_kwargs = cols_kwargs, width = 140)
with(pbar) do
    job = addjob!(pbar; N = 100)
    for i in 1:100
        update!(job)
        sleep(0.02)
    end
end

"""
This is an example of how to use a progress bar to show file
downloading/loading progress.
"""

import Term.Progress: SeparatorColumn, ProgressColumn, DescriptionColumn, DownloadedColumn

FILESIZE = 2342341
CHUNK = 2048
nsteps = Int64(ceil(FILESIZE / CHUNK))

mycols = [DescriptionColumn, SeparatorColumn, ProgressColumn, DownloadedColumn]

pbar = ProgressBar(; columns = mycols, width = 140)
job = addjob!(pbar; N = FILESIZE)

with(pbar) do
    for i in 1:nsteps
        update!(job; i = CHUNK)
        sleep(0.001)
    end
end

# ------------------------------- constructors ------------------------------- #
"""
A `Pager` is a widget for visualizing long texts a few lines at the time. 
It shows a few lines of a longer text and allows users to move up and down the text
using keys such as arrow up and arrow down.
"""
@with_repr mutable struct Pager <: AbstractWidget
    internals::WidgetInternals
    controls::AbstractDict
    text::AbstractString
    content::Vector{String}
    title::Union{Nothing,String}
    line_numbers::Bool
    tot_lines::Int
    curr_line::Int
    page_lines::Int
end

# --------------------------------- controls --------------------------------- #
"""
move to the next line
"""
next_line(p::Pager, ::Union{Char,ArrowDown}) =
    p.curr_line = min(p.tot_lines - p.page_lines, p.curr_line + 1)

"""
move to the previous line
"""
prev_line(p::Pager, ::Union{Char,ArrowUp}) = p.curr_line = max(1, p.curr_line - 1)

"""
move to the next page
"""
next_page(p::Pager, ::Union{PageDownKey,ArrowRight,Char}) =
    p.curr_line = min(p.tot_lines - p.page_lines, p.curr_line + p.page_lines)

"""
move to the previous page
"""
prev_page(p::Pager, ::Union{PageUpKey,ArrowLeft,Char}) =
    p.curr_line = max(1, p.curr_line - p.page_lines)

"""
move to first line
"""
home(p::Pager, ::HomeKey) = p.curr_line = 1

"""
move to the last line
"""
toend(p::Pager, ::EndKey) = p.curr_line = p.tot_lines - p.page_lines

pager_controls = Dict(
    ArrowRight() => next_page,
    ']' => next_page,
    ArrowLeft() => prev_page,
    '[' => prev_page,
    ArrowDown() => next_line,
    '.' => next_line,
    ArrowUp() => prev_line,
    ',' => prev_line,
    HomeKey() => home,
    EndKey() => toend,
    Esc() => quit,
    'q' => quit,
)

"""
    reshape_pager_content(content::AbstractString, line_numbers::Bool)::Vector{string}

Turns a text into a vector of lines with the right size (and optionally line numbers)
"""
function reshape_pager_content(
    content::AbstractString,
    line_numbers::Bool,
    width::Int,
)::Vector{String}
    reshaped_content = if line_numbers == true
        join(
            map(iln -> "{dim}$(iln[1])  {/dim}" * iln[2], enumerate(split(content, "\n"))),
            "\n",
        )
    else
        content
    end

    reshaped_content = reshape_code_string(content, width - 6)
    return split(string(RenderableText(reshaped_content; width = width - 6)), "\n")
    # return split(reshaped_content, "\n")

end

function Pager(
    text::String;
    controls::AbstractDict = pager_controls,
    height = 30,
    width = console_width(),
    title::Union{Nothing,String} = nothing,
    line_numbers::Bool = false,
    on_draw::Union{Nothing,Function} = nothing,
    on_activated::Function = on_activated,
    on_deactivated::Function = on_deactivated,
)
    content = reshape_pager_content(text, line_numbers, width)
    return Pager(
        WidgetInternals(
            Measure(height, width),
            nothing,
            on_draw,
            on_activated,
            on_deactivated,
            false,
        ),
        controls,
        text,
        content,
        title,
        line_numbers,
        length(content),
        1,
        max(height - 5, 1),
    )
end

function on_layout_change(p::Pager, m::Measure)
    p.page_lines = max(m.h - 5, 1)
    p.content = reshape_pager_content(p.text, p.line_numbers, m.w)
    p.tot_lines = length(p.content)
    p.curr_line = min(p.curr_line, p.tot_lines - p.page_lines)
    p.internals.measure = m
end

# ---------------------------------- frame  ---------------------------------- #

"""
    make_page_content(pager::Pager, i::Int, Δi::Int)::String

Returns the content of the page as a string
"""
function make_page_content(pager, i, Δi)
    if Δi >= pager.tot_lines
        return join(pager.content, "\n")
    else
        return join(pager.content[i:min(pager.tot_lines, i + Δi)], "\n")
    end
end

"""
    make_scrollbar(pager::Pager, i::Int, Δi::Int)::String

Generate a scrollbar display to show progress in the pager's content.
"""
function make_scrollbar(pager, i, Δi)
    page_lines = pager.page_lines
    scrollbar_lines = min(pager.page_lines, 6)
    scrollbar_lines_half = scrollbar_lines // 2
    scrollbar = vLine(scrollbar_lines; style = "white on_white")

    p = (i) / (pager.tot_lines - Δi)  # progress in the file
    scrollbar_center = p * (page_lines) |> round |> Int
    nspaces_above = max(0, scrollbar_center - scrollbar_lines_half) |> round |> Int
    nspaces_below = max(0, page_lines - scrollbar_lines - nspaces_above) |> round |> Int

    if nspaces_above == 0
        below =
            RenderableText(join(repeat([" \n"], nspaces_below + 1)); style = "on_gray23")
        return scrollbar / below
    elseif nspaces_below == 0
        above =
            RenderableText(join(repeat([" \n"], nspaces_above + 1)); style = "on_gray23")
        return above / scrollbar
    else
        above = RenderableText(join(repeat([" \n"], nspaces_above)); style = "on_gray23")
        below = RenderableText(join(repeat([" \n"], nspaces_below)); style = "on_gray23")
        return above / scrollbar / below
    end
end

function make_page(pager, i, Δi)
    page_content = make_page_content(pager, i, Δi)
    scrollbar = make_scrollbar(pager, i, Δi)
    return page_content * scrollbar
end

"""
    frame(pager::Pager)::AbstractRenderable

Create a Panel with, as content, the currently visualized lines in the Pager.
"""
function frame(pager::Pager; omit_panel = false)::AbstractRenderable
    isnothing(pager.internals.on_draw) || pager.internals.on_draw(pager)

    i, Δi = pager.curr_line, pager.page_lines
    page = make_page(pager, i, Δi)

    style = isactive(pager) ? pink : "blue dim"

    # return content
    omit_panel && return "  " * RenderableText(page)
    return Panel(
        page,
        fit = false,
        width = pager.internals.measure.w,
        height = pager.internals.measure.h,
        padding = (2, 0, 1, 0),
        subtitle = "Lines: $(max(1, i)):$(min(i+Δi, pager.tot_lines)) of $(pager.tot_lines)",
        subtitle_style = "bold dim",
        subtitle_justify = :right,
        style = style,
        title = pager.title,
        title_style = "bold white",
    )
end

module Boxes

import Term: rint, chars, join_lines, loop_last, textlen, get_lr_widths, str_trunc

import ..Style: apply_style
import ..Segments: Segment

export get_row, get_title_row
export BOXES

# ---------------------------------------------------------------------------- #
#                                      BOX                                     #
# ---------------------------------------------------------------------------- #
"""
  BoxLine

Stores the characters for a line of a `Box` object.
"""
struct BoxLine
    left::Char
    mid::Char
    vertical::Char
    right::Char
end

"""
  Box

Defines characters to render boxes.

Row names:

┌─┬┐ top
│ ││ head
├─┼┤ head_row
│ ││ mid
├─┼┤ row
├─┼┤ foot_row
│ ││ foot
└─┴┘ bottom

each row is an instance of `BoxLine`
"""
struct Box
    name::String
    top::BoxLine
    head::BoxLine
    head_row::BoxLine
    mid::BoxLine
    row::BoxLine
    foot_row::BoxLine
    foot::BoxLine
    bottom::BoxLine
end

"""
    Box(string)

Construct a `Box` objet out of a box string.
"""
function Box(box_name::String, box::String)
    top, head, head_row, mid, row, foot_row, foot, bottom = split(box, "\n")
    return Box(
        box_name,
        BoxLine(chars(top)...),
        BoxLine(chars(head)...),
        BoxLine(chars(head_row)...),
        BoxLine(chars(mid)...),
        BoxLine(chars(row)...),
        BoxLine(chars(foot_row)...),
        BoxLine(chars(foot)...),
        BoxLine(chars(bottom)...),
    )
end

function Base.show(io::IO, box::Box)
    if io ≡ stdout
        print(io, "Box ($(box.name))\n$(fit(box, [1, 3, 1]))")
    else
        print(io, "Box\e[2m($(box.name))\e[0m")
    end
end

"""
    get_row(box, [1, 2, 3], :row)

Gets characters for a row of a Box object.

The level Symbol can be used to specify the box level (:top, :footer...).
The total width will be the sum of the widths +2
"""
function get_row(box::Box, widths::Vector{Int}, level::Symbol)::String
    # get the correct level of the box
    level = getfield(box, level)

    line = level.left
    for (last, w) in loop_last(widths)
        segment = last ? level.mid^w * level.right : level.mid^w * level.vertical
        line *= segment
    end
    return line
end

"""
    get_row(box::Box, width::Int, level::Symbol)::String

Get a box's row of given width.
"""
function get_row(box::Box, width::Int, level::Symbol)::String
    level = getfield(box, level)
    return level.left * level.mid^(width - 2) * level.right
end

"""
    get_lrow(box::Box, width::Int, level::Symbol)::String

Get a box's row's left part (no righ char)

Get a box's row's right part (no left char)
See also [`get_row`](@ref), [`get_rrow`](@ref).
"""
function get_lrow(box::Box, width::Int, level::Symbol; with_left = true)::String
    level = getfield(box, level)
    return if with_left
        level.left * level.mid^(width - 1)
    else
        level.mid^(width - 1)
    end
end

"""
get_rrow(box::Box, width::Int, level::Symbol)::String

Get a box's row's right part (no left char)
See also [`get_row`](@ref), [`get_lrow`](@ref).
"""
function get_rrow(box::Box, width::Int, level::Symbol; with_right = true)::String
    level = getfield(box, level)
    return if with_right
        level.mid^(width - 1) * level.right
    else
        level.mid^(width - 1)
    end
end

"""
  get_title_row(row::Symbol, box::Box, title::Union{Nothing, AbstractString}; <keyword arguments>)

Create a box row with a title string.

Can create both titles in the top and bottom row to produce subtitles.

#Arguments:
- width::Int: width of line
- style::String: style of line
- title_style::String: style of title string
- justify::Symbol=:left: position of title string

See also [`get_row`](@ref).
"""
function get_title_row(
    row::Symbol,
    box,  # ::Box,
    title::Union{Nothing,String};
    width::Int = default_width(),
    style::String = "default",
    title_style::Union{Nothing,String} = nothing,
    justify::Symbol = :left,
)::Segment

    # if no title or no space, just return a row
    if isnothing(title) || width < 12
        return Segment("\e[0m{$style}" * get_row(box, width, row) * "{/$(style)}\e[0m")
    else
        title = apply_style(title)
        title =
            (textlen(title) < width - 12 || textlen(title) <= 4) ? title :
            str_trunc(title, max(1, width - 15))
    end

    # compose title line 
    boxline = getfield(box, row)

    open, close, space = "{" * style * "}", "{/" * style * "}\e[0m", " "

    topen, tclose = "\e[0m", open
    if !isnothing(title_style)
        topen, tclose = if style == "hidden"
            "\e[28m" * "{" * title_style * "}", "{/" * title_style * "}" * open * "\e[8m"
        else
            "{" * title_style * "}", "{/" * title_style * "}" * open
        end
    end

    # get the title
    title = space * topen * title * tclose * space

    # only add the title if the box is wide enough
    if width < 6
        line = open * boxline.left * boxline.mid^(width - 2) * boxline.right * close
    else
        # close the box
        if justify ≡ :left
            line = open * boxline.left * boxline.mid^4 * title

            # check if the title is too long
            if width - textlen(line) - 1 < 1
                line = open * boxline.left * boxline.mid^2 * title
            end

            line *= boxline.mid^(max(1, width - textlen(line) - 1)) * boxline.right * close
        elseif justify ≡ :right
            pre_len = width - textlen(title) - 4
            line = open * get_lrow(box, pre_len, row)
            line *= title * boxline.mid^3 * boxline.right * close
        else  # justify :center
            tl, tr = get_lr_widths(textlen(title))
            lw, rw = get_lr_widths(width)
            line =
                open *
                get_lrow(box, lw - tl, row) *
                title *
                get_rrow(box, rw - tr, row) *
                close
            return Segment(line)
        end
    end
    return Segment(line)
end

"""
  fit(box::Box, widths::Vector{Int})::String

Creates a box.

The box has one of each level type with columns
widths specified by a vector of widhts.
"""
fit(box::Box, widths::Vector{Int}) = join_lines([
    get_row(box, widths, :top),
    get_row(box, widths, :head),
    get_row(box, widths, :head_row),
    get_row(box, widths, :mid),
    get_row(box, widths, :row),
    get_row(box, widths, :foot_row),
    get_row(box, widths, :foot),
    get_row(box, widths, :bottom),
])

# ---------------------------------------------------------------------------- #
#                                   Box types                                  #
# ---------------------------------------------------------------------------- #

const BOXES = (
    NONE = Box(
        "NONE",
        """
            
            
            
            
            
            
            
            
        """,
    ),
    ASCII = Box(
        "ASCII",
        """
        +--+
        | ||
        |-+|
        | ||
        |-+|
        |-+|
        | ||
        +--+
        """,
    ),
    ASCII2 = Box(
        "ASCII2",
        """
        +-++
        | ||
        +-++
        | ||
        +-++
        +-++
        | ||
        +-++
        """,
    ),
    ASCII_DOUBLE_HEAD = Box(
        "ASCII_DOUBLE_HEAD",
        """
        +-++
        | ||
        +=++
        | ||
        +-++
        +-++
        | ||
        +-++
        """,
    ),
    SQUARE = Box(
        "SQUARE",
        """
        ┌─┬┐
        │ ││
        ├─┼┤
        │ ││
        ├─┼┤
        ├─┼┤
        │ ││
        └─┴┘
        """,
    ),
    SQUARE_DOUBLE_HEAD = Box(
        "SQUARE_DOUBLE_HEAD",
        """
        ┌─┬┐
        │ ││
        ╞═╪╡
        │ ││
        ├─┼┤
        ├─┼┤
        │ ││
        └─┴┘
        """,
    ),
    MINIMAL = Box(
        "MINIMAL",
        """
          ╷ 
          │ 
        ╶─┼╴
          │ 
        ╶─┼╴
        ╶─┼╴
          │ 
          ╵ 
        """,
    ),
    MINIMAL_HEAVY_HEAD = Box(
        "MINIMAL_HEAVY_HEAD",
        """
          ╷ 
          │ 
        ╺━┿╸
          │ 
        ╶─┼╴
        ╶─┼╴
          │ 
          ╵ 
        """,
    ),
    MINIMAL_DOUBLE_HEAD = Box(
        "MINIMAL_DOUBLE_HEAD",
        """
          ╷ 
          │ 
         ═╪ 
          │ 
         ─┼ 
         ─┼ 
          │ 
          ╵ 
        """,
    ),
    SIMPLE = Box(
        "SIMPLE",
        """
            
            
         ── 
            
            
         ── 
            
            
        """,
    ),
    SIMPLE_HEAD = Box(
        "SIMPLE_HEAD",
        """
            
            
         ── 
            
            
            
            
            
        """,
    ),
    SIMPLE_HEAVY = Box(
        "SIMPLE_HEAVY",
        """
            
            
         ━━ 
            
            
         ━━ 
            
            
        """,
    ),
    HORIZONTALS = Box(
        "HORIZONTALS",
        """
         ── 
            
         ── 
            
         ── 
         ── 
            
         ── 
        """,
    ),
    ROUNDED = Box(
        "ROUNDED",
        """
        ╭─┬╮
        │ ││
        ├─┼┤
        │ ││
        ├─┼┤
        ├─┼┤
        │ ││
        ╰─┴╯
        """,
    ),
    HEAVY = Box(
        "HEAVY",
        """
        ┏━┳┓
        ┃ ┃┃
        ┣━╋┫
        ┃ ┃┃
        ┣━╋┫
        ┣━╋┫
        ┃ ┃┃
        ┗━┻┛
        """,
    ),
    HEAVY_EDGE = Box(
        "HEAVY_EDGE",
        """
        ┏━┯┓
        ┃ │┃
        ┠─┼┨
        ┃ │┃
        ┠─┼┨
        ┠─┼┨
        ┃ │┃
        ┗━┷┛
        """,
    ),
    HEAVY_HEAD = Box(
        "HEAVY_HEAD",
        """
        ┏━┳┓
        ┃ ┃┃
        ┡━╇┩
        │ ││
        ├─┼┤
        ├─┼┤
        │ ││
        └─┴┘
        """,
    ),
    DOUBLE = Box(
        "DOUBLE",
        """
        ╔═╦╗
        ║ ║║
        ╠═╬╣
        ║ ║║
        ╠═╬╣
        ╠═╬╣
        ║ ║║
        ╚═╩╝
        """,
    ),
    DOUBLE_EDGE = Box(
        "DOUBLE_EDGE",
        """
        ╔═╤╗
        ║ │║
        ╟─┼╢
        ║ │║
        ╟─┼╢
        ╟─┼╢
        ║ │║
        ╚═╧╝
        """,
    ),
)

end

import Term.Dendograms: link, Dendogram

@testset "DENDOGRAM" begin
    mydendo = Dendogram("awesome", "this", :is, "a", "dendogram!")
    otherdendo = Dendogram("head", "these", "are", "colorful", "leaves")
    smalldendo = Dendogram("head", [1, 2])

    IS_WIN || begin
        @compare_to_string(mydendo, "dendogram_1")
    end

    large = link(mydendo, otherdendo; title = "{red}superdendo{/red}")
    IS_WIN || begin
        @compare_to_string(large, "dendogram_2")
    end

    nested = link(
        smalldendo,
        link(
            smalldendo,
            link(smalldendo, smalldendo; title = "a level");
            title = "another level",
        );
        title = "first level",
    )
    IS_WIN || begin
        @compare_to_string(nested, "dendogram_3")
    end

    D = link(mydendo, mydendo, mydendo)
    @test D.measure.w == 150
end

import Base: rpad as brpad

"""
    reshape_text(text::AbstractString, width::Int)

Reshape a text to have a given width. 

Insert newline characters in a string so that each line is within the given width.
"""
function reshape_text(text::AbstractString, width::Int; ignore_markup::Bool = false)
    occursin('\n', text) && (
        return do_by_line(
            ln -> reshape_text(ln, width::Int; ignore_markup = ignore_markup),
            text,
        )
    )
    textlen(text) ≤ width && return text

    lines = []
    line, line_length = "", 0
    bracketed = false
    in_escape_code = false
    for c in text
        # check if we are entering a special context
        if c == '\e'
            in_escape_code = true
        end
        if c == '{' && !ignore_markup
            bracketed = true
        end

        line *= c

        # see if we need to go to a new line
        if !bracketed && !in_escape_code
            line_length += textwidth(c)

            if line_length + 1 > width
                push!(lines, rstrip(line))
                line, line_length = "", 0
            elseif (line_length + 1 > width - 5) && (c == ' ')
                push!(lines, rstrip(line))
                line, line_length = "", 0
            end
        end

        # check if we are exiting from a special context
        if c == 'm' && in_escape_code
            in_escape_code = false
        end
        if c == '}'
            bracketed = false
        end
    end
    push!(lines, rstrip(line))

    out = join((fix_ansi_across_lines ∘ fix_markup_across_lines)(lines), "\n")
    chomp(out)
end

"""
    justify(text::AbstractString, width::Int)::String

Justify a piece of text spreading out text to fill in a given width.
"""
function justify(text::AbstractString, width::Int)::String
    returnfn(text) = text * ' '^(width - textlen(text))

    occursin('\n', text) && (return do_by_line(ln -> justify(ln, width), text))

    # cleanup text
    text = strip(text)
    text = endswith(text, "\e[0m") ? text[1:(end - 4)] : text
    text = strip(text)
    n_spaces = width - textlen(text)
    (n_spaces < 2 || textlen(text) ≤ 0.5width) && (return returnfn(text))

    # get number of ' ' and their location in the string
    spaces_locs = map(m -> m[1], findall(" ", text))
    spaces_locs = length(spaces_locs) < 2 ? spaces_locs : spaces_locs[1:(end - 1)]
    n_locs = length(spaces_locs)
    n_locs < 1 && (return returnfn(text))
    space_per_loc = div(n_spaces, n_locs)
    space_per_loc == 0 && (return returnfn(text))

    inserted = 0
    for (last, loc) in loop_last(spaces_locs)
        n_to_insert = last ? width - textlen(text) : space_per_loc
        to_insert = " "^n_to_insert
        text = replace_text(text, loc + inserted, loc + inserted, to_insert)
        inserted += n_to_insert
    end
    return returnfn(text)
end

"""
    text_to_width(text::AbstractString, width::Int)::String

Cast a text to have a given width by reshaping, it and padding.
It includes an option to justify the text (:left, :right, :center, :justify).
"""
function text_to_width(
    text::AbstractString,
    width::Int,
    justify::Symbol;
    background::Union{String,Nothing} = nothing,
)::String
    # reshape text
    if Measure(text).w > width
        text = reshape_text(text, width - 1)
    end
    return pad(text, width, justify, bg = background)
end

# ---------------------------------------------------------------------------- #
#                                APP  INTERNALS                                #
# ---------------------------------------------------------------------------- #
"""
struct AppInternals
    iob::IOBuffer
    ioc::IOContext
    term::AbstractTerminal
    prevcontent::Union{Nothing, AbstractRenderable, String}
    prevcontentlines::Vector{String}
    raw_mode_enabled::Bool
    last_update::Union{Nothing, Int}
    refresh_Δt::Int
    help_shown::Bool
end

`AppInternals` handles "under the hood" work for live widgets. 
It takes care of keeping track of information such as the content
displayed at the last refresh of the widget to inform the printing
of the widget's content at the next refresh.

AppInternals also holds linked_widgets which can be used to link to 
other widgets to access their internal variables.
"""
@with_repr mutable struct AppInternals
    iob::IOBuffer
    ioc::IOContext
    term::AbstractTerminal
    prevcontent::Union{Nothing,AbstractRenderable}
    prevcontentlines::Vector{String}
    raw_mode_enabled::Bool
    last_update::Union{Nothing,Int}
    refresh_Δt::Int
    help_shown::Bool
    help_message::Union{Nothing,String}
    should_stop::Bool

    function AppInternals(;
        refresh_rate::Int = 60,
        help_message = nothing,
        suppress_output = false,
    )
        # get output buffers
        iob = IOBuffer()
        ioc = IOContext(iob, :displaysize => displaysize(stdout))

        # prepare terminal 
        raw_mode_enabled = try
            raw!(get_terminal(), true)
            true
        catch err
            suppress_output ||
                @warn "Unable to enter raw mode: " exception = (err, catch_backtrace())
            false
        end

        # hide the cursor
        raw_mode_enabled && print(get_terminal().out_stream, "\x1b[?25l")
        return new(
            iob,
            ioc,
            get_terminal(),
            nothing,
            String[],
            raw_mode_enabled,
            nothing,
            (Int ∘ round)(1000 / refresh_rate),
            false,
            help_message,
            false,
        )
    end
end

# ---------------------------------------------------------------------------- #
#                                      APP                                     #
# ---------------------------------------------------------------------------- #

# ------------------------------- CONSTRUCTORS ------------------------------- #
"""
An `App` is a collection of widgets.

!!! tip
    Transition rules bind keys to "movement" in the app to change
    focus to a different widget
"""
@with_repr mutable struct App <: AbstractWidgetContainer
    internals::AppInternals
    measure::Measure
    controls::AbstractDict
    parent::Union{Nothing,AbstractWidget}
    compositor::Compositor
    layout::Expr
    width::Int
    height::Int
    expand::Bool
    widgets::AbstractDict
    transition_rules::AbstractDict
    active::Symbol
    on_draw::Union{Nothing,Function}
    on_stop::Union{Nothing,Function}
end

isactive(::App) = true

"""
Execute a transition rule to switch focus to another widget.
"""
function execute_transition_rule(app::App, key)::Bool
    haskey(app.transition_rules, key) || return false
    rulesset = app.transition_rules[key]
    haskey(rulesset, app.active) || return false
    app.active = rulesset[app.active]
    return true
end

function quit(app::App)
    app.internals.should_stop = true
    return nothing
end

app_controls = Dict(
    'q' => quit,
    Esc() => quit,
    'h' => toggle_help,
    :setactive => execute_transition_rule,
)

"""
    App(
        widget::AbstractWidget;
        controls::AbstractDict = app_controls,
        width=1.0,
        height=min(40, console_height()),
        kwargs...
    )

Convenience constructor for an `App` with a single widget.
"""
function App(
    widget::AbstractWidget;
    controls::AbstractDict = app_controls,
    width = 1.0,
    height = min(40, console_height()),
    kwargs...,
)
    layout = :(A($height, $width))
    return App(
        layout;
        widgets = Dict{Symbol,AbstractWidget}(:A => widget),
        controls = controls,
        height = height,
        width = fint(width * console_width()),
        kwargs...,
    )
end

function App(
    layout::Expr;
    widgets::Union{Nothing,AbstractDict} = nothing,
    transition_rules::Union{Nothing,AbstractDict} = nothing,
    width = console_width(),
    height = min(40, console_height()),
    controls::AbstractDict = app_controls,
    on_draw::Union{Nothing,Function} = nothing,
    on_stop::Union{Nothing,Function} = nothing,
    expand::Bool = true,
    help_message::Union{Nothing,String} = nothing,
)

    # parse the layout expression and get the compositor
    compositor = Compositor(
        layout;
        max_w = min(console_width(), width),
        max_h = min(console_height(), height),
    )
    measure = render(compositor).measure

    # if widgets are not provided, create empty widgets placeholders
    widgets = if isnothing(widgets)
        make_placeholders(compositor)
    else
        widgets
    end

    # check that the layout and the widgets match
    layout_keys = compositor.elements |> keys |> collect
    widgets_keys = widgets |> keys |> collect
    @assert issetequal(layout_keys, widgets_keys) "Mismatch between widget names and layout names: $layout_keys vs $widgets_keys"

    on_activated(widgets[first(widgets_keys)])

    # enforce the size of each widget
    widgets = enforce_app_size(compositor, widgets)

    transition_rules =
        isnothing(transition_rules) ? infer_transition_rules(layout) : transition_rules

    msg_style = TERM_THEME[].emphasis
    app = App(
        AppInternals(; help_message = help_message),
        measure,
        controls,
        nothing,
        compositor,
        layout,
        width,
        height,
        expand,
        widgets,
        transition_rules,
        widgets_keys[1],
        on_draw,
        on_stop,
    )

    set_as_parent(app)
    return app
end

"""
    infer_transition_rules(layout::Expr)::Dict

If no transition rules are passed, infer them from the layout's
spatial relationships.
"""
function infer_transition_rules(layout::Expr)::Dict
    """ recursively get widgets in a  layout elements """
    function get_elements(elem::Expr)
        out = []
        for node in PreOrderDFS(elem)
            node isa Expr || continue
            node.args[1] ∉ (:*, :/) && push!(out, node.args[1])
        end
        return out
    end
    get_elements(x) = nothing

    transition_rules = Dict(
        ArrowRight() => Dict(),
        ArrowLeft() => Dict(),
        ArrowDown() => Dict(),
        ArrowUp() => Dict(),
    )

    for node in PreOrderDFS(layout)
        if node isa Expr
            op = node.args[1]
            op ∈ (:*, :/) || continue
            source = get_elements(node.args[2])
            dest = get_elements(node.args[3])

            # store commands to and from widgets
            first_key, second_key =
                op == :* ? (ArrowRight(), ArrowLeft()) : (ArrowDown(), ArrowUp())
            for w in source
                transition_rules[first_key][w] = dest[1]
            end
            for w in dest
                transition_rules[second_key][w] = source[1]
            end
        end
    end

    return transition_rules
end

"""
If no widget was passed, create placeholder widgets.
"""
function make_placeholders(compositor)
    elements = compositor.elements
    colors = if length(elements) > 1
        getfield.(Palette(blue, pink; N = length(elements)).colors, :string)
    else
        [pink]
    end

    ws = Dict()
    for (i, (name, elem)) in enumerate(pairs(elements))
        ws[name] = PlaceHolderWidget(elem.h, elem.w, string(name), colors[i])
    end
    return ws
end

"""
    enforce_app_size(compositor::Compositor, widgets::AbstractDict)

Called when an App is first created to set the size of all widgets.
"""
function enforce_app_size(compositor::Compositor, widgets::AbstractDict)
    _keys = widgets |> keys |> collect

    for k in _keys
        elem, wdg = compositor.elements[k], widgets[k]
        wdg.internals.measure = Measure(elem.h, elem.w)
        on_layout_change(wdg, wdg.internals.measure)
    end
    return widgets
end

"""
    enforce_app_size(app::App, measure::Measure)

Called when a console is resized to adjust the apps layout. 
"""
function enforce_app_size(app::App, measure::Measure)
    compositor = Compositor(app.layout; max_w = measure.w, max_h = measure.h)
    _keys = app.widgets |> keys |> collect

    for k in _keys
        elem, wdg = compositor.elements[k], app.widgets[k]
        wdg.internals.measure = Measure(elem.h, elem.w)
        on_layout_change(wdg, wdg.internals.measure)
    end

    app.compositor = compositor
end

# ----------------------------------- frame ---------------------------------- #

"""
    on_layout_change(app::App)

Called when the console is resized to adjust the apps layout.
"""
function on_layout_change(app::App)
    new_width = app.expand ? console_width() : min(app.width, console_width())
    new_width == app.measure.w && return

    erase!(app)
    clear(stdout)

    # the console is too small, re-design
    app.measure = Measure(app.measure.h, new_width)
    enforce_app_size(app, app.measure)
end

"""
    frame(app::App)

Render the app and its content.
"""
function frame(app::App; kwargs...)
    isnothing(app.on_draw) || app.on_draw(app)

    # adjust size to changes in console
    on_layout_change(app)

    for (name, widget) in pairs(app.widgets)
        # toggle active
        if length(app.widgets) > 1
            app.active == name ? widget.internals.on_activated(widget) :
            widget.internals.on_deactivated(widget)
        end

        content = frame(widget)

        update!(app.compositor, name, content)
    end

    # reset the activation state of each widget
    for widget in values(app.widgets)
        # wasactive, willbeactive = widget.internals.active, isactive(widget)
        # !wasactive && willbeactive && widget.internals.on_activated(widget)

        widget.internals.active = isactive(widget)
    end

    return render(app.compositor)
end

"""
    add_debugging_info!(content::AbstractRenderable, app::App)::AbstractRenderable

Add debugging information to the top of the app.
"""
function add_debugging_info!(content::AbstractRenderable, app::App)::AbstractRenderable
    # print the app's layout as a TREE
    tree = sprint(print, app)

    debug_info = Panel(tree; width = content.measure.w)
    return debug_info / content
end

# ---------------------------------------------------------------------------- #
#                                   RENDERING                                  #
# ---------------------------------------------------------------------------- #

"""
    shouldupdate(app::App)::Bool

Check if a widget's display should be updated based on:
    1. enough time elapsed since last update
    2. the widget has not beed displayed het
"""
function shouldupdate(app::App)::Bool
    currtime = Dates.value(now())
    isnothing(app.internals.last_update) && begin
        app.internals.last_update = currtime
        return true
    end

    Δt = currtime - app.internals.last_update
    if Δt > app.internals.refresh_Δt
        app.internals.last_update = currtime
        return true
    end
    return false
end

"""
    replace_line(internals::AppInternals)

Erase a line and move cursor
"""
function replace_line(internals::AppInternals)
    erase_line(internals.ioc)
    down(internals.ioc)
end

"""
    replace_line(internals::AppInternals, newline)

Erase a line, write new content and move cursor. 
"""
function replace_line(internals::AppInternals, newline)
    erase_line(internals.ioc)
    println(internals.ioc, newline)
end

"""
    refresh!(live::AbstractWidget)::Tuple{Bool, Any}

Update the terminal display of a app.

this is done by calling `frame` on the app to get the new content.
Then, line by line, the new content is compared to the previous one and when
a discrepancy occurs the lines gets re-written. 
This is all done printing to a buffer first and then to `stdout` to avoid
jitter.
"""
function refresh!(app::App)
    # check for keyboard inputs
    retval = keyboard_input(app)
    app.internals.should_stop && return something(retval, [])

    # check if its time to update
    shouldupdate(app) || return nothing

    # get new content
    internals = app.internals
    content::AbstractRenderable = frame(app)

    LIVE_DEBUG[] == true && begin
        content = add_debugging_info!(content, app)
    end

    content_lines::Vector{String} = split(string(content), "\n")
    nlines::Int = length(content_lines)
    nlines_prev::Int =
        isnothing(internals.prevcontentlines) ? 0 : length(internals.prevcontentlines)
    old_lines = internals.prevcontentlines
    nlines_prev == 0 && print(internals.ioc, "\n")

    # render new content
    up(internals.ioc, nlines_prev)
    for i in 1:nlines
        line = content_lines[i]

        # avoid re-writing unchanged lines
        !isnothing(internals.prevcontent) &&
            nlines_prev > i &&
            begin
                old_line = old_lines[i]
                line == old_line && begin
                    down(internals.ioc)
                    continue
                end
            end

        # re-write line
        replace_line(internals, line)
    end

    # output
    internals.prevcontent = content
    internals.prevcontentlines = content_lines
    write(stdout, take!(internals.iob))
    return nothing
end

"""
    erase!(app::App)

Erase a app from the terminal.
"""
function erase!(app::App)
    isnothing(app.internals.prevcontent) && return

    nlines = app.internals.prevcontent.measure.h
    up(app.internals.ioc, nlines)
    cleartoend(app.internals.ioc)
    write(stdout, take!(app.internals.iob))
    nothing
end

"""
    stop!(app::App)

Restore normal terminal behavior.
"""
function stop!(app::App)
    Base.stop_reading(stdin)

    internals = app.internals
    print(internals.term.out_stream, "\x1b[?25h") # unhide cursor
    print(stdout, "\x1b[?25h")
    raw!(internals.term, false)
    nothing
end

"""
    play(app::App; transient::Bool=true)

Keep refreshing a renderable, until the user interrupts it. 
"""
function play(app::App; transient::Bool = true)
    Base.start_reading(stdin)

    retval = nothing
    while isnothing(retval)
        retval = refresh!(app)
    end
    stop!(app)
    transient && erase!(app)

    retval = length(retval) > 0 ? retval[1] : retval
    return retval
end

using Term.Progress
import Term.Progress: AbstractColumn, getjob, get_columns, jobcolor
import Term: install_term_logger, uninstall_term_logger, str_trunc
import Term.Progress:
    CompletedColumn, SeparatorColumn, ProgressColumn, DescriptionColumn, TextColumn

using ProgressLogging

@testset "\e[34mProgress - jobs" begin
    pbar = ProgressBar()

    io = PipeBuffer()
    show(io, MIME("text/plain"), pbar)  # coverage
    @test startswith(read(io, String), "Progress bar")

    j1 = addjob!(pbar; description = "test", N = 10)
    @test render(j1) isa String  # coverage
    @test jobcolor(j1) == "(209, 16, 112)"

    @test j1.id == 1
    @test j1.N == 10
    @test j1.i == 0
    @test j1.description == "test"
    @test j1.started
    @test j1.columns isa Vector{AbstractColumn}

    update!(j1)
    @test j1.i == 1
    update!(j1; i = 10)
    @test j1.i == 11

    @test getjob(pbar, j1.id).id == j1.id

    removejob!(pbar, j1)
    @test length(pbar.jobs) == 0
end

@testset "\e[34mProgress basic" begin
    @test_nothrow begin
        pbar = ProgressBar()
        with(pbar) do
            job = addjob!(pbar; N = 10)
            for i in 1:10
                update!(job)
                sleep(0.001)
            end
        end
    end

    @test_nothrow begin
        pbar2 = ProgressBar(; transient = true)
        with(pbar2) do
            job = addjob!(pbar2; N = 10)
            job2 = nothing
            for i in 1:10
                i == 50 && (job2 = addjob!(pbar2; N = 10))
                i ≥ 50 && update!(job2)
                i == 75 && removejob!(pbar2, job2)

                update!(job)
                sleep(0.001)
            end
        end
    end

    @test_nothrow begin
        @track for i in 1:10
            sleep(0.001)
        end
    end
end

@testset "\e[34mProgress columns" begin
    for (i, colinfo) in enumerate((:minimal, :default, :spinner, :detailed))
        pbar = ProgressBar(; columns = colinfo)
        @test pbar.columns == get_columns(colinfo)
        @test pbar.columns isa Vector{DataType}

        job = addjob!(pbar; N = colinfo == :spinner ? nothing : 10)
        @test job.columns isa Vector{AbstractColumn}

        with(pbar) do
            for i in 1:10
                update!(job)
                sleep(0.01)
            end
        end

        start!(pbar)
        (!IS_WIN && colinfo ∈ [:spinner]) &&
            @compare_to_string render(job) "pbar_cols_style_$i"
    end

    mycols =
        [DescriptionColumn, CompletedColumn, SeparatorColumn, ProgressColumn, TextColumn]
    colkwargs = Dict(
        :DescriptionColumn => Dict(:style => "red"),
        :TextColumn => Dict(:text => "test"),
    )
    pbar = ProgressBar(; columns = mycols, columns_kwargs = colkwargs)
    job = addjob!(pbar; N = 10)
    @test job.columns[1].segments[1].text == "\e[31mRunning...\e[39m"
end

@testset "Progress customization" begin
    pbar = ProgressBar(;
        expand = true,
        columns = :detailed,
        colors = "#ffffff",
        columns_kwargs = Dict(
            :ProgressColumn => Dict(:completed_char => '█', :remaining_char => '░'),
        ),
    )
    job = addjob!(pbar; N = 100, description = "Test")

    job2 = addjob!(
        pbar;
        N = 100,
        description = "Test2",
        columns_kwargs = Dict(
            :ProgressColumn => Dict(:completed_char => 'x', :remaining_char => '_'),
        ),
    )

    with(pbar) do
        for i in 1:100
            update!(job)
            update!(job2)
            sleep(0.01)
            i == 45 && break
        end
    end

    start!(pbar)  # re-activate
    IS_WIN || @compare_to_string render(pbar) "pbar_customization"
end

@testset "\e[34mProgress foreachprogress" begin
    @test_nowarn redirect_stdout(Base.DevNull()) do
        Term.Progress.foreachprogress(1:10) do i
            sleep(0.01)
        end
    end
end
# @testset "\e[34mProgress ProgressLogging" begin
#     install_term_logger()

#     @test_nothrow begin
#         @progress "inner... $i" for j in  1:10
#             sleep(0.01)
#         end
#     end
# end

struct ANSICode{T<:AbstractString}
    open::T
    close::T
end

const CODES = Dict(
    :default => ANSICode("\e[22m", "\e[22m"),
    :bold => ANSICode("\e[1m", "\e[22m"),
    :b => ANSICode("\e[1m", "\e[22m"),
    :dim => ANSICode("\e[2m", "\e[22m"),
    :italic => ANSICode("\e[3m", "\e[23m"),
    :i => ANSICode("\e[3m", "\e[23m"),
    :underline => ANSICode("\e[4m", "\e[24m"),
    :u => ANSICode("\e[4m", "\e[24m"),
    :blink => ANSICode("\e[5m", "\e[25m"),
    :inverse => ANSICode("\e[7m", "\e[27m"),
    :hidden => ANSICode("\e[8m", "\e[28m"),
    :striked => ANSICode("\e[9m", "\e[29m"),
    "black" => 0,
    "red" => 1,
    "green" => 2,
    "yellow" => 3,
    "blue" => 4,
    "magenta" => 5,
    "cyan" => 6,
    "white" => 7,
    "default" => 9,
)

const CODES_16BIT_COLORS = Dict(
    "bright_black" => 8,
    "bright_red" => 9,
    "bright_green" => 10,
    "bright_yellow" => 11,
    "bright_blue" => 12,
    "bright_magenta" => 13,
    "bright_cyan" => 14,
    "bright_white" => 15,
    "grey0" => 16,
    "navy_blue" => 17,
    "dark_blue" => 18,
    "blue3" => 20,
    "blue1" => 21,
    "dark_green" => 22,
    "deep_sky_blue4" => 25,
    "dodger_blue3" => 26,
    "dodger_blue2" => 27,
    "green4" => 28,
    "spring_green4" => 29,
    "turquoise4" => 30,
    "deep_sky_blue3" => 32,
    "dodger_blue1" => 33,
    "green3" => 40,
    "spring_green3" => 41,
    "dark_cyan" => 36,
    "light_sea_green" => 37,
    "deep_sky_blue2" => 38,
    "deep_sky_blue1" => 39,
    "spring_green2" => 47,
    "cyan3" => 43,
    "dark_turquoise" => 44,
    "turquoise2" => 45,
    "green1" => 46,
    "spring_green1" => 48,
    "medium_spring_green" => 49,
    "cyan2" => 50,
    "cyan1" => 51,
    "dark_red" => 88,
    "deep_pink4" => 125,
    "purple4" => 55,
    "purple3" => 56,
    "blue_violet" => 57,
    "orange4" => 94,
    "grey37" => 59,
    "gray37" => 59,
    "medium_purple4" => 60,
    "slate_blue3" => 62,
    "royal_blue1" => 63,
    "chartreuse4" => 64,
    "dark_sea_green4" => 71,
    "pale_turquoise4" => 66,
    "steel_blue" => 67,
    "steel_blue3" => 68,
    "cornflower_blue" => 69,
    "chartreuse3" => 76,
    "cadet_blue" => 73,
    "sky_blue3" => 74,
    "steel_blue1" => 81,
    "pale_green3" => 114,
    "sea_green3" => 78,
    "aquamarine3" => 79,
    "medium_turquoise" => 80,
    "chartreuse2" => 112,
    "sea_green2" => 83,
    "sea_green1" => 85,
    "aquamarine1" => 122,
    "dark_slate_gray2" => 87,
    "dark_magenta" => 91,
    "dark_violet" => 128,
    "purple" => 129,
    "light_pink4" => 95,
    "plum4" => 96,
    "medium_purple3" => 98,
    "slate_blue1" => 99,
    "yellow4" => 106,
    "wheat4" => 101,
    "grey53" => 102,
    "gray53" => 102,
    "light_slate_grey" => 103,
    "light_slate_gray" => 103,
    "medium_purple" => 104,
    "light_slate_blue" => 105,
    "dark_olive_green3" => 149,
    "dark_sea_green" => 108,
    "light_sky_blue3" => 110,
    "sky_blue2" => 111,
    "dark_sea_green3" => 150,
    "dark_slate_gray3" => 116,
    "sky_blue1" => 117,
    "chartreuse1" => 118,
    "light_green" => 120,
    "pale_green1" => 156,
    "dark_slate_gray1" => 123,
    "red3" => 160,
    "medium_violet_red" => 126,
    "magenta3" => 164,
    "dark_orange3" => 166,
    "indian_red" => 167,
    "hot_pink3" => 168,
    "medium_orchid3" => 133,
    "medium_orchid" => 134,
    "medium_purple2" => 140,
    "dark_goldenrod" => 136,
    "light_salmon3" => 173,
    "rosy_brown" => 138,
    "grey63" => 139,
    "gray63" => 139,
    "medium_purple1" => 141,
    "gold3" => 178,
    "dark_khaki" => 143,
    "navajo_white3" => 144,
    "grey69" => 145,
    "gray69" => 145,
    "light_steel_blue3" => 146,
    "light_steel_blue" => 147,
    "yellow3" => 184,
    "dark_sea_green2" => 157,
    "light_cyan3" => 152,
    "light_sky_blue1" => 153,
    "green_yellow" => 154,
    "dark_olive_green2" => 155,
    "dark_sea_green1" => 193,
    "pale_turquoise1" => 159,
    "deep_pink3" => 162,
    "magenta2" => 200,
    "hot_pink2" => 169,
    "orchid" => 170,
    "medium_orchid1" => 207,
    "orange3" => 172,
    "light_pink3" => 174,
    "pink3" => 175,
    "plum3" => 176,
    "violet" => 177,
    "light_goldenrod3" => 179,
    "tan" => 180,
    "misty_rose3" => 181,
    "thistle3" => 182,
    "plum2" => 183,
    "khaki3" => 185,
    "light_goldenrod2" => 222,
    "light_yellow3" => 187,
    "grey84" => 188,
    "gray84" => 188,
    "light_steel_blue1" => 189,
    "yellow2" => 190,
    "dark_olive_green1" => 192,
    "honeydew2" => 194,
    "light_cyan1" => 195,
    "red1" => 196,
    "deep_pink2" => 197,
    "deep_pink1" => 199,
    "magenta1" => 201,
    "orange_red1" => 202,
    "indian_red1" => 204,
    "hot_pink" => 206,
    "dark_orange" => 208,
    "salmon1" => 209,
    "light_coral" => 210,
    "pale_violet_red1" => 211,
    "orchid2" => 212,
    "orchid1" => 213,
    "orange1" => 214,
    "sandy_brown" => 215,
    "light_salmon1" => 216,
    "light_pink1" => 217,
    "pink1" => 218,
    "plum1" => 219,
    "gold1" => 220,
    "navajo_white1" => 223,
    "misty_rose1" => 224,
    "thistle1" => 225,
    "yellow1" => 226,
    "light_goldenrod1" => 227,
    "khaki1" => 228,
    "wheat1" => 229,
    "cornsilk1" => 230,
    "grey100" => 231,
    "gray100" => 231,
    "grey3" => 232,
    "gray3" => 232,
    "grey7" => 233,
    "gray7" => 233,
    "grey11" => 234,
    "gray11" => 234,
    "grey15" => 235,
    "gray15" => 235,
    "grey19" => 236,
    "gray19" => 236,
    "grey23" => 237,
    "gray23" => 237,
    "grey27" => 238,
    "gray27" => 238,
    "grey30" => 239,
    "gray30" => 239,
    "grey35" => 240,
    "gray35" => 240,
    "grey39" => 241,
    "gray39" => 241,
    "grey42" => 242,
    "gray42" => 242,
    "grey46" => 243,
    "gray46" => 243,
    "grey50" => 244,
    "gray50" => 244,
    "grey54" => 245,
    "gray54" => 245,
    "grey58" => 246,
    "gray58" => 246,
    "grey62" => 247,
    "gray62" => 247,
    "grey66" => 248,
    "gray66" => 248,
    "grey70" => 249,
    "gray70" => 249,
    "grey74" => 250,
    "gray74" => 250,
    "grey78" => 251,
    "gray78" => 251,
    "grey82" => 252,
    "gray82" => 252,
    "grey85" => 253,
    "gray85" => 253,
    "grey89" => 254,
    "gray89" => 254,
    "grey93" => 255,
    "gray93" => 255,
)

# ---------------------------------------------------------------------------- #
#                                    COLORS                                    #
# ---------------------------------------------------------------------------- #
const NAMED_COLORS =
    ["default", "black", "red", "green", "yellow", "blue", "magenta", "cyan", "white"]

const COLORS_16b = vcat(
    [
        "bright_black",
        "bright_red",
        "bright_green",
        "bright_yellow",
        "bright_blue",
        "bright_magenta",
        "bright_cyan",
        "bright_white",
        "grey0",
        "navy_blue",
        "dark_blue",
        "blue3",
        "blue1",
        "dark_green",
        "deep_sky_blue4",
        "dodger_blue3",
        "dodger_blue2",
        "green4",
        "spring_green4",
        "turquoise4",
        "deep_sky_blue3",
        "dodger_blue1",
        "green3",
        "spring_green3",
        "dark_cyan",
        "light_sea_green",
        "deep_sky_blue2",
        "deep_sky_blue1",
        "spring_green2",
        "cyan3",
        "dark_turquoise",
        "turquoise2",
        "green1",
        "spring_green1",
        "medium_spring_green",
        "cyan2",
        "cyan1",
        "dark_red",
        "deep_pink4",
        "purple4",
        "purple3",
        "blue_violet",
        "orange4",
        "grey37",
        "gray37",
        "medium_purple4",
        "slate_blue3",
        "royal_blue1",
        "chartreuse4",
        "dark_sea_green4",
        "pale_turquoise4",
        "steel_blue",
        "steel_blue3",
        "cornflower_blue",
        "chartreuse3",
        "cadet_blue",
        "sky_blue3",
        "steel_blue1",
        "pale_green3",
        "sea_green3",
        "aquamarine3",
        "medium_turquoise",
        "chartreuse2",
        "sea_green2",
        "sea_green1",
        "aquamarine1",
        "dark_slate_gray2",
        "dark_magenta",
        "dark_violet",
        "purple",
        "light_pink4",
        "plum4",
        "medium_purple3",
        "slate_blue1",
        "yellow4",
        "wheat4",
        "grey53",
        "gray53",
        "light_slate_grey",
        "light_slate_gray",
        "medium_purple",
        "light_slate_blue",
        "dark_olive_green3",
        "dark_sea_green",
        "light_sky_blue3",
        "sky_blue2",
        "dark_sea_green3",
        "dark_slate_gray3",
        "sky_blue1",
        "chartreuse1",
        "light_green",
        "pale_green1",
        "dark_slate_gray1",
        "red3",
        "medium_violet_red",
        "magenta3",
        "dark_orange3",
        "indian_red",
        "hot_pink3",
        "medium_orchid3",
        "medium_orchid",
        "medium_purple2",
        "dark_goldenrod",
        "light_salmon3",
        "rosy_brown",
        "grey63",
        "gray63",
        "medium_purple1",
        "gold3",
        "dark_khaki",
        "navajo_white3",
        "grey69",
        "gray69",
        "light_steel_blue3",
        "light_steel_blue",
        "yellow3",
        "dark_sea_green2",
        "light_cyan3",
        "light_sky_blue1",
        "green_yellow",
        "dark_olive_green2",
        "dark_sea_green1",
        "pale_turquoise1",
        "deep_pink3",
        "magenta2",
        "hot_pink2",
        "orchid",
        "medium_orchid1",
        "orange3",
        "light_pink3",
        "pink3",
        "plum3",
        "violet",
        "light_goldenrod3",
        "tan",
        "misty_rose3",
        "thistle3",
        "plum2",
        "khaki3",
        "light_goldenrod2",
        "light_yellow3",
        "grey84",
        "gray84",
        "light_steel_blue1",
        "yellow2",
        "dark_olive_green1",
        "honeydew2",
        "light_cyan1",
        "red1",
        "deep_pink2",
        "deep_pink1",
        "magenta1",
        "orange_red1",
        "indian_red1",
        "hot_pink",
        "dark_orange",
        "salmon1",
        "light_coral",
        "pale_violet_red1",
        "orchid2",
        "orchid1",
        "orange1",
        "sandy_brown",
        "light_salmon1",
        "light_pink1",
        "pink1",
        "plum1",
        "gold1",
        "navajo_white1",
        "misty_rose1",
        "thistle1",
        "yellow1",
        "light_goldenrod1",
        "khaki1",
        "wheat1",
        "cornsilk1",
        "grey100",
        "gray100",
        "grey3",
        "gray3",
        "grey7",
        "gray7",
        "grey11",
        "gray11",
        "grey15",
        "gray15",
        "grey19",
        "gray19",
        "grey23",
        "gray23",
        "grey27",
        "gray27",
        "grey30",
        "gray30",
        "grey35",
        "gray35",
        "grey39",
        "gray39",
        "grey42",
        "gray42",
        "grey46",
        "gray46",
        "grey50",
        "gray50",
        "grey54",
        "gray54",
        "grey58",
        "gray58",
        "grey62",
        "gray62",
        "grey66",
        "gray66",
        "grey70",
        "gray70",
        "grey74",
        "gray74",
        "grey78",
        "gray78",
        "grey82",
        "gray82",
        "grey85",
        "gray85",
        "grey89",
        "gray89",
        "grey93",
        "gray93",
    ],
    [string(i) for i in 1:255],
)

# ---------------------------------------------------------------------------- #
#                                     MODES                                    #
# ---------------------------------------------------------------------------- #
const NAMED_MODES = [
    "default",
    "bold",
    "b",
    "dim",
    "italic",
    "i",
    "underline",
    "u",
    "blink",
    "inverse",
    "hidden",
    "striked",
]

module Segments

import Term: remove_markup, remove_ansi, unescape_brackets

import ..Style: apply_style, MarkupStyle
import ..Measures: Measure, width

using Term: Term

export Segment

# ---------------------------------------------------------------------------- #
#                                    SEGMENT                                   #
# ---------------------------------------------------------------------------- #

"""
    Segment

stores one piece of text with all the styles applied to it.
"""
struct Segment
    text::AbstractString   # text with ANSI codes injected
    measure::Measure       # measure of plain text
end

# ------------------------------- constructors ------------------------------- #
"""
    Segment(text::AbstractString)

Construct a Segment out of a string with markup.
"""
Segment(text) = begin
    text = apply_style(text)
    Segment(text, Measure(text))
end

"""
    Segment(text::Union{Segment, AbstractString}, markup::AbstractString)

Construct a Segment out of a plain string and a markup string with style info
"""
Segment(text, markup::String) = Segment("{$markup}" * text * "{/$markup}")

# --------------------------------- printing --------------------------------- #

Base.show(io::IO, seg::Segment) = print(io, unescape_brackets(seg.text))

Base.show(io::IO, ::MIME"text/plain", seg::Segment) =
    print(io, "Segment{$(typeof(seg.text))} \e[2m(size: $(seg.measure))\e[0m")

# ---------------------------------------------------------------------------- #
#                                    LAYOUT                                    #
# ---------------------------------------------------------------------------- #

# -------------------------------- concatenate ------------------------------- #
"""
concatenate strings and segments
"""
Base.:*(seg::Segment, str::AbstractString) = Segment(seg.text * str)
Base.:*(str::AbstractString, seg::Segment) = Segment(str * seg.text)
Base.:*(seg1::Segment, seg2::Segment) = Segment(seg1.text * seg2.text)

# ------------------------------- string types ------------------------------- #

"""
    get_string_types(segments_vectors...)

Given a number of `Segment[]` vectors, get the `AbstractString` like
type they're using. If they are all using normal `String` or `Substring`
go with that, but if one of them is using a different string type, use it. 
"""
function get_string_types(segments_vectors...)::DataType
    stypes::Vector{DataType} =
        vcat(map(segments -> getfield.(segments, :text), segments_vectors)...) .|>
        typeof |>
        unique

    stypes = setdiff(stypes, [String, SubString])
    return length(stypes) == 0 ? String : stypes[1]
end
end

"""
    This example shows how to create Dendogram visualizations.


According to wikipedia: "A dendrogram is a diagram representing a tree", 
but really you just need to see to understand:
"""

import Term: Dendogram

mydendo = Dendogram("awesome", "this", :is, "a", "dendogram!")
print("\n"^2)
print(mydendo)

"""
The first argument si the "head" (or trunk) and all the others are leaves
"""

otherdendo = Dendogram("head", "these", "are", "colorful", "leaves")
print("\n"^2)
print(otherdendo)

"""
Let's say you want to create a hierarchical structure in your dendogram, 
just link individual elements together.
"""

import Term.Dendograms: link
print("\n"^2)
print(link(mydendo, otherdendo; title = "{red}superdendo{/red}"))

"""
and so on...
"""
smalldendo = Dendogram("head", [1, 2])

print("\n"^2)
print(
    link(
        smalldendo,
        link(
            smalldendo,
            link(smalldendo, smalldendo; title = "a level");
            title = "another level",
        );
        title = "first level",
    ),
)

"""
display/hide help tooltip
"""
function toggle_help(app, args...;)
    internals = app.internals
    width = app.measure.w
    msg =
        if !isnothing(internals.help_message) == true
            parse_md(Markdown.parse(app.internals.help_message); width = width - 6)
        else
            "{dim} no help message shown{/dim}"
        end |> RenderableText

    # get the docstring of the currently active widget
    active_widget = app.widgets[app.active]
    widget_msg =
        something(
            parse_md(getdocs(active_widget); width = max(20, width - 6)),
            "{dim} no help message shown{/dim}",
        ) |> RenderableText

    # get the docstring of each control method
    col = TERM_THEME[].text_accent
    all_controls = [pairs(active_widget.controls)..., pairs(app.controls)...]
    already_added = []
    controls = []

    for (k, c) in all_controls
        (k ∈ already_added || k isa Symbol) && continue

        push!(
            controls,
            RenderableText(
                "{bold $col} - $(k){/bold $col}: " *
                parse_md(getdocs(c); width = max(20, width - 20)),
            ),
        )
        push!(already_added, k)
    end
    # create content
    content = [
        msg,
        "",
        RenderableText(
            md"#### Active widget: $(typeof(active_widget))";
            width = width - 10,
        ),
        "",
        widget_msg,
        "",
        RenderableText(md"#### Controls"; width = width - 10),
        controls...,
    ]

    # create full message
    help_message = Panel(
        content;
        width = width,
        title = "Help",
        title_style = "default bold blue",
        title_justify = :center,
        style = "dim",
    )

    # show/hide message
    if internals.help_shown
        # hide it
        internals.help_shown = false

        # go to the top of the error message and delete everything
        h =
            console_height() - length(internals.prevcontentlines) - help_message.measure.h -
            1
        move_to_line(stdout, h)
        cleartoend(stdout)

        # move cursor back to the top of the live to re-print it in the right position
        move_to_line(stdout, console_height() - length(internals.prevcontentlines))
    else
        # show it
        erase!(app)
        println(stdout, help_message)
        internals.help_shown = true
    end

    internals.prevcontent = nothing
    internals.prevcontentlines = String[]
end

using Term
using Term.LiveWidgets
install_term_logger()
install_term_stacktrace()

LiveWidgets.LIVE_DEBUG[] = false  # set to true show extra info

"""
Example on how to create a simple app without any specific content, 
just to specify the widget's layout.
"""

layout = :((r(10, 0.5) * g(10, 0.5)) / b(10, 1.0))

app = App(
    layout;
    expand = true,
    help_message = """
This is just an example of how to create a simple app without any specific content.

!!! note
    You can make apps too!
""",
)

play(app)

install_term_repr()
import Term.Consoles: clear
import Term: Panel

sprint_termshow(io::IO, x) = termshow(io, x; width = 60)

@testset "REPR renderable repr" begin
    p = string(Panel())
    w = TEST_CONSOLE_WIDTH
    @test sprint(show, Panel()) ==
          "\e[38;5;117mPanel <: AbstractRenderable\e[0m \e[2m(h:3, w:80)\e[0m"
end

@testset "REPR @with_repr" begin
    # just check that creating a @with_repr is ok
    @with_repr struct Rocket
        width::Int
        height::Int
        mass::Float64

        manufacturer::String
    end

    obj = Rocket(10, 50, 5000, "NASA")
    @with_repr struct T end

    if VERSION ≥ v"1.7"
        IS_WIN || @compare_to_string sprint(termshow, obj) "repr_rocket"
        IS_WIN || @compare_to_string sprint(termshow, T()) "repr_T_struct"
        if VERSION ≤ v"1.10"
            IS_WIN || @compare_to_string sprint(termshow, Rocket) "repr_rocket_struct"
        end
    end
    @with_repr struct MyTestStruct3
        x::String
        y::Array
        z::Int
        a::Panel
        c::String
    end

    mts = MyTestStruct3("aa aa"^100, zeros(100, 100), 3, Panel(), "b b b"^100)

    if VERSION ≥ v"1.7"
        IS_WIN || @compare_to_string sprint(termshow, mts) "mts_repr"
    end
end

@testset "REPR @with_repr with doc" begin
    """docs"""
    @with_repr struct Rocket2
        width::Int
        height::Int
        mass::Float64

        manufacturer::String
    end

    r = Rocket2(1, 1, 1.0, "me")
    _repr = sprint(io -> show(io, MIME("text/plain"), r))
    IS_WIN || @compare_to_string _repr "repr_rocket_2"
    IS_WIN ||
        @compare_to_string sprint(io -> show(io, MIME("text/plain"), Rocket2)) "repr_rocket_2_show"
end

"test function"
fn(x::Int) = x
fn(s::String) = s

objs = if VERSION >= v"1.7.1"
    (
        (1, [1, 2, 3]),
        (2, Dict(:x => [1, 2, 3], "a" => Dict(:z => "a"))),
        (3, Dict(i => i for i in 1:100)),
        (4, zeros(120, 300)),
        (5, zeros(200)),
        (6, zeros(3, 3, 3)),
        (7, fn),
        (8, :(x / y + √9)),
        (9, zeros(10)),
        (10, zeros(5, 5)),
        (11, zeros(100, 100, 100)),
    )
else
    (
        (1, [1, 2, 3]),
        (2, Dict(:x => [1, 2, 3], "a" => Dict(:z => "a"))),
        (3, Dict(i => i for i in 1:100)),
        (7, fn),
    )
end

v"1.7" ≤ VERSION ≤ v"1.10" && @testset "TERMSHOW for types" begin
    for (i, t) in objs
        t = sprint(sprint_termshow, t)
        IS_WIN || @compare_to_string(t, "termshow_$i")
    end
end

v"1.7" ≤ VERSION ≤ v"1.10" && @testset "Term automatic repr" begin
    repr_show(io, x) = show(io, MIME("text/plain"), x)
    @test sprint(repr_show, 1) == "\e[38;2;144;202;249m1\e[39m"

    IS_WIN || @compare_to_string(sprint(repr_show, Dict(1 => :x)), "automatic_repr_1")
    IS_WIN || @compare_to_string(sprint(repr_show, :(x + y)), "automatic_repr_2")
end

v"1.7" ≤ VERSION ≤ v"1.10" && @testset "@showme" begin
    # fix for different path on remote CI
    loc = "\e[2m/Users/federicoclaudi/Documents/Github/Term.jl/src/"
    rem = "             \e[2m/home/runner/work/Term.jl/Term.jl/src/"
    fn(x) = replace(x, rem => loc)

    IS_WIN || begin
        @compare_to_string(
            :(@showme tprint(stdout, "test")),
            "automatic_repr_showme_1",
            fn,
            2,  # skip the last two lines
        )
    end
end

"""
This example shows how to use Term.jl to print styled text to the console.

The easiest way to apply style to a String is to use Markup Tags.

Let's say you have this string: 

s = "this is my string!"

and you want 'my' to be bold and blue, then simply write:

s = "this is [bold blue]my[/bold blue] string!

The [xx]text[/xx] syntax will result in the style 'xx' being applied to the
text between parentheses.
The style can include things like: `bold`, `underline`, `italic`, `red`, `blue`...
all separated by a space. You can also use hexcodes (like #ff0022) to specify 
the color of your text.


Once you're happy with your markup string, you can use `Term.tprintln` to print it!

Note: the second set of parentheses, [/xx], terminates the markup tag and the style
information 'xx' must be identical between the start/end parentheses.
"""

import Term: tprintln

my_string = "{bold underline}This{/bold underline} is {red italic}my{/red italic} {on_green black bold}string{/on_green black bold}"
tprintln(my_string)

"""
Using markup tags is great when you want your styled text to be printed within other `Renderable` object
from Term such as `TextBox` and `Panel` (see examples).

But if you just need to quickly print something with a bit of color, you don't want to be typing all those [,].
Fortunately, Term provides a set of macros to easily print styled strings!!
"""

import Term: @red, @blue, @style

println(@red "This is red")
println(@blue "and this is blue")

# or, if you want some more control
println(@style "this is my beautifully styled text" green italic bold)

interpolate_from_dict(ex::Expr, dict) =
    Expr(ex.head, interpolate_from_dict.(ex.args, Ref(dict))...)
interpolate_from_dict(ex::Symbol, dict::Dict) = get(dict, ex, ex)
interpolate_from_dict(ex::Any, dict) = ex

layout_symbols = (
    Symbol(/),
    Symbol(*),
    :vstack,
    :lvstack,
    :leftalign,
    :hstack,
    :center,
    :rightalign,
    :lvstack,
    :rvstack,
    :cvstack,
    :pad,
    :pad!,
    :vertical_pad,
    :vertical_pad!,
)

"""
    parse_single_element_layout(ex::Expr)

Parse an expression with a single layout element, like :(A(5, 25)) or :(A)
"""
function parse_single_element_layout(ex::Expr)
    if length(ex.args) == 3
        s, h, w = ex.args
    else
        s = ex.args[1]
        h, w = default_size()
    end
    return [:($s($h, $w))]
end

"""
    get_elements_and_sizes(ex::Expr)

Get elements names and sizes.
"""
function get_elements_and_sizes(ex::Expr; placeholder_size = nothing)
    elements = collect_elements(ex)
    elements = elements isa Expr ? parse_single_element_layout(elements) : elements
    min_h = min_w = typemax(Int)
    for e in elements
        e isa Symbol && continue

        h, w = e.args[2], e.args[3]
        h = h isa Int ? h : fint(console_height() * h)
        w = w isa Int ? w : fint(console_width() * w)
        min_h = min(min_h, h)
        min_w = min(min_w, w)
    end

    # fallback size
    h, w = something(placeholder_size, default_size())
    min_h == typemax(Int) && (min_h = h)
    min_w == typemax(Int) && (min_w = w)

    return [e isa Symbol ? :($e($min_h, $min_w)) : e for e in elements]
end

"""
    collect_elements(ex::Expr)

Collects elements (individual LayoutElements) that are
in a layout expresssion.
"""
function collect_elements(ex::Expr)
    if ex.args[1] ∉ layout_symbols
        return if length(ex.args) > 2
            s, h, w = ex.args
            :($s($h, $w))
        else
            nothing
        end
    else
        symbols = map(x -> x isa Symbol ? x : collect_elements(x), ex.args)
        symbols = filter(s -> s ∉ layout_symbols && !isnothing(s), symbols)
        return reduce(vcat, symbols)
    end
end

function clean_layout_expr(ex::Expr)
    if ex.args[1] ∉ layout_symbols
        return ex.args[1]
    else
        ex.args = map(a -> a isa Expr ? clean_layout_expr(a) : a, ex.args)
    end
    return ex
end

compositor_placeholder(s, h, w, c) = begin
    h = h isa Int ? h : fint(console_height() * h)
    w = w isa Int ? w : fint(console_width() * w)
    PlaceHolder(
        h,
        w;
        style = c,
        text = "{bold underline bright_blue}$s{/bold underline bright_blue} {white}($h × $w){/white}",
    )
end

"""
    extract_renderable_from_kwargs(s, h, w; kwargs...)

When passing kwargs to a `Compositor`, check for renderables that are 
to be assigned to its content.
"""
function extract_renderable_from_kwargs(s, h, w; check = true, kwargs...)
    ren = get(kwargs, s, nothing)
    if !isnothing(ren)
        ren = ren isa AbstractRenderable ? ren : RenderableText(ren)

        # check renderable has the right size
        if check
            msg = "While creating a Compository layout, the layout element"
            @assert ren.measure.h == h highlight(
                "$msg :$s has height $h but the renderable passed has height $(ren.measure.h)",
            )
            @assert ren.measure.w == w highlight(
                "$msg :$s has width $w but the renderable passed has width $(ren.measure.w)",
            )
        end
    end
    return ren
end

"""
    module Prompts

Defines functionality relative to prompts in the terminal. 
Typically a prompt is composed of a piece of text that gets displayed prompting
the user to provide an input and some machinery to parse/validate the user's inputs.
For example, some prompts may only accept as replies objects of a given type (e.g. an `Int`).
Additionally, some prompts will have "options" the user can choose between and the answer
has to be one of these options.
"""
module Prompts

import Term
import Term: highlight, TERM_THEME
import ..Style: apply_style
import ..Tprint: tprint, tprintln
import ..Repr: @with_repr, termshow

export Prompt, TypePrompt, OptionsPrompt, DefaultPrompt, confirm, ask

"""
Prompts in VSCODE require a bit of a hack:
https://discourse.julialang.org/t/vscode-errors-with-user-input-readline/75097/4?u=fedeclaudi

When the text is displayed, the user should input "space" and a new line before inputting the
actual reponse. This is not a Term.jl problem.
"""

# ------------------------------ abstract prompt ----------------------------- #

""" Prompt types """
abstract type AbstractPrompt end

_print_prompt_text(io::IO, prompt::AbstractPrompt) =
    tprintln(io, "{$(prompt.style)}{dim}❯❯❯ {/dim}" * prompt.prompt * "{/$(prompt.style)}")

"""
    Base.print(io::IO, prompt::AbstractPrompt)

Default prompt printing, just prints the message `prompt`
with a bit of style.
"""
Base.print(io::IO, prompt::AbstractPrompt) = _print_prompt_text(io, prompt)

"""
    ask

Ask does three things:
  1. displays a prompt
  2. accepts user input and validates it
  3. if the answer was accepted, returns the desired value.
"""
function ask end

""" 
    ask(io::IO, prompt::AbstractPrompt)

Default `ask` method for generic prompt objects.
"""
function ask(io::IO, prompt::AbstractPrompt)
    print(io, prompt)
    ans = readline()
    return validate_answer(ans, prompt)
end

ask(prompt::AbstractPrompt) = ask(stdout, prompt)

"""
    validate_answer

Validate user's answer for a prompt type.
The validation mechanism depends on the type of prompt.
Validate answer will return the answer if it passed validation
or raise and error otherwise.
"""
function validate_answer end

# -------------------------- answer validation error ------------------------- #

"""
    AnswerValidationError <: Exception

Exception to handle cases in which the user's answer to a
prompt failed to pass validation.
"""
struct AnswerValidationError <: Exception
    answer_type
    expected_type
    err
end

Base.showerror(io::IO, e::AnswerValidationError) = print(
    io,
    highlight(
        "TypePrompt expected an answer of type: `$(e.expected_type)`, got `$(e.answer_type)` instead\nConversion to `$(e.expected_type)` failed because of: $(e.err)",
    ) |> apply_style,
)

# ---------------------------------------------------------------------------- #
#                                    PROMPT                                    #
# ---------------------------------------------------------------------------- #

"""
    struct Prompt{T} <: AbstractPrompt
        prompt::String
        style::String = TERM_THEME[].prompt_text
    end

Generic prompt, accepts any answer
"""
@with_repr struct Prompt <: AbstractPrompt
    prompt::String
    style::String
end
Prompt(prompt::String) = Prompt(prompt, TERM_THEME[].prompt_text)

validate_answer(ans, ::Prompt) = ans

# ---------------------------------------------------------------------------- #
#                                  TYPE PROMPT                                 #
# ---------------------------------------------------------------------------- #

"""
    struct TypePrompt{T}
        answer_type::Union{Union, DataType} = T
        prompt::String
    end

Asks for input given `prompt` and checks/converts the answer to type `T`
"""
struct TypePrompt{T} <: AbstractPrompt
    answer_type::T
    prompt::String
    style::String
end

TypePrompt(answer_type, prompt::String) =
    TypePrompt(answer_type, prompt, TERM_THEME[].prompt_text)

"""
    validate_answer(answer, prompt::TypePrompt)

For a TypePrompt an anwer is valid if it is of the correct type
or if a string containg the answer can be parsed as the correct type.
For example, `answer="1.0"` can be accepted for a TypePrompt
asking for a `Number`.
If validation fails, an error is raised.
"""
function validate_answer(answer, prompt::TypePrompt)
    answer isa prompt.answer_type && return answer

    err = nothing
    try
        return parse(prompt.answer_type, answer)
    catch err
    end
    throw(
        AnswerValidationError(typeof(answer), prompt.answer_type, apply_style(string(err))),
    )
end

# ---------------------------------------------------------------------------- #
#                                OPTIONS PROMPTS                               #
# ---------------------------------------------------------------------------- #
""" Prompt types where user can only choose among options """
abstract type AbstractOptionsPrompt <: AbstractPrompt end

"""
    struct OptionsPrompt <: AbstractOptionsPrompt
        options::Vector{String}
        prompt::String
        style::String 
        answers_style::String
    end

Just a simple prompt, giving some pre-defined options.
"""
@with_repr struct OptionsPrompt <: AbstractOptionsPrompt
    options::Vector{String}
    prompt::String
    style::String
    answers_style::String
end

OptionsPrompt(options, prompt::String) =
    OptionsPrompt(options, prompt, TERM_THEME[].prompt_text, TERM_THEME[].prompt_options)

"""
    Base.print(io::IO, prompt::AbstractOptionsPrompt)

Options prompts additionally print the available options. 
"""
function Base.print(io::IO, prompt::AbstractOptionsPrompt)
    _print_prompt_text(io, prompt)
    tprint(
        io,
        " {$(prompt.answers_style)}" *
        join(prompt.options, " {$(prompt.style)}/{/$(prompt.style)} ") *
        "{/$(prompt.answers_style)}";
        highlight = false,
    )
end

"""
    validate_answer(answer, prompt::AbstractOptionsPrompt)

For an AbstractOptionsPrompt an answer is accepted if its one of the options.
Additionally, for an `AbstractDefaultPrompt`, if no answer is given that's
also accepted and the default option is returned.
"""
function validate_answer(answer, prompt::AbstractOptionsPrompt)
    (prompt isa AbstractDefaultPrompt && strip(answer) == "") &&
        return prompt.options[prompt.default]
    strip(answer) ∉ prompt.options && begin
        tprintln("{dim}Answer `$(answer)` is not valid.{/dim}")
        return nothing
    end
    return answer
end

"""
    ask(io::IO, prompt::AbstractOptionsPrompt)

In asking an `AbstractOptionsPrompt`, keep asking for input
until an accepted answer is provided.
"""
function ask(io::IO, prompt::AbstractOptionsPrompt)
    ans = nothing
    while isnothing(ans)
        println(io, prompt)
        ans = validate_answer(readline(), prompt)
    end
    return ans
end

# ---------------------------------------------------------------------------- #
#                                DEFAULT PROMPT                                #
# ---------------------------------------------------------------------------- #

""" Options prompt types with a default answer """
abstract type AbstractDefaultPrompt <: AbstractOptionsPrompt end

"""

"""
@with_repr struct DefaultPrompt <: AbstractDefaultPrompt
    options::Vector{String}
    default::Int
    prompt::String
    style::String
    answers_style::String
    default_answer_style::String

    function DefaultPrompt(options::Vector, default::Int, prompt::String, args...)
        @assert default > 0 && default <= length(options) "Default answer number: $default not valid"
        new(options, default, prompt, args...)
    end
end

function DefaultPrompt(options::Vector, default::Int, prompt::String)
    DefaultPrompt(
        options,
        default,
        prompt,
        TERM_THEME[].prompt_text,
        TERM_THEME[].prompt_options,
        TERM_THEME[].prompt_default_option,
    )
end

"""
    Base.print(io::IO, prompt::AbstractDefaultPrompt)

Print a prompt with style applied to the default option.
"""
function Base.print(io::IO, prompt::AbstractDefaultPrompt)
    n_options = length(prompt.options)
    _print_prompt_text(io, prompt)
    answer_styles = map(
        i -> i == prompt.default ? prompt.default_answer_style : prompt.answers_style,
        1:n_options,
    )
    options = join(
        (map(
            i -> "{$(answer_styles[i])}$(prompt.options[i]){/$(answer_styles[i])}",
            1:n_options,
        )),
        ", ",
    )
    tprint(io, " " * options)
end

confirm() = ask(DefaultPrompt(["yes", "no"], 1, "Confirm?"))
end

using Term.TermMarkdown
using Markdown

m1 = md"""
This is a test function for math syntax

```math
\\alpha^2 - \\sqrt9 \\in [1, 2, 3] \\cup [4, 5, 6]
```
"""

m2 = md"""
# Markdown rendering in Term.jl
## twp
### three
#### four
##### five
###### six
"""

m3 = md"""
This is an example of markdown content rendered in Term.jl.
You can use markdown syntax to make words **bold** and *italic* or insert `literals`.


You markdown can include in-line latex ``\LaTeX  \frac{{1}}{{2}}`` and maths in a new line too:

```math
f(a) = \frac{1}{2\pi}\int_{0}^{2\pi} (\alpha+R\cos(\theta))d\theta
```

You can also have links: [Julia](http://www.julialang.org) and
footnotes [^1] for your content [^named].

And, of course, you can show some code too:

```julia
function say_hi(x)
    print("Hello World")
end
```

---

You can use "quotes" to highlight a section:

> Multi-line quotes can be helpful to make a 
> paragraph stand out, so that users won't miss it!
> You can use **other inline syntax** in you `quotes` too.
 
but if you really need to grab someone's attention, use admonitions:

!!! note
    You can use different levels

!!! warning
    to send different messages

!!! danger
    to your reader

!!! tip "Wow!"
    Turns out that admonitions can be pretty useful!
    What will you use them for?

---

Of course you can have classic lists:
* item one
* item two
* And a sublist:
    + sub-item one
    + sub-item two

and ordered lists too:
1. item one
2. item two
3. item three


!!! note "Tables"
    You can use the [Markdown table syntax](https://www.markdownguide.org/extended-syntax/#tables)
    to insert tables - Term.jl will convert them to Table object!

| Term | handles | tables|
|:---------- | ---------- |:------------:|
| Row `1`    | Column `2` |              |
| *Row* 2    | **Row** 2  | Column ``3`` |


----

This is where you print the content of your foot notes:

[^1]: Numbered footnote text.

[^note]:
    Named footnote text containing several toplevel elements.

"""

@testset "Test Markdown Strings" begin
    for (i, m) in enumerate([m1, m2, m3])
        t = parse_md(m; width = 60)
        IS_WIN || @compare_to_string(t, "markdown_$i")
    end
end

module Renderables

import Term:
    split_lines,
    reshape_text,
    ltrim_str,
    join_lines,
    unescape_brackets_with_space,
    DEBUG_ON,
    textwidth,
    str_trunc,
    text_to_width,
    get_bg_color,
    textlen,
    NOCOLOR,
    cleantext

import Term

import Term: highlight as highlighter
import ..Consoles: console_width
import ..Measures: Measure
import ..Measures: width as get_width
import ..Segments: Segment, get_string_types
import ..Style: apply_style, MarkupStyle, get_style_codes

export AbstractRenderable, Renderable, RenderableText

# ------------------------------- abstract type ------------------------------ #

"""
    AbstractRenderable
"""
abstract type AbstractRenderable end

Measure(renderable::AbstractRenderable) = renderable.measure

info(r::AbstractRenderable)::String =
    "\e[38;5;117m$(typeof(r)) <: AbstractRenderable\e[0m \e[2m(h:$(r.measure.h), w:$(r.measure.w))\e[0m"

"""
    Base.string(r::AbstractRenderable)::String

Creates a string representation of a renderable
"""
function Base.string(r::AbstractRenderable)
    isnothing(r.segments) && return ""
    seg_texts = getfield.(r.segments, :text)
    stype = get_string_types(r.segments)
    return join(seg_texts, "\n") |> stype
end

Base.String(r::AbstractRenderable) = Base.string(r)

"""
    print(io::IO, renderable::AbstractRenderable)

Print a renderable to an IO
"""
function Base.print(io::IO, renderable::AbstractRenderable; highlight = true)
    ren = unescape_brackets_with_space(string(renderable)) |> apply_style
    NOCOLOR[] && (ren = cleantext(ren))
    return println(io, ren)
end

"""
    show(io::IO, renderable::AbstractRenderable)

Show a renderable.
"""
Base.show(io::IO, renderable::AbstractRenderable) = print(io, info(renderable))

"""
    show(io::IO, mime::MIME"text/plain", renderable::AbstractRenderable)

Show a renderable and some information about its shape.
"""
function Base.show(io::IO, ::MIME"text/plain", renderable::AbstractRenderable)
    println(io, string(renderable))
    DEBUG_ON[] && println(io, info(renderable))
end

# -------------------------------- union type -------------------------------- #
RenderablesUnion = Union{AbstractString,AbstractRenderable}

# ------------------------- generic renderable object ------------------------ #

"""
    Renderable

Generic `Renderable` object.
"""

mutable struct Renderable <: AbstractRenderable
    segments::Vector{Segment}
    measure::Measure
end

"""
    Renderable(
        str::String; width::Union{Nothing,Int} = nothing
    )

Convenience method to construct a RenderableText
"""
Renderable(str::AbstractString) = RenderableText(str)

Renderable(ren::AbstractRenderable) = ren
Renderable() = Renderable(Vector{Segment}[], Measure(0, 0))

# ---------------------------------------------------------------------------- #
#                                TEXT RENDERABLE                               #
# ---------------------------------------------------------------------------- #

"""
    RenderableText

`Renderable` representing a text.

See also [`Renderable`](@ref), [`TextBox`](@ref)
"""

mutable struct RenderableText <: AbstractRenderable
    segments::Vector{Segment}
    measure::Measure
    style::Union{Nothing,String}
end

"""
    RenderableText(text::String; width::Union{Nothing, Int, Symbol}=nothing)

Construct a `RenderableText` out of a string.

The text is resized to fit the given width.
Optionally `justify`  can be used to set the text justification style ∈ (:left, :center, :right, :justify).
"""
function RenderableText(
    text::AbstractString;
    style::Union{Nothing,String} = nothing,
    width::Int = min(Measure(text).w, console_width(stdout)),
    background::Union{Nothing,String} = nothing,
    justify::Symbol = :left,
)
    stype::DataType = typeof(text)
    text = text_to_width(text, width, justify; background = background) |> chomp
    text = apply_style(text)

    style = isnothing(style) ? "" : style
    # background = isnothing(background) ? "" : get_bg_color(background)
    # style = style * background

    style_init, style_finish = get_style_codes(MarkupStyle(style))

    segments = map(ln -> Segment(stype(style_init * ln * style_finish)), split(text, "\n"))

    return RenderableText(segments::Vector{Segment}, Measure(segments), style::String)
end

"""
    RenderableText(rt::RenderableText; width::Union{Nothing,Int} = nothing)

Construct a RenderableText by possibly re-shaping a RenderableText
"""
function RenderableText(
    rt::RenderableText;
    style::Union{Nothing,String} = nothing,
    width::Int = console_width(),
    kwargs...,
)
    return if rt.style == style && rt.measure.w == width
        rt
    else
        text = join_lines([seg.text for seg in rt.segments])
        RenderableText(text; style = style, width = width, kwargs...)
    end
end

function RenderableText(
    ren::AbstractRenderable,
    args...;
    width = console_width(),
    kwargs...,
)
    if ren.measure.w <= width
        return RenderableText(ren.segments, ren.measure, nothing)
    else
        lines = getfield.(ren.segments, :text)
        # texts = map(l -> RenderableText(l, args...; width=width, kwargs...), lines)
        # return foldl(/, texts)
        return RenderableText(join(lines, "\n"), args...; width = width, kwargs...)
    end
end

# ---------------------------------------------------------------------------- #
#                                     MISC.                                    #
# ---------------------------------------------------------------------------- #

"""
    trim_renderable(ren::Union{String, AbstractRenderable}, width::Int)

Trim a string or renderable to a max width.
"""
function trim_renderable(ren::AbstractRenderable, width::Int)::AbstractRenderable
    text = getfield.(ren.segments, :text)
    segs = Segment.(map(s -> get_width(s) > width ? str_trunc(s, width) : s, text))
    return Renderable(segs, Measure(segs))
end

function trim_renderable(ren::RenderableText, width::Int)::RenderableText
    text = join(getfield.(ren.segments, :text))
    return RenderableText(text, width = width)
end

end

using Term.Consoles
import Term: tprint, tprintln

println("\nTesting tprint, stdout temporarily disabled")

@suppress_out begin
    @testset "\e[34mTPRINT" begin
        @test_nothrow tprint("string")
        @test_nothrow tprint("{red}adasd{/red}")
        @test_nothrow tprint("{blue on_green}adasda")
        @test_nothrow tprint("{red}dadas{green}insdai{/green}outssdrse{blue}fsfsf{/blue}")
        @test_nothrow tprint(Panel("test"))
        @test_nothrow tprint(TextBox("test"))
        @test_nothrow tprint(1)
        @test_nothrow tprint(:x)
        @test_nothrow tprint(1, Panel("test"), "test")
        @test_nothrow tprintln("test")
        @test_nothrow tprintln(Panel("test"))
        @test_nothrow tprintln(1, Panel("test"), "test")

        @test_nothrow tprint(stdout, "string")
        @test_nothrow tprint(stdout, "{red}adasd{/red}")
        @test_nothrow tprint(stdout, "{blue on_green}adasda")
        @test_nothrow tprint(
            stdout,
            "{red}dadas{green}insdai{/green}outssdrse{blue}fsfsf{/blue}",
        )
        @test_nothrow tprint(stdout, Panel("test"))
        @test_nothrow tprint(stdout, TextBox("test"))
        @test_nothrow tprint(stdout, 1)
        @test_nothrow tprint(stdout, :x)
        @test_nothrow tprint(stdout, 1, Panel("test"), "test")
        @test_nothrow tprintln(stdout, "test")
        @test_nothrow tprintln(stdout, Panel("test"))
        @test_nothrow tprintln(stdout, 1, Panel("test"), "test")
    end
end

@testset "\e[34mCONSOLE" begin
    @test console_height() == displaysize(stdout)[1]

    @test console_width() == TEST_CONSOLE_WIDTH

    @test sprint(cursor_position) == "\e[6n"
    @test sprint(up) == "\e[1A"
    @test sprint(beginning_previous_line) == "\e[F"
    @test sprint(down) == "\e[1B"
    @test sprint(clear) == "\e[2J"
    @test sprint(hide_cursor) == "\e[?25l"
    @test sprint(show_cursor) == "\e[?25h"
    @test sprint(line) == "\n"
    @test sprint(prev_line) == "\e[1F"
    @test sprint(next_line) == "\e[1E"
    @test sprint(erase_line) == "\e[2K"
    @test sprint(cleartoend) == "\e[0J"
    @test sprint(move_to_line) == "\e[1;1H"
    @test sprint(change_scroll_region) == "\e[1;1r\e[1B"
    @test sprint(savecursor) == "\e[s"
    @test sprint(restorecursor) == "\e[u"
end

import Term: install_term_stacktrace, TERM_SHOW_LINK_IN_STACKTRACE
import Term.Errors: StacktraceContext, render_backtrace

install_term_stacktrace(; hide_frames = false)
TERM_SHOW_LINK_IN_STACKTRACE[] = false

"""
The logic behind these tests is that if something goes
wrong during the error message generation, the 
exception returned by the test
will be different from the one you'd expect
"""

@testset "\e[34mERRORS" begin
    @test_throws MethodError 1 - "a"

    @test_throws DomainError √(-1)

    import Term: Panel
    # @test_throws AssertionError Panel("mytext", title = "this title is waaaay too long!!!", fit=true)

    @test_throws UndefVarError println(sadfsadfasdsfsd)

    @test_throws BoundsError collect(1:10)[20]

    @test_throws DivideError div(2, 0)

    a() = b()
    b() = a()
    @test_throws StackOverflowError a()

    mydict = Dict(:a => "a", :b => "b")
    @test_throws KeyError mydict["a"]

    @test_throws InexactError Int(2.5)

    my_func(; my_arg::Int) = my_arg + 1
    @test_throws UndefKeywordError my_func()

    m = zeros(20, 20)
    n = zeros(5, 4)
    @test_throws DimensionMismatch m .+ n

    @test_throws MethodError exp("hello")  # issue #130

    # @test_throws TaskFailedException Threads.@threads for i in 1:10
    #     i + "a"
    # end
end

@testset "MethodError" begin
    # kwargs call
    struct Test3
        x::Float64
        y::Int

        # Test3(x, y, z) = new(x, y)
        Test3(x, y) = new(x, y)
    end
    @test_throws MethodError Test3(1; a = :test)

    # convert
    f(x)::Vector = 2x
    @test_throws MethodError f(1)
end

# ! this fails to pass tests for some reason.
# @testset "ERRORS - backtrace" begin
#     f2(x) = 2x
#     f1(x) = 3x
#     f0(x; kwargs...) = begin
#         st = stacktrace()
#         ctx = StacktraceContext(TEST_CONSOLE_WIDTH[])
#         bt = render_backtrace(ctx, st; kwargs...)
#         return string(bt)
#     end

#     bt1 = f0(f2(f1(2)); hide_frames = true)
#     bt2 = f0(f2(f1(2)); hide_frames = false)

#     IS_WIN || @compare_to_string(string(bt1), "backtrace_1")
#     IS_WIN || @compare_to_string(string(bt2), "backtrace_2")
# end

import Term: tprintln
using Markdown

text = md"""
 # Markdown rendering in Term.jl
 ## two
 ### three
 #### four
 ##### five
 ###### six

 This is an example of markdown content rendered in Term.jl.
 You can use markdown syntax to make words **bold** and *italic* or insert `literals`.


 You markdown can include in-line latex ``\LaTeX  \frac{{1}}{{2}}`` and maths in a new line too:

 ```math
 f(a) = \frac{1}{2\pi}\int_{0}^{2\pi} (\alpha+R\cos(\theta))d\theta
 ```

 You can also have links: [Julia](http://www.julialang.org) and
 footnotes [^1] for your content [^named].

 And, of course, you can show some code too:

 ```julia
 function say_hi(x)
     print("Hello World")
 end
 ```

 ---

 You can use "quotes" to highlight a section:

 > Multi-line quotes can be helpful to make a 
 > paragraph stand out, so that users won't miss it!
 > You can use **other inline syntax** in you `quotes` too.
  
 but if you really need to grab someone's attention, use admonitions:

 !!! note
     You can use different levels

 !!! warning
     to send different messages

 !!! danger
     to your reader

 !!! tip "Wow!"
     Turns out that admonitions can be pretty useful!
     What will you use them for?

 ---

 Of course you can have classic lists:
 * item one
 * item two
 * And a sublist:
     + sub-item one
     + sub-item two

 and ordered lists too:
 1. item one
 2. item two
 3. item three


 !!! note "Tables"
     You can use the [Markdown table syntax](https://www.markdownguide.org/extended-syntax/#tables)
     to insert tables - Term.jl will convert them to Table object!

 | Term | handles | tables|
 |:---------- | ---------- |:------------:|
 | Row `1`    | Column `2` |              |
 | *Row* 2    | **Row** 2  | Column ``3`` |


 ----

 This is where you print the content of your foot notes:

 [^1]: Numbered footnote text.

 [^note]:
     Named footnote text containing several toplevel elements.
 """

tprintln(text)

tprintln(md"""
Or you can use:

```
using Term: RenderableText
RenderableText(text)
```
""")

# ---------------------------------------------------------------------------- #
#                                ABSTRACT WIDGET                               #
# ---------------------------------------------------------------------------- #

"""
    AbstractWidget

Abstract widgets must have three obligatory fields:
    measure::Measure
    controls:: Dict{Union{KeyInput, Char}, Function}
    parent::Union{Nothing, AbstractWidget}

and one optional one
    on_draw::Union{Nothing, Function} = nothing
"""
abstract type AbstractWidget end

"""
    WidgetInternals

This struct is used to store the internal state of a widget as well as
callbacks assigned to it.
"""
mutable struct WidgetInternals
    measure::Measure
    parent::Union{Nothing,AbstractWidget}
    on_draw::Union{Nothing,Function}
    on_activated::Function
    on_deactivated::Function
    active::Bool
end

# ----------------------------- widget functions ----------------------------- #
"""
    get_active(w::AbstractWidget)

Nothing: no children.
"""
get_active(::AbstractWidget) = nothing

"""
    isactive(w::AbstractWidget)

Returns true if the widget is active, i.e. if it is the active widget
"""
function isactive(widget::AbstractWidget)
    par = AbstractTrees.parent(widget)
    isnothing(par) && return true
    return widget == get_active(par) && isactive(par)
end

"""
Default callback for a widget being activated
"""
on_activated(wdg::AbstractWidget) = wdg.internals.active = true

"""
Default callback for a widget being deactivated
"""
on_deactivated(wdg::AbstractWidget) = wdg.internals.active = false

"""
Quit the current app, potentially returning some value.
"""
function quit end
quit(::Nothing) = return
quit(widget::AbstractWidget, ::Any) = quit(AbstractTrees.parent(widget))
quit(widget::AbstractWidget) = quit(AbstractTrees.parent(widget))

"""
Get the current content of a widget
"""
frame(::AbstractWidget) = error("Not implemented")

# ------------------------------ tree structure ------------------------------ #

"""
Methods to let the AbstractTrees API handle applications as tree
structures based on the nesting of widgets.
"""

function AbstractTrees.children(widget::AbstractWidget)
    hasfield(typeof(widget), :widgets) || return []
    widget.widgets isa AbstractDict && return collect(values(widget.widgets))
    return widget.widgets
end

function AbstractTrees.parent(widget::AbstractWidget)
    hasfield(typeof(widget), :parent) && return widget.parent
    return widget.internals.parent
end

"""
    print_node(io, x) 

Print function to print a node (widget) in an application's hierarchy tree. 
It prints the node's stated dimensions vs its content's (calling `frame`).
Used for debugging
"""
function print_node(io, x)
    color = isactive(x) ? "bright_blue" : "dim blue"
    style = isactive(x) ? "default" : "dim"
    content = frame(x)

    measure = hasfield(typeof(x), :measure) ? x.measure : x.internals.measure
    hx, wx = measure.h, measure.w
    hc, wc = content.measure.h, content.measure.w

    h_color = hx >= hc ? style : "red"
    w_color = wx >= wc ? style : "red"

    msg = """{$color}$(typeof(x)){/$color} {dim} ($hx, $wx){/dim}
           {$style}content: ({$h_color}$hc{/$h_color}, {$w_color}$wc{/$w_color}){/$style}"""
    print(io, apply_style(msg))
end

Base.print(io::IO, widget::AbstractWidget) = print_tree(print_node, print, io, widget)

module Errors

import Base: show_method_candidates, ExceptionStack, InterpreterIP

import Term:
    highlight,
    highlight_syntax,
    str_trunc,
    reshape_text,
    load_code_and_highlight,
    default_stacktrace_width,
    escape_brackets,
    unescape_brackets,
    remove_markup,
    TERM_THEME,
    plural,
    Theme,
    do_by_line,
    STACKTRACE_HIDDEN_MODULES,
    STACKTRACE_HIDE_FRAMES,
    reshape_code_string,
    TERM_SHOW_LINK_IN_STACKTRACE,
    NOCOLOR,
    cleantext

# import ..Links: Link
import ..Style: apply_style
import ..Layout:
    hLine,
    rvstack,
    cvstack,
    rvstack,
    vstack,
    vLine,
    Spacer,
    hstack,
    lvstack,
    pad,
    vertical_pad
import ..Renderables: RenderableText, AbstractRenderable
import ..Panels: Panel
import ..Measures: height

export install_term_stacktrace

"""
Stores information useful for creating the layout
of a stack trace visualization.
"""
struct StacktraceContext
    out_w::Int              # max width of the stacktrace
    frame_panel_w::Int      # width of inner elements like frame panels
    module_line_w::Int      # width of hline to print module name
    func_name_w::Int        # width of frame's function name and file
    code_w::Int             # width of code panels
    theme::Theme
end

function StacktraceContext(w = default_stacktrace_width())
    frame_panel_w = w - 4 - 12 - 3 # panel walls and padding
    module_line_w = w - 4 - 4
    func_name_w = frame_panel_w - 4 - 8 # including (n) before fname
    code_w = func_name_w - 8
    return StacktraceContext(
        w,
        frame_panel_w,
        module_line_w,
        func_name_w,
        code_w,
        TERM_THEME[],
    )
end

include("_errors.jl")

# ---------------------------------------------------------------------------- #
#                              INSTALL STACKTRACE                              #
# ---------------------------------------------------------------------------- #

function print_term_error(io::IO, er, bt, reverse_backtrace, max_n_frames, hide_frames)
    try
        # create a StacktraceContext
        ctx = StacktraceContext()

        # print an hLine with the error name
        ename = string(typeof(er))
        length(bt) > 0 && print(
            io,
            hLine(
                ctx.out_w,
                "{default bold $(ctx.theme.err_errmsg)}$ename{/default bold $(ctx.theme.err_errmsg)}";
                style = "dim $(ctx.theme.err_errmsg)",
            ),
        )

        # print error backtrace or panel
        if length(bt) > 0
            rendered_bt = render_backtrace(
                ctx,
                bt;
                reverse_backtrace = reverse_backtrace,
                max_n_frames = max_n_frames,
                hide_frames = hide_frames,
            )
            print(io, rendered_bt)
        end

        # print message panel if VSCode is not handling that through a second call to this fn

        msg = highlight(sprint(Base.showerror, er)) |> apply_style
        err_panel = Panel(
            RenderableText(
                reshape_code_string(msg, ctx.module_line_w);
                width = ctx.module_line_w,
            );
            width = ctx.out_w,
            title = "{bold $(ctx.theme.err_errmsg) default underline}$(typeof(er)){/bold $(ctx.theme.err_errmsg) default underline}",
            padding = (2, 2, 1, 1),
            style = "dim $(ctx.theme.err_errmsg)",
            title_justify = :center,
            fit = false,
        )
        print(io, err_panel)

    catch cought_err  # catch when something goes wrong during error handling in Term
        @error "Term.jl: error while rendering error message: " cought_err

        for (i, (exc, _bt)) in enumerate(current_exceptions())
            i == 1 && println(io, "Error during term's stacktrace generation:")
            Base.show_backtrace(io, _bt)
            print('\n'^3)
            Base.showerror(io, exc)
        end

        print('\n'^5)
        println(io, "Original error:")
        Base.show_backtrace(io, bt)
        print('\n'^3)
        Base.showerror(io, er)
    end
end

"""
    install_term_stacktrace(; reverse_backtrace::Bool = true, max_n_frames::Int = 30)

Replace the default Julia stacktrace error stacktrace printing with Term's.

Term parses a `StackTrace` adding additional info and style before printing it out to the user.
The printed output consists of two parts:
    - a list of "frames": nested code points showing where the error occurred, the "Error Stack"
    - a message: generally the standard info message given by Julia but with addintional formatting
        option. 

Several options are provided to reverse the order in which the frames are shown (compared to
Julia's default ordering), hide extra frames when a large number is in the trace (e.g. Stack Overflow error)
and hide Base and standard libraries error information (i.e. when a frame is in a module belonging to those.)
"""
function install_term_stacktrace(;
    reverse_backtrace::Bool = true,
    max_n_frames::Int = 30,
    hide_frames = true,
)
    @eval begin
        function Base.showerror(io::IO, er, bt; backtrace = true)
            print(io, "\n")
            # @info "Showing" er bt

            # shorten very long backtraces
            isa(er, StackOverflowError) && (bt = [bt[1:25]..., bt[(end - 25):end]...])

            # if the terminal is too narrow, avoid using Term's functionality
            if default_stacktrace_width() < 70
                println(io)
                @warn "Term.jl: can't render error message, console too narrow. Using default stacktrace"
                Base.show_backtrace(io, bt)
                print(io, '\n'^3)
                Base.showerror(io, er)
                return
            end

            # print
            err = sprint(
                print_term_error,
                er,
                bt,
                $(reverse_backtrace),
                $(max_n_frames),
                $(hide_frames),
            )
            NOCOLOR[] && (err = cleantext(err))
            print(io, err)
        end
    end
end

end

import Term: Theme, set_theme, demo_theme

@testset "\e[34mtheme" begin
    io = PipeBuffer()
    show(io, MIME("text/plain"), Theme())  # coverage
    @test read(io, String) isa String

    theme = TERM_THEME[]
    @test set_theme(theme) == theme
end

@testset "Theme demo" begin
    newtheme = Theme(
        name = "default",
        docstring = "green",
        string = "red",
        type = "red",
        code = "bright_blue",
        multiline_code = "bright_blue",
        symbol = "green",
        expression = "bright_Red",
        number = "grey",
        operator = "blue",
        func = "yellow",
        text = "white",
        text_accent = "greeen",
        emphasis = "blue  bold",
        emphasis_light = "yellow",
        info = "#7cb0cf",
        debug = "#197fbd",
        warn = "green",
        error = "bold #d13f3f",
        logmsg = "#8abeff",
        tree_mid = "blue",
        tree_terminator = "blue",
        tree_skip = "blue",
        tree_dash = "blue",
        tree_trunc = "blue",
        tree_pair = "red",
        tree_keys = "green",
        tree_max_leaf_width = 22,
        repr_accent = "green",
        repr_name = "yellow",
        repr_type = "red",
        repr_values = "blue",
        repr_line = "dim red bold",
        repr_panel = "blue",
        repr_array_panel = "green",
        repr_array_title = "bold bright_blue",
        repr_array_text = "red",
        err_accent = "yellow",
        er_bt = "white",
        err_btframe_panel = "green",
        err_filepath = "grey",
        err_errmsg = "red",
        inspect_highlight = "yellow",
        inspect_accent = "green",
        progress_accent = "green",
        progress_elapsedcol_default = "black",
        progress_etacol_default = "green",
        progress_spiner_default = "bold red",
        progress_spinnerdone_default = "blue",
        dendo_title = "green",
        dendo_pretitle = "red",
        dendo_leaves = "default dim",
        dendo_lines = "default dim",
        md_h1 = "bold greem",
        md_h2 = "bold blue underline",
        md_h3 = "bold blue",
        md_h4 = "bold red",
        md_h5 = "bold green",
        md_h6 = "bold red",
        md_latex = "yellow italic",
        md_code = "yellow italic",
        md_codeblock_bg = "red",
        md_quote = "green",
        md_footnote = "red",
        md_table_header = "bold blue",
        md_admonition_note = "red",
        md_admonition_info = "red",
        md_admonition_warning = "green",
        md_admonition_danger = "black",
        md_admonition_tip = "bold white",
        tb_style = "red",
        tb_header = "bold grey",
        tb_columns = "green",
        tb_footer = "green",
        tb_box = :SIMPLE,
        line = "red",
        box = :HEAVY,
    )

    @compare_to_string(demo_theme(newtheme), "theme_demo")
end

module Style

import Parameters: @with_kw

import Term:
    unspace_commas,
    NAMED_MODES,
    has_markup,
    OPEN_TAG_REGEX,
    replace_text,
    CODES,
    ANSICode,
    tview,
    do_by_line,
    ANSI_REGEX

import ..Colors:
    AbstractColor, NamedColor, is_color, is_background, get_color, is_hex_color, hex2rgb

export apply_style

apply_style(text::String, style::String) =
    if occursin('\n', text)
        do_by_line(ln -> apply_style(ln, style), text)
    else
        apply_style("{" * style * "}" * text * "{/" * style * "}")
    end

"""
Check if a string is a mode name
"""
is_mode(string) = string ∈ NAMED_MODES

# ---------------------------------------------------------------------------- #
#                                  MarkupStyle                                 #
# ---------------------------------------------------------------------------- #
"""
    MarkupStyle

Holds information about the style specification set out by a `MarkupTag`.
"""
@with_kw mutable struct MarkupStyle
    default::Bool = false
    bold::Bool = false
    dim::Bool = false
    italic::Bool = false
    underline::Bool = false
    blink::Bool = false
    inverse::Bool = false
    hidden::Bool = false
    striked::Bool = false
    color::Union{Nothing,AbstractColor} = nothing
    background::Union{Nothing,AbstractColor} = nothing
end

"""
    MarkupStyle(tag::MarkupTag)

Builds a MarkupStyle definition from a MarkupTag.
"""
function MarkupStyle(markup)
    style = MarkupStyle()
    for code in split(unspace_commas(markup))
        if is_mode(code)
            setproperty!(style, Symbol(code), true)
        elseif is_color(code)
            style.color = get_color(code)
        elseif is_background(code)
            style.background = get_color(code; bg = true)
            # elseif code != "nothing"
            #     @debug "Code type not recognized: $code"
        end
    end
    return style
end

# -------------------------------- apply style ------------------------------- #

"""
    get_style_codes(style::MarkupStyle)

Get `ANSICode`s corresponding to a `MarkupStyle`.
"""
function get_style_codes(style::MarkupStyle)
    # start applying styles
    style_init, style_finish = "", ""
    for attr in fieldnames(MarkupStyle)
        value = getfield(style, attr)
        if attr ≡ :background
            code = isnothing(value) ? nothing : ANSICode(value; bg = true)
        elseif attr ≡ :color
            if !isnothing(value)
                try
                    code = ANSICode(value; bg = false)
                catch
                    continue
                end
            else
                code = nothing
            end
        elseif attr != :tag && value == true  # MODES
            code = CODES[attr]
        else
            # if value != false && attr != :tag
            #     @debug "Attr/value not recognized or not set" attr value
            # end
            continue
        end

        if !isnothing(code)
            style_init *= code.open
            style_finish *= code.close
            style_finish *= (occursin(code.close, style_finish) ? "" : code.close)
        end
    end

    return style_init, style_finish
end

"""
    apply_style(text)

Apply style to a piece of text.

Extract markup style information and insert the 
appropriate ANSI codes to style a string.

When multiple, nested color tags are present, like in"
    "{red} abcd {green} asd {/green} eadsa {/red}"
extra care should be put to ensure that when `green` is closed
the text is rendered as red. To this end, this function
keeps track of the last color style information and where it occurred in the input
text. If the current markup tag is nested in the previous, it changes, for example
    "{/green}"
to
    "{/green}{red}".
The same in parallel has to be done for background colors. 

By default, "orphaned" tags (i.e. open/close markup tags without the corresponding
tag) are removed from the string. Use `leave_orphan_tags` to change this behavior.
"""
function apply_style(text; leave_orphan_tags = false)::String
    has_markup(text) || return text

    previous_color = (0, length(text), MarkupStyle("default"))
    previous_background = (0, length(text), MarkupStyle("default"))
    while has_markup(text)
        # get opening markup tag
        open_match = match(OPEN_TAG_REGEX, text)
        markup = open_match.match[2:(end - 1)]

        # get style codes
        ms = MarkupStyle(markup)
        ansi_open, ansi_close = get_style_codes(ms)

        # insert open tag
        if ansi_open == "" && ansi_close == "" && leave_orphan_tags
            # found an invalid tag (e.g. {string}). Leave it but edit it to avoid getting stuck in this lookup
            # replace markup with ANSI codes
            text = replace_text(
                text,
                max(open_match.offset - 1, 0),
                open_match.offset + length(markup) + 1,
                "{{" * markup * "}}",
            )
        else
            # replace markup with ANSI codes
            text = replace_text(
                text,
                max(open_match.offset - 1, 0),
                open_match.offset + length(markup) + 1,
                ansi_open,
            )
        end

        # get closing tag (including [/] or missing close)
        close_rx = r"(?<!\{)\{(?!\{)\/" * markup * r"\}"
        if !occursin(close_rx, text)
            text = text * "{/" * markup * "}"
        end
        close_match = match(close_rx, text)

        # if previous style had color and we're nested, use color info
        if open_match.offset > previous_color[1] &&
           close_match.offset < previous_color[2] &&
           !isnothing(previous_color[3].color)
            col_prev_ansi_open, _ = get_style_codes(previous_color[3])
            ansi_close = ansi_close * col_prev_ansi_open
        end

        # and for background
        if open_match.offset > previous_background[1] &&
           close_match.offset < previous_background[2] &&
           !isnothing(previous_background[3].background)
            bg_prev_ansi_open, _ = get_style_codes(previous_background[3])
            ansi_close = ansi_close * bg_prev_ansi_open
        end

        # replace close tag
        text = replace_text(
            text,
            close_match.offset - 1,
            close_match.offset + length(markup) + 2,
            ansi_close,
        )

        # store style info
        isnothing(ms.color) || (
            previous_color = (
                max(open_match.offset - 1, 0),
                close_match.offset + length(markup) + 2,
                ms,
            )
        )

        isnothing(ms.background) || (
            previous_background = (
                max(open_match.offset - 1, 0),
                close_match.offset + length(markup) + 2,
                ms,
            )
        )
    end
    return text
end

end

""" 
multiple strings replacement.
"""
function replace_multi(text::AbstractString, pairs::Pair...)::String
    VERSION ≥ v"1.7" && return replace(text, pairs...)
    VERSION < v"1.7" && begin
        for pair in pairs
            text = replace(text, pair)
        end
    end
    return text
end

plural(word::AbstractString, n) = n <= 1 ? word : word * 's'

# ---------------------------------------------------------------------------- #
#                                     REGEX                                    #
# ---------------------------------------------------------------------------- #
# ---------------------------------- markup ---------------------------------- #

OPEN_TAG_REGEX = r"(?<!\{)\{(?!\{)[a-zA-Z _0-9. ,()#]*\}"
CLOSE_TAG_REGEX = r"\{\/[a-zA-Z _0-9. ,()#]+[^/\{]\}"
GENERIC_CLOSER_REGEX = r"(?<!\{)\{(?!\{)\/\}"

"""
    remove_markup(input_text::AbstractString)::AbstractString

Remove all markup tags from a string of text.
"""
function remove_markup(input_text; remove_orphan_tags = true)::String
    if remove_orphan_tags
        return replace_multi(
            input_text,
            OPEN_TAG_REGEX => "",
            GENERIC_CLOSER_REGEX => "",
            CLOSE_TAG_REGEX => "",
        )
    else
        # turn non-orphaned closing tags in opening tags before removing them
        for match in eachmatch(OPEN_TAG_REGEX, input_text)
            markup = match.match[2:(end - 1)]
            close = r"\{\/" * Regex(markup) * r"\}"
            input_text = replace(input_text, close => "{$markup}", count = 1)
        end
        return replace_multi(input_text, OPEN_TAG_REGEX => "", GENERIC_CLOSER_REGEX => "")
    end
end

""" 
    has_markup(text::String)

Returns `true` if `text` includes a `MarkupTag`
"""
has_markup(text)::Bool = occursin(OPEN_TAG_REGEX, text)

# ----------------------------------- ansi ----------------------------------- #
const ANSI_REGEX = r"\e\[[0-9;]*m"

"""
    remove_ansi(input_text::AbstractString)::AbstractString

Remove all ANSI tags from a string of text
"""
remove_ansi(input_text)::String = replace(input_text, ANSI_REGEX => "")

""" 
    has_ansi(text::String)

Returns `true` if `text` includes a `MarkupTag`
"""
has_ansi(text)::Bool = occursin(ANSI_REGEX, text)

# --------------------------- clean text / text len -------------------------- #
"""
    cleantext(str::AbstractString)

Remove all style information from a string.
"""
cleantext(str)::String = (remove_ansi ∘ remove_markup)(str)

"""
    textlen(x::AbstractString)

Get length of text after all style information is removed.
"""
textlen(x; remove_orphan_tags = false)::Int =
    remove_markup(remove_ansi(x); remove_orphan_tags = remove_orphan_tags) |> textwidth

# --------------------------------- brackets --------------------------------- #
const brackets_regexes = [r"(?<!\{)\{(?!\{)", r"(?<!\})\}(?!\})"]

"""
    escape_brackets(text)::Stringremove_ansi(str)::String

Replace each curly bracket with a double copy of itself
"""
escape_brackets(text)::String =
    replace_multi(text, brackets_regexes[1] => "{{", brackets_regexes[2] => "}}")

"""
    unescape_brackets(text)::String

Replece every double squared parenthesis with a single copy of itself
"""
unescape_brackets(text)::String = replace_multi(text, "{{" => "{", "}}" => "}")

unescape_brackets_with_space(text)::String = replace_multi(text, "{{" => " {", "}}" => "} ")

# ------------------------------ multiline-style ----------------------------- #
"""
    fix_markup_across_lines(lines::Vector{AbstractString})::Vector{AbstractString}

When splitting text with markup tags across multiple lines, tags can get separated
across lines. This is a problem when the text gets printed side by side with other 
text with style information. This fixes that by copying/closing markup tags
across lines as requested.
Essentially, if a tag is opened but not closed in a line, close it at the end of 
the line and add the same open tag at the start of the next, taking care of 
doing things in the correct order when multiple tags are in the same line.
"""
function fix_markup_across_lines(lines::Vector)::Vector
    for (i, ln) in enumerate(lines)
        # loop over each open tag regex
        for open_match in reverse(collect(eachmatch(OPEN_TAG_REGEX, ln)))
            # get closing tag text
            markup = open_match.match[2:(end - 1)]
            close_tag = "{/$markup}"

            # if there's no close tag, add the open tag to the next line and close it on this
            if !occursin(close_tag, ln[(open_match.offset):end]) && !occursin("{/}", ln)
                # @info "carrying over" i markup
                ln = ln * "{/$markup}"
                i < length(lines) && (lines[i + 1] = "{$markup}" * lines[i + 1])
            end
        end
        lines[i] = ln # * "\e[0m"
    end

    return lines
end

""" Check if an ANSI tag is a closer """
function is_closing_ansi_tag(tag::SubString)
    tag ∈ (
        "\e[0m",
        "\e[39m",
        "\e[49m",
        "\e[22m",
        "\e[23m",
        "\e[24m",
        "\e[25m",
        "\e[27m",
        "\e[28m",
        "\e[29m",
    )
end

ansi_pairs = Dict(
    "\e[22m" => "\e[22m",
    "\e[1m" => "\e[22m",
    "\e[1m" => "\e[22m",
    "\e[2m" => "\e[22m",
    "\e[3m" => "\e[23m",
    "\e[3m" => "\e[23m",
    "\e[4m" => "\e[24m",
    "\e[4m" => "\e[24m",
    "\e[5m" => "\e[25m",
    "\e[7m" => "\e[27m",
    "\e[8m" => "\e[28m",
    "\e[9m" => "\e[29m",
)

""" Given an ANSI tag, get the correct closer tag """
function get_closing_ansi_tag(tag::SubString)
    tag ∈ keys(ansi_pairs) && return ansi_pairs[tag]

    # deal with foreground colors
    occursin(r"\e\[3\dm", tag) && return "\e[39m"
    occursin(r"\e\[38[0-9;]*m", tag) && return "\e[39m"

    # deal with background colors
    occursin(r"\e\[4\dm", tag) && return "\e[49m"
    occursin(r"\e\[48[0-9;]*m", tag) && return "\e[49m"
    return nothing
end

"""

Same as `fix_markup_across_lines` but for ANSI style tags.
"""
function fix_ansi_across_lines(lines::Vector)::Vector
    for (i, ln) in enumerate(lines)
        for match in reverse(collect(eachmatch(ANSI_REGEX, ln)))
            ansi = match.match
            is_closing_ansi_tag(ansi) && continue

            # get closing tag
            closer = get_closing_ansi_tag(ansi)

            # check if the closing tag occurs in the line
            if !occursin(closer, ln[(match.offset):end])
                # if no closing, add closing to end of line and tag to start of next line
                ln = ln * closer
                i < length(lines) && (lines[i + 1] = ansi * lines[i + 1])
            end
        end
        lines[i] = ln
    end

    return lines
end

# ---------------------------------------------------------------------------- #
#                                      I/O                                     #
# ---------------------------------------------------------------------------- #
"""
    read_file_lines(path::String, start::Int, stop::Int)

Read a file and select only lines in range `start` -> `stop`.

Returns a vector of tuples with the line number and line content.
"""
function read_file_lines(path::AbstractString, start::Int, stop::Int)
    !isfile(path) && return nothing

    start = start < 1 ? 1 : start
    stop = stop ≥ countlines(path) ? countlines(path) : stop
    lines = readlines(path; keep = true)
    return collect(enumerate(lines))[start:stop]
end

# ---------------------------------------------------------------------------- #
#                                     MISC                                     #
# ---------------------------------------------------------------------------- #
"""
    tview(text, start::Int, stop::Int)

Get a view object with appropriate indices
"""
tview(text, start::Int, stop::Int) = view(text, thisind(text, start):thisind(text, stop))

"""
    replace_text(text::AbstractString, start::Int, stop::Int, replace::AbstractString)

Replace a section of a `text` between `start` and `stop` with `replace`.
"""
function replace_text(text, start::Int, stop::Int, replace::String)::String
    if start == 0
        return replace * text[(stop + 1):end]
    end

    start = isvalid(text, start) ? start : max(prevind(text, start), 1)
    return if start == 1
        text[1] * replace * text[(stop + 1):end]
    elseif stop == ncodeunits(text)
        text[1:start] * replace
    else
        text[1:start] * replace * text[(stop + 1):end]
    end
end

"""
    replace_text(text::AbstractString, start::Int, stop::Int, char::Char='_')

Replace a section of a `text`  between `start` and `stop` with another string composed of repeats of a given character `char`.
"""
function replace_text(text, start::Int, stop::Int, char::Char = '_')::String
    replacement = char^(stop - start)
    return replace_text(text, start, stop, replacement)
end

"""
    ltrim_str(str, width)

Cut a chunk of width `width` form the left of a string
"""
function ltrim_str(str, width)
    edge = nextind(str, 0, width)
    return if edge ≥ ncodeunits(str)
        str
    else
        str[1:edge]
    end
end

"""
    rtrim_str(str, width)

Cut a chunk of width `width` form the right of a string
"""
function rtrim_str(str, width)
    edge = nextind(str, 0, width)
    return str[edge:end]
end

"""
    unspace_commas(text::AbstractString)

Remove spaces after commas.
"""
unspace_commas(text)::String = replace_multi(text, ", " => ",", ". " => ".")

"""
Split a string into a vector of Chars.
"""
chars(text::AbstractString)::Vector{Char} = collect(text)

"""
    join_lines(lines)

Merge a vector of strings in a single string.
"""
join_lines(lines::Vector{String})::String = join(lines, "\n")

"""
    split_lines(text::AbstractString)

Split a string into its composing lines.
"""
split_lines(text::String)::Vector{String} = split(text, "\n")
split_lines(text::SubString)::Vector{String} = String.(split(text, "\n"))

"""
    do_by_line(fn::Function, text::String)

Apply `fn` to each line in the `text`.

The function `fn` should accept a single `::String` argument.
"""
do_by_line(fn::Function, text::AbstractString)::String = join(fn.(split_lines(text)), "\n")

# ------------------------------- reshape text ------------------------------- #
"""
    fillin(text::String)::String

Ensure that each line in a multi-line text has the same width.
"""
function fillin(text; bg = nothing)::String
    lines = split_lines(text)
    length(lines) == 1 && return text

    w = max(map(textlen, lines)...)
    padline(ln) =
        if isnothing(bg)
            ln * " "^(w - textlen(ln))
        else
            ln * "{$bg}" * " "^(w - textlen(ln)) * "{/$bg}"
        end
    return join_lines(map(padline, lines))
end

"""
    str_trunc(text::AbstractString, width::Int)

Shorten a string of text to a target width
"""
function str_trunc(
    text::AbstractString,
    width::Int;
    trailing_dots = "...",
    ignore_markup = false,
)::String
    width < 0 && return text
    textlen(text) ≤ width && return text
    if contains(text, '\n')
        return do_by_line(
            l -> str_trunc(
                l,
                width;
                trailing_dots = trailing_dots,
                ignore_markup = ignore_markup,
            ),
            text,
        )
    end

    trunc =
        reshape_text(text, width - textwidth(trailing_dots); ignore_markup = ignore_markup)
    out = first(split_lines(trunc))
    textlen(out) == 0 && return out
    out[end] != ' ' && (out *= trailing_dots)
    return out
end

# ---------------------------------------------------------------------------- #
#                                     LINK                                     #
# ---------------------------------------------------------------------------- #

"""
    excise_link_display_text(link::String)

Given a link string of the form:
    "\x1b]8;;LINK_DESTINATION\x1b\\LINK_DISPLAY_TEXT\x1b]8;;\x1b\\"
this function returns "LINK_DISPLAY_TEXT" alone.
"""
function excise_link_display_text(link::AbstractString)
    parts = split(link, "\x1b\\")
    return if length(parts) > 1
        replace(parts[2], "\e]8;;" => "")
    else
        ""
    end
end

"""
    string_type(x)
Return the type of `x` if it's an AbstractString, else String
"""
string_type(x) = x isa AbstractString ? typeof(x) : String

"""
Author(s): T Bltg (github.com/t-bltg)
"""
module Grid

import ..Renderables: Renderable, AbstractRenderable
import ..Measures: Measure, default_size, height, width
import ..Layout: PlaceHolder, vstack
import ..Compositors: Compositor

import Term: calc_nrows_ncols

export grid

include("_compositor.jl")

"""
    grid(
        rens::Union{AbstractVector,Tuple,NamedTuple};
        placeholder::Union{Nothing,AbstractRenderable} = nothing,
        placeholder_size::Union{Nothing,Tuple} = nothing,
        aspect::Union{Nothing,Number,NTuple} = nothing,
        layout::Union{Nothing,Tuple,Expr} = nothing,
        show_placeholder::Bool = false,
        pad::Union{Tuple,Integer} = 0,
        order::Symbol = :row,
    )

# Description

Construct a grid from an iterable (`AbstractVector`, `Tuple`, `NamedTuple`).

Lays out the renderables to create a grid with the desired aspect ratio or
layout (number of rows, number of columns, or one left free with `nothing`).
Complex layout is supported using compositor expressions.

# Arguments

`placeholder`: placeholder for empty grid components.
`placeholder_size`: size of the auto-placeholder.
`aspect`: target grid aspect ratio.
`layout`: tuple (rows, cols) final size or complex expression.
`show_placeholder`: display/hide placeholder(s).
`pad`: additional padding between layout components.
`order`: `:row` for row major input iteration (default) or `:col` for column major.
"""
function grid(
    rens::Union{AbstractVector,Tuple,NamedTuple};
    placeholder::Union{Nothing,AbstractRenderable} = nothing,
    placeholder_size::Union{Nothing,Tuple} = nothing,
    aspect::Union{Nothing,Number,NTuple} = nothing,
    layout::Union{Nothing,Tuple,Expr} = nothing,
    show_placeholder::Bool = false,
    pad::Union{Tuple,Integer} = 0,
    order::Symbol = :row,
)
    rens_seq = if rens isa NamedTuple
        collect(values(rens))
    elseif rens isa Tuple
        collect(rens)
    else
        rens
    end

    ph_style = show_placeholder ? "" : "hidden"

    if layout isa Expr
        sizes = size.(rens_seq)
        # arbitrary, if `placeholder_size` not given, take the smallest `Renderable` size for placeholders
        ph_size =
            something(placeholder_size, (minimum(first.(sizes)), minimum(last.(sizes))))

        kw = Dict{Symbol,Any}()
        n = 0
        for (i, e) in enumerate(get_elements_and_sizes(layout; placeholder_size = ph_size))
            kw[nm] = if (nm = e.args[1]) ≡ :_
                compositor_placeholder(nm, ph_size..., ph_style)
            elseif haskey(kw, nm)
                kw[nm]  # repeated element
            elseif rens isa NamedTuple
                rens[nm]  # symbol mapping
            else
                rens[n += 1]  # stream of `Renderable`s
            end
        end
        compositor =
            Compositor(layout; placeholder_size = ph_size, check = false, pairs(kw)...)
        return Renderable(compositor)
    end

    nrows, ncols = isnothing(layout) ? calc_nrows_ncols(length(rens), aspect) : layout
    if isnothing(nrows)
        nrows, r = divrem(length(rens), ncols)
        r == 0 || (nrows += 1)
    elseif isnothing(ncols)
        ncols, r = divrem(length(rens), nrows)
        r == 0 || (ncols += 1)
    end

    fill_in = something(placeholder, PlaceHolder(first(rens); style = ph_style))
    rens_all = vcat(rens_seq, fill(fill_in, nrows * ncols - length(rens)))

    sz, permute = if order ≡ :row
        (ncols, nrows), true
    elseif order ≡ :col
        (nrows, ncols), false
    else
        throw(ArgumentError("`$order` not understood"))
    end

    return grid(reshape(rens_all, sz...) |> (permute ? permutedims : identity); pad = pad)
end

"""
    grid(
        rens::Nothing = nothing;
        placeholder_size::Union{Nothing,Tuple} = nothing,
        layout::Union{Nothing,Tuple,Expr} = nothing,
        kw...
    )

Construct a grid of `PlaceHolder`s, for a given layout.
"""
function grid(
    rens::Nothing = nothing;
    placeholder_size::Union{Nothing,Tuple} = nothing,
    layout::Union{Nothing,Tuple,Expr} = nothing,
    kw...,
)
    isnothing(layout) &&
        throw(ArgumentError("`layout` must be given as `Tuple` of `Integer`s or `Expr`"))
    return grid(
        fill(PlaceHolder(something(placeholder_size, default_size())...), prod(layout));
        layout = layout,
        kw...,
    )
end

"""
    grid(rens::AbstractMatrix; pad::Union{Tuple,Integer} = 0))

Construct a grid from an `AbstractMatrix`.
"""
function grid(rens::AbstractMatrix; pad::Union{Tuple,Integer} = 0)
    hpad, vpad = if pad isa Integer
        (pad, pad)
    else
        pad
    end
    rows = collect(
        foldl((a, b) -> a * ' '^hpad * b, col[2:end]; init = first(col)) for
        col in eachrow(rens)
    )
    if vpad > 0
        vspace = vpad > 1 ? vstack(fill(" ", vpad)...) : " "
        cat = (a, b) -> a / vspace / b
    else
        cat = (a, b) -> a / b
    end
    return foldl(cat, rows[2:end]; init = first(rows))
end

end

using Suppressor
import Suppressor: @capture_out
using StableRNGs
using Term
using Test
import Term: console_width
import Term: Tree, Dendogram, Table, Compositor

const RNG = StableRNG(1337)

include("__test_utils.jl")

using TimerOutputs: TimerOutputs, @timeit
const TIMEROUTPUT = TimerOutputs.TimerOutput()

import Term.Consoles: Console, enable, disable

Term.DEBUG_ON[] = false
const TEST_DEBUG_MODE = false  # renderables are saved as strings
const TEST_CONSOLE_WIDTH = 80
const IS_WIN = Sys.iswindows()
con = Console(TEST_CONSOLE_WIDTH)
enable(con)

macro runner(fn)
    quote
        tprintln(
            $(
                "\n{bold green}Running:{/bold green} {underline bold white}'$fn'{/underline bold white}"
            ),
        )
        @time @timeit_include($fn)
    end |> esc
end

# @testset "Ambiguous methods" begin
#     @test Test.detect_ambiguities(Term; recursive=true)
# end

@runner "01_test_text_utils.jl"
@runner "02_test_ansi.jl"
@runner "03_test_measure.jl"
@runner "04_test_style.jl"
@runner "05_test_macros.jl"
@runner "06_test_box.jl"
@runner "07_test_renderables.jl"
@runner "08_test_panel.jl"
@runner "09_test_layout.jl"
@runner "10_test_inspect.jl"
@runner "11_test_theme.jl"
@runner "12_test_console.jl"
@runner "13_test_logs.jl"
@runner "14_test_highlight.jl"
@runner "15_test_progress.jl"
@runner "16_test_tree.jl"
@runner "17_test_dendogram.jl"
@runner "18_test_table.jl"
@runner "19_test_repr.jl"
@runner "20_test_compositor.jl"
@runner "21_test_markdown.jl"
@runner "22_test_grid.jl"
@runner "23_test_link.jl"
@runner "24_prompts.jl"
@runner "25_annotations.jl"
@runner "26_test_live.jl"
@runner "98_test_examples.jl"
@runner "99_test_errors.jl"

show(TIMEROUTPUT; compact = true, sortby = :firstexec)
println('\n')
disable(con)

import Term: load_code_and_highlight
using Term.LiveWidgets
import Term.Consoles: console_width

"""
Simple example showing how to load a file's content and highlight the syntax to then 
use a pager to view it in the terminal. 

Multiple pagers are visualized via a Gallry widget.
"""

import Term.LiveWidgets: LIVE_DEBUG
LIVE_DEBUG[] = false

filepath1 = "././src/live/abstract_widget.jl"
filepath2 = "././src/live/gallery.jl"

gallery = Gallery(
    [
        Pager(
            load_code_and_highlight(filepath1);
            height = 40,
            title = filepath1,
            line_numbers = true,
            width = console_width() - 6,
        ),
        Pager(
            load_code_and_highlight(filepath2);
            height = 40,
            title = filepath2,
            line_numbers = true,
            width = console_width() - 6,
        ),
    ];
    height = 50,
)

app = App(gallery)
play(app; transient = true)

#TODO pager update tot lines, line number...

module Measures

import Term: rint, remove_ansi, remove_markup, default_width, DEFAULT_ASPECT_RATIO, textlen
import Base: ==
export Measure

"""
    Measure

Stores the size of a piece of renderable material.
"""
mutable struct Measure
    h::Int
    w::Int
end

Base.string(M::Measure) = "(h: $(M.h), w: $(M.w))"
Base.show(io::IO, M::Measure) = print(io, "Measure (h: $(M.h), w: $(M.w))")

"""
    default_size()

Returns default size (h, w).
"""
default_size() = (rint(default_width() / 2DEFAULT_ASPECT_RATIO[]), default_width())

"""
    Measure(str::String)

Constructs a measure object from a string
"""
function Measure(str::AbstractString)
    str = remove_markup(remove_ansi(str); remove_orphan_tags = false)
    lines = split(str, '\n')
    return Measure(length(lines), maximum(textlen.(lines; remove_orphan_tags = false)))
end

Measure(::Nothing) = Measure(0, 0)
Measure() = Measure(0, 0)

"""
The sum of measures returns a measure with the highest value along each dimension.
"""
Base.:+(m1::Measure, m2::Measure)::Measure = Measure(m1.h + m2.h, max(m1.w, m2.w))

==(m1::Measure, m2::Measure)::Bool = m1.h == m2.h && m1.w == m2.w

"""
    width

Measure the width of renderable objects (text, AbsstractRenderable).
"""
width(x) = width(string(x))
width(x::AbstractString) = Measure(x).w

"""
    height

Measure the height of renderable objects (text, AbsstractRenderable).
"""
height(x) = height(string(x))
height(x::AbstractString) = Measure(x).h

Base.size(m::Measure) = (m.h, m.w)

end

import Term.Colors:
    is_named_color,
    is_rgb_color,
    is_hex_color,
    is_color,
    is_background,
    get_color,
    NamedColor,
    RGBColor,
    BitColor

@testset "\e[34mANSI detect color" begin
    for name in ["red", "blue", "black", "grey42", "deep_sky_blue3", "dark_blue"]
        @test is_named_color(name)
        @test is_color(name)
        @test !is_rgb_color(name)
        @test !is_hex_color(name)
    end

    for name in ["255", "1", "21", "6", "128"]
        @test is_named_color(name)
        @test is_color(name)
        @test !is_rgb_color(name)
        @test !is_hex_color(name)
    end

    rgbs = ["(1, .8, .0)", "(.2,.1,.33)", "(.5,0.1, .99)", "(255, 128,128)", "(128,58,200)"]
    for rgb in rgbs
        @test is_rgb_color(rgb)
        @test is_color(rgb)
        @test !is_hex_color(rgb)
        @test !is_named_color(rgb)
    end

    hexes = ["#ffffff", "#000000", "#dadada", "#123123"]
    for hex in hexes
        @test is_hex_color(hex)
        @test is_color(hex)
        @test !is_named_color(hex)
        @test !is_rgb_color(hex)
    end
end

@testset "\e[34mANSI get color" begin
    for name in ["red", "blue", "black"]
        @test get_color(name) isa NamedColor
    end

    for name in ["255", "1", "21", "6", "128", "grey42", "deep_sky_blue3", "dark_blue"]
        @test get_color(name) isa BitColor
    end

    for rgb in
        ["(1, .8, .0)", "(.2,.1,.33)", "(.5,0.1, .99)", "(255, 128,128)", "(128,58,200)"]
        @test get_color(rgb) isa RGBColor
    end

    hexes = ["#ffffff", "#000000", "#dada1a", "#123123"]
    for hex in hexes
        @test get_color(hex) isa RGBColor
    end
end

@testset "\e[34mANSI background color" begin
    for name in ["on_red", "on_blue", "on_black"]
        @test is_background(name)
        @test !is_color(name)
        @test get_color(name; bg = true) isa NamedColor
    end

    for name in ["on_255", "on_1", "on_21", "on_6", "on_128"]
        @test is_background(name)
        @test !is_color(name)
        @test get_color(name; bg = true) isa BitColor
    end

    for rgb in [
        "on_(1, .8, .0)",
        "on_(.2,.1,.33)",
        "on_(.5,0.1, .99)",
        "on_(255, 128,128)",
        "on_(128,58,200)",
    ]
        @test is_background(rgb)
        @test !is_color(rgb)
        @test get_color(rgb; bg = true) isa RGBColor
    end

    hexes = ["on_#ffffff", "on_#000000", "on_#dada2a", "on_#123123"]
    for hex in hexes
        @test is_background(hex)
        @test get_color(hex; bg = true) isa RGBColor
    end
end

"""
    This example shows how to use Term's layout functionality.


When creating structured terminal output, you want to have control
over what goes well. Maybe you want to print two panels, side by side, 
or you want to stack them vertically. Maybe you want to have some space
between content or use line to delimit sections of content that should be
separate. Term.jl has got your back.
"""

"""
Let's start with stacking. 
You can use `*` to horizontally stack content, and `/` to stack it
vertically.
"""

using Term
using Term.Layout

# with strings
s1 = @red "one string"
s2 = @green "and another"

println(s1 * " " * s2)
println(s1 / s2)

# with panels (and text boxes)
p1 = Panel("content {blue}content{/blue} "^10; fit = false, width = 30)
tb1 = TextBox("this is a text box! "^5; width = 66)

println(p1 * tb1)
println(p1 / tb1)

# you can stack multiple things too, and mix types
println(s1 / p1 / s2 / tb1)

"""
Now, stacking things is great, but want if you want some space between them?
`Spacer` lets you create an empty space with set width and height
"""
space = Spacer(p1.measure.h, 20)  # create empty space with same height as p1!

# horizontally stack everything and print!
top = p1 * space * p1
println(top)

"""
you can use `hLine` and `vLine` to create styled lines to separate pieces of content
"""

print("\n\n\n")
vline = vLine(p1.measure.h; style = "blue")  # create a vertical line as high as the panel
top = p1 * vline * space * vline * p1
line = hLine(top.measure.w, "some space"; style = "red", box = :DOUBLE)

# vertically stack everything and print nested in a panel
println(
    Panel(
        top / line / top;
        title = "layout is great!",
        title_style = "bold red",
        style = "red dim",
        title_justify = :left,
        fit = true,
    ),
)

import Term: cleantext, chars, textlen, split_lines, replace_multi
import Term: Table

cleanstring(x) = replace(string(x), "\r\n" => "\n")
cleansprint(fn, x) = replace(sprint(fn, x), "\r\n" => "\n")

"""
Write one or multiple strings to a text file so that they can 
later be used for testing.
"""
tofile(content::Vector, filepath) =
    open(filepath, "w") do io
        map(ln -> println(io, ln), content)
        close(io)
    end

tofile(content::String, filepath) =
    open(filepath, "w") do io
        print(io, content)
        close(io)
    end

"""
Load a string representation of a renderable from file
and clean it up
"""
fromfile(filepath) = replace_multi(read(filepath, String), "\\n" => "\n", "\\e" => "\e")

fromfilelines(filepath) = readlines(filepath)

"""
Highlight different characters between two strings.
"""
function highlight_diff(s1::String, s2::String; stop = 500)
    s1 == s2 && return

    r(x) = replace(x, ' ' => "⋅")  # replace spaces for visualization
    c1, c2 = Any[collect(r(s1))...], Any[collect(r(s2))...]
    length(c1) != length(c2) &&
        (@warn "Strings have different length: $(length(c1)) vs $(length(c2))")

    for i in 1:min(length(c1), length(c2))
        a, b = c1[i], c2[i]
        color = a == b ? "default" : "bold black on_red"
        c1[i] = "{$color}$a{/$color}"
        c2[i] = "{$color}$b{/$color}"
    end

    hLine("STRING DIFFERENCE $(length(c1)) chrs", style = "red") |> tprint
    hLine("FIRST", style = "blue") |> tprint
    println(s1)
    hLine("SECOND", style = "blue") |> tprint
    println(s2)
    hLine(style = "dim blue") |> tprint

    i = 1
    while i < (min(length(c1), length(c2)) - 50)
        "{dim}Characters $i-$(i+50){/dim}" |> tprintln
        tprintln(
            "{bold blue}(current){/bold blue}  - " * join(c1[i:(i + 50)]),
            highlight = false,
        )
        tprintln(
            "{bold blue}(correct){/bold blue}  - " * join(c2[i:(i + 50)]),
            highlight = false,
        )
        hLine(style = "dim") |> tprint
        print("\n")
        i += 50
        i > stop && break
    end
    hLine(style = "red") |> tprint
end

"""
Load "correct' string from .txt file and correct new lines
for windows.
"""
function load_from_txt(filename)
    filepath = "./txtfiles/$(filename).txt"
    correct = fromfile(filepath)
    IS_WIN && (correct = replace(correct, "\n" => "\r\n"))
    correct
end

"""
    macro compare_to_string(obj, filename::String, fn::Function=x->x)

Check that the string representation of an object is identical to
what's saved in a .txt file at `filename`. If `obj` is an expression or
a renderable first turn it into a string.

If `TEST_DEBUG_MODE=true`, instead of comparing to a file, save the 
obj's string to the file for future comparison. Also print out
the output for visual inspection.
"""
macro compare_to_string(obj, filename, fn = x -> x, skip = nothing)
    __f = string(__source__.file)
    __l = string(__source__.line)
    quote
        txt = if $obj isa Expr
            @capture_out eval($obj)
        else
            $obj
        end |> string
        txt = $fn(txt)

        !isnothing($skip) && (txt = join(split(txt, '\n')[1:(end - $skip)], '\n'))

        filepath = "./txtfiles/$($filename).txt"

        if TEST_DEBUG_MODE || !isfile(filepath)  # if it doesn't exist, create it.
            print("\n"^3)
            tprintln(txt, highlight = false)
            tofile(txt, filepath)
        else
            correct = load_from_txt($filename)
            txt != correct && (@warn "Failed to match to text" $filename $__f $__l)
            highlight_diff(txt, correct)
            @test txt == correct # <-- TEST
        end
    end |> esc
end

# ----------------------------------- misc ----------------------------------- #

same_widths(text::String) = length(unique(textlen.(split_lines(text)))) == 1

function check_widths(text, width)
    for line in split_lines(text)
        @test textlen(line) <= width
    end
end

"""
Extensively test a panel making sure it has
the right size and Measure
"""
macro testpanel(p, h, w)
    quote
        # isnothing($h) || println(vLine(h) * $p)
        # check all lines have the same length
        _p = string($p)

        dw = displaysize(stdout)[2]
        if isnothing($w) || $w > dw
            return nothing
        else
            widths = textwidth.(cleantext.(split(_p, '\n')))
        end

        # println(p, p.measure, widths)
        @test length(unique(widths)) == 1

        # check it has the right measure
        if !isnothing($w)
            @test $p.measure.w == $w
            _txt = $p.segments[1].text
            @test textlen(cleantext(_txt)) == $w
            @test length(chars(cleantext(_txt))) == $w
        end

        if !isnothing($h)
            @test $p.measure.h == $h
            @test length($p.segments) == $h
        end
    end |> esc
end

macro testtree(p, h, w)
    quote
        # check all lines have the same length
        _p = string($p)

        dw = displaysize(stdout)[2]
        if isnothing($w) || $w > dw
            return nothing
        else
            widths = textwidth.(cleantext.(split(_p, '\n')))
        end

        # println(p, p.measure, widths)
        @test length(unique(widths)) == 1

        # check it has the right measure
        if !isnothing($w)
            @test $p.measure.w == $w
        end

        if !isnothing($h)
            @test $p.measure.h == $h
            @test length($p.segments) == $h
        end
    end |> esc
end

nlines(x) = length(split(x, '\n'))
lw(x) = max(length.(split(x, '\n'))...)

"""
Include but with a timer
"""

macro timeit_include(path::AbstractString)
    return :(@timeit TIMEROUTPUT $path include($path))
end

# ------------------------------- test no throw ------------------------------ #

struct NoException <: Exception end

macro test_nothrow(ex)
    return esc(:(@test_throws NoException ($(ex); throw(NoException()))))
end

import Term: default_width
import OrderedCollections: OrderedDict

function repr_get_obj_fields_display(obj)
    theme = TERM_THEME[]

    field_names = fieldnames(typeof(obj))
    length(field_names) == 0 && return RenderableText(
        "$obj{$(theme.repr_type)}::$(typeof(obj)){/$(theme.repr_type)}",
    )
    field_types = map(f -> "::" * string(f), typeof(obj).types)
    _values = map(f -> getfield(obj, f), field_names)

    fields = map(
        ft -> RenderableText(
            apply_style(string(ft[1]), theme.repr_accent) *
            apply_style(string(ft[2]), theme.repr_type),
        ),
        zip(field_names, field_types),
    )

    values = []
    for val in _values
        val = str_trunc(string(val), 45)
        push!(values, RenderableText.(val; style = theme.repr_values))
    end

    return Table(
        OrderedDict(:field => fields, :value => values);
        hpad = 0,
        box = :NONE,
        show_header = false,
        compact = true,
    )
end

"""
    typename(typedef::Expr)

Get the name of a type as an expression
"""
typename(typedef::Expr) =
    if typedef.args[2] isa Symbol
        typedef.args[2]
    elseif typedef.args[2].args[1] isa Symbol
        typedef.args[2].args[1]
    elseif typedef.args[2].args[1].args[1] isa Symbol
        typedef.args[2].args[1].args[1]
    else
        error("Could not parse type-head from: $typedef")
    end

"""
Create a Panel showing repr content using the current theme's style info.
"""
repr_panel(
    obj,
    content,
    subtitle;
    width = min(console_width() - 10, default_width()),
    justify = :center,
    kwargs...,
) = Panel(
    content;
    fit = true,
    title = isnothing(obj) ? obj : escape_brackets(string(typeof(obj))),
    title_justify = :left,
    width = width,
    justify = justify,
    style = TERM_THEME[].repr_panel,
    title_style = TERM_THEME[].repr_name,
    padding = (1, 1, 1, 1),
    subtitle = subtitle,
    subtitle_justify = :right,
    kwargs...,
)

function vec_elems2renderables(v::Union{Tuple,AbstractVector}, N, max_w; ellipsis = false)
    v = Vector(v)  # necessary to handle sparse vectors
    shortsting(x) =
        x isa AbstractRenderable ? info(x) : remove_markup(str_trunc(string(x), max_w))
    out = highlight.(shortsting.(v[1:N]))

    ellipsis && length(v) > N && push!(out, " ⋮";)
    return out
end

function matrix2content(mtx::AbstractMatrix; max_w = 12, max_items = 50, max_D = 10)
    max_D = if console_width() > 150
        max_D
    elseif console_width() < 80
        3
    else
        5
    end

    N = min(max_items, size(mtx, 1))
    D = min(max_D, size(mtx, 2))

    _D = size(mtx, 2) > max_D ? D - 1 : D
    columns = [vec_elems2renderables(mtx[:, i], N, max_w; ellipsis = true) for i in 1:_D]

    # add a column of ellipses
    if size(mtx, 2) > max_D
        c = repeat(["⋯"], length(columns[1]) - 1)
        push!(c, size(mtx, 1) <= max_items ? "⋯" : "⋱")
        push!(columns, c)

        headers = "(" .* string.(1:(length(columns) - 1)) .* ")" |> collect
        push!(headers, "($(size(mtx, 2)))")
    else
        headers = "(" .* string.(1:length(columns)) .* ")" |> collect
    end

    # add a column of row numbers
    if size(mtx, 1) <= max_items
        pushfirst!(columns, "{dim}(" .* string.(1:length(columns[1])) .* "){/dim}")
    else
        nums = "{dim}(" .* string.(1:(length(columns[1]) - 1)) .* "){/dim}"
        push!(nums, "")
        pushfirst!(columns, nums)
    end
    pushfirst!(headers, "")

    content = Table(
        OrderedDict(map(i -> headers[i] => columns[i], 1:length(columns)));
        vpad = 0,
        hpad = 1,
        compact = true,
        box = :NONE,
        header_style = "dim",
        header_justify = :center,
        columns_justify = :left,
    )
    return content
end

function vec2content(vec::Union{Tuple,AbstractVector})
    max_w = default_width()
    max_items = 50
    N = min(max_items, length(vec))

    N == 0 && return "{bright_blue}empty vector{/bright_blue}"

    vec_items = vec_elems2renderables(vec, N, max_w)
    counts = "(" .* string.(1:length(vec_items)) .* ")"

    length(vec) > N && begin
        push!(vec_items, " ⋮";)
        push!(counts, "";)
    end

    content = Table(
        [counts vec_items];
        show_header = false,
        columns_justify = [:right, :left],
        columns_style = ["dim", "default"],
        # columns_widths = [12, 60],
        vpad = 0,
        hpad = 2,
        compact = true,
        box = :NONE,
    )

    return content
end

style_function_methods(fun; kwargs...) =
    style_function_methods(fun, methods(fun); kwargs...)

style_function_methods(fun, _methods::Base.MethodList; kwargs...) =
    style_function_methods(fun, string(_methods); kwargs...)

"""
Create a styled list of methods for a function.
Accepts `string(methods(function))` as argument.
"""
function style_function_methods(fun, methods::String; max_n = 11, width = default_width())
    _methods = split_lines(methods)
    N = length(_methods)

    _methods = length(_methods) > 1 ? _methods[2:min(max_n, N)] : []
    _methods = map(m -> join(split(join(split(m, "]")[2:end]), " in ")[1]), _methods)
    _methods = map(
        m -> replace(
            m,
            string(fun) => "{bold #a5c6d9}$(string(fun)){/bold #a5c6d9}";
            count = 1,
        ),
        _methods,
    )
    counts = RenderableText.("(" .* string.(1:length(_methods)) .* ") "; style = "bold dim")
    if (m = N - length(_methods) - 1) > 0
        push!(
            _methods,
            "\n{bold dim bright_blue}$m{/bold dim bright_blue}{dim bright_blue} $(plural("method", m)) omitted...{/dim bright_blue}",
        )
    end
    methods_contents = if N > 1
        methods_texts = map(m -> reshape_code_string(m, width - 30), _methods)

        vstack(map(i -> counts[i] * methods_texts[i], 1:length(counts))...)
    else
        fun |> methods |> string |> split_lines |> first
    end

    return methods_contents, N
end

"""
    keyboard_input(widget::AbstractWidget)

Get keyboard input from the terminal and execute the corresponding control function
if it exists. Returns a list of return values from the control functions.
"""
function keyboard_input(widget::AbstractWidget)
    controls = widget.controls
    if bytesavailable(get_terminal().in_stream) > 0
        # get input
        c = readkey(get_terminal().in_stream)
        c = haskey(KEYs, Int(c)) ? KEYs[Int(c)] : Char(c)

        # see if a control has been defined for this key
        haskey(controls, c) && return controls[c](widget, c)

        # see if we can just pass any character
        c isa Char && haskey(controls, Char) && return controls[Char](widget, c)
    end
    return []
end

"""
    keyboard_input(widget::AbstractWidgetContainer) 

Get keyboard input from the terminal and execute the corresponding control function for active widgets.
"""
function keyboard_input(widget::AbstractWidgetContainer)
    retvals = []
    if bytesavailable(get_terminal().in_stream) > 0
        # get input
        c = readkey(get_terminal().in_stream)
        c = haskey(KEYs, Int(c)) ? KEYs[Int(c)] : Char(c) # ::Union{Char, KeyInput}

        # execute command on each subwidget
        for wdg in PreOrderDFS(widget)
            retval = nothing
            controls = wdg.controls

            # see if key is an app control key
            haskey(controls, :setactive) && begin
                control_exectued = controls[:setactive](wdg, c)
                control_exectued && return retval
            end

            # only apply to active widget(s)
            isactive(wdg) || continue

            # see if a control has been defined for this key
            haskey(controls, c) && (retval = controls[c](wdg, c))

            # see if we can just pass any character
            c isa Char && haskey(controls, Char) && (retval = controls[Char](wdg, c))

            # if retval says so, stop looking at other widgets here
            retval == :stop && break
            isnothing(retval) || push!(retvals, retval)
        end
    end
    return retvals
end

print("\n\n\n\n")

using Term

txt = join(
    repeat(["this is a random {red}text{/red} to test {bold}precompilation"], 10),
    "\n",
)

runnable = quote
    originalSTDOUT = stdout
    (outRead, outWrite) = redirect_stdout()

    Panel(txt; fit = false, width = 25) |> tprint
    close(outRead)
    redirect_stdout(originalSTDOUT)
end

println("\n\nFIRST RUN")
tstart = time();
eval(runnable);
tend = time();
tend - tstart |> println

println("\nSECOND RUN")
tstart = time();
eval(runnable);
tend = time();
tend - tstart |> println

# Errors

In `Logging` we've seen how `Term` can replace the default logging system in Julia to produce stylized logging messages. `Term` can do the same for error messages and stack traces.


!!! warning "not for developers"
    Setting up Term's error handling will change this behavior for any downstream user of your code. While this could be okay, it might be surprising and undesirable for some, so do at your own risk. If you're writing code just for you, then go ahead! Term's error messages look great and hopefully they'll help finding and fixing errors more quickly.



Setting up `Term` to handle errors for you is very simple:
```Julia
import Term: install_term_stacktrace

install_term_stacktrace()  # entering the danger zone

function test()
    sum([])
end

test()


```

![](stacktrace.png)


### Term is opinionated

In altering Julia's default stacktraces handling, a few choices where made such as: inverting the order in which the backtrace's stack frames are shown and hiding frames from `Base` or other packages installed through `Pkg` (similarly to [AbbreviatedStackTraces.jl](https://github.com/BioTurboNick/AbbreviatedStackTraces.jl)).
When installing `Term`'s stacktrace system with `install_term_stacktrace`, you can use the keyword arguments to alter this behavior
    
```@example
using Term # hide
install_term_repr() # hide
install_term_stacktrace(;
    reverse_backtrace = true,  # change me!
    max_n_frames = 30,
    hide_frames = false,
)
```

but you can also do more, if you just want to quickly change some options (e.g. to deal with a particularly though bug). You can set flags to change the behavior on the fly:

```@example
import Term: STACKTRACE_HIDDEN_MODULES, STACKTRACE_HIDE_FRAMES

STACKTRACE_HIDDEN_MODULES[] = ["REPL", "OhMyREPL"]  # list names of modules you want ignored in the stacktrace
STACKTRACE_HIDE_FRAMES[] = false # set to true to hide frame, false to show all of them
```

# tprint 
We've seen tprint before. When passed a string with markup information it will print it with the correct style.

```@example tp
import Term: tprint
tprint("This text has {bold gold1 underline}style!")
```

But there's more. Compare `Base.print` with `Term.tprint` here:
```@example tp
print("This is a: ", 1, "of type", typeof(1), "this is a function", print)
print("\n") # hide
tprint("This is a: ", 1, "of type", typeof(1), "this is a function", print)
```

you can see two differences. The first is that when passing multiple comma separated arguments `tprint` inserts a space between them, making the output easier to parse. The second is that it colors certain objects types (`Number`, `DataType` and `Function` in the example). Thus any number will be printed blue, function names will be yellow etc.

In addition, `tprint` will automatically highlight numbers, types etc... in your strings.
```@example tp
tprint("This is a: 1 of type ::Int64 this is a function `print`")
```

!!! info "highlighting"
    By default `tprint` highlights strings before printing them out. If you don't like that, set `tprint(...; highlight=false)`! Also, if your text already has markup or ANSI style information, it won't be highlighted: highlighting styled text get messy!

`Tprint` can also print renderables, of course.
```@example
using Term # hide
tprint(Panel(; width=22, height=2), Panel(; width=22, height=3))
```
As you can see the renderables are printed one above the other. 


Finally, you should know that like `print` has `println`, so `tprint` has `tprintln` to add a new line to the output.

With this we conclude our overview of the basic elements of `Term`: markup style to create styled text, `tprint` to print it to console, renderables like `Panel` and `TextBox` and the layout syntax to create beautiful terminal output. 
There's a lot more you can use `Term` for, but styled text, panels and layout operators will get you far! Enjoy!

# Styled text
The term `styled text` refers to text printed out to a terminal (or other `::IO`) with either color or other style (e.g., bold, italic) information. This is done by adding `ANSI` escape sequences in a string being printed to the terminal. These escape sequences are not rendered as characters but add the style information.

## Style macros
The easiest way to add style information to a `String` in `Term` is using the dedicated macros:

```@example
using Term
println(@green "this is green")
println(@blue "and this is blue")
print("\n")
println(@bold "this is bold")
println(@underline "and this is underlined")
```

To color you can use these macros: `@black, @red, @green, @yellow, @blue, @magenta, @cyan, @white, @default`.
While for styling you have: `@bold @dim @italic @underline`.

Note that the styling macros return a string, so you can combine the resulting strings as you would normally:

```@example
using Term # hide
println(
    @green("This is green") * " and " * @red("this is red")
)
println(
    "Make your text $(@underline("stand out"))!"
)
```

With these style macros you can do some simple styling, but it gets clunky when you want to go beyond adding some color. Let's say you want you text to be blue, bold and underlined; do you really need to use three macros?

Of course not, you can use the `@style` macro!

```@example
using Term # hide
mytext = @style "this is my text" blue bold underline
println(mytext)
```

Like the macros you already know, `@style` returns a string with the desired style, except that now you can specify multiple styles at once! 

## Markup text
The basic styling macros are great for handling simple cases where you just want to add a bit of style to a piece of text. More realistically, you might want more control about exactly which parts of your text have what style. 

As a way of example, let's say you want every other word of yours string:

```julia
str="Every other word has colors!"
```

to have a color. You could do it with macros:

```@example
using Term # hide
e = @red "Every"
o = "other"
w = @green "word"
h = "has"
c = @blue "colors!"

print(join((e, o, w, h, c), " "))
```

but that's awful. String [interpolation](https://docs.julialang.org/en/v1/manual/strings/#string-interpolation) would also not be of much help here. Instead, it would be great if we could specify styles directly inside a normal string and let `Term` figure it out.

Well, that's exactly what we're going to do:
```@example
import Term: tprint
tprint(
    "{red}Every{/red} other {green}word{/green} has {blue}colors!{/blue}"
)
```

Woah! What just happened!!
Two things happened: 1) `Term` styling machinery detects strings segments like `"{red}Every{/red}"` as meaning that the text between `"{...}"` and `"{/...}"` should be colored red and 2) `tprint` (short for term print) detects this style information and applies it to your text before printing. 

Not bad huh? Even better, the style information inside a parentheses can be more than just color:
```@example
using Term # hide
tprint(
    "{bold black underline on_red}So much {gold3 bold}STYLE{/gold3 bold} in this text{/bold black underline on_red}"
)
```
that's right, `Term.jl` can also color the background of your text (by adding `on_C` to your color `C` you set it as the background, see `colors` page). As you can see you can pass multiple style information tags as space separated words within the `"{...}"`. Also, you might have noticed, `Term` can also handle nested style tags!

!!! info "Where did my brackets go!?!?"
    Perhaps you've tried something like `tprint("This is {my} text")` and got surprised when the output was `"This is text"`. If so, read on. What happened there is that `Term.jl` interprets anything with single squared parentheses (`{...}`) as style information
    and removes that from your text output. So in the example it treated `{my}` as a markup style tag and removed it from the text, but `my` is not a valid style so it was ultimately ignored. If you want to use `{}` in your text, you simply need to use double brackets: `tprint("This is {{my}} text")` will print `"This is {my} text"` as expected. 


If you just want to **use** `Term.jl`'s style functionality, just make sure to read the admonition below. If you're curious about what's happening under the hood, read on below!

!!! warning "A note on style tags"
    The style tags used by `Term.jl` have an opening `"{style}"` and closing `"{/style}"` syntax. The style is applied to everything in between. For `"{/style]"` to close `"{style]"` the text in the parentheses must match exactly (excluding `/`), up to the number and position of spaces and the words order. So:
    ```julia
    "{red} wohoo {/red}"  # works
    "{red} wohoo {/red }" # doesn't
    "{bold blue} wohoo {/bold blue}" # works
    "{bold blue} wohoo {/blue bold}" # doesn't
    ```

!!! tip
    Occasionally you can do without the closing tag:
    
    ```@example
    tprint("{red}text")
    ```
    `Term.jl` will add the closing tag to the end of the string for you. Generally though, when multiple styles are 
    applied to the same string, it's better to be explicit in exactly where each style starts and ends.


## Highlighting
Term provides a highlighting functionality to automatically style text (e.g. coloring numbers, code snippets etc.) The usage is very simple
```@example h
import Term: load_code_and_highlight, highlight_syntax, highlight, tprint

tprint(highlight("This text has 1 2 3 numbers, a ::Int type and a :symbol"); highlight=false)
```

pretty easy. Highlighting happens automatically when calling tprint:
```@example h
tprint("This text has 1 2 3 numbers, a ::Int type and a :symbol")
```
but you can turn it off with `tprint(...; highlight=false)`.

You can also specify how you want some text to be highlighted:
```@example h
tprint(highlight("This is just some text", :number))  # it will be colored as number!
```

The colors used for the highlights are specified by the [Theme](@ref ThemeDocs) being used as seen a previous section. 

You can also highlight syntax from code snippets (only Julia code for now):
```@example h

tprint(highlight_syntax("""
function foo(x::Int)
    x^2
end

"""))
```

or just load and highlight a file (showing lines in a specific range):
```Julia

load_code_and_highlight(".../src/highlight.jl", 125; δ=5) |> tprint
```


## Under the hood

If you're reading here you're curious about what exactly is happening under the hood. So let's get started.
`Term.jl`, like `rich` in python, defines a simple markup language to specify the style of bits of strings.
As we saw, the syntax is very simple with an opening and closing tag specifying the style and marking the start and end of the styled text. 

So the first thing that needs to happen is the **detection** of these markup tags. This is surprisingly hard because there are so many possible combinations. You can have markup tags whose style information varies considerably, you can have nested tags, you can have tags spread across lines and you can have nested tags spread across lines:

```@example
using Term # hide
tprint(
    """
And {blue} somehow
it {bold red} all {/bold red}
has to {green underline} always
work {/green underline} correctly {/blue}
somehow.
    """
)
```

```@meta
CurrentModule = Term.Style
```

All of this is taken care of by `Term.Style.apply_style` which extracts markup style information from your strings and replaces them with the appropriate [ANSI escape codes](https://gist.github.com/fnky/458719343aabd01cfb17a3a4f7296797). This is done by parsing the markup information (the text between `{...}`) into a `Term.Style.MarkupStyle` object which stores the style information. Finally, `get_style_codes` get the ANSI codes corresponding to the required style. 
So in summary:

```julia
apply_style("{red}text{/red}")
```
will return a string with style information

```@example
import Term.Style: apply_style  # hide
apply_style("{red}text{/red}") # hide
```

which printed to the console looks like:
```@example
import Term.Style: apply_style  # hide
print(apply_style("{red}text{/red}")) # hide
```

# Nesting

The simplest way to create a layout with multiple elements: put one into the other.
We've already seen how you can do it with `Panel`s:

```@example nesting

import Term: Panel # hide


Panel(
    Panel(
        Panel(
            "We need to go deeper...",
            height=3,
            width=28,
            style="green",
            box=:ASCII,
            title="ED",title_style="white",
            justify=:center
        ),
        style="red", box=:HEAVY, title="ST", title_style="white", fit=true
    ),
    width=44, justify=:center, style="blue", box=:DOUBLE, title="NE", title_style="white"
)

```


okay, nothing crazy here - but we can actually achieve some nice looking layouts with this alone:

```@example nesting
import Term: Panel, TextBox

title = Panel(
    "{white bold}This is an {red} important {/red}title{/white bold}";
    width=60, fit=false, box=:DOUBLE_EDGE, style="bright_blue dim", justify=:center
)
summary = Panel(
    "This is a short summary of the content of the next paragraph."^5;
    width=60, fit=false, style="dim", justify=:left,
    padding=(4, 4, 1, 1), title="Summary", title_style="white default"
)

main_text = TextBox(
    "This is a very long paragraph with a lot of text you don't need to read."^10;
    width=60, fit=false, style="bright_blue dim", justify=:left
)

Panel(title, summary, main_text; style="#9bb3e0", subtitle="Technical details", 
subtitle_justify=:right, subtitle_style="yellow default"
)
```

## Nested layouts? No head ache
If you want to have several nested panels, you might want to make sure that their widths are set correctly so that they fit nicely together. There's a macro for that!

```@example nesting
import Term: @nested_panels
@nested_panels Panel(
    Panel(
        Panel(
            Panel(
                ; title="deepest", style="blue", background="blue"
            ); title="deeper", style="green");
        title="not so deep");
    style="red",
    title="outer"
) 
```
It sets the width of each panel to match their depth. It only works if you're actively calling Panel() in the macro call.
something like this won't work:
```@example nesting
another_panel = Panel("this won't work")
@nested_panels Panel(
    Panel(
        Panel(
            Panel(
                another_panel,
                ; title="deepest", 
            ); title="deeper", style="green");
        title="not so deep");
    style="red",
    title="outer"
) 

```


This is all nice, but, that's not enough... so let' see what more we can do!

# Intro

In the `Basics` section we've learned how to style text, create renderables and stack them into more complex layouts. You can use all of that to produce great terminal output for your Julia code, but that doesn't exhaust the range of things `Term` can do. 

In this section we'll have a look at `Term`'s additional functionality: `logging` discusses how to replace the default logging system in Julia to style logging messages with `Term`, `Errors` looks at how to replace the standard error messages with better ones made by `Term` and `introspection` will discuss `Term`'s `inspect` function which can be used to peek into objects in your Julia code.

Let's get started.

# Renderables
In the previous section we...
```@example
using Term  # hidden
tprint("{green}...have seen how to add some {gold3 bold underline}style{/gold3 bold underline} to our text")  # hidden
```

and that's great, but it's not enough. If you want to create really beautiful and structured terminal outputs, a bit of color and bold text is not enough. You want to be able to create panels to separate different pieces of content, lines to mark out different sections, you want to be able to control the aspect (e.g. line length) of the content you are printing and, most importantly, you want to do all this without too many headaches. `Term.jl` has got your back.

In this section we will look at `Renderable` objects (subtypes of `AbstractRenderable`) such as `TextBox` and `Panel`. Each type of renderable also has a dedicated pages under the section "Renderables" where the renderable is described more in detail. Here we will describe renderables in general, while in the coming section we'll talk about building layouts composed of multiple renderables. 


## AbstractRenderable
This section focuses a bit on how renderables work under the hood. If you just want use `Term` and you don't care too much for how it works, skip ahead to the next section!


When you venture beyond styling simple strings, virtually every object you'll encounter will be a subtype of the  [`AbstractRenderable`](@ref Term.Renderables.AbstractRenderable) type. We will call these objects renderables. Renderable types vary, but they all must have two fields: [`Segment`](@ref Term.Segments.Segment) and [`Measure`](@ref Term.Measures.Measure):


A `Segment` is roughly equivalent to one line of text. Let's take something like this (printed out in your terminal):
```
╭────────────────────╮
│                    │
╰────────────────────╯
```
you can think of this as being made of three segments:
```
# 1
╭────────────────────╮

# 2
│                    │

# 3
╰────────────────────╯
```

When the renderable get's printed each of its segments is printed separately on a new line, giving the illusion of a single object (if we designed the segments correctly). 
In addition, the text stored by a `Segment` already has applied style information to it (i.e. markup tags are converted to ANSI codes), so it's ready to print!

In addition to a vector of segments, a renderable is defined by a `Measure` object. Roughly speaking, a `Measure` object stores information about the size of a renderable **as it will appear in the terminal**. Anything can have a measure: a string of text, a segment (the measure of its text) and a renderable (the combined measure of its segments). This information is crucial when we start putting multiple renderables together. For instance the renderable shown above is a [Panel](@ref PanelDocs) and a `Panel` can be created to fit a piece of text:

```@example
import Term: Panel

print(Panel("this is {red}RED{/red}"; fit=true))
```

in order to do that `Panel` needs to know the size of the text it needs to fit, and that's done by taking its measure (note that the measure correctly ignores the style information to get the size of the text as it will be when printed out).
Finally, we can think of the panel itself as having a `Measure=(17, 3)`: 17 is the width of the panel and 3 its height (the number of segments). Again, this information is crucial when creating layouts of multiple renderables:
```@example

import Term: Panel

print(Panel(;height=3, width=6) * Panel(; height=5, width=12))
```
but more on that in the next section. 


## Other renderables
`Term` comes with a few different types of renderables (we saw `Panel` already, but there's more), but the basic idea is that they are made of segments of text and have a measure. Each renderable has its own additional features on top of that, but those are described more in detail in dedicated pages (look left!).
Briefly, we have `Panel` which creates stuff like what we've just seen, [RenderableText](@ref RtextDoc) which handles rendering text in the console (surprise!) and [TextBox](@ref TBoxDoc) which is somewhat in between the two. Other renderables include things like [Tree](@ref TreeDoc) and, in the future, `Table`. Now lets look at how we can put multiple renderables together!

# App

The starting point of any good "live" or interactive terminal display is an `App`. The `App` takes care of generating and updating the visuals as well as taking in user input making use of it (e.g. to update the display accordingly). 
An app has some content. This content is in the form of `AbstractWidget` elements. These widgets are single content elements that serve a specific function, for example displaying some text or acting as buttons etc. More on widgets later. In addition to knowing **what** is in an app, we also need to specify **how** it should look like. Specifically, how should the different widgets be layed out.  So in addition to creating widgets, you will need to specify a layout for your app. 
There's a lot more to apps, but for now we can start with some simple examples

### A first example
We start with a simple example: an app that only shows one single widget. a `TextWidget` displaying a bit of text. As the output is quite long, we supress the it to avoid cluttering this page. Note that Term 2.0 is required to create live widgets.

```@example app
using Term
using Term.LiveWidgets

app = App(
    TextWidget("""
The starting point of any good "live" or interactive terminal display is an `App`. The `App` takes care of generating and updating the visuals as well as taking in user input making use of it (e.g. to update the display accordingly). 
An app has some content. This content is in the form of `AbstractWidget` elements. These widgets are single content elements that serve a specific function, for example displaying some text or acting as buttons etc. More on widgets later. In addition to knowing **what** is in an app, we also need to specify **how** it should look like. Specifically, how should the different widgets be layed out.  So in addition to creating widgets, you will need to specify a layout for your app. 
There's a lot more to apps, but for now we can start with some simple examples
""")
);

```

Easy. Now to *use* the app you'd call `play(app)`. This starts an interactive session in which the app continuously refreshes its display and reacts to user input until the app is exited by pressing `q` or `Esc`.
Unfortunately we can't do that here in the docs, but we can use `frame` to see what the app would look like
when we start it:

```@example app
frame(app)
```

!!! tip "Ask for help"
    Press `h` while using `play` to interact with an app to display a help tooltip.

### Layout
Ok, one widget apps are not that useful. 
When adding more widgets you'll eventually have to specify how to lay them out. Essentially you want to specify the space taken by the app as a whole  (the width and height in the terminal) and then within that you need to specify the size of each 
widgets and where they are located (e.g. widget A is to the left of B and A,B together are above C).

To specify the layout you need to use an `Expr` like the one used for ['Compositor'](@ref CompositorDocs) content. 
The expression is made of elements like `a(h, w)` where `a` is the layout element's name and `h,w` are the height and width of the element.
Note that `h` has to be an integer (the number of lines spanned by the widget) but `w` can be either `Int` (number of columns) or `Float64` with `0 < w < 1` to specify the fraction of the available space that should be used.

For example:
```julia
:r(10, 0.5)
```
says that the widget `r` should take up 10 lines and half of the available width.

In addition to elements, you can use `*` and `/` to specify the relation between elements: `*` means "to the side of" and `/` means "above".
Combined with parentheses you can get some pretty complex layouts. For example:

```@example app
layout = :(
    :(( a(10, .5) * b(10, .5) )/c(10, 1))
)
```

With a layout in mind you can start creating your app.
Eventually you'll need to provide some widgets too, but if you just want to check the layout (and maybe tweak it) you can 
create an empty app with placeholders to visualize the position of each widget:

```@example app
App(layout) |> frame  
```

Note that you can always specify the `width` and `height` of the app. If you don't, the app will try to use the full terminal size.


!!! tip "Responsive layout"
    If you use a `Float` to specify your layout elements size, the app will automatically resize the elements when the terminal 
    size is reduced. If you also want your app to expand to fill in the whole terminal if the terminal is enlarged, you can use
    `expand` keyword argument for `App`. 



### Adding widgets
To create an app with multiple widgets, you'll need the layout info as shown above and a `Dict` with 
the widgets you want your app to display. The keys in the `Dict` need to match the layout elements names.
For example, to create an app showing two pieces of text.

```@example app

layout = :(a(25, .5) * b(25, .5))

widgets = Dict(
    :a => TextWidget("""To create an app with multiple widgets, you'll need the layout info as shown above and a `Dict` with 
the widgets you want your app to display. The keys in the `Dict` need to match the layout elements names.
For example, to create an app showing two pieces of text.
"""; as_panel=true),
    :b => TextWidget("""
    The starting point of any good "live" or interactive terminal display is an `App`. The `App` takes care of generating and updating the visuals as well as taking in user input making use of it (e.g. to update the display accordingly). 
An app has some content. This content is in the form of `AbstractWidget` elements. These widgets are single content elements that serve a specific function, for example displaying some text or acting as buttons etc. More on widgets later. In addition to knowing **what** is in an app, we also need to specify **how** it should look like. Specifically, how should the different widgets be layed out.  So in addition to creating widgets, you will need to specify a layout for your app. 
There's a lot more to apps, but for now we can start with some simple examples
"""; as_panel=true)
)

App(layout; widgets=widgets) |> frame
```

Note that one panel is dim while the other is not, why?
That's because the app considers the first widget to be 'active' and the brighter color signals that. 
Different widgets show that they are active differently, but generally they use colors to signal to the user that they are 
the currently active one. This is important because user input's (like key presses) will be passed to the currently active widget.
For example, if you have a widget that is a button and it get's pressed by using `spacebar`, then pressing space
will only work if the button is active.

To change the currently active widget you can "navigate" through the app using arrow keys. 
`App` analyzes the `layout` of the app to infer the relative position of the widgets and set up the navigation accordingly.
To test this, use `play` on the app we just created and then left/right arrow to change focus!
(Don't forget to use `q` to exit the app when you're done)

### Activating widgets by keyboard input
Sometimes you want different ways to specify which widget should be active, either by using an arrow key or by pressing a specific key. While there are some defaults for simple apps, you will likely need to specify these "transition rules" manually for most layouts. This is done by passing a `Dict` as the keyword argument `transition_rules` when you create your `App`.  The keys of `transition_rules` should be of type `KeyInput`, and the values should of type `Dict`, mapping symbols to symbols. The wording can get complicated with these nested dictionaries, so the example below hopefully explains how to define apropriate transition rules:
```
App(
    # Layout: 3 columns (a b c), with b split in the middle
    :(a(10, 0.2) * (b1(5, 0.2) / b2(5, 0.2)) * c(10, 0.2)); 
    widgets = Dict(
        :a => TextWidget("Box 1", as_panel=true),
        :b1 => TextWidget("Box 2.1", as_panel=true),
        :b2 => TextWidget("Box 2.2", as_panel=true),
        :c => TextWidget("Box 3", as_panel=true),
    ), transition_rules = Dict(
        ArrowRight() => Dict(:a => :b1, :b1=>:c, :b2=>:c),
        ArrowLeft() => Dict(:c => :b1, :b1=>:a, :b2=>:a),
        ArrowDown() => Dict(:b1 => :b2),
        ArrowUp() => Dict(:b2 => :b1),
    )
)
```
To mentally parse the first transition rule, you should think "When ArrowRight is pressed, if :a is selected, move to :b1. If :b1 is selected, move to :c. If :b2 is selected, move to :c."

# Layout renderables

In this section we'll look at a few renderable types that are useful layout elements: they can be used to insert lines to demarcate different section, create some space or even as place holders for when you want to create a layout but don't have some content yet. 

!!! note "Layout syntax"
    Here we make use of the layout operators `*` and `/` to horizontally and vertically stack renderables. Have a look at the `Layout` section for more details!

## Spacer
`Spacer` creates a *box* of empty text with a given width and height. This can be useful for instance if you're stacking two other renderables but want some space between them:
```@example layout
import Term: Panel
import Term.Layout: Spacer

p = Panel(height=3, width=10)
space = Spacer(3, 5)
print(p * space * p)
print(p * p)
```

## Vertical line
`vLine` does one simple thing: creates a vertical line. You can style it and like for `Panel` you can use different `Boxes` to obtain different looks:
```@example layout

import Term.Layout: vLine
space = Spacer(10, 5)
vLine(10; style="red") * space * vLine(10; style="blue") * space * vLine(10; style="green", box=:DOUBLE)
```

and you can pass another `Renderable` as argument to create a line as tall as it:
```@example layout
import Term: Panel
p = Panel(height=3, width=15)
l = vLine(p)
l * p * l
```

## Horizontal line
Similar to `vLine` (surprising I know), but horizontal:
```@example layout
import Term.Layout: hLine

h1 = hLine(10; style="red")
h2 = hLine(10; style="blue")
h3 = hLine(p; style="green", box=:DOUBLE)
h1 / h2 / h3 / p
```

But! You can use some text to add a "title" to the center of your line:
```@example layout

hLine(100, "{bold white}wow{/bold white}")
```

which can be nice some times. 


## PlaceHolder
Does what it says on the tin. It's a convenience thing to create a renderable with a given size that you can use while you think about how to create a layout:

```@example layout
import Term.Layout: PlaceHolder

p1 = PlaceHolder(10, 35)
p2 = PlaceHolder(10, 35; style="red")
p3 = PlaceHolder(10, 75; style="blue")

(p1 * " "^5 * p2) / " " / p3
```


For more complex layout situations, `Grid` and `Compositor` are your friends. These are a bit more involved so we'll describe them more in detail in a dedicated `Layout` section below. 

# Markdown
If you've had a look at the `REPR` section, you might have noticed that Term is doing some fancy print out of the functions docstrings. That's because docstrings in Julia are represented as Markdown text and Term can parse it nicely!

Let's have a look.

```@example md
import Term.Consoles: Console, enable, disable # hide
con = Console(60) # hide
enable(con) #hide
import Term: tprintln
using Term.TermMarkdown
using Markdown

mymd = md"""
# This is a Markdown file

This is a paragraph of text.
This is a list:
* one
* two
"""
```

and now in Term:
```@example md
import Term: tprintln, tprint
tprintln(parse_md(mymd))
```

or more simply:
```@example md
tprint(mymd)
```

Anything that goes into a Julia's Markdown object can be rendered nicely.

### Maths
```@example md
tprint(md"""
You markdown can include in-line latex ``\sqrt(\gamma)`` and maths in a new line too:


!!! warning
    this is where you'd put multi-line math, but it doesn't work in Documenter - sorry.
    Have a go in your own REPL!
""")

```

### Code

This is what you'd do to show code:
```julia

tprint("""

"this function is a bit pointless"
function my_useless_fn(x)
    println("I don't do much!")
    return x
end

""")
```


```@example md
tprint(md"""

!!! warning
    this is where you'd put multi-line code, but it doesn't work in Documenter - sorry.
    Have a go in your own REPL!
""")
```

### Quotes and admonitions
```@example md
tprint(md"""
You can use "quotes" to highlight a section:

> Multi-line quotes can be helpful to make a 
> paragraph stand out, so that users won't miss it!

but if you really need to grab someone's attention, use admonitions:

!!! note
    You can use different levels

!!! warning
    to send different messages

!!! danger
    to your reader

!!! tip "Wow!"
    Turns out that admonitions can be pretty useful!
    What will you use them for?
""")
```

### Lists
```@example md
tprint(md"""
Of course you can have classic lists:
* item one
* item two
* And a sublist:
    + sub-item one
    + sub-item two

and ordered lists too:
1. item one
2. item two
3. item three

""")
```

### Tables
```@example md
tprint(md"""
!!! note "Tables"
    You can use the [Markdown table syntax](https://www.markdownguide.org/extended-syntax/#tables)
    to insert tables - Term.jl will convert them to Table object!

| Term | handles | tables|
|:---------- | ---------- |:------------:|
| Row `1`    | Column `2` |              |
| *Row* 2    | **Row** 2  | Column ``3`` |
""")

disable(con)  # hide
```


and more (links, footnotes, headers of different levels, etc.)

# [RenderableText](@id RtextDoc)
`RenderableText`, what is it? Exactly what the name says: a renderable that stores a bit of text:
```@example
using Term # hide
rend = RenderableText("""
{bold red}Woah, my first {yellow italic}`Renderable`!
""")
print(rend)
```

Nothing special here. You'll notice that `RenderableText` automatically applies style information though. Also, when we were just styling strings before we had to use `tprint` instead of the normal `print` function to get our styled output. Well no more! `Renderable` objects work well with `print` so you can drop that `t` (when printed renderables print their `Segmen`s remember? `Segment`s already store style information). 

Now, do we really need a whole new type just to print a bit of text? Of course not, but `RenderableText` does more than that!

```@example
import Term: RenderableText

print(RenderableText(","^100; width=25))
print("\n"^2)
print(RenderableText(","^100; width=50))
```

magic! When we pass a width argument `RenderableText` reshapes our input text to the desired width! As you can imagine, when you're creating a layout made up of multiple elements, you want to be able to control the width of each element, so here you go! 

Admittedly this is not huge, but it can come in handy sometimes. More importantly, the behavior of `RenderableText` also give you an idea of what happens to your strings when you put them in a `Panel` or `TextBox` renderable, so let's look at them!

# Layout

Okay, we've seen how you can create style text in various ways and that there's a number of `Renderables` we can use to display different kinds of contents. 
Now, for really cool displays you want to have multiple elements next to each other in a meaningful layout. Here we'll get into the tricks to get layouts of multiple renderables up and running. 

# [Compositor](@id CompositorDocs)
We've just seen how you can use `grid` to achieve nice layouts very easily. That's great when you have a bunch of renderables of the same size and you want to crate a simple layout. If you want to get fancy using grid is not trivial:

```@example compositor
using Term: Panel
using Term.Layout
import Term.Grid: grid

plarge = Panel(height=10, width=60)
psmall = Panel(height=10, width=20)
panels = repeat([psmall], 3)

plarge / grid(panels, layout=(1, 3))
```

you can do it, of course, but the more complex you get the harder it is to handle. You could also use the normal stacking syntax of course:
```@example compositor
plarge / hstack(panels...)
```

but again you suffer from the same problem if you want to create something like, say, this:
```@example compositor
using Term.Compositors # hide
import Term.Compositors: update! # hide
layout = :(vstack(  # hide
            A(5, 40), B(5, 40),  # hide
            hstack(C(5, 18), D(5, 18); pad=4); pad=1 # hide
        ) # hide
        * E(20, 5) * vstack( # hide
            F(5, 40), G(5, 40),  # hide
            hstack(H(5, 18), I(5, 18); pad=4); pad=1 # hide
        ) / O(5, 85) # hide
) # hide

Compositor(layout) # hide
```
that's a total of 10 place holders in a complex layout... surely it must be a pain right?


Nope, not if you use `Compsitor`.
"What is Compositor?" I hear you ask - well let me tell you. 

The idea is that you create the layout you care about using an `Expression` like this:
```@example compositor

layout = :(A(5, 45) * B(5, 45))
```

There `A` and `B` will be two place holders for renderables that make up the layout.
The `(5, 45)` specify the size of the place holders and `*` is the usual stacking operator. 
Give this expression to the `Compositor` and magic happens
```@example compositor
using Term.Compositors

Compositor(layout)
```

`Compositor` parses the expression, creates the place holders and then creates the layout. You just sit back and relax!.

Now, you have a lot of freedom of what goes into the expression, but you need to respect the rule that renderables are specified by a single character name and a size. Other than that, go crazy and use all the syntax for stacking renderables you like!
```@example compositor
layout = :(
        vstack(
            A(5, 40), B(5, 40), hstack(C(5, 18), D(5, 18); pad=4); pad=1
        )
)
Compositor(layout)
```

and remember that you can use interpolation in the expression, so a large expression for a complex layout can be broken down into smaller pieces:
```@example compositor
first_column = :(
    vstack(
            A(5, 40), B(5, 40), hstack(C(5, 18), D(5, 18); pad=4); pad=1
        )
)
second_column = :(
    vstack(
            F(5, 40), G(5, 40), hstack(H(5, 18), I(5, 18); pad=4); pad=1
        )
)

layout = :(
         ($first_column * E(20, 5) * $second_column) / O(5, 85)
)

Compositor(layout)
```

easy peasy.


Some of you might argue: but this way I need to know exactly what size each element has to have in order to fit in the available terminal real estate... that's annoying! Nope, just use `Float64` as dimensions values to specify that you want to fill that fraction of the available space:
```@example compositor
layout = :(A(20, $(0.75)) * B(20, $(0.25)))
Compositor(layout)
```


## Compositor content
Some of you will be thinking: "this is all well and good, but I don't want to just show place holders I've got actual content!". Fair enough, so let's add some.

The easiest thing is to pass content to `Compositor` directly:

```@example compositor

panel = Panel(height=5, width=45)
layout = :(A(5, 45) * B(5, 45))

Compositor(layout; B=panel)
```

done!

But there's more and it's something that warrants an admonition:

!!! warning
    A `Compositor` is not a `Renderable`!!! When stacking renderables, using `grid` etc you get out an actual `Renderable <: AbstractRenderable` which behaves like any good renderable does. `Compositor` does not do that, it does a whole lot more (and even more in the future) but to do that it needs to be different from a renderable. Among other things this means that it can't be stacked/nested with other renderables. But it's worth it!


### Updating a compositor
That's right, you can update a compositor at any time. That's different from, say, using `grid` where you don't have access to its constituents. Here you can grab any element of the layout and update it at will:

```@example compositor
layout = :(A(5, 45) * B(5, 45))

composition = Compositor(layout; B=panel)
update!(composition, :B, panel)
composition
```

nice, but that's not it. You can keep updating stuff!
```@example compositor

another_panel = Panel(height=5, width=45, background="on_red", style="bold red",  box=:SQUARE)
update!(composition, :B, another_panel)
composition
```

and so on... just make sure that the new content has the correct size specified in `layout` or `Compositor` will complain:
```@example compositor

p = Panel()
update!(composition, :B, p)
composition
```

# Intro
This section aims to introduce the basic concepts about `Term`. It will show how to create *styled text* with color and style information and how to create more complex renderable objects such as `Panel` and `TextBox`es. Finally we'll go over how to 'stack' these renderables to crate complex layouts in your terminal. 

The main goal of all of this is to produce beautiful, informative, terminal outputs. 
`Term` can do a lot more than this (e.g., it can replace the standard logging system in Julia), but this kind of advanced functionality is discussed in a separate section.

Let's get started!

# [Logging](@id LoggingDoc)

Julia has a [great logging system](https://docs.julialang.org/en/v1/stdlib/Logging/). If you come from other programming languages like Python you'll likely already love it, but it can be better!

AS you know, if you use logging macros like `@info` with a bunch of arguments after, Julia produces something like this:

```Julia
@info "My log message" 1+1 n="a string!" :x
```

It shows your log messages and then the other arguments as `key = value` display even evaluating expressions like `1 + 1` and showing you the result. Very useful, but visually a bit dull. Also, we might want additional info to be shown: at what time was the log message produced, by which line of code, inside which function, what are the types of the arguments...

Well, `Term` provides logging functionality that gives all that information, plus a ton of styling on top. To do that we need to install `Term`'s own logger (`TermLogger`, very creative name) as the global logger to handle all error messages:

```Julia
import Term: install_term_logger
install_term_logger()
```

Done. Not a lot of work. Now you can just use your logging macros as you would normally, you don't need to change anything. But magic will happen:

```@example termlogger
import Term: TermLogger, TERM_THEME; import Logging: with_logger # hide
with_logger(TermLogger(stderr, TERM_THEME[])) do # hide

@info "My log message" 1+1 n="a string!" :x

end # hide
```

As you can see, it shows all the information that is normally there, an more! 
If your log macro is called from within a function, it will also tell you that:
```@example termlogger
with_logger(TermLogger(stderr, TERM_THEME[])) do # hide

function my_useful_function()
    @info "My log message" 1+1 n="a string!" :x
end

my_useful_function()

end # hide
```

And of course it works nicely with all logging macros:

```@example termlogger
with_logger(TermLogger(stderr, TERM_THEME[])) do # hide

@info "just some info"
@warn "careful!"
@error "uh oh, not good!"

end # hide
```

!!! warning "not for developers"
    Setting up Term's loggers  will change this behavior for any downstream user of your code. While this could be okay, it might be surprising and undesirable for some, so do at your own risk. 

!!! tip
    You can revert to the original logger using `uninstall_term_logger`.


!!! tip "Term and other log outputs"
    See [here](https://discourse.julialang.org/t/term-jl-logging-sending-messages-to-multiple-locations/84841) for some info on how to use Term's logger in conjunction with other logging outputs.

# Live widgets

Alright, making fancy terminal graphics is all good and well, but a bit boring isn't it? Wouldn't it be nice to have something more dynamics. Something that updates over times and maybe even reacts to users input? Well, that's what live widgets are for. Live widgets are a way to make your terminal application more interactive. They are a way to make your terminal application more dynamic. They are a way to make your terminal application more fun. 

Let's go. 

# Prompt

Time for a little example of a simple thing you can use `Term.jl` for: asking for some input. Use a `Prompt`, ask a question, get an answer. Simple, but a little extra style. That's what `AbstractPrompt` types are for. There's a few different flavors, which we'll look at in due time, but essentially a prompt is made of a bit of text, the `prompt` that is displayed to the user, and some machinery to capture the user's input and parse it/ validate it. 

For example:

```@example prompt
using Term.Prompts

prompt = Prompt("Simple, right?");
```

creates a `Prompt` object and `ask` then prints the prompt and asks for input: 
```julia
prompt |> ask
```
the output should look something like
```@example prompt
print(prompt)  # hide
```

here we construct a basic `Prompt` and "ask" it: print the message and capture the reply. `ask` returns the answer, which you can do with as you please. A small warning before we carry on:

!!! warning "Using VSCode"
    As you can see [here](https://discourse.julialang.org/t/vscode-errors-with-user-input-readline/75097/4?u=fedeclaudi), `readlines`, which `AbstractPrompts` use to get the user's input, is a bit troublesome in VSCode. In VSCode, after the prompt gets printed you need to enter "space" (hit the space bar) and then enter and **after** that you can enter your actual replies.

## Prompt flavours
There's a couple more ways you can use prompts like. One is to ensure you get an answer of the correct `Type`, using the imaginatively names `TypePrompt`:

```@example prompt

# this only accepts `Int`s
prompt = TypePrompt(Int, "give me a number")  # don't forget to |> ask
print(prompt) # hide
```


If your answer can't be converted to the correct type you'll get a `AnswerValidationError`, not good.


So, what if you want to get user inputs, but you don't want to handle any crazy input they can provide? Fear not, use `OptionsPrompt` so that only acceptable options will be ok. This will keep "asking" your prompt until the user's answer matches one of the given options

```@example prompt
prompt = OptionsPrompt(["a lot", "so much", "the most"], "How likely would you be to recommend Term.jl to a friend or colleague?") # don't forget to |> ask
print(prompt) # hide
```

Okay, so much typing though. Let's be realistic, most likely you just want to ask a yes/no question and the answer is likely just yes. So just use a `DefaultPrompt`:

```@example prompt

# one says the first option is the default
prompt = DefaultPrompt(["yes", "no"], 1, "Confirm?") # don't forget to |> ask
print(prompt) # hide
```

still too much typing? You can just use the `confirm` function which is equivalent to asking the prompt shown above. 


## Style
The style of prompt elements (e.g. the color of the prompt's text or of the options) is defined in `Theme`. You can also pass style information during prompt creation:

```@example prompt
Prompt("Do you like this color?", "red") |> println
DefaultPrompt(["yes", "no"], 1, "Confirm?", "green", "blue", "red") |> println
```

# Justify

We've seen that you can vertically stack renderables:

```@example justify
using Term
using Term.Layout

p1 = Panel(height=3, width=20)
p2 = Panel(height=3, width=40)
p3 = Panel(height=3, width=60)
vstack(p1, p2, p3;)
```

but when the renderables have unequal lengths they all get pushed to the left. This might not be what you want, so you can use the `justify` function to align them:
```@example justify

center!(p1, p2, p3;)  # there's also the non-modifying `center
vstack(p1, p2, p3;)
```

calling `center!(p1, p3;)` modifies the two renderables to ensure that they have the same width by padding to the left and right so that they're centered. You can also use `rightalign!` and `leftalign!` to align them to the right or left respectively too.

Admittedly, this is nice but the syntax is a bit clunky. But don't worry of course we provide a shorthand notation to stack and justify in one fell swoop (because why would you justify if you're not stacking):

```@example justify
p1 = Panel(height=3, width=20)
p2 = Panel(height=3, width=40)
p3 = Panel(height=3, width=60)

rvstack(p1, p2, p3;)
```

`rvstack` justifies to the right and vertically stacks renderables. Guess what `cvstack` and `lvstack` do?

# Introspection
Introspection refers to code that looks into another bit of code (or itself) to give you more details about it. 

!!! tip "Check out REPR"
    The easiest way to do introspection with Term is to use the [Term Repr](@ref ReprDoc) functionality including functions such as  `termshow` and `@showme` to get all the details you need about your Julia code. Head over there to find out more. 

## `inspect`
You're using a new library, trying to get a hold of the different types they've defined and how they're used. We've all been there, it can take a while and be quite confusing. 
Term to the rescue!

You can now use `inspect(T::DataType)` to get all information you possibly need about a type `T` (and some more). You get: docstring, definition, constructor methods, methods using `T` and methods using `T`'s supertypes. It can be quite a lot of stuff, so you can use some conveniently placed tags to choose what you want to see:


```@meta
CurrentModule = Term.Introspection
```

```@docs
inspect
```

Try, for example: `using Term; inspect(Panel, documentation=true)`.

## `typestree`
As you know, one of Julia's defining features is its hierarchical types structure. Sometimes, you want to get an overview of this hierarchy but there isn't always a convenient way achieve that... or is there...

```@example
import Term: typestree

print(typestree(Float64))

```



## Expression & `expressiontree`
If you're doing a bit of metaprogramming (or teaching it to new Julia coders), you want to get an idea of what the parts of the `Expr` you're building are. You can use `expressiontree` to get a [Tree](@ref TreeDoc) based visualization:

```@example
import Term: expressiontree
expr = :(2x + √x^y)
expressiontree(expr)
```

enjoy!

# Grid
Layout renderables (`hLine`, `vLine`), nesting, stacking... all very nice. But boy is it a lot of work sometimes to combine it all into a single layout!

Well that's were `grid` comes in (and `Compositor` too, see the next page).
The idea is simple: take a bunch of renderables and make a grid out of them:

```@example grid
import Term: Panel
import Term.Grid: grid


panels = repeat([Panel(height=6, width=12)], 8)

grid(panels)
```

Simple, but effective. `grid` gives you a lot of options to control the layout:
```@example grid
grid(panels; pad=2)  # specify padding
```

```@example grid
grid(panels; pad=(8, 1))  # hpad & vpad
```

You can also specify the aspect ratio of the grid:
```@example grid
grid(panels; aspect=1)
```

Note that with an aspect ratio of `1` the best way is to create `3` columns and `3` rows, but we only have `8` renderables! No problem, `grid` introduces a placeholder for the missing renderables. This is not shown by default, but you can see it with:
But you can hide it too:
```@example grid
grid(panels; aspect=1, show_placeholder=true)
```

You can use `layout` to more directly specify the number of rows and columns in the grid:
```@example grid
grid(panels; layout=(3, 4), show_placeholder=true)
```

Leaving a `nothing` argument will auto-magically compute the remaining `rows` or `cols` of the layout:
You can use `layout` to more directly specify the number of rows and columns in the grid:
```@example grid
grid(panels; layout=(3, nothing), show_placeholder=true)
```

One can use complex expressions for layouts, using an underscore `_` to specify empty elements in the layout:
```@example grid
grid(panels[1:6]; layout=:((a * _ * b) / (_ * _ * c * d) / (_ * e * f)))
```

Repeating elements is supported:
```@example grid
grid(panels[1:2]; layout=:((α * _ * α) / (_ * _ * β * β)))
```


!!! note 
    Note that grid uses `vstack` and `hstack` to combine the renderables into the layout you requested. As such, it returns a single renderable, you don't have access to the individual renderables that went into making the grid any longer. This also means that the grid can be stack with other content to create a larger layout. 

# [Annotation](@id AnnotationDocs)

I could describe what an `Annotation` is, but it's easier to show it:
```@example ann
using Term.Annotations

Annotation(
    "This is the main text to annotate",
    "main"=>"by main we mean most important, the rest is annotations",
    "annotate"=>"annotations are just extra bits of info"
)
```

as you can see, `Panel`s with extra messages are displayed underneath the main bit of text. 
Each "annotation" is defined by `Pair`, the first element of the `Pair` is a substring of the 
main text indicating what we want to annotate. The second element is used to specify what we
want to annotate it with. 

If you want to assign some `Style` information to each annotation, you can specify that by using a `Tuple{String, String}` as second element of the `Annotation` `Pair`. In this tuple, the first part refers to the annotation message while the second can store style information. 

```@example ann

Annotation("this has some style", "style"=>("style means color or stuff like bold", "bold red"))
```

and of course you can mix your normal `markup` style too:
Annotation("{bold italic}this{/bold italic} has some style", "style"=>("style means {bright_blue}color{/bright_blue} or stuff like {bold}bold{/bold}", "bold red")). 

---

`Annotation` objects are `AbstractRenderables`, so you can mix and match them with other things too. 
```@example ann
import Term: Panel, highlight_syntax

code = highlight_syntax("Annotation(\"main text\", \"main\"=>\"most important\")")

Panel(
    Annotation(code, "\"main text\""=>"main message to be annotated", "\"main\"=>\"most important\""=>"annotation");
    padding=(4, 4, 2, 1),
    title="Annotation: usage", fit=true, title_style="default green bold",
    title_justify=:center, style="green dim"
)
```

# [Dendogram](@id DendoDoc)

Similarly to [Tree](@ref TreeDoc), `Dendogram` is a renderable that can be used to visualize hierarchical data:

```@example dendo
import Term.Dendograms: Dendogram

dendo = Dendogram("trunk", "the", "tree", "has", "leaves")
print(dendo)
```

As you can see, the first argument is the "trunk" or title of the dendogram while all other arguments are added as leaves. Compare it to a `Tree` renderable:

```@example
import Term: Tree
print(
    Tree(
        Dict(:a=>"the", :b=>"tree", :c=>"has", :d=>"leaves")
    )
)
```

If you've seen [Tree](@ref TreeDoc), you'll know that `Tree` can handle nested hierarchical structures, what about `Dendogram`? The way you do that is by `linking` individual dendograms:

```@example dendo
import Term.Dendograms: link

mydend = Dendogram("first", [1, 2])
otherdend = Dendogram("other", [:a, :b])

print(
    link(mydend, link(otherdend, otherdend; title="another level"); title="One level")
)
```

# Widgets

Widgets are the building blocks that `App`s are made of. 
A widget is generally a single piece of content with a specific function (display text, act as a button...).

## Predefined widgets
`Term` comes with a bunch of widgets you can already plug into your applications.
If you want to develop your own, read below. 

### TextWidget
We've seen this already, it's the simplest widget: just show some text. 


```@example widgets
using Term.LiveWidgets

TextWidget("Hello world!") |> frame

```

unlike other widgets it doesn't have a whole lot of options, just gives you the 
choice of showing just text or a panel:
```@example widgets
TextWidget("Hello world!", as_panel=true) |> frame
```

### InputBox
This widget is a bit more complex. It's a text input box. It's a bit like a `TextWidget` but it also allows the user to type in it.
When this widget is active, any key press get's captured and displayed as text in the widget. 
As usual things like Space Bar, Enter and Del add spaces, new lines and delete characters respectively. 
Make an `App` with an `InputBox` to see how it works!

### Buttons
```@example widgets
Button("Click me please!") |> frame
```
You can specify the color of the text and the button. You can also pass a `callback`: a `Function` that gets called 
when the button is pressed. 

Normally, when pressed, a button will change its color to indicate that it has been pressed and then revert to its
original style. If you want something that acts like a toggle switch, use `ToggleButton` instead. 



### Menus

The idea is simple, provide the user with some option and let them choose one. 
```@example widgets
SimpleMenu(["Option 1", "Option 2", "Option 3"]) |> frame
```

the user can use the arrow keys to navigate the menu and press Enter to select an option.
Selecting an options quits the application and returns an integer with the index of the selected option.
`active_style, inactive_style` can be used to set the style of the currently active options while the user 
navigates the menu. The `layout` options lets you choose if you want the options to be displayed horizontally or vertically.
If you want the menu elements to stand out more, you can use `ButtonsMenu`. 


If you want to let users select more than one option at once, use `MultiSelectMenu`. It shows a checkbox like display and 
users can use the space bar to toggle the state of the checkbox.

### Pager
A pager is a widget that lets you display a lot of text in a scrollable window. 
```@example widgets
Pager("This is a pager. It lets you display a lot of text in a scrollable window."^300) |> frame
```

You can use various keyboard inputs to navigate the pager (arrows to move up and down and to page up and down, Home and End to go to the top and bottom of the text respectively).

You can specify the size (height and width) of the pager and if line numbers should be shown (useful to display code):

```@example widgets
Pager("This is a pager. It lets you display a lot of text in a scrollable window."^300, height=20, width=20, line_numbers=true) |> frame
```


### Gallery

A `Gallery` is somewhat in between a widget and an `App`. It's a container for other widgets. 
Only one widget at the time is displayed in the space taken by the `Gallery`.

```@example widgets
g = Gallery(
    [TextWidget("Hello world!"), TextWidget("Not shown")];
    height = 25, width=60, title="My gallery"
) |> frame
```

Use arrows to change which widget is active. 


## Defining widgets
All widgets are subtypes of the `abstract type AbstractWidget`.
A new widget type needs to be defined as a `mutable struct` and it needs to have two obligatory fields:
```julia
    internals::WidgetInternals
    controls::AbstractDict
```

`WidgetInternals` is a struct that contains the state of the widget. It keeps track of things like the size 
of the widget and the three callback functions `on_draw`, `on_activated` and `on_deactivated`. 
These are optional functions that are called when `frame` is called on a widget or when the widget is activated or deactivated.
The activated/deactivated functions can be used to change the appearance of the widget to signal to the user that the widget is active or not.

`controls` is a `Dict{Union{Char, KeyboardInput}, Function}` that says how keyboard inputs should be used: it maps a keyboard input to a function that gets called when that input is pressed if the widget is active. 

Other than these obligatory fields, the `struct` needs to have anything that the widget needs to work.

Two obligatory methods need to be defined for the widget to work. 
`frame(w::MyWidget; kwargs...)::AbstractRenderbles`  is the function that gets called when the app's display is updated. The renderable that is returned is what gets displayed on the screen.
`on_layout_change(w::MyWidget, m::Measure)` says what should happen when the app gets resized. The `Measure` is the new size of the widget.
Usually it's enough to do something like:
```julia
on_layout_change(t::TextWidget, m::Measure) = t.internals.measure = m
```


To get an idea of how to define a widget, take a look at the source code of the widgets that come with `Term`.

# Colors
Okay, so far so good. We can use macros like `@red` and the `tprint` function to print colored strings. But so far we've only been using few named colors, but..

```@example
import Term: rint, tprint # hide
function rainbow_maker() # hide
    text = "there's a whole rainbow\n of colors out there" # hide
    _n = Int(length(text)/2)  # hide
    R = hcat(range(30, 255, length=_n), range(255, 60, length=_n))  # hide
    G =hcat(range(255, 60, length=_n), range(60, 120, length=_n))  # hide
    B = range(50, 255, length=length(text))  # hide
    out = ""  # hide
    for n in 1:length(text)  # hide
        r, g, b = rint(R[n]), rint(G[n]), rint(B[n])  # hide
        out *= "{($r, $g, $b)}$(text[n]){/($r, $g, $b)}"  # hide
    end # hide
    return out  # hide
end # hide
tprint(rainbow_maker(); highlight=false) # hide
```

so how can we use different kinds of colors?
It's all done through `Term`'s markup syntax of course. Look:
```@example
using Term: tprint # hide
tprint("{(255, 50, 100)}colors!{/(255, 50, 100)}"; highlight=false)
```

yep, you can pass a set of `(r, g, b)` values and that'll do it. Personally, I prefer working with hex codes, and so `Term` can accept them too:
```@example
using Term: tprint # hide
indigo = "#42A5F5"

tprint("Some {$indigo}color!{/$indigo}"; highlight=false)
```

## Under the hood
What `Term` is doing here is taking each bit of style information in the markup tag (each word or each `(...)` within `{...}`) and constructing style codes with an `ANSICode` object.

If the style information represents a color, `Term` first represents it as a `AbstractColor` type: `NamedColor` or `BitColor` or `RGBColor`.  

`NamedColor` objects represent simple colors like `red` and `blue`, `BitColor` represent 16-bit colors like `dark_goldenrod` and `RGBColor`, surprisingly, represents rgb-style colors. There's no method to represent hex colors as these are converted into rgb first. 

The distinction between `NamedColor`, `BitColor` and `RGBColor` is necessary because the three color styles are represented by a different syntax in the ANSI codes. Naturally, `Term` users won't normally worry about this and can use whichever color formulation is most convenient.


# [Theme](@id ThemeDocs)
Term defines a `Theme` type that carries styling information used throughout. 
It tells `highlight` what color things should be, it stores the colors of elements of [Tree](@ref TreeDoc), and of the [Repr functionality](@ref ReprDoc).

```@example theme
import Term: Theme, set_theme, TERM_THEME

default = TERM_THEME[]
```

You can create a new theme with different colors:
```@example theme
newtheme = Theme(string="red", code="black on_white")
```

and set it as the new theme to be used by Term:
```@example theme
set_theme(newtheme)
```

```@example theme
set_theme(Theme()) # hide
```


The default theme used by `Term` is tailored for a dark terminal, if you fancy a lighter terminal experience, you might want to:
```julia
import Term: set_theme, LightTheme

set_theme(LightTheme)
```

# [Tree](@id TreeDoc)

The `Tree` renderable shows hierarchical structures:

```@example tree
import Term.Trees: Tree

data = Dict(
    "a" => 1,
    "b" => Int64,
    "c" => (1, 2, 3),
)

print(Tree(data))
```

As you can see, the starting point is a `Dict` with `key -> value` entries which get rendered as leaves in the tree. Also, the `Type` of `value` is shown by colors in the tree.

If you have nested data, just create nested dictionaries!

```@example tree
data = Dict(
    "a" => 1,
    "b" => Int64,
    "deep" => Dict(
            "x" => 1,
            "y" => :x
    ),
)

print(Tree(data))
```

Under the hood, `Tree` just leverages [AbstractTrees.jl](https://github.com/JuliaCollections/AbstractTrees.jl) to handle tree-like data structures, so anything that is compatible with that framework will printed as a `Tree`.


```@example tree
# expressions
Tree(:(print, (:x, :(y+1)))) |> print

# arrays
Tree([1, [1, 2, [:a, :b, :c]]]) |> print

# and more!
```

Essentially `Tree` work's with `AbstractTrees` to just produce stylized output. 

!!! tip `Tree` is not a *tree*
    `Tree` is an `AbstractRenderable`, it is **not** a datastructure for handling tree-like data. It's only meant to be used to *display* trees in your terminal. As such you can't do operations like finding children of nodes or getting a subtree etc. All of that should be done with `AbstractTrees` and `Tree` is only there to display the output


As per the note above, `Tree` is a `AbstractRenderable` type so it plays well with other renderables in term. 

```@example tree
import Term: Panel

data = Dict(
    "a" => 1,
    "b" => Int64,
    "c" => (1, 2, 3),
)

_tree = Tree(data)
_info = Panel("This is a panel\nYou can use it to explain\nwhat the contents of the\ntree are!"; width=30, height=_tree.measure.h, subtitle="description")

print(_tree * "  " *_info)

```

### Styling
Easy! [`Tree`](@ref) has lots of options to allow you to style it as you like.
The style is set by the [`Theme`](@ref ThemeDocs). 

```@example tree
import Term: Theme
using MyterialColors

# create a new theme editing the tree style
theme = Theme(
    tree_mid             = blue,
    tree_terminator       = blue,
    tree_skip           = blue,
    tree_dash           = blue,
    tree_trunc         = blue,
    tree_pair           = red_light,
    tree_keys           = yellow,
    tree_max_leaf_width = 22,
)

print(
    Tree(data,
        theme=theme
    )
)
```
`tree_max_leaf_width` sets the max width of the display of each leaf while the other values set the color of different elements of the `Tree`. In particular `mid`, `terminator`, `dash` refer to the lines (or guides) of the tree. 

And since we're talking about `guides` you can also use different ones
```@example tree
print(
    Tree(data,
        guides=:asciitree
    )
)
```

there's a couple named guides style, but you can customize things even further using an `AbstractTree.TreeCharSet` if you wish.


## TypeTree
As you know, Julia allows for hierarchical types structures. Trees are for visualizing hierarchical data structures. So...

```@example
import Term: typestree

typestree(AbstractFloat)
```

Enjoy!

# Table
You know what a table is. You probably also know that Julia has an awesome `Tables` interface for handling tabular data (e.g. that's what `DataFrames` uses). All that `Term` does here is that that and make it look fancy. 

```@example tb
using Term.Tables
t = 1:3
data = hcat(t, rand(Int8, length(t)))
Table(data) # or use a matrix!
```

nothing spectacular so far, but `Table` has a ton of options.

### Box style
You can adjust the box used and its style
```@example tb
Table(data; box=:ROUNDED, style="red")
```
```@example tb
Table(data; box=:SIMPLE, style="dim bold")
```
```@example tb
Table(data; box=:MINIMAL_DOUBLE_HEAD, style="dim bold green")
```

### Header
You can set the header style:
```@example tb
Table(data; header_style="bold green")
```
and setting each style independently
```@example tb
Table(data; header_style=["bold green", "dim"])
```


you can also set what the header should be and if it should be left-center-right justified:
```@example tb
Table(data; header=["A", "B"], header_justify=[:left, :right])
```

!!! note
    For all parameters that apply to the header, columns and footer; you can either pass a single parameter or a vector of parameters. If a single parameter is passed, it will be applied to all the columns, otherwise each element of the vector is applied to each column.

### Footer
Very similar to the header, but at the bottom:
```@example tb
Table(data; footer=["A", "B"], footer_justify=[:left, :right], footer_style="bold green")
```

a nice little thing: use functions to create a footer:
Table(data; footer=sum)

### Columns
Like for header and footer you can set the style and justification of the columns, all together or independently:
```@example tb
Table(data; columns_style=["bold green", "dim"], columns_justify=[:left, :right])
```

but there's more (there always is, isn't it?):
```@example tb
import Term.Layout: PlaceHolder
ph1 = PlaceHolder(3, 12)
ph2 = PlaceHolder(5, 12)
ph3 = PlaceHolder(7, 12)

data = Dict(
    "first\ncol." => [ph1, ph2, ph3],
    "second\ncol." => [ph1, ph2, ph3],
    "third\ncol." => [ph3, ph1, ph3],
)

Table(data)
```

and now look, vertical justify!
```@example tb
Table(data; vertical_justify= :bottom)
```

### Padding
Finally, you can use `hpad` and `vpad` to adjust the padding of the table:
```@example tb
t = 1:3
data = hcat(t, rand(Int8, length(t)))
Table(data; hpad=20) 
```
and
```@example tb
Table(data; vpad=5)
```

as you can see it changes the size of the cells around the content.


That's all you need to know about how to make a `Table`. You can play around with the parameters to make great looking tables!
```@example tb
data = Dict(
    :Parameter => [:α, :β, :γ],
    :Value => [1, 2, 3],
)

Table(data;
    header_style="bold white on_black",
    header_justify=[:right, :left],
    columns_style=["bold white", "dim"],
    columns_justify=[:right, :left],
    footer=["", "{bold red}3{/bold red} params"],
    footer_justify=[:right, :left],
    box=:SIMPLE,
    style="#9bb3e0"
)
```

# Console
Term provides a `Console` object whose main function (for now) is to simulate having a terminal with a size different from what you actually have. Imagine that your terminal is currently 100 columns wide, but you want to simulate having a narrower one (why? Don't know, but assume that's the case), then using `Console` allows you to do just that. 

It may seems like a fairly niche thing to have, but can actually be useful if you want to ensure that the output of your package looks the same for all users regardless of their terminal size. Also `Console` will do a lot more in the future.

```@example
using Term: tprintln
using Term.Consoles: Console, enable, disable

tprintln("This is a very long text"^10)

myc = Console(40)  # 40 columns wide
myc |> enable  # activate it


tprintln("This is a very long text"^10)  # get's reshaped to fit in 60cols

myc |> disable  # de-activate the console

tprintln("This is a very long text"^10)

```

it also works for any `Renderable` made with Term:

```@example
using Term: tprintln, Panel # hide
using Term.Consoles: Console, enable, disable #hide

print(Panel())

myc = Console(40)  # 40 columns wide
myc |> enable  # activate it


print(Panel())  # get's reshaped to fit in 60cols

myc |> disable  # de-activate the console

print(Panel())

```


!!! warning "print vs tprint"
    `Console` reshapes the output of a `print` call only if this is *not* just a plain `String`. Any renderables you're using will be re-shaped. If it's just a string, the default `Base.print` method will be called and there's nothing we can do about it. One possible work-around is using Term's `tprint` which will take the `Console` in consideration, alternatively wrap your strings in `RenderableText` objects.

# [Panel](@id PanelDocs)
Okay, time to move beyond simple text. It's time for:
```@example
import Term: Panel # hide
print(# hide
    Panel(# hide
        "{red}awesome{/red}", # hide
        title="Term's", # hide
        title_style="bold green", # hide
        style="gold1 bold", # hide
        subtitle="Panels", # hide
        subtitle_style="bold blue", # hide
        subtitle_justify=:right, # hide
        width=18, # hide
        justify=:center # hide
    ) # hide
) # hide
```

Simply put, a `Panel` shows a piece of content (generally a styled string, but it can be any `Renderable` really) surrounded by a box. Simple but effective.

Well not that simple actually because [`Term.Panels.Panel`](@ref) is the first renderable that allows you lots of options to personalize its appearance. For instance the panel printed above is given by:
```julia
    Panel(
        "{red}awesome{/red}",
        title="Term's",
        title_style="bold green",
        style="gold1 bold",
        subtitle="Panels",
        subtitle_style="bold blue",
        subtitle_justify=:right,
        width=18,
        justify=:center
    )
```

The first argument is the content, the rest is styling options. As you can see you can specify the titles and subtitles (or leave them out if you prefer, do your thing!), their appearance (via `markup` style information) and their position (`:left, :center` or `:right`). The `style` argument sets the style of the box itself (and title/subtitle if they don't have dedicated style information).

The box is created using `Term`'s own `Box` type! It's not worth going too much into exactly how it works, but it's worth pointing out that there's loads of types of boxes:
```
ASCII,
ASCII2,
ASCII_DOUBLE_HEAD,
SQUARE,
SQUARE_DOUBLE_HEAD,
MINIMAL,
MINIMAL_HEAVY_HEAD
MINIMAL_DOUBLE_HEAD,
SIMPLE,
SIMPLE_HEAD,
SIMPLE_HEAVY,
HORIZONTALS,
ROUNDED,
HEAVY
HEAVY_EDGE,
HEAVY_HEAD,
DOUBLE,
DOUBLE_EDGE
```

And you can use any of these with your panels:
```@example panel
import Term: Panel

print(
    Panel(width=8, box=:DOUBLE, style="green") *
    Panel(width=8, box=:HEAVY, style="white") *
    Panel(width=8, box=:ROUNDED, style="red"),
)
```


Let's look at some more examples:
```@example panel

print(
    Panel("this panel has fixed width, text on the left"; width = 66, justify = :left),    
    Panel("this one too, but the text is at the center!"; width = 66, justify = :center),
    Panel("the text is here!"; width = 66, justify = :right),
)
print("\n")
```
You can justify the panel's content to `:left, :center, :right`!

```@example panel
    Panel("Titles have style too!!"; width = 60, justify = :center, title="My Title", title_style="red bold", title_justify=:right, subtitle="Made with Term", subtitle_style="dim", subtitle_justify=:left
)
```
And style the title and subtitle, or the whole background too:
```@example panel
import Term: highlight_syntax

Panel(
    highlight_syntax("""
function show_off(x)
    print(x)
end
"""); 
    background="on_black", fit=true, style="on_black"
)

```

By the way, `Panels` are not limited to having strings as content, they can have other renderables too (multiple ones in fact)!
```@example panel
Panel(
        Panel(width=18, style="green"),
        Panel(width=18, style="white"),
        Panel(width=18, style="red"),
        title="so many panels!",
        fit=true,
        title_justify=:left,
        title_style="bold red"
    )

```

## Size & fitting
By default `Panel` tries to fit your content:

```@example panel
print(Panel("."^10))
print(Panel("."^30))
print(Panel("."^60))
```

but you can change this by passing a `width` value. In fact you can se a height too:
```@example panel
Panel("."^10; height=5, width=20)
```

Alternatively, you can use `fit=false`. 
```@example panel
Panel("."^10; fit=false)
```
this will make all panels have the same width (unless you specify a width). The main difference is that if the content is larger than the panel, it will be truncated, which is not what happens if `fit=true`"
```@example panel
p1 = Panel("."^10; height=5, width=60)
print(Panel(p1; height=2, width=30))  # fit=true -> expand out panel, width/height ignored
print(Panel(p1; height=10, width=30, fit=false))  # fit=false -> truncate the content
print(Panel("very long text"^20; height=10, width=30, fit=false))  # text is reshaped to fit the panel
```


## Padding
You'll notice in the example above that there's still some space between the panel's borders and its content. That's padding. You can change how much padding to have to the left, right, top and bottom (in number of spaces/lines):

```@example panel
inner = Panel(height=4, width=8, background="on_#262626", style="bold red")
print(
    Panel(inner; fit=false, padding=(0, 0, 0, 0)),
    Panel(inner; fit=false, padding=(3, 1, 3, 1)),
    Panel(inner; fit=false, padding=(20, 3, 3, 1)),
)
```

The syntax is `(left, right, top, bottom)` and the default is `(2, 2, 0, 0)`.


# [TextBox](@id TBoxDoc)
Sometimes you want to have the benefits of `Panel` (you can control the height, width, padding, justification, titles...) without actually showing the panel itself. Introduce: `TextBox`.
```@example
using Term: TextBox
TextBox("A very long piece of text"^10; title="TEXT", width=30, fit=false)
```

Easy peasy!

# Keyboard input
Apps can capture input from the user by reading key presses and passing them to the active widget. 

Each widget must have a `controls` attribute with a dictionary mapping keys to function. 
The keys of this dictionary can take one of two types: 
- `Char`: a single character. Used to map a "letter" key to a function. For example `q` generally quits the app and `h` displays help.
- a `KeyInput` type like `ArrowLeft()` or `HomeKey()`. These are special keys including the arrows, page up/down, Esc, Del and SpaceBar. 


The values of the dictionary are functions. The function should have a signature: `fn(w, k)` where `w` is the widget they are assigned to and `k` is the key that was pressed.
For example in `Pager` you can use `ArrowRight, PageDownKey` and `]` to scroll down so a function is defined as:
```julia
next_page(p::Pager, ::Union{PageDownKey,ArrowRight,Char})
```

and with similar functions the `controls` for `Pager` are:
```

pager_controls = Dict(
    ArrowRight() => next_page,
    ']' => next_page,
    ArrowLeft() => prev_page,
    '[' => prev_page,
    ArrowDown() => next_line,
    '.' => next_line,
    ArrowUp() => prev_line,
    ',' => prev_line,
    HomeKey() => home,
    EndKey() => toend,
    Esc() => quit,
    'q' => quit,
)
```

there's no restriction to which/how many control functions you should have and how they should affect your widget.
However having `quit` is generally a good idea or the user can't quit the app while that widget is active!
Different widgets will have different controls. 
A widget's controls are only activated if the corresponding key is pressed while the widget is active.

# Progress bars


!!! warning
    Progress bars displays are updated in the background while your code executes. This is done by having the display rendering code run on a separate thread. If you're using a single thread (see: https://docs.julialang.org/en/v1/manual/multi-threading/) you'll need to add a `sleep(0.001)` or `yield()` command inside your code whose progress you're monitoring to ensure that the display is updated correctly.


## Overview
Progress bars! We all love progress bars, and Julia has some great [progress bars](https://juliapackages.com/p/progressbars) packages. 
But this is `Term`, and `Term` too has its own progress bars API. We think you'll like it. If not, worry not! `Term`'s progress bars play well `ProgressLogging.jl`, scroll to the bottom of this page!

!!! warning
    Progress bars do some terminal magic that doesn't play well with how the docs are rendered here. If you want to see what progress bars actually look like, 
    we **encourage** you to copy-paste the code below and try it out in your own console. Or head to [github](https://github.com/FedeClaudi/Term.jl) where you can find more examples.

So this is what a progress bar looks like in `Term`:

```@example prog
using Term.Progress

pbar = ProgressBar()
job = addjob!(pbar; N=5)
start!(pbar)
for i in 1:5
    update!(job)
    sleep(0.01)
    render(pbar)
end
stop!(pbar)
```


Let's see what's happening. We start by creating a progress bar

```Julia
pbar = ProgressBar()
```

and then we add a "job"

```Julia
job = addjob!(pbar; N=5)
```

what's that? `Term`'s `ProgressBar`s can handle multiple "jobs" simultaneously. So if you have multiple things you want to keep track of (e.g. multiple nested loops), you can have a job for each. Next we start the progress bar:
```Julia
start!(pbar)
```
we update the job at each step of the loop and render the updated display:
```Julia
    update!(job)
    render(pbar)
```
and finally we stop the whole thing:
```
stop!(pbar)
```.

Okay, why do we need all of this starting and stopping business? Updating the job makes sense, we need to know when we made progress, but why do we need to start and stop the progress bar? Well, `ProgressBar` does a bit of terminal magic to ensure that any content you print to STDOUT is displayed without disrupting the progress bar's behavior, so we need to start and stop it to make sure that the magic happens and that the terminal is restored when we're done. 

You might spot a problem: what if we forgot `stop!`, or our code errors before we reach it or something else like this? That's a problem, our terminal won't be restored. Well don't worry, there's a solution:

```@example prog

pbar = ProgressBar()
job1 = addjob!(pbar; N=5)
job2 = addjob!(pbar; N=10)

with(pbar) do
    for i in 1:10
        update!(job1)
        update!(job2)
        i % 3 == 0 && println("text appears here!")
        sleep(0.001)
    end
end
```

!!! info "`println` vs `print`"
    You'll notice we've used `println` in the example above. Currently, using `print` will break the layout and the text won't be printed correctly. Please use `println` while using `ProgressBar`!

`with` takes care of it all. It starts the progress bar and stops it too! No matter what happens in the code inside the `do` block, `with` will stop the progress bar so we can use it with no fear. It also removes the need to explicitly call `start!/stop!`, which helps. We recommend that you always use `with`. 

So with `with` we loose some of the boiler plate, but it's still a bit too much isn't it? It's cool if you
need something specific, but if you want a simple progress bar to monitor progress in a loop perhaps you want something simpler. That's where `@track` comes in:

```@example prog
@track for i in 1:10
    sleep(0.01)
end
```

As simple as that!



### ProgressJob
There's just couple things you need to know about `ProgessJob`. First, you can set the expected number of steps in the progress bar. We've seen that before, it's the `N` in `addjob!(pbar; N=5)`. You don't have to though, if you don't know how long your job's going to be then just leave it out! In that case you won't see a progress bar, but you can still see some progress:

```@example prog
pbar = ProgressBar(; columns=:spinner)
job = addjob!(pbar; description="how long is this")

with(pbar) do
    for i in 1:10
        update!(job)
        sleep(0.001)
    end
end
```

What's up with that `columns=:spinner`? Read below. By the way, there's a few different kind of spinners

```@example prog
import Term.Progress: SPINNERS

for spinner in keys(SPINNERS)
    columns_kwargs = Dict(
        :SpinnerColumn => Dict(:spinnertype => spinner, :style=>"bold green"),
        :CompletedColumn => Dict(:style => "dim")
    )

    pbar = ProgressBar(; columns=:spinner, columns_kwargs=columns_kwargs)
    with(pbar) do
        job = addjob!(pbar; description="{orange1}$spinner...")
        for i in 1:3
            update!(job)
            sleep(.0025)
        end
    end
end

```


## Options
The main way in which you can personalize progress bars display, is by choosing which columns to show (see below), but there's also a few additional parameters. You can use `width` to specify how wide the progress bar display should be, or set `expand=true` to make it fill up all available space. Also, sometimes you want to have a bunch of display bars to show progress in various bits of your code, but you don't want your final terminal display to be cluttered. In that case set `transient=true` and the progress bars will be erased when they're finished!


## Columns
As you've seen, each progress bar display shows various bits of information: some text description, the progress bar itself, a counts bit... Each of these is a "column" (a subtype of `AbstractColumn`). There's many types of columns showing different kinds of information, and you can make your own too (see below). `Term` offers different presets columns layouts do display varying levels of detail:


```@example prog
for details in (:minimal, :default, :detailed)
    pbar = ProgressBar(; columns=details, width=80)
    with(pbar) do 
        job = addjob!(pbar; N=5)
        for i in 1:5
            update!(job)
            sleep(0.02)
        end
    end
end

```

but you can also choose your own combination of columns:

```@example prog
import Term.Progress: CompletedColumn, SeparatorColumn, ProgressColumn, DescriptionColumn

mycols = [DescriptionColumn, CompletedColumn, SeparatorColumn, ProgressColumn]
cols_kwargs = Dict(
    :DescriptionColumn => Dict(:style=>"red bold")
)

pbar = ProgressBar(; columns=mycols, columns_kwargs=cols_kwargs, width=140)
with(pbar) do 
    job = addjob!(pbar; N=5)
    for i in 1:5
        update!(job)
        sleep(0.02)
    end
end
```

what's that `cols_kwargs`? You can use that to pass additional parameters to each columns, e.g. to set its style.


You can also pass a `cols_kwargs` argument to `addjob!` to set the column style for individual jobs!
```@example prog

pbar = ProgressBar(; expand = true, columns=:detailed, colors="#ffffff", 
    columns_kwargs = Dict(
        :ProgressColumn => Dict(:completed_char => '█', :remaining_char => '░'),
    )
)
job = addjob!(pbar; N = 10, description="Test")

job2 = addjob!(
    pbar; 
    N = 10, 
    description="Test2", 
    columns_kwargs = Dict(
        :ProgressColumn => Dict(:completed_char => 'x', :remaining_char => '_'),
    )
)

with(pbar) do
    for i in 1:10
        update!(job)
        update!(job2)
        sleep(0.01)
    end
end
```

### Custom columns
If there some kind of information that you want to display and Term doesn't have a column for it, just make your own! 

You need two things: a column type that is a subtype of `AbstractColumn` and an `update!` method to update the column's text at each step of the progress bar. Here's a, not very useful, example of a column that displays random text:

```@example customcolumn
using Random

using Term.Progress
import Term.Progress: AbstractColumn, DescriptionColumn, CompletedColumn, SeparatorColumn, ProgressColumn
import Term.Segments: Segment
import Term.Measures: Measure

struct RandomColumn <: AbstractColumn
    job::ProgressJob
    segments::Vector{Segment}
    measure::Measure
    style::String

    function RandomColumn(job::ProgressJob; style="red" )
        txt = Segment(randstring(6), style)
        return new(job, [txt], txt.measure, style)
    end
end


function Progress.update!(col::RandomColumn, color::String, args...)::String
    txt = Segment(randstring(6), col.style)
    return txt.text
end
```

which you can use as you would any column:

```@example customcolumn

mycols = [DescriptionColumn, CompletedColumn, SeparatorColumn, ProgressColumn, RandomColumn]
cols_kwargs = Dict(
    :RandomColumn => Dict(:style=>"green bold")
)

pbar = ProgressBar(; columns=mycols, columns_kwargs=cols_kwargs, width=140)
with(pbar) do 
    job = addjob!(pbar; N=5)
    for i in 1:5
        update!(job)
        sleep(0.02)
    end
end

```

done!

## For each progress
Want to just wrap an iterable in a progress bar rendering? Check this out.

```Julia
using Term
using Term.Progress

pbar = Term.ProgressBar()
foreachprogress(1:100, pbar,   description = "Outer    ", parallel=true) do i
    foreachprogress(1:5, pbar, description = "    Inner") do j
        sleep(rand() / 5)
    end
end
```

The loop above will render a progress bar for each iteration of the outer loop, and a progress bar for each iteration of the inner loop - easy.


## ProgressLogging
I know that some of you will be thinking: hold on, Julia already had a perfectly functioning progress API with `ProgressLogging.jl`, can't we just use that? Long story short, yes you can. But `Term`'s API gives you so much more control over what kind information to display and what it should look like. Nonetheless, many of you will want to use `ProgressLogging` in conjunction with Term, so we've made it possible, you just need to use Term's logger (see [Logger](@ref LoggingDoc)):


```Julia
using ProgressLogging
import Term: install_term_logger
install_term_logger()

@progress "outer...." for i in 1:3
    sleep(0.01)
end

```

# [Term Repr](@id ReprDoc)
Note: by repr here we refer generically to how information about an object is represented in the terminal, not the `repr` function in Julia.

## Type REPR
You can use `Term.jl` to create a styled type display in your console. 

The easiest way to explain it is by way of example.
Let's say you define a type, and create an instance of it:

```@example repr


struct myType
    name::String
    height::Int
    width::Int
    mass::Float64
end


obj = myType("Rocket", 10, 10, 99.9)
```

as you can see the default way to represent your object in the console is not very exciting. 
But we can improve that with a simple macro!
```@example repr
using Term.Repr

@with_repr struct myFancyType
    name::String
    height::Int
    width::Int
    mass::Float64
end


obj = myFancyType("Rocket", 10, 10, 99.9)
```

now every time we display an instance of `myFancyType` in the console, we get a nice representation (note that that's not true for `print(obj)`!).


!!! warning "Docs display"
    Ooopss... it looks like the `Panel` display in the example above is not working out in the Docs. It will look fine in your REPL though!

## Termshow
Very nice, but what if I don't have access to where the types are created (perhaps they are in another package) but still want to have the nice display? One way is to use `termshow`:
```@example repr

dullobj = myType("Rocket", 10, 10, 99.9)
termshow(dullobj)
```

easy!

But wait, there's more!
```@example repr
termshow(termshow)  # or any other function
```

Fancy right? It shows the function, various methods for it and it's docstrings (by parsing the Markdown). It works with types too
```@example repr
import Term: Panel
termshow(Panel)
```

and in general you can display almost any object
```@example repr
termshow(Dict(:x => 1, :y => 2))
termshow(zeros(3, 3))
```

### install term repr
Okay, `termshow` is pretty cool (even if I say so myself), but we need to call it every time we need to display something. I just want to type a variable name in the REPL (devs are lazy you know). Well, there's a solution for that too of course:
```@example repr
install_term_repr()
Panel
```

now showing anything in the REPL goes through `termshow`

!!! warning "Not for developers!!!"
    If you're writing code just for yourself, go ahead and use `install_term_repr`. Enjoy it. But, if the code you're writing is intended for others you should really avoid doing that. It will modify the behavior of the REPL for them too and that's confusing and possibly error prone. 


## @showme
One of Julia's most loved features is multiple dispatch. However, sometimes it can be hard to know which method gets called by your code and what that method is doing. There's lots of tools out there to help with this, including some built in in Julia's base code. Here we show a nifty little macro that builds upon `CodeTracking` by Tim Holy to directly show you the method your code is calling:

```@example showme
import Term.Repr: @showme

@showme tprint(stdout, "this is TERM")  # which method is being called?
```

as you can see, it shows the source code of the particular `tprint` method being called by the combination of arguments, for different arguments different methods will be invoked:

```@example showme
@showme tprint("this is also TERM")  # different method
```

You can also list all methods for the function you're calling, should you wish to do so
```@example showme
@showme tprint("still TERM") show_all_methods=true
```

Enjoy.

# Stacking
The idea is simple: horizontally stack two renderables and they will appear side by side, stack them vertically and they will appear one over the other. The syntax is even simpler: `*` lets you horizontally stack (or concatenate strings) and `/` lets you stack them vertically.

!!! note
    The choice of `*` and `/` as operators for stacking operations was somewhat arbitrary.
    `*` was chosen because it's already what Julia uses to concatenate strings, and you can think of that as "horizontally stacking them". `/` was chosen because it reminds me of fractions, and fractions have one number over another. 

    If you don't like to use these operators, you're in luck! They are really just a 
    shorthand notation for the functions `hstack` & `vstack`. You'll find that this notation makes for some pretty nifty code though.

Let's stack things:

```@example

import Term: Panel # hide

println(
    Panel("horizontally"; fit=true) * Panel("stacked"; fit=true)
)
println("&\n")
println(
    Panel("vertically"; fit=true) / Panel("stacked"; fit=true)
)

```

As simple as that. But you can also go crazy if you like:

```@example

import Term: Panel # hide

p = Panel(width=5)
println(
    (p * p * p) / (p * (p/p)) / (p * p * "{bold red}supripse!{/bold red}")
)
```


what's that red text doing in there? We didn't use `tprint`, or `apply_style`, we didn't put it into a [`RenderableText`](@ref RtextDoc) or a [`TextBox`](@ref TBoxDoc) (see [Renderables](@ref RenIntro))... why didn't it print as `"{bold red}supripse!{/bold red}"`??

The answer is that stacking operators return the generic `Renderable` type object, and `Renderable`s apply their styles before printing out to console. Okay, not a huge surprise I guess, but I just wanted an excuse to say that regardless of what goes into `*` and `/` the output is a generic `Renderable` (well with the exception of `*` between two strings which returns a string; also `*` and `/` don't work with things like `::Number` & co., but you get the idea). The reason for the generic `Renderable` type is that the product of two stacked renderables should act as a unitary single renderable in its own right. You should be able to print it, stack it etc... So `Renderable` is the simplest type of renderable that can do this (it only has segments and measure, no other features - see previous section), so when we stack together multiple different types of renderables we create a generic container. 

Previously we briefly mentioned the idea of the `Measure` or a renderable object. `Measure` stores information about the width and height of a renderable as it will appear in the terminal. When we stack renderables, the `Measure` of the resulting `Renderable` will do the following:
- if we are using `*` the width will be the sum of widths of the two renderables and the height will be the height  of the tallest renderable
-  if we are using `/` the width will be that of the widest renderable and the height will be the sum of heights. 

Let's see:
```@example
import Term: Panel # hide
p1 = Panel(height=5, width=5)
println("p1.measure: ", p1.measure)


p2 = Panel(height=5, width=8)
println("p2.measure: ", p2.measure)

h = p1 * p2
println("* stacked measure: ", h.measure)

v = p1 / p2
println("/ stacked measure: ", v.measure)
```

This is important, because often you want to know a `Renderable`'s size when creating a layout, as we'll see next.

## vstack, hstack & padding
When stacking more than 2 renderables at one time, it's probably easier to use `vstack` or `hstack` than to use `*` and `/` directly:

```@example stacking
import Term.Layout: vstack, hstack # hide
import Term: Panel # hide
p1 = Panel(height=4, width=8) # hide

p1 * p1 * p1 * p1
```

can be written as:
```@example stacking
hstack(p1, p1, p1, p1)
```

which is easier to read. But more importantly. `vstack` and `hstack` let you define a padding (spacing) between the renderables being stacked:
```@example stacking
hstack(p1, p1, p1, p1; pad=8)
```
and 
```@example stacking
vstack(p1, p1, p1, p1; pad=1)
```

which is equivalent but much nicer than:
```@example stacking
space = " "^8  # or use Spacer
p1 * space * p1 * space * p1 
```

```@meta
CurrentModule = Term
```
# Term

`Term.jl` is a Julia library for producing styled, beautiful terminal output. 
It uses a simple *markup* syntax to add style information to standard Julia strings.
It also provides `Renderable` objects such as the `Panel` and `TextBox` as you can see in the example below.
These too can be styled, include styled text, and they can be nested and stacked to produce
structured visual displays in your terminal. 

!!! warning "OS concerns"
    `Term` has been tested extensively so far, but only on Mac. If you're using a Linux or Windows machine you might find some bugs that have eluded us so far. Please get in touch so that we can fix them!

!!! info "`Term` and `rich`"
    While `Term` was written from scratch in Julia, it's based upon a pre-existing python library called [`rich`](https://github.com/Textualize/rich). If you have never used `rich`, just know that it's absolutely awesome. And its creator, Will McGugan, made it open source for anyone to use. That also meant people like us could take inspiration from `rich` to create related packages in other languages. We are very grateful to Will, and we hope that `Term` will end up being a fraction as cool as `rich`.

### Installation
In a Julia script:
```Julia
using Pkg

Pkg.add("Term")
```

or in the Julia REPL
```
julia> ]  # enters the pkg interface
pkg> add Term
```

done!


----

The rest of the documentation is dedicated to explaining the basic concepts behind `Term.jl` and how to use `Term` to produce styled terminal text. 
Head to the [GitHub](https://github.com/FedeClaudi/Term.jl) repository to find several detailed examples or jump in the [Discussions](https://github.com/FedeClaudi/Term.jl/discussions) to start chatting with us. 



## Getting in touch
If you want to get in touch with us, the easiest way is on GitHub. You can open an [issue](https://github.com/FedeClaudi/Term.jl/issues) to report a bug or ask for a new feature or join the [discussions](https://github.com/FedeClaudi/Term.jl/discussions) for more general chats about `Term`. The discussion section is also a good place to go for general questions about `Term` and how to use it. 

`Term` is written to be a useful piece of software for anyone using Julia, from beginners to more advanced users. If you're comfortable writing and testing code, you can jump in right now and start actively working on `Term` with us. If you're not, that's totally fine. There are a lot of ways in which you can help: open an issue to report problems with `Term`, ask questions on GitHub, help expand the docs and examples for other users too. Or just tell us what you're experience using `Term` was like, any feedback can help us improve!

## Related packages
As mentioned, `Term` is inspired on `rich` in python. There's also a project called [Spectre console](https://spectreconsole.net/) which is a .NET Standard 2.0 version of `rich`.

In Julia there are several pre-existing packages aimed at producing styling terminal output; we note in particular:
- [Crayons](https://github.com/KristofferC/Crayons.jl)
- [AnsiColor](https://github.com/Aerlinger/AnsiColor.jl)
